/*
SQLyog Ultimate v11.11 (64 bit)
MySQL - 5.5.27 : Database - gventas
*********************************************************************
*/


/*!40101 SET NAMES utf8 */;

/*!40101 SET SQL_MODE=''*/;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;
CREATE DATABASE /*!32312 IF NOT EXISTS*/`gventas` /*!40100 DEFAULT CHARACTER SET utf8 */;

USE `gventas`;

/*Table structure for table `gv_almacen` */

DROP TABLE IF EXISTS `gv_almacen`;

CREATE TABLE `gv_almacen` (
  `ida` int(11) NOT NULL AUTO_INCREMENT,
  `nombre` varchar(125) NOT NULL,
  `direccion` varchar(125) NOT NULL,
  `encargado` int(11) NOT NULL,
  `activo` int(1) DEFAULT '1',
  PRIMARY KEY (`ida`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

/*Data for the table `gv_almacen` */

insert  into `gv_almacen`(`ida`,`nombre`,`direccion`,`encargado`,`activo`) values (1,'almacen desconocid','direccion desconocida',27,1),(2,'almacen 2','direccion desconocida2',2,0),(3,'almacen 3','stand 4',2,1);

/*Table structure for table `gv_almaceproduct` */

DROP TABLE IF EXISTS `gv_almaceproduct`;

CREATE TABLE `gv_almaceproduct` (
  `idpa` bigint(20) NOT NULL AUTO_INCREMENT,
  `idalmacen` int(11) NOT NULL,
  `idproducto` bigint(20) NOT NULL,
  `cantidad_actual` int(11) NOT NULL,
  `cantidad_inicial` int(11) NOT NULL,
  `tipo_manipulacion` enum('VENTA','COMPRA','TRANSLADO','REGISTRO') NOT NULL,
  `fecha` date DEFAULT NULL,
  `activo` int(1) DEFAULT '1',
  PRIMARY KEY (`idpa`)
) ENGINE=InnoDB AUTO_INCREMENT=70 DEFAULT CHARSET=utf8 COMMENT='almacen producto';

/*Data for the table `gv_almaceproduct` */

insert  into `gv_almaceproduct`(`idpa`,`idalmacen`,`idproducto`,`cantidad_actual`,`cantidad_inicial`,`tipo_manipulacion`,`fecha`,`activo`) values (46,1,24,49,0,'REGISTRO','2013-03-08',1),(47,2,24,0,0,'REGISTRO','2013-03-08',0),(48,3,24,20,0,'REGISTRO','2013-03-08',1),(49,1,25,50,0,'REGISTRO','2013-03-08',1),(50,2,25,0,0,'REGISTRO','2013-03-08',0),(51,3,25,30,0,'REGISTRO','2013-03-08',1),(52,1,26,29,0,'REGISTRO','2013-03-25',1),(53,2,26,0,0,'REGISTRO','2013-03-25',0),(54,3,26,0,0,'REGISTRO','2013-03-25',1),(55,1,27,30,0,'REGISTRO','2013-03-25',1),(56,2,27,0,0,'REGISTRO','2013-03-25',0),(57,3,27,20,0,'REGISTRO','2013-03-25',1),(58,1,28,41,0,'REGISTRO','2013-03-25',1),(59,2,28,0,0,'REGISTRO','2013-03-25',0),(60,3,28,40,0,'REGISTRO','2013-03-25',1),(61,1,29,10,0,'REGISTRO','2013-03-25',1),(62,2,29,0,0,'REGISTRO','2013-03-25',0),(63,3,29,0,0,'REGISTRO','2013-03-25',1),(64,1,30,28,0,'REGISTRO','2013-03-25',1),(65,2,30,0,0,'REGISTRO','2013-03-25',0),(66,3,30,20,0,'REGISTRO','2013-03-25',1),(67,1,31,13,0,'REGISTRO','2014-02-10',1),(68,2,31,0,0,'REGISTRO','2014-02-10',0),(69,3,31,0,0,'REGISTRO','2014-02-10',1);

/*Table structure for table `gv_asignarauth` */

DROP TABLE IF EXISTS `gv_asignarauth`;

CREATE TABLE `gv_asignarauth` (
  `nombreitem` varchar(64) NOT NULL,
  `iduser` varchar(64) NOT NULL,
  `bizrule` text,
  `dato` text,
  PRIMARY KEY (`nombreitem`,`iduser`),
  CONSTRAINT `gv_asignarauth_ibfk_1` FOREIGN KEY (`nombreitem`) REFERENCES `gv_authitem` (`nombre`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `gv_asignarauth` */

insert  into `gv_asignarauth`(`nombreitem`,`iduser`,`bizrule`,`dato`) values ('administrador','genius','','');

/*Table structure for table `gv_authitem` */

DROP TABLE IF EXISTS `gv_authitem`;

CREATE TABLE `gv_authitem` (
  `nombre` varchar(64) NOT NULL,
  `tipo` int(11) NOT NULL,
  `descripcion` text,
  `bizrule` text,
  `dato` text,
  PRIMARY KEY (`nombre`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `gv_authitem` */

insert  into `gv_authitem`(`nombre`,`tipo`,`descripcion`,`bizrule`,`dato`) values ('actualizarCliente',0,'null','null','null'),('actualizarProducto',0,'null','null','null'),('actualizarStock',0,'null','null','null'),('actualizarUsuario',0,'null','null','null'),('administrador',2,'Rol administrador no tiene restricciones','null','null'),('administrar',1,'Tarea Principal de un administrador','null','null'),('almacenar',1,'Tarea Principal de un almacenero','null','null'),('almacenero',2,'Rol almacenero encargado de registrar productos,mover productos, y actualizar el stock','null','null'),('buscarCliente',0,'null','null','null'),('buscarProducto',0,'null','null','null'),('buscarUsuario',0,'null','null','null'),('eliminarCliente',0,'null','null','null'),('eliminarProducto',0,'null','null','null'),('eliminarUsuario',0,'null','null','null'),('imprimirStock',0,'null','null','null'),('imprimirVenta',0,'null','null','null'),('moverProducto',0,'null','null','null'),('registraProducto',0,'null','null','null'),('registrarCliente',0,'null','null','null'),('registrarUsuario',0,'null','null','null'),('registrarVenta',0,'null','null','null'),('vendedor',2,'Rol vendedor encargado de administra clientes, imprimir documento de ventas y ver stock','null','null'),('vender',1,'Tarea Principal de un vendedor','null','null'),('verStock',0,'null','null','null');

/*Table structure for table `gv_authitemchild` */

DROP TABLE IF EXISTS `gv_authitemchild`;

CREATE TABLE `gv_authitemchild` (
  `padre` varchar(64) NOT NULL,
  `hijo` varchar(64) NOT NULL,
  PRIMARY KEY (`padre`,`hijo`),
  KEY `hijo` (`hijo`),
  CONSTRAINT `gv_authitemchild_ibfk_1` FOREIGN KEY (`padre`) REFERENCES `gv_authitem` (`nombre`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `gv_authitemchild_ibfk_2` FOREIGN KEY (`hijo`) REFERENCES `gv_authitem` (`nombre`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `gv_authitemchild` */

insert  into `gv_authitemchild`(`padre`,`hijo`) values ('vender','actualizarCliente'),('almacenar','actualizarProducto'),('almacenar','actualizarStock'),('administrar','actualizarUsuario'),('administrador','administrar'),('almacenero','almacenar'),('administrar','almacenero'),('vender','buscarCliente'),('almacenar','buscarProducto'),('vender','buscarProducto'),('administrar','buscarUsuario'),('vender','eliminarCliente'),('almacenar','eliminarProducto'),('administrar','eliminarUsuario'),('almacenar','imprimirStock'),('vender','imprimirVenta'),('almacenar','moverProducto'),('almacenar','registraProducto'),('vender','registrarCliente'),('administrar','registrarUsuario'),('vender','registrarVenta'),('administrar','vendedor'),('vendedor','vender'),('vender','verStock');

/*Table structure for table `gv_bitacora` */

DROP TABLE IF EXISTS `gv_bitacora`;

CREATE TABLE `gv_bitacora` (
  `idbitacora` bigint(20) NOT NULL AUTO_INCREMENT,
  `idusuario` int(11) NOT NULL,
  `OS` varchar(80) DEFAULT NULL,
  `arquitectura` varchar(80) DEFAULT NULL,
  `verssion` varchar(50) DEFAULT NULL,
  `nomCuenta` varchar(200) DEFAULT NULL COMMENT 'nombre de usuaio en el sistema operativo',
  `ultima_actividad` bigint(20) NOT NULL,
  `fecha_actividad` bigint(20) NOT NULL,
  PRIMARY KEY (`idbitacora`)
) ENGINE=InnoDB AUTO_INCREMENT=486 DEFAULT CHARSET=utf8;

/*Data for the table `gv_bitacora` */

insert  into `gv_bitacora`(`idbitacora`,`idusuario`,`OS`,`arquitectura`,`verssion`,`nomCuenta`,`ultima_actividad`,`fecha_actividad`) values (1,11,NULL,NULL,NULL,NULL,1352933151374,1352933151374),(2,11,NULL,NULL,NULL,NULL,1352933171108,1352933151374),(3,11,NULL,NULL,NULL,NULL,1352933247551,1352933151374),(4,11,NULL,NULL,NULL,NULL,1352933151374,1352933385979),(5,11,NULL,NULL,NULL,NULL,1352933151374,1352933403050),(6,11,NULL,NULL,NULL,NULL,1352933151374,1352933433840),(7,11,NULL,NULL,NULL,NULL,1352933433840,1352933502375),(8,11,NULL,NULL,NULL,NULL,1352933502375,1352933517776),(9,27,'Windows XP','x86','5.1','Ferz',1359757843609,1359757843609),(10,28,'Windows XP','x86','5.1','Ferz',1364848892328,1364848892328),(11,29,'Windows XP','x86','5.1','Ferz',1364914563421,1364914563421),(12,35,'Windows XP','x86','5.1','Ferz',1364916343125,1364916343125),(13,27,'Windows XP','x86','5.1','Ferz',1359757843609,1364923489609),(14,27,'Windows XP','x86','5.1','Ferz',1364923489609,1364923568406),(15,27,'Windows XP','x86','5.1','Ferz',1364923568406,1364923626453),(16,27,'Windows XP','x86','5.1','Ferz',1364923626453,1364924119140),(17,27,'Windows XP','x86','5.1','Ferz',1364924119140,1364931152828),(18,27,'Windows XP','x86','5.1','Ferz',1364931152828,1364931300890),(19,27,'Windows XP','x86','5.1','Ferz',1364931300890,1364931387203),(20,27,'Windows XP','x86','5.1','Ferz',1364931387203,1364931944390),(21,27,'Windows XP','x86','5.1','Ferz',1364931944390,1364931993453),(22,27,'Windows XP','x86','5.1','Ferz',1364931993453,1364932366000),(23,27,'Windows XP','x86','5.1','Ferz',1364932366000,1364932468671),(24,27,'Windows XP','x86','5.1','Ferz',1364932468671,1364933879187),(25,27,'Windows XP','x86','5.1','Ferz',1364933879187,1364933945000),(26,27,'Windows XP','x86','5.1','Ferz',1364933945000,1364935563421),(27,27,'Windows XP','x86','5.1','Ferz',1364935563421,1364935944125),(28,27,'Windows XP','x86','5.1','Ferz',1364935944125,1364936034296),(29,27,'Windows XP','x86','5.1','Ferz',1364936034296,1364936100359),(30,27,'Windows XP','x86','5.1','Ferz',1364936100359,1364936425968),(31,27,'Windows XP','x86','5.1','Ferz',1364936425968,1364936509890),(32,27,'Windows XP','x86','5.1','Ferz',1364936509890,1364936584515),(33,27,'Windows XP','x86','5.1','Ferz',1364936584515,1364936612546),(34,27,'Windows XP','x86','5.1','Ferz',1364936612546,1364936677796),(35,27,'Windows XP','x86','5.1','Ferz',1364936677796,1364936761031),(36,27,'Windows XP','x86','5.1','Ferz',1364936761031,1364938645734),(37,27,'Windows XP','x86','5.1','Ferz',1364938645734,1364938715437),(38,27,'Windows XP','x86','5.1','Ferz',1364938715437,1364940649343),(39,27,'Windows XP','x86','5.1','Ferz',1364940649343,1364940795765),(40,27,'Windows XP','x86','5.1','Ferz',1364940795765,1364941219500),(41,27,'Windows XP','x86','5.1','Ferz',1364941219500,1364941493484),(42,27,'Windows XP','x86','5.1','Ferz',1364941493484,1364941599921),(43,27,'Windows XP','x86','5.1','Ferz',1364941599921,1364941854656),(44,27,'Windows XP','x86','5.1','Ferz',1364941854656,1364942022593),(45,27,'Windows XP','x86','5.1','Ferz',1364942022593,1365102220484),(46,27,'Windows XP','x86','5.1','Ferz',1365102220484,1365102666953),(47,27,'Windows XP','x86','5.1','Ferz',1365102666953,1365102971734),(48,27,'Windows XP','x86','5.1','Ferz',1365102971734,1365103618281),(49,27,'Windows XP','x86','5.1','Ferz',1365103618281,1365103787828),(50,27,'Windows XP','x86','5.1','Ferz',1365103787828,1365103878937),(51,27,'Windows XP','x86','5.1','Ferz',1365103878937,1365104301890),(52,27,'Windows XP','x86','5.1','Ferz',1365104301890,1365104367593),(53,27,'Windows XP','x86','5.1','Ferz',1365104367593,1365105051031),(54,27,'Windows XP','x86','5.1','Ferz',1365105051031,1365105309359),(55,27,'Windows XP','x86','5.1','Ferz',1365105309359,1365105418750),(56,27,'Windows XP','x86','5.1','Ferz',1365105418750,1365105879421),(57,27,'Windows XP','x86','5.1','Ferz',1365105879421,1365106240328),(58,27,'Windows XP','x86','5.1','Ferz',1365106240328,1365106700890),(59,27,'Windows XP','x86','5.1','Ferz',1365106700890,1365106956687),(60,27,'Windows XP','x86','5.1','Ferz',1365106956687,1365107226312),(61,27,'Windows XP','x86','5.1','Ferz',1365107226312,1365107283125),(62,27,'Windows XP','x86','5.1','Ferz',1365107283125,1365107337250),(63,27,'Windows XP','x86','5.1','Ferz',1365107337250,1365107398765),(64,27,'Windows XP','x86','5.1','Ferz',1365107398765,1365107466703),(65,27,'Windows XP','x86','5.1','Ferz',1365107466703,1365107570734),(66,27,'Windows XP','x86','5.1','Ferz',1365107570734,1365107613578),(67,27,'Windows XP','x86','5.1','Ferz',1365107613578,1365110691515),(68,27,'Windows XP','x86','5.1','Ferz',1365110691515,1365111423546),(69,27,'Windows XP','x86','5.1','Ferz',1365111423546,1365111561046),(70,27,'Windows XP','x86','5.1','Ferz',1365111561046,1365111693906),(71,27,'Windows XP','x86','5.1','Ferz',1365111693906,1365112154718),(72,27,'Windows XP','x86','5.1','Ferz',1365112154718,1365112431062),(73,27,'Windows XP','x86','5.1','Ferz',1365112431062,1365112538593),(74,27,'Windows XP','x86','5.1','Ferz',1365112538593,1365113278125),(75,27,'Windows XP','x86','5.1','Ferz',1365113278125,1365113538968),(76,27,'Windows XP','x86','5.1','Ferz',1365113538968,1365114575906),(77,27,'Windows XP','x86','5.1','Ferz',1365114575906,1365114722828),(78,27,'Windows XP','x86','5.1','Ferz',1365114722828,1365115149984),(79,27,'Windows XP','x86','5.1','Ferz',1365115149984,1365115423812),(80,27,'Windows XP','x86','5.1','Ferz',1365115423812,1365116239156),(81,27,'Windows XP','x86','5.1','Ferz',1365116239156,1365116369531),(82,27,'Windows XP','x86','5.1','Ferz',1365116369531,1365117011921),(83,27,'Windows XP','x86','5.1','Ferz',1365117011921,1365117265468),(84,27,'Windows XP','x86','5.1','Ferz',1365117265468,1365117622125),(85,27,'Windows XP','x86','5.1','Ferz',1365117622125,1365117721921),(86,27,'Windows XP','x86','5.1','Ferz',1365117721921,1365118572765),(87,27,'Windows XP','x86','5.1','Ferz',1365118572765,1365118811406),(88,27,'Windows XP','x86','5.1','Ferz',1365118811406,1365119053359),(89,27,'Windows XP','x86','5.1','Ferz',1365119053359,1365119399484),(90,27,'Windows XP','x86','5.1','Ferz',1365119399484,1365119455078),(91,27,'Windows XP','x86','5.1','Ferz',1365119455078,1365119526421),(92,27,'Windows XP','x86','5.1','Ferz',1365119526421,1365120110484),(93,27,'Windows XP','x86','5.1','Ferz',1365120110484,1365120355046),(94,27,'Windows XP','x86','5.1','Ferz',1365120355046,1365120517750),(95,27,'Windows XP','x86','5.1','Ferz',1365120517750,1365120616515),(96,27,'Windows XP','x86','5.1','Ferz',1365120616515,1365120807125),(97,27,'Windows XP','x86','5.1','Ferz',1365120807125,1365120927531),(98,27,'Windows XP','x86','5.1','Ferz',1365120927531,1365121462531),(99,27,'Windows XP','x86','5.1','Ferz',1365121462531,1365121635906),(100,27,'Windows XP','x86','5.1','Ferz',1365121635906,1365121794734),(101,27,'Windows XP','x86','5.1','Ferz',1365121794734,1365129336750),(102,27,'Windows XP','x86','5.1','Ferz',1365129336750,1365129444343),(103,27,'Windows XP','x86','5.1','Ferz',1365129444343,1365129926578),(104,27,'Windows XP','x86','5.1','Ferz',1365129926578,1365130072890),(105,27,'Windows XP','x86','5.1','Ferz',1365130072890,1365130190890),(106,27,'Windows XP','x86','5.1','Ferz',1365130190890,1365130568359),(107,27,'Windows XP','x86','5.1','Ferz',1365130568359,1365130886859),(108,27,'Windows XP','x86','5.1','Ferz',1365130886859,1365131291312),(109,27,'Windows XP','x86','5.1','Ferz',1365131291312,1365131703109),(110,27,'Windows XP','x86','5.1','Ferz',1365131703109,1365132433343),(111,27,'Windows XP','x86','5.1','Ferz',1365132433343,1365132820687),(112,27,'Windows XP','x86','5.1','Ferz',1365132820687,1365132910281),(113,27,'Windows XP','x86','5.1','Ferz',1365132910281,1365133288578),(114,27,'Windows XP','x86','5.1','Ferz',1365133288578,1365133373875),(115,27,'Windows XP','x86','5.1','Ferz',1365133373875,1365133523953),(116,27,'Windows XP','x86','5.1','Ferz',1365133523953,1365133643937),(117,27,'Windows XP','x86','5.1','Ferz',1365133643937,1365133681562),(118,27,'Windows XP','x86','5.1','Ferz',1365133681562,1365133751000),(119,27,'Windows XP','x86','5.1','Ferz',1365133751000,1365133886734),(120,27,'Windows XP','x86','5.1','Ferz',1365133886734,1365134097656),(121,27,'Windows XP','x86','5.1','Ferz',1365134097656,1365134165765),(122,27,'Windows XP','x86','5.1','Ferz',1365134165765,1365134314531),(123,27,'Windows XP','x86','5.1','Ferz',1365134314531,1365134714453),(124,27,'Windows XP','x86','5.1','Ferz',1365134714453,1365135002875),(125,27,'Windows XP','x86','5.1','Ferz',1365135002875,1365135170859),(126,27,'Windows XP','x86','5.1','Ferz',1365135170859,1365135204781),(127,27,'Windows XP','x86','5.1','Ferz',1365135204781,1365135402203),(128,27,'Windows XP','x86','5.1','Ferz',1365135402203,1365135594343),(129,27,'Windows XP','x86','5.1','Ferz',1365135594343,1365135868718),(130,27,'Windows XP','x86','5.1','Ferz',1365135868718,1365136353640),(131,27,'Windows XP','x86','5.1','Ferz',1365136353640,1365136552625),(132,27,'Windows XP','x86','5.1','Ferz',1365136552625,1365136618125),(133,27,'Windows XP','x86','5.1','Ferz',1365136618125,1365136710140),(134,27,'Windows XP','x86','5.1','Ferz',1365136710140,1365136840859),(135,27,'Windows XP','x86','5.1','Ferz',1365136840859,1365172291375),(136,27,'Windows XP','x86','5.1','Ferz',1365172291375,1365173220421),(137,27,'Windows XP','x86','5.1','Ferz',1365173220421,1365173419734),(138,27,'Windows XP','x86','5.1','Ferz',1365173419734,1365173719171),(139,27,'Windows XP','x86','5.1','Ferz',1365173719171,1365173857984),(140,27,'Windows XP','x86','5.1','Ferz',1365173857984,1365174827328),(141,27,'Windows XP','x86','5.1','Ferz',1365174827328,1365174998750),(142,27,'Windows XP','x86','5.1','Ferz',1365174998750,1365175144562),(143,27,'Windows XP','x86','5.1','Ferz',1365175144562,1365175475093),(144,27,'Windows XP','x86','5.1','Ferz',1365175475093,1365176048406),(145,27,'Windows XP','x86','5.1','Ferz',1365176048406,1365176168546),(146,27,'Windows XP','x86','5.1','Ferz',1365176168546,1365177366984),(147,27,'Windows XP','x86','5.1','Ferz',1365177366984,1365204950015),(148,27,'Windows XP','x86','5.1','Ferz',1365204950015,1365205306484),(149,27,'Windows XP','x86','5.1','Ferz',1365205306484,1365206043015),(150,27,'Windows XP','x86','5.1','Ferz',1365206043015,1365206268406),(151,27,'Windows XP','x86','5.1','Ferz',1365206268406,1365206612562),(152,27,'Windows XP','x86','5.1','Ferz',1365206612562,1365206826656),(153,27,'Windows XP','x86','5.1','Ferz',1365206826656,1365206976562),(154,27,'Windows XP','x86','5.1','Ferz',1365206976562,1365207042000),(155,27,'Windows XP','x86','5.1','Ferz',1365207042000,1365207512531),(156,27,'Windows XP','x86','5.1','Ferz',1365207512531,1365207546234),(157,27,'Windows XP','x86','5.1','Ferz',1365207546234,1365207664750),(158,27,'Windows XP','x86','5.1','Ferz',1365207664750,1365207801781),(159,27,'Windows XP','x86','5.1','Ferz',1365207801781,1365207996203),(160,27,'Windows XP','x86','5.1','Ferz',1365207996203,1365208210468),(161,27,'Windows XP','x86','5.1','Ferz',1365208210468,1365208484609),(162,27,'Windows XP','x86','5.1','Ferz',1365208484609,1365208577546),(163,27,'Windows XP','x86','5.1','Ferz',1365208577546,1365209593468),(164,27,'Windows XP','x86','5.1','Ferz',1365209593468,1365210555531),(165,27,'Windows XP','x86','5.1','Ferz',1365210555531,1365210608765),(166,27,'Windows XP','x86','5.1','Ferz',1365210608765,1365210746828),(167,27,'Windows XP','x86','5.1','Ferz',1365210746828,1365210792015),(168,27,'Windows XP','x86','5.1','Ferz',1365210792015,1365210885343),(169,27,'Windows XP','x86','5.1','Ferz',1365210885343,1365211028640),(170,27,'Windows XP','x86','5.1','Ferz',1365211028640,1365211131515),(171,27,'Windows XP','x86','5.1','Ferz',1365211131515,1365211179468),(172,27,'Windows XP','x86','5.1','Ferz',1365211179468,1365211556156),(173,27,'Windows XP','x86','5.1','Ferz',1365211556156,1365211846484),(174,27,'Windows XP','x86','5.1','Ferz',1365211846484,1365211926859),(175,27,'Windows XP','x86','5.1','Ferz',1365211926859,1365212034671),(176,27,'Windows XP','x86','5.1','Ferz',1365212034671,1365212114765),(177,27,'Windows XP','x86','5.1','Ferz',1365212114765,1365212356328),(178,27,'Windows XP','x86','5.1','Ferz',1365212356328,1365212577125),(179,27,'Windows XP','x86','5.1','Ferz',1365212577125,1365212698078),(180,27,'Windows XP','x86','5.1','Ferz',1365212698078,1365213114734),(181,27,'Windows XP','x86','5.1','Ferz',1365213114734,1365213556828),(182,27,'Windows XP','x86','5.1','Ferz',1365213556828,1365213693125),(183,27,'Windows XP','x86','5.1','Ferz',1365213693125,1365214007546),(184,27,'Windows XP','x86','5.1','Ferz',1365214007546,1365214098109),(185,27,'Windows XP','x86','5.1','Ferz',1365214098109,1365214338828),(186,27,'Windows XP','x86','5.1','Ferz',1365214338828,1365214919062),(187,27,'Windows XP','x86','5.1','Ferz',1365214919062,1365225427703),(188,27,'Windows XP','x86','5.1','Ferz',1365225427703,1365225959125),(189,27,'Windows XP','x86','5.1','Ferz',1365225959125,1365226289171),(190,27,'Windows XP','x86','5.1','Ferz',1365226289171,1365226809328),(191,27,'Windows XP','x86','5.1','Ferz',1365226809328,1365226947046),(192,27,'Windows XP','x86','5.1','Ferz',1365226947046,1365227088187),(193,27,'Windows XP','x86','5.1','Ferz',1365227088187,1365227317828),(194,27,'Windows XP','x86','5.1','Ferz',1365227317828,1365227541156),(195,27,'Windows XP','x86','5.1','Ferz',1365227541156,1365227767187),(196,27,'Windows XP','x86','5.1','Ferz',1365227767187,1365227863125),(197,27,'Windows XP','x86','5.1','Ferz',1365227863125,1365228099171),(198,27,'Windows XP','x86','5.1','Ferz',1365228099171,1365228300531),(199,27,'Windows XP','x86','5.1','Ferz',1365228300531,1365228411843),(200,27,'Windows XP','x86','5.1','Ferz',1365228411843,1365228526796),(201,27,'Windows XP','x86','5.1','Ferz',1365228526796,1365228673031),(202,27,'Windows XP','x86','5.1','Ferz',1365228673031,1365228771703),(203,27,'Windows XP','x86','5.1','Ferz',1365228771703,1365229410281),(204,27,'Windows XP','x86','5.1','Ferz',1365229410281,1365229577359),(205,27,'Windows XP','x86','5.1','Ferz',1365229577359,1365229768359),(206,27,'Windows XP','x86','5.1','Ferz',1365229768359,1365230356765),(207,27,'Windows XP','x86','5.1','Ferz',1365230356765,1365264268546),(208,27,'Windows XP','x86','5.1','Ferz',1365264268546,1365264717125),(209,27,'Windows XP','x86','5.1','Ferz',1365264717125,1365264779750),(210,27,'Windows XP','x86','5.1','Ferz',1365264779750,1365264852515),(211,27,'Windows XP','x86','5.1','Ferz',1365264852515,1365264967796),(212,27,'Windows XP','x86','5.1','Ferz',1365264967796,1365265172921),(213,27,'Windows XP','x86','5.1','Ferz',1365265172921,1365265233421),(214,27,'Windows XP','x86','5.1','Ferz',1365265233421,1365265348328),(215,27,'Windows XP','x86','5.1','Ferz',1365265348328,1365265837281),(216,27,'Windows XP','x86','5.1','Ferz',1365265837281,1365266207890),(217,27,'Windows XP','x86','5.1','Ferz',1365266207890,1365266320031),(218,27,'Windows XP','x86','5.1','Ferz',1365266320031,1365267316468),(219,27,'Windows XP','x86','5.1','Ferz',1365267316468,1365267564000),(220,27,'Windows XP','x86','5.1','Ferz',1365267564000,1365267848500),(221,27,'Windows XP','x86','5.1','Ferz',1365267848500,1365267984437),(222,27,'Windows XP','x86','5.1','Ferz',1365267984437,1365268264453),(223,27,'Windows XP','x86','5.1','Ferz',1365268264453,1365268368984),(224,27,'Windows XP','x86','5.1','Ferz',1365268368984,1365268536250),(225,27,'Windows XP','x86','5.1','Ferz',1365268536250,1365268660562),(226,27,'Windows XP','x86','5.1','Ferz',1365268660562,1365268700671),(227,27,'Windows XP','x86','5.1','Ferz',1365268700671,1365268887812),(228,27,'Windows XP','x86','5.1','Ferz',1365268887812,1365269329109),(229,27,'Windows XP','x86','5.1','Ferz',1365269329109,1365269494656),(230,27,'Windows XP','x86','5.1','Ferz',1365269494656,1365269597312),(231,27,'Windows XP','x86','5.1','Ferz',1365269597312,1365269798718),(232,27,'Windows XP','x86','5.1','Ferz',1365269798718,1365269880343),(233,27,'Windows XP','x86','5.1','Ferz',1365269880343,1365270102875),(234,27,'Windows XP','x86','5.1','Ferz',1365270102875,1365270641890),(235,27,'Windows XP','x86','5.1','Ferz',1365270641890,1365436345875),(236,27,'Windows XP','x86','5.1','Ferz',1365436345875,1365436772812),(237,27,'Windows XP','x86','5.1','Ferz',1365436772812,1365437048656),(238,27,'Windows XP','x86','5.1','Ferz',1365437048656,1365437138562),(239,27,'Windows XP','x86','5.1','Ferz',1365437138562,1365437227218),(240,27,'Windows XP','x86','5.1','Ferz',1365437227218,1365437357781),(241,27,'Windows XP','x86','5.1','Ferz',1365437357781,1365437606984),(242,27,'Windows XP','x86','5.1','Ferz',1365437606984,1365437775281),(243,27,'Windows XP','x86','5.1','Ferz',1365437775281,1365439371796),(244,27,'Windows XP','x86','5.1','Ferz',1365439371796,1365477950859),(245,27,'Windows XP','x86','5.1','Ferz',1365477950859,1365478052828),(246,27,'Windows XP','x86','5.1','Ferz',1365478052828,1365478756453),(247,27,'Windows XP','x86','5.1','Ferz',1365478756453,1365478831906),(248,27,'Windows XP','x86','5.1','Ferz',1365478831906,1365479686687),(249,27,'Windows XP','x86','5.1','Ferz',1365479686687,1365479874687),(250,27,'Windows XP','x86','5.1','Ferz',1365479874687,1365479950421),(251,27,'Windows XP','x86','5.1','Ferz',1365479950421,1365480029796),(252,27,'Windows XP','x86','5.1','Ferz',1365480029796,1365480128359),(253,27,'Windows XP','x86','5.1','Ferz',1365480128359,1365480214734),(254,27,'Windows XP','x86','5.1','Ferz',1365480214734,1365480335671),(255,27,'Windows XP','x86','5.1','Ferz',1365480335671,1365480581906),(256,27,'Windows XP','x86','5.1','Ferz',1365480581906,1365480863781),(257,27,'Windows XP','x86','5.1','Ferz',1365480863781,1365481017312),(258,27,'Windows XP','x86','5.1','Ferz',1365481017312,1365481290406),(259,27,'Windows XP','x86','5.1','Ferz',1365481290406,1365481384546),(260,27,'Windows XP','x86','5.1','Ferz',1365481384546,1365481479812),(261,27,'Windows XP','x86','5.1','Ferz',1365481479812,1365481543437),(262,27,'Windows XP','x86','5.1','Ferz',1365481543437,1365481706078),(263,27,'Windows XP','x86','5.1','Ferz',1365481706078,1365481761046),(264,27,'Windows XP','x86','5.1','Ferz',1365481761046,1365482139671),(265,27,'Windows XP','x86','5.1','Ferz',1365482139671,1365482346359),(266,27,'Windows XP','x86','5.1','Ferz',1365482346359,1365482471468),(267,27,'Windows XP','x86','5.1','Ferz',1365482471468,1365482817656),(268,27,'Windows XP','x86','5.1','Ferz',1365482817656,1365483047703),(269,27,'Windows XP','x86','5.1','Ferz',1365483047703,1365483293562),(270,27,'Windows XP','x86','5.1','Ferz',1365483293562,1365483437281),(271,27,'Windows XP','x86','5.1','Ferz',1365483437281,1365483572437),(272,27,'Windows XP','x86','5.1','Ferz',1365483572437,1365483690671),(273,27,'Windows XP','x86','5.1','Ferz',1365483690671,1365483969109),(274,27,'Windows XP','x86','5.1','Ferz',1365483969109,1365484061187),(275,27,'Windows XP','x86','5.1','Ferz',1365484061187,1365554814843),(276,27,'Windows XP','x86','5.1','Ferz',1365554814843,1365555616156),(277,27,'Windows XP','x86','5.1','Ferz',1365555616156,1365556081218),(278,27,'Windows XP','x86','5.1','Ferz',1365556081218,1365557002140),(279,27,'Windows XP','x86','5.1','Ferz',1365557002140,1365557058984),(280,27,'Windows XP','x86','5.1','Ferz',1365557058984,1365695403843),(281,27,'Windows XP','x86','5.1','Ferz',1365695403843,1365695855593),(282,27,'Windows XP','x86','5.1','Ferz',1365695855593,1365775939281),(283,27,'Windows XP','x86','5.1','Ferz',1365775939281,1365776100312),(284,27,'Windows XP','x86','5.1','Ferz',1365776100312,1365776307078),(285,27,'Windows XP','x86','5.1','Ferz',1365776307078,1365776518062),(286,27,'Windows XP','x86','5.1','Ferz',1365776518062,1365776573312),(287,27,'Windows XP','x86','5.1','Ferz',1365776573312,1365776766765),(288,27,'Windows XP','x86','5.1','Ferz',1365776766765,1365776808125),(289,27,'Windows XP','x86','5.1','Ferz',1365776808125,1365777029796),(290,27,'Windows XP','x86','5.1','Ferz',1365777029796,1365777222328),(291,27,'Windows XP','x86','5.1','Ferz',1365777222328,1365777682640),(292,27,'Windows XP','x86','5.1','Ferz',1365777682640,1366040641015),(293,27,'Windows XP','x86','5.1','Ferz',1366040641015,1366040980031),(294,27,'Windows XP','x86','5.1','Ferz',1366040980031,1366041100609),(295,27,'Windows XP','x86','5.1','Ferz',1366041100609,1366041264593),(296,27,'Windows XP','x86','5.1','Ferz',1366041264593,1366041950093),(297,27,'Windows XP','x86','5.1','Ferz',1366041950093,1366043619406),(298,27,'Windows XP','x86','5.1','Ferz',1366043619406,1366046048812),(299,27,'Windows XP','x86','5.1','Ferz',1366046048812,1366046281250),(300,27,'Windows 7','amd64','6.1','asumaretv',1366046281250,1392045958144),(301,27,'Windows 7','amd64','6.1','asumaretv',1392045958144,1392047859919),(302,27,'Windows 7','amd64','6.1','asumaretv',1392047859919,1392048729127),(303,27,'Windows 7','amd64','6.1','asumaretv',1392048729127,1394660678175),(304,27,'Windows 7','amd64','6.1','asumaretv',1394660678175,1394660997039),(305,27,'Windows 7','amd64','6.1','asumaretv',1394660997039,1397237433925),(306,27,'Windows 7','amd64','6.1','asumaretv',1397237433925,1397240780525),(307,27,'Windows 7','amd64','6.1','asumaretv',1397240780525,1397240934932),(308,27,'Windows 7','amd64','6.1','asumaretv',1397240934932,1397241536359),(309,27,'Windows 7','amd64','6.1','asumaretv',1397241536359,1397242354859),(310,27,'Windows 7','amd64','6.1','asumaretv',1397242354859,1397242422683),(311,27,'Windows 7','amd64','6.1','asumaretv',1397242422683,1397242451499),(312,27,'Windows 7','amd64','6.1','asumaretv',1397242451499,1397242957583),(313,27,'Windows 7','amd64','6.1','asumaretv',1397242957583,1397243248439),(314,27,'Windows 7','amd64','6.1','asumaretv',1397243248439,1397243450965),(315,27,'Windows 7','amd64','6.1','asumaretv',1397243450965,1397245706534),(316,27,'Windows 7','amd64','6.1','asumaretv',1397245706534,1397245808611),(317,27,'Windows 7','amd64','6.1','asumaretv',1397245808611,1397245954355),(318,27,'Windows 7','amd64','6.1','asumaretv',1397245954355,1397246320750),(319,27,'Windows 7','amd64','6.1','asumaretv',1397246320750,1397246581568),(320,27,'Windows 7','amd64','6.1','asumaretv',1397246581568,1397246872360),(321,27,'Windows 7','amd64','6.1','asumaretv',1397246872360,1397247534744),(322,27,'Windows 7','amd64','6.1','asumaretv',1397247534744,1397247657646),(323,27,'Windows 7','amd64','6.1','asumaretv',1397247657646,1397247973859),(324,27,'Windows 7','amd64','6.1','asumaretv',1397247973859,1397248616613),(325,27,'Windows 7','amd64','6.1','asumaretv',1397248616613,1397321975834),(326,27,'Windows 7','amd64','6.1','asumaretv',1397321975834,1397322096984),(327,27,'Windows 7','amd64','6.1','asumaretv',1397322096984,1397322652267),(328,27,'Windows 7','amd64','6.1','asumaretv',1397322652267,1397322993470),(329,27,'Windows 7','amd64','6.1','asumaretv',1397322993470,1397323044966),(330,27,'Windows 7','amd64','6.1','asumaretv',1397323044966,1397323115868),(331,27,'Windows 7','amd64','6.1','asumaretv',1397323115868,1397323330681),(332,27,'Windows 7','amd64','6.1','asumaretv',1397323330681,1397323502343),(333,27,'Windows 7','amd64','6.1','asumaretv',1397323502343,1397323512343),(334,27,'Windows 7','amd64','6.1','asumaretv',1397323512343,1397325899725),(335,27,'Windows 7','amd64','6.1','asumaretv',1397325899725,1397326015368),(336,27,'Windows 7','amd64','6.1','asumaretv',1397326015368,1397326083275),(337,27,'Windows 7','amd64','6.1','asumaretv',1397326083275,1397923794766),(338,27,'Windows 7','amd64','6.1','asumaretv',1397923794766,1397923861130),(339,27,'Windows 7','amd64','6.1','asumaretv',1397923861130,1397924057331),(340,27,'Windows 7','amd64','6.1','asumaretv',1397924057331,1397924380664),(341,27,'Windows 7','amd64','6.1','asumaretv',1397924380664,1397924625673),(342,27,'Windows 7','amd64','6.1','asumaretv',1397924625673,1397925387587),(343,27,'Windows 7','amd64','6.1','asumaretv',1397925387587,1398035459810),(344,27,'Windows 7','amd64','6.1','asumaretv',1398035459810,1398140524441),(345,27,'Windows 7','amd64','6.1','asumaretv',1398140524441,1398150651617),(346,27,'Windows 7','amd64','6.1','asumaretv',1398150651617,1398297993734),(347,27,'Windows 7','amd64','6.1','asumaretv',1398297993734,1398298372216),(348,27,'Windows 7','amd64','6.1','asumaretv',1398298372216,1398300336579),(349,27,'Windows 7','amd64','6.1','asumaretv',1398300336579,1398301066358),(350,27,'Windows 7','amd64','6.1','asumaretv',1398301066358,1398301132339),(351,27,'Windows 7','amd64','6.1','asumaretv',1398301132339,1398301299354),(352,27,'Windows 7','amd64','6.1','asumaretv',1398301299354,1398301520119),(353,27,'Windows 7','amd64','6.1','asumaretv',1398301520119,1398301676490),(354,27,'Windows 7','amd64','6.1','asumaretv',1398301676490,1398301801116),(355,27,'Windows 7','amd64','6.1','asumaretv',1398301801116,1398301886805),(356,27,'Windows 7','amd64','6.1','asumaretv',1398301886805,1398301923815),(357,27,'Windows 7','amd64','6.1','asumaretv',1398301923815,1398302463014),(358,27,'Windows 7','amd64','6.1','asumaretv',1398302463014,1398302587063),(359,27,'Windows 7','amd64','6.1','asumaretv',1398302587063,1398302736825),(360,27,'Windows 7','amd64','6.1','asumaretv',1398302736825,1398302974783),(361,27,'Windows 7','amd64','6.1','asumaretv',1398302974783,1398303213388),(362,27,'Windows 7','amd64','6.1','asumaretv',1398303213388,1398303301648),(363,27,'Windows 7','amd64','6.1','asumaretv',1398303301648,1398303370806),(364,27,'Windows 7','amd64','6.1','asumaretv',1398303370806,1398303425666),(365,27,'Windows 7','amd64','6.1','asumaretv',1398303425666,1398303724929),(366,27,'Windows 7','amd64','6.1','asumaretv',1398303724929,1398303819092),(367,27,'Windows 7','amd64','6.1','asumaretv',1398303819092,1398303927499),(368,27,'Windows 7','amd64','6.1','asumaretv',1398303927499,1398304093132),(369,27,'Windows 7','amd64','6.1','asumaretv',1398304093132,1398304435591),(370,27,'Windows 7','amd64','6.1','asumaretv',1398304435591,1398304469476),(371,27,'Windows 7','amd64','6.1','asumaretv',1398304469476,1398304960169),(372,27,'Windows 7','amd64','6.1','asumaretv',1398304960169,1398305036043),(373,27,'Windows 7','amd64','6.1','asumaretv',1398305036043,1398305159227),(374,27,'Windows 7','amd64','6.1','asumaretv',1398305159227,1398305285239),(375,27,'Windows 7','amd64','6.1','asumaretv',1398305285239,1398305346220),(376,27,'Windows 7','amd64','6.1','asumaretv',1398305346220,1398305474903),(377,27,'Windows 7','amd64','6.1','asumaretv',1398305474903,1398305825198),(378,27,'Windows 7','amd64','6.1','asumaretv',1398305825198,1398306052898),(379,27,'Windows 7','amd64','6.1','asumaretv',1398306052898,1398306118415),(380,27,'Windows 7','amd64','6.1','asumaretv',1398306118415,1398306375774),(381,27,'Windows 7','amd64','6.1','asumaretv',1398306375774,1398313295342),(382,27,'Windows 7','amd64','6.1','asumaretv',1398313295342,1398313537672),(383,27,'Windows 7','amd64','6.1','asumaretv',1398313537672,1398313594035),(384,27,'Windows 7','amd64','6.1','asumaretv',1398313594035,1398313715092),(385,27,'Windows 7','amd64','6.1','asumaretv',1398313715092,1398313814120),(386,27,'Windows 7','amd64','6.1','asumaretv',1398313814120,1398314162298),(387,27,'Windows 7','amd64','6.1','asumaretv',1398314162298,1398381239734),(388,27,'Windows 7','amd64','6.1','asumaretv',1398381239734,1398381720563),(389,27,'Windows 7','amd64','6.1','asumaretv',1398381720563,1398381804253),(390,27,'Windows 7','amd64','6.1','asumaretv',1398381804253,1398381931669),(391,27,'Windows 7','amd64','6.1','asumaretv',1398381931669,1398382152209),(392,27,'Windows 7','amd64','6.1','asumaretv',1398382152209,1398382199748),(393,27,'Windows 7','amd64','6.1','asumaretv',1398382199748,1398382598700),(394,27,'Windows 7','amd64','6.1','asumaretv',1398382598700,1398382677955),(395,27,'Windows 7','amd64','6.1','asumaretv',1398382677955,1398382959048),(396,27,'Windows 7','amd64','6.1','asumaretv',1398382959048,1398383082743),(397,27,'Windows 7','amd64','6.1','asumaretv',1398383082743,1398383166634),(398,27,'Windows 7','amd64','6.1','asumaretv',1398383166634,1398383623251),(399,27,'Windows 7','amd64','6.1','asumaretv',1398383623251,1398383675826),(400,27,'Windows 7','amd64','6.1','asumaretv',1398383675826,1398383798137),(401,27,'Windows 7','amd64','6.1','asumaretv',1398383798137,1398384000189),(402,27,'Windows 7','amd64','6.1','asumaretv',1398384000189,1398384188534),(403,27,'Windows 7','amd64','6.1','asumaretv',1398384188534,1398384239043),(404,27,'Windows 7','amd64','6.1','asumaretv',1398384239043,1398384330345),(405,27,'Windows 7','amd64','6.1','asumaretv',1398384330345,1398384393236),(406,27,'Windows 7','amd64','6.1','asumaretv',1398384393236,1398384451772),(407,27,'Windows 7','amd64','6.1','asumaretv',1398384451772,1398384726960),(408,27,'Windows 7','amd64','6.1','asumaretv',1398384726960,1398384859933),(409,27,'Windows 7','amd64','6.1','asumaretv',1398384859933,1398385016814),(410,27,'Windows 7','amd64','6.1','asumaretv',1398385016814,1398385141639),(411,27,'Windows 7','amd64','6.1','asumaretv',1398385141639,1398385226715),(412,27,'Windows 7','amd64','6.1','asumaretv',1398385226715,1398385346024),(413,27,'Windows 7','amd64','6.1','asumaretv',1398385346024,1398385447244),(414,27,'Windows 7','amd64','6.1','asumaretv',1398385447244,1398385540647),(415,27,'Windows 7','amd64','6.1','asumaretv',1398385540647,1398385768181),(416,27,'Windows 7','amd64','6.1','asumaretv',1398385768181,1398386289958),(417,27,'Windows 7','amd64','6.1','asumaretv',1398386289958,1398386620097),(418,27,'Windows 7','amd64','6.1','asumaretv',1398386620097,1398386800200),(419,27,'Windows 7','amd64','6.1','asumaretv',1398386800200,1398387590647),(420,27,'Windows 7','amd64','6.1','asumaretv',1398387590647,1398398669117),(421,27,'Windows 7','amd64','6.1','asumaretv',1398398669117,1398398782591),(422,27,'Windows 7','amd64','6.1','asumaretv',1398398782591,1398398943911),(423,27,'Windows 7','amd64','6.1','asumaretv',1398398943911,1398399097899),(424,27,'Windows 7','amd64','6.1','asumaretv',1398399097899,1398399581032),(425,27,'Windows 7','amd64','6.1','asumaretv',1398399581032,1398399663353),(426,27,'Windows 7','amd64','6.1','asumaretv',1398399663353,1398399765346),(427,27,'Windows 7','amd64','6.1','asumaretv',1398399765346,1398400227528),(428,27,'Windows 7','amd64','6.1','asumaretv',1398400227528,1398401262871),(429,27,'Windows 7','amd64','6.1','asumaretv',1398401262871,1398401337501),(430,27,'Windows 7','amd64','6.1','asumaretv',1398401337501,1398401438933),(431,27,'Windows 7','amd64','6.1','asumaretv',1398401438933,1398401482629),(432,27,'Windows 7','amd64','6.1','asumaretv',1398401482629,1398401746487),(433,27,'Windows 7','amd64','6.1','asumaretv',1398401746487,1398401912082),(434,27,'Windows 7','amd64','6.1','asumaretv',1398401912082,1398402118096),(435,27,'Windows 7','amd64','6.1','asumaretv',1398402118096,1398402216454),(436,27,'Windows 7','amd64','6.1','asumaretv',1398402216454,1398402928032),(437,27,'Windows 7','amd64','6.1','asumaretv',1398402928032,1398403012413),(438,27,'Windows 7','amd64','6.1','asumaretv',1398403012413,1398403063409),(439,27,'Windows 7','amd64','6.1','asumaretv',1398403063409,1398575149113),(440,27,'Windows 7','amd64','6.1','asumaretv',1398575149113,1398575448327),(441,27,'Windows 7','amd64','6.1','asumaretv',1398575448327,1398575535509),(442,27,'Windows 7','amd64','6.1','asumaretv',1398575535509,1398575726710),(443,27,'Windows 7','amd64','6.1','asumaretv',1398575726710,1398575884032),(444,27,'Windows 7','amd64','6.1','asumaretv',1398575884032,1398575894425),(445,27,'Windows 7','amd64','6.1','asumaretv',1398575894425,1398576448420),(446,27,'Windows 7','amd64','6.1','asumaretv',1398576448420,1398576491858),(447,27,'Windows 7','amd64','6.1','asumaretv',1398576491858,1398576597888),(448,27,'Windows 7','amd64','6.1','asumaretv',1398576597888,1398580491181),(449,27,'Windows 7','amd64','6.1','asumaretv',1398580491181,1398580510075),(450,27,'Windows 7','amd64','6.1','asumaretv',1398580510075,1398580547309),(451,27,'Windows 7','amd64','6.1','asumaretv',1398580547309,1398580672189),(452,27,'Windows 7','amd64','6.1','asumaretv',1398580672189,1398580981979),(453,27,'Windows 7','amd64','6.1','asumaretv',1398580981979,1398581047252),(454,27,'Windows 7','amd64','6.1','asumaretv',1398581047252,1398581193149),(455,27,'Windows 7','amd64','6.1','asumaretv',1398581193149,1398581263080),(456,27,'Windows 7','amd64','6.1','asumaretv',1398581263080,1398581599168),(457,27,'Windows 7','amd64','6.1','asumaretv',1398581599168,1398582146589),(458,27,'Windows 7','amd64','6.1','asumaretv',1398582146589,1398582333479),(459,27,'Windows 7','amd64','6.1','asumaretv',1398582333479,1398582524036),(460,27,'Windows 7','amd64','6.1','asumaretv',1398582524036,1398583412971),(461,27,'Windows 7','amd64','6.1','asumaretv',1398583412971,1398583552528),(462,27,'Windows 7','amd64','6.1','asumaretv',1398583552528,1398583622678),(463,27,'Windows 7','amd64','6.1','asumaretv',1398583622678,1398584286105),(464,27,'Windows 7','amd64','6.1','asumaretv',1398584286105,1398584563297),(465,27,'Windows 7','amd64','6.1','asumaretv',1398584563297,1398618506081),(466,27,'Windows 7','amd64','6.1','asumaretv',1398618506081,1398618864552),(467,27,'Windows 7','amd64','6.1','asumaretv',1398618864552,1398619058997),(468,27,'Windows 7','amd64','6.1','asumaretv',1398619058997,1398619365878),(469,27,'Windows 7','amd64','6.1','asumaretv',1398619365878,1398639368266),(470,27,'Windows 7','amd64','6.1','asumaretv',1398639368266,1398639569952),(471,27,'Windows 7','amd64','6.1','asumaretv',1398639569952,1398640568271),(472,27,'Windows 7','amd64','6.1','asumaretv',1398640568271,1398640807938),(473,27,'Windows 7','amd64','6.1','asumaretv',1398640807938,1398640967488),(474,27,'Windows 7','amd64','6.1','asumaretv',1398640967488,1398641443501),(475,27,'Windows 7','amd64','6.1','asumaretv',1398641443501,1398642179940),(476,27,'Windows 7','amd64','6.1','asumaretv',1398642179940,1398642257324),(477,27,'Windows 7','amd64','6.1','asumaretv',1398642257324,1398642874307),(478,27,'Windows 7','amd64','6.1','asumaretv',1398642874307,1398644420676),(479,27,'Windows 7','amd64','6.1','asumaretv',1398644420676,1398644591395),(480,27,'Windows 7','amd64','6.1','asumaretv',1398644591395,1398644639504),(481,27,'Windows 7','amd64','6.1','asumaretv',1398644639504,1398644712937),(482,27,'Windows 7','amd64','6.1','asumaretv',1398644712937,1398644791930),(483,27,'Windows 7','amd64','6.1','asumaretv',1398644791930,1398644895943),(484,27,'Windows 7','amd64','6.1','asumaretv',1398644895943,1398703928946),(485,27,'Windows 7','amd64','6.1','asumaretv',1398703928946,1398704692381);

/*Table structure for table `gv_clase` */

DROP TABLE IF EXISTS `gv_clase`;

CREATE TABLE `gv_clase` (
  `idclase` int(11) NOT NULL AUTO_INCREMENT,
  `nombre` varchar(125) NOT NULL,
  `activo` int(1) DEFAULT '1',
  PRIMARY KEY (`idclase`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

/*Data for the table `gv_clase` */

insert  into `gv_clase`(`idclase`,`nombre`,`activo`) values (1,'clase 1',1),(2,'sdfasdf',1);

/*Table structure for table `gv_cliente` */

DROP TABLE IF EXISTS `gv_cliente`;

CREATE TABLE `gv_cliente` (
  `idc` bigint(20) NOT NULL AUTO_INCREMENT,
  `ruc` varchar(35) DEFAULT NULL,
  `dni` varchar(30) DEFAULT NULL,
  `nombre` varchar(125) NOT NULL,
  `apellidos` varchar(125) NOT NULL,
  `tipo` enum('NATURAL','JURIDICA') DEFAULT NULL,
  `email` varchar(225) DEFAULT NULL,
  `telefono` varchar(15) DEFAULT NULL,
  `movil` varchar(15) DEFAULT NULL,
  `nextel` varchar(15) DEFAULT NULL,
  `fax` varchar(15) DEFAULT NULL,
  `sexo` enum('H','M') DEFAULT NULL,
  `fec_reg` bigint(20) NOT NULL,
  `activo` int(1) DEFAULT '1',
  PRIMARY KEY (`idc`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `gv_cliente` */

/*Table structure for table `gv_compra` */

DROP TABLE IF EXISTS `gv_compra`;

CREATE TABLE `gv_compra` (
  `idcompra` int(11) NOT NULL AUTO_INCREMENT,
  `tipodoc` enum('FACTURA','BOLETA','GUIA','NOTA DE PEDIDO','DUA') DEFAULT NULL,
  `numdoc` varchar(20) DEFAULT NULL,
  `idproveedor` int(11) DEFAULT NULL,
  `idusuario` int(11) DEFAULT NULL,
  `idmoneda` int(11) DEFAULT NULL,
  `estado` enum('CANCELADO','PENDIENTE') DEFAULT NULL,
  `numitems` int(11) DEFAULT NULL,
  `observaciones` text,
  `subtotal` double DEFAULT NULL,
  `igv` double DEFAULT NULL,
  `total` double DEFAULT NULL,
  `fecha` date DEFAULT NULL,
  `activo` int(1) DEFAULT '1',
  PRIMARY KEY (`idcompra`)
) ENGINE=InnoDB AUTO_INCREMENT=24 DEFAULT CHARSET=utf8;

/*Data for the table `gv_compra` */

insert  into `gv_compra`(`idcompra`,`tipodoc`,`numdoc`,`idproveedor`,`idusuario`,`idmoneda`,`estado`,`numitems`,`observaciones`,`subtotal`,`igv`,`total`,`fecha`,`activo`) values (16,'FACTURA','555588996',2,27,2,'CANCELADO',3,'fdfasdfasdf',271.1864406779661,18,320,'2014-04-19',1),(17,'FACTURA','55589654',3,27,2,'CANCELADO',4,'fdfasdfasdf',627.9152542372882,18,740.94,'2014-04-23',1),(18,'FACTURA','89762548',1,27,2,'CANCELADO',4,'fdfasdfasdf',1057.6271186440679,18,1248,'2014-04-23',1),(19,'FACTURA','55899663',3,27,2,'CANCELADO',4,'fdfasdfasdf',288.135593220339,18,340,'2014-04-23',1),(20,'FACTURA','99868885',2,27,2,'CANCELADO',1,'fdfasdfasdf',254.23728813559322,18,300,'2014-04-23',1),(21,'FACTURA','99986575',5,27,2,'CANCELADO',4,'fdfasdfasdf',251.67796610169492,18,296.98,'2014-04-24',1),(22,'FACTURA','8996587',7,27,2,'CANCELADO',3,'fdfasdfasdf',769.4915254237288,18,908,'2014-04-24',1),(23,'FACTURA','36698547',1,27,2,'CANCELADO',2,'fdfasdfasdf',701.6949152542372,18,828,'2014-04-24',1);

/*Table structure for table `gv_detallecompra` */

DROP TABLE IF EXISTS `gv_detallecompra`;

CREATE TABLE `gv_detallecompra` (
  `iddetallec` int(11) NOT NULL AUTO_INCREMENT,
  `idcompra` int(11) NOT NULL,
  `idproducto` int(11) NOT NULL,
  `cantidad` int(11) NOT NULL,
  `importe` double NOT NULL,
  `descuento` double DEFAULT NULL COMMENT 'porcentaje de descuento',
  `activo` int(1) DEFAULT '1',
  PRIMARY KEY (`iddetallec`)
) ENGINE=InnoDB AUTO_INCREMENT=55 DEFAULT CHARSET=utf8;

/*Data for the table `gv_detallecompra` */

insert  into `gv_detallecompra`(`iddetallec`,`idcompra`,`idproducto`,`cantidad`,`importe`,`descuento`,`activo`) values (19,12,24,1,50,0,1),(22,13,30,5,3790,0,1),(29,12,28,1,120,0,1),(30,16,31,2,200,0,1),(31,16,26,1,70,0,1),(32,16,24,1,50,0,1),(33,17,31,2,200,0,1),(34,17,24,2,100,0,1),(35,17,27,3,80.94,0,1),(36,17,28,3,360,0,1),(37,18,24,1,50,0,1),(38,18,26,2,140,0,1),(39,18,31,3,300,0,1),(40,18,30,1,758,0,1),(41,19,26,1,70,0,1),(42,19,24,1,50,0,1),(43,19,28,1,120,0,1),(44,19,31,1,100,0,1),(45,20,31,3,300,0,1),(46,21,31,1,100,0,1),(47,21,28,1,120,0,1),(48,21,27,1,26.98,0,1),(49,21,24,1,50,0,1),(50,22,30,1,758,0,1),(51,22,31,1,100,0,1),(52,22,24,1,50,0,1),(53,23,30,1,758,0,1),(54,23,26,1,70,0,1);

/*Table structure for table `gv_encargadoalmacen` */

DROP TABLE IF EXISTS `gv_encargadoalmacen`;

CREATE TABLE `gv_encargadoalmacen` (
  `idEA` int(11) NOT NULL AUTO_INCREMENT,
  `idusuario` int(11) NOT NULL,
  `idalmacen` int(11) NOT NULL,
  `tipocargo` enum('Lider','Empleado') NOT NULL,
  `activo` int(11) DEFAULT '1',
  PRIMARY KEY (`idEA`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

/*Data for the table `gv_encargadoalmacen` */

insert  into `gv_encargadoalmacen`(`idEA`,`idusuario`,`idalmacen`,`tipocargo`,`activo`) values (1,24,1,'Lider',1),(2,35,1,'Lider',1),(3,27,1,'Lider',1),(4,31,3,'Empleado',1);

/*Table structure for table `gv_kardex` */

DROP TABLE IF EXISTS `gv_kardex`;

CREATE TABLE `gv_kardex` (
  `idkardex` int(11) NOT NULL AUTO_INCREMENT,
  `idProductos` int(11) DEFAULT NULL,
  `fecha` date DEFAULT NULL,
  `documento` enum('APERTURA','VENTA','COMPRA','COMPRA_ACTUALIZACION','VENTA_ACTUALIZACION','PRODUCTO_ELIMINADO_COMPRA') DEFAULT NULL,
  `nro_documento` varchar(30) DEFAULT NULL,
  `entrada` int(11) DEFAULT NULL,
  `salida` int(11) DEFAULT NULL,
  `precio` decimal(11,2) DEFAULT NULL,
  `valor` decimal(11,2) DEFAULT NULL,
  `stock_actual` int(11) DEFAULT NULL,
  `valorTotal` decimal(11,2) DEFAULT NULL,
  `activo` int(1) DEFAULT '1',
  PRIMARY KEY (`idkardex`)
) ENGINE=InnoDB AUTO_INCREMENT=67 DEFAULT CHARSET=utf8;

/*Data for the table `gv_kardex` */

insert  into `gv_kardex`(`idkardex`,`idProductos`,`fecha`,`documento`,`nro_documento`,`entrada`,`salida`,`precio`,`valor`,`stock_actual`,`valorTotal`,`activo`) values (5,24,'2013-03-08','APERTURA','000000',50,0,0.00,0.00,0,0.00,1),(6,25,'2013-03-08','APERTURA','000000',80,0,0.00,0.00,0,0.00,1),(7,26,'2013-03-25','APERTURA','000000',20,0,0.00,0.00,0,0.00,1),(8,28,'2013-03-25','APERTURA','000000',70,0,0.00,0.00,0,0.00,1),(9,29,'2013-03-25','APERTURA','000000',10,NULL,NULL,NULL,NULL,NULL,1),(10,30,'2013-03-25','APERTURA','000000',40,0,0.00,0.00,0,0.00,1),(14,24,'2013-04-15','COMPRA','88859658',38,0,50.00,50.00,58,2900.00,1),(15,28,'2013-04-15','COMPRA','88859658',32,0,120.00,120.00,72,8640.00,1),(16,27,'2013-04-15','COMPRA','88859658',22,0,26.98,26.98,42,1133.16,1),(17,30,'2013-04-15','COMPRA','88859656',5,0,758.00,758.00,45,34110.00,1),(18,31,'2014-02-10','APERTURA','000000',0,NULL,NULL,NULL,NULL,NULL,1),(19,26,'2014-02-10','COMPRA','548575',2,0,70.00,70.00,23,1610.00,1),(20,31,'2014-02-10','COMPRA','548575',4,0,100.00,100.00,4,400.00,1),(21,31,'2014-03-12','COMPRA','889958',2,0,100.00,100.00,6,600.00,1),(22,24,'2014-03-12','COMPRA','889958',2,0,50.00,50.00,60,3000.00,1),(23,24,'2013-04-15','COMPRA_ACTUALIZACION','88859658',1,0,50.00,50.00,61,3050.00,1),(24,28,'2013-04-15','COMPRA_ACTUALIZACION','88859658',1,0,120.00,120.00,73,8760.00,1),(25,27,'2013-04-15','COMPRA_ACTUALIZACION','88859658',2,0,26.98,26.98,44,1187.12,1),(26,26,'2013-04-15','COMPRA_ACTUALIZACION','88859658',1,0,70.00,70.00,24,1680.00,1),(27,24,'2013-04-15','COMPRA_ACTUALIZACION','88859658',1,0,50.00,50.00,62,3100.00,1),(28,28,'2013-04-15','COMPRA_ACTUALIZACION','88859658',1,0,120.00,120.00,74,8880.00,1),(29,27,'2013-04-15','COMPRA_ACTUALIZACION','88859658',2,0,26.98,26.98,46,1241.08,1),(30,26,'2013-04-15','COMPRA_ACTUALIZACION','88859658',1,0,70.00,70.00,25,1750.00,1),(31,24,'2013-04-15','COMPRA_ACTUALIZACION','88859658',1,0,50.00,50.00,63,3150.00,1),(32,26,'2013-04-15','COMPRA_ACTUALIZACION','88859658',1,0,70.00,70.00,26,1820.00,1),(33,31,'2013-04-15','COMPRA_ACTUALIZACION','88859658',1,0,100.00,100.00,7,700.00,1),(34,28,'2013-04-15','COMPRA_ACTUALIZACION','88859658',1,0,120.00,120.00,75,9000.00,1),(35,31,'2014-04-12','PRODUCTO_ELIMINADO_COMPRA','88859658',1,0,100.00,100.00,6,600.00,1),(36,24,'2013-04-15','COMPRA_ACTUALIZACION','88859658',1,0,50.00,50.00,64,3200.00,1),(37,28,'2013-04-15','COMPRA_ACTUALIZACION','88859658',1,0,120.00,120.00,76,9120.00,1),(38,26,'2014-04-19','PRODUCTO_ELIMINADO_COMPRA','548575',2,0,70.00,70.00,24,1680.00,1),(39,31,'2014-04-19','PRODUCTO_ELIMINADO_COMPRA','548575',4,0,100.00,100.00,2,200.00,1),(40,31,'2014-04-19','COMPRA','555588996',2,0,100.00,100.00,4,400.00,1),(41,26,'2014-04-19','COMPRA','555588996',1,0,70.00,70.00,25,1750.00,1),(42,24,'2014-04-19','COMPRA','555588996',1,0,50.00,50.00,65,3250.00,1),(43,31,'2014-04-19','PRODUCTO_ELIMINADO_COMPRA','889958',2,0,100.00,100.00,2,200.00,1),(44,24,'2014-04-19','PRODUCTO_ELIMINADO_COMPRA','889958',2,0,50.00,50.00,63,3150.00,1),(45,31,'2014-04-23','COMPRA','55589654',2,0,100.00,100.00,4,400.00,1),(46,24,'2014-04-23','COMPRA','55589654',2,0,50.00,50.00,65,3250.00,1),(47,27,'2014-04-23','COMPRA','55589654',3,0,26.98,26.98,49,1322.02,1),(48,28,'2014-04-23','COMPRA','55589654',3,0,120.00,120.00,79,9480.00,1),(49,24,'2014-04-23','COMPRA','89762548',1,0,50.00,50.00,66,3300.00,1),(50,26,'2014-04-23','COMPRA','89762548',2,0,70.00,70.00,27,1890.00,1),(51,31,'2014-04-23','COMPRA','89762548',3,0,100.00,100.00,7,700.00,1),(52,30,'2014-04-23','COMPRA','89762548',1,0,758.00,758.00,46,34868.00,1),(53,26,'2014-04-23','COMPRA','55899663',1,0,70.00,70.00,28,1960.00,1),(54,24,'2014-04-23','COMPRA','55899663',1,0,50.00,50.00,67,3350.00,1),(55,28,'2014-04-23','COMPRA','55899663',1,0,120.00,120.00,80,9600.00,1),(56,31,'2014-04-23','COMPRA','55899663',1,0,100.00,100.00,8,800.00,1),(57,31,'2014-04-23','COMPRA','99868885',3,0,100.00,100.00,11,1100.00,1),(58,31,'2014-04-24','COMPRA','99986575',1,0,100.00,100.00,12,1200.00,1),(59,28,'2014-04-24','COMPRA','99986575',1,0,120.00,120.00,81,9720.00,1),(60,27,'2014-04-24','COMPRA','99986575',1,0,26.98,26.98,50,1349.00,1),(61,24,'2014-04-24','COMPRA','99986575',1,0,50.00,50.00,68,3400.00,1),(62,30,'2014-04-24','COMPRA','8996587',1,0,758.00,758.00,47,35626.00,1),(63,31,'2014-04-24','COMPRA','8996587',1,0,100.00,100.00,13,1300.00,1),(64,24,'2014-04-24','COMPRA','8996587',1,0,50.00,50.00,69,3450.00,1),(65,30,'2014-04-24','COMPRA','36698547',1,0,758.00,758.00,48,36384.00,1),(66,26,'2014-04-24','COMPRA','36698547',1,0,70.00,70.00,29,2030.00,1);

/*Table structure for table `gv_marca` */

DROP TABLE IF EXISTS `gv_marca`;

CREATE TABLE `gv_marca` (
  `idmarca` int(11) NOT NULL AUTO_INCREMENT,
  `nombre` varchar(125) NOT NULL,
  `activo` int(1) DEFAULT '1',
  PRIMARY KEY (`idmarca`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

/*Data for the table `gv_marca` */

insert  into `gv_marca`(`idmarca`,`nombre`,`activo`) values (1,'marca desconocida2',1);

/*Table structure for table `gv_modelo` */

DROP TABLE IF EXISTS `gv_modelo`;

CREATE TABLE `gv_modelo` (
  `idmodelo` int(11) NOT NULL AUTO_INCREMENT,
  `nombre` varchar(125) NOT NULL,
  `activo` int(1) DEFAULT '1',
  PRIMARY KEY (`idmodelo`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

/*Data for the table `gv_modelo` */

insert  into `gv_modelo`(`idmodelo`,`nombre`,`activo`) values (1,'Modelo1',0),(2,'Modelo2',1),(3,'modelo 387',0),(4,'modelo 4',1);

/*Table structure for table `gv_moneda` */

DROP TABLE IF EXISTS `gv_moneda`;

CREATE TABLE `gv_moneda` (
  `idm` int(3) NOT NULL AUTO_INCREMENT,
  `nombre` varchar(50) NOT NULL,
  `simbolo` varchar(3) NOT NULL,
  `activo` int(1) DEFAULT '1',
  `isdefault` int(1) DEFAULT '0',
  PRIMARY KEY (`idm`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

/*Data for the table `gv_moneda` */

insert  into `gv_moneda`(`idm`,`nombre`,`simbolo`,`activo`,`isdefault`) values (1,'Nuevo soles','S/.',1,0),(2,'Dolar','$',1,1),(3,'EUROS','E',1,0);

/*Table structure for table `gv_producto` */

DROP TABLE IF EXISTS `gv_producto`;

CREATE TABLE `gv_producto` (
  `idproducto` bigint(20) NOT NULL AUTO_INCREMENT,
  `cod_barras` varchar(50) NOT NULL,
  `codigo` varchar(50) NOT NULL,
  `cod_del_fabricante` varchar(30) DEFAULT NULL,
  `nombre` varchar(125) NOT NULL,
  `costo` decimal(10,3) NOT NULL,
  `precioalmayor` decimal(10,3) NOT NULL,
  `precioalmenor` decimal(10,3) NOT NULL,
  `utilidad` int(3) NOT NULL,
  `aplica_igv` tinyint(1) DEFAULT '1',
  `stock_min` int(11) NOT NULL,
  `tipo` enum('Producto Terminado','Componente','Insumo') NOT NULL,
  `idmoneda` int(11) NOT NULL,
  `imagen` longblob,
  `idclase` int(11) DEFAULT NULL,
  `idmarca` int(11) DEFAULT NULL,
  `idmodelo` int(11) DEFAULT NULL,
  `ubicacion` varchar(10) DEFAULT NULL,
  `unidad_principal` enum('CAJA','MILLAR','UNIDAD','CARTUCHO','PAQUETE') DEFAULT NULL,
  `peso` float DEFAULT '0',
  `activo` int(1) DEFAULT '1',
  PRIMARY KEY (`idproducto`)
) ENGINE=InnoDB AUTO_INCREMENT=32 DEFAULT CHARSET=utf8;

/*Data for the table `gv_producto` */

insert  into `gv_producto`(`idproducto`,`cod_barras`,`codigo`,`cod_del_fabricante`,`nombre`,`costo`,`precioalmayor`,`precioalmenor`,`utilidad`,`aplica_igv`,`stock_min`,`tipo`,`idmoneda`,`imagen`,`idclase`,`idmarca`,`idmodelo`,`ubicacion`,`unidad_principal`,`peso`,`activo`) values (24,'','99996655','','Producto dlsaks',50.000,0.000,65.000,0,1,0,'Producto Terminado',1,'\0JFIF\0\0\0\0\0\0\0C\0\0C\0+\"\"\0\0\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0}\0!1AQa\"q2#BR$3br	\n\Z%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0\0\0\0\0\0	\n\0\0\0w\0!1AQaq\"2B	#3Rbr\n$4%\Z&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0?\0LA1NmJ.ٮ.BEeD3,!F3\Z(4VkĊfm5˓\rͽaŬ:\"Nea+M4 N4y/4[K[oYcU󢺾Bnw S=!Vj|:@X-.⹞	݋g0,\ZK+R%\0J]\nVnթF\'SީBcNj{J*N|P^W?H`8FP+Rdof䣫MS\nj<ͭ][f5[m:kحl7ϛ6Xck-w{Ʊ_w,9zνu%\\ɨXa9\0O6dGZƟ\r4סݤiDrۈ#f-b{	(rHOK9Ρ;!f71ȑOQ4.\Z9#wh4bd:9MrQtgT6۴h*RhQQJIxznXt\\7UcQ1O8͵V)EIԞ2Z[U{ۻR7L.F)^9;t(Lbuk&5ݩkˋ˩bMӒ(IKh%ZhN(-u^[C$|`K7dhEkSUi\"2E-εGce,P#],m\'Ligw[CvV[{THf25^(9\n^&,ppНW+teRG)*iW)ǒz˙%UuY^Э^3=*)4Ӎ?q9ME\'~\\&K+E&^tՎ\'%m9-Ɲ=3mEVNբK)tNŮe}JVqè([Ȓ*,%+inMwrO̅١v`?٥F%Ey0Z}݄	-\'ehAiu&y-qx#)6ԣRxsQR4eJ1vVR$2xjUhPbp5P犩)VN	:rQN*_5ˋfNV8E&x`i7SyscuCO{iu-zSY ZmUkcXأ=B>QLY\\7%gHHh/!KwV1%ٵǞ8$1	Y xcic&)xwF:Uio5pG^j7[$1h<+/26qL&k>=el$*ⰵPJ$]:XXRWQR*r<*ͧ.Db׵U**JqSӝ\\UKFT5\Zj3Ji?{{/+Uxd\ZK*mX#P{9{	n3ʯ4palldym沐z!$e \"p`3bK\'nzti:Wnn&%kh/mlk,Z+HC\rҤ!u.s63,}m-Ålc\"{2Myy.<w>vF69֕L6\Z_h먼2Bk?}{\ra:J5Zt(4w*890ѧJH:^8䮢%.K]Fsi7vfYlZ.l-nӈӬf+wnm/%F7MzOw,7⼰a7>BY^2ƶaɝ3I{$)&s3ŧݙIެ6vJqju@F\"c	FaIT3Zy\\ZhdOٻ}\\EZ[L]K6x`-7hFU}z<E|.\ZtjWt乡\nP\n+ը[\Z6G\ZpV*tE)G(\niAYOH}5*IR(%{hP[<wv.b,m.Emn/{[K9on0}VfI^1=qKvLRy篣ꉦjvK6Im+[ٴM\r^IXFnq@wuo	\ZBI3kBƬ\05\'*p򭄭FqS>H;K%ȓkc\ZOFJ&Egl4\\շvYhG2^4]ΰ<Lƻ$h1\"#F٭<\"[{{wWr]Lк,8#f,:-L7xy	\r\Z/o:,L[%Geג^GU7j\r1弐/o$v4\nXt7I4-$aӉ&FW6n#.G&H*ԩ®RTB\nJrt\'Ms	({Fa%SJ\\{cNl,/Х\ZQ+Su̹6֮.)٫زlS]+_D4(\0fȢK[&KxH>17Hv.wwd,k$wn\"+x@ʷVEĭr!1);6is_]q}ZOwO,-۬ѩL./\\*<2T/5*]iZVp}P6wzS]شZ2-ų,Kތw<=\r,CN=UTXz|TŹSL5vj<,e<L%uUFڥƔiӕjr|n۪˭ks1lkt\rIR[Iku{n+W 8?.u]J1=ź/u!ϻD+%sK,\Z괵TaXW$̱XG1Ư6I4ݥȉ9hM&ѴK4q\nEmmEXR.d\rtьUkЫJz!I73N2+&ҏ$hRaBȩNUMiRҽ뻩a%Z#{q4+똜,sKLǯ[}JZyy.#6qK*]\"-٤y,Kih$g+`Ma!kYoOp_f&	m$f2ɶ`%c멢\0[L;;,RY#?Iˉ \\..hU*W5zєaneI)J5\\ԛjN2oueR:M%KN%(8JP\'5	F)ův.O%݁--Q-kwP,cb_R5_YjiSuiioo\\[[gHSN2-k2,V.j\Zwm<YbI&s$-W[RFH);W_O\\&3[ܗ*\'u9hm\\YnhuG(u#(ʕJ315*UUiSZuqUmee^okFNs´\"ф*Ӌ(F<nd=q-5^k\'KdSB\Z@w|hf?X/mJQNrC=յ0[(ZK[m	{Vn?_\\vk\rɴZͮ\"GO:E>c䪖tsᵷ-B+\\;-!w&XKkKdʶ>eQNRcwV+Ngu8UzMRΖ\rL֞\Z\nЄj5#	Jj:oP~ɾIrl*׶5ݼ!%ߩMM4RWA=[j}0fB=>xfX\\wrU0JK;+Ho.g6{)(ݥh`m\\9SU<ĳ[hԵ].u)g,jJȒEn3Ir\\J%a\"o*|/ae6,&rNiK:RRĨiY:T>+CNxMNt%%	rd>T;{FۄG\nw7%gk\Z@Y-gq|v|tij^Ku<KC3ylm9^_mDdZVfBTG\Zgo--bS<s{%یIqo`8]N]9 \ZF}]G:+Iwu{)$y>H7F	/_Vc\nUSʞ	hP);{H&-a*9F1Ν\nҝrUJIRT긫/u՗Co~HἽJ8!ìxcEs\"FI$r/|քcPyB[>KWVi5fc\nZ82o|FHDH5L_+B4y7* \\Vn5+94&n]nn;MHRosr&&P%KuiF:u*Tri)=a>Xr.5j#Ro^eeehB$\\|S{quR	5C.dYmeY#xʌ\"(MZ--7iqϴ$39\"D$,.wY\0XK,chY|DJZ4El|<DY?!8Z.wNYˬBC:ixNJdWKNteFsj&U\nܼ񃜫֌$Jgg΢U<<IF$F3j7GAn+N{M	f$I%^9$gy#RV7f%F%G\0QQ\r\ZxPӤ D6VS!,J_Qvmsvo`muo-9#1WK;t\0meΝkOo5K\"[cɑ#ͳQkEܓ]Kp&e8\"HӦ:uԙf\Z8X3m5V-І[%J4oIۺ}Krڒyn\0H&S:ȲJhBE5t{V\rPw{<qNy%OYf,$xLʭ|4L\\i0J9^R|\Z4TR+pRvV\'a.zcWxTrpm4Nm$[[5R:koe-,WW˳;baG$\r\n\"?oeD6HEIKȖ[5p^8%6k-ûK3EƁ}--;AnaD.ŁcI\ZInaFTAu+k6L>imkT+$ְO{1Y1Lyou2aR9)Fu1\n,CIF.q:UR%	^n|ӕVO_:thYqVtJ~Tڋ%1崵wZ^a`{)R)\ntwlxcSfRgTysHyooc2Ik/<w>>q1y3\'\rv[Z6ejie5ݪq\r팗ö$٤g{I4HjkioƷ~rMRd8H\n[@͕Wi!#үc&b#*u\n1ҧR88FTs8MS=p39\n9ZJ0HU.T%)9\\`Vvbc6SnC7ŃLIFll*|4uD<DqqçQmO\07	{jpCe,]<6Km~V[t3G!2<k{Ms\\sm$#I\"\ZoLNak,M,eԮKq\"F$Pk>uTpT(ӫYbQTjV:XUMTZs~petWCMIӄiΒU*>W+%V]7\'ֆ\n=#Jgkie=辉bBk$\"5ZڛbjGtȶmMKEאٵʒH#ʹ8UMk4ve{(j-FzAs,%aA-#4ܪJM<eu\0Gi1^J~1-E9&&]#xSzM\01XL\rj֧0u=Juk)SRoރcΝ\nUTXz󏴜Ӌ/g\Zhx_[pYصV\Z^Ϩwpq,L_r[9dz\ZD>D4KH.;bg\Z}IusH[[|j`.Z8kξ\\E<Iqftm[vT\nfOηR#kOe,,ZZW\nY^YY 76moylqde,}4>_꘺֩bpO8SMB*0(JM*:~[Ҕa7Vuzu*эmXV%-.(s(Yx${=H.YBGvKL7@-[;K\Zk!!d0[;^;(dXQۆYdMqw$\Zu5ڕ$%[{GX\0)(Ș&o.n-ZnPQ0}$FFBmxV`Mjc0Hz1:TOeʜ(ꩩF)Jk{_k\'ʣ⡈jƦjƬj:QN>)s3]Zng5mͮYCpC6\n,0ȗ[/J\'b^K4ˋ/m&k{{6P-Ħ;u+C<]$R#9Z5nVQCqotsa-Օ&A*Av]⶷1en9`H5O߹7ɨOkcI@#\r$Z?	t1>¥x)*Vy60qgJ4J|K8/vMz(SBjtBO	ISr\nR8{q^7\'DMT.y$am&!gYxioaH-D1Ƒ$^}|-<\"3sV7W:Ə{{k{{A#DJWmdܼQ\rJi\ZOn-;_<ѥ\"wah!޲4)\"#GX\\ԷNĖi0\\p4WWБ$4MqAc0W\\{xRQPUQZI.o:XO	W{Gx_>IЭ9[1iICR3n̵\Z:=Սk?6n\Z}wۀrunӲܔ@\"ws}]O}jmӥ7Ao#iͱ;f+)ǟG yi쒬L:vBa=ޝtJtX\"mMowpu{y#$Nmu<fĐCvV	vO$r4ouҔӍL/)J8.MZ85N5#VHu*6yC\r%+rB*5M*ROb98O{Yix/,sXE̳)7?hQG$L~[X(58%,du#uJ4Jy)V{wci/eT9lm6Y+cg$mZG q§s%RIk+\ZR:,:\n[Km;G)i&KG1$XrέJXz*qqս\Ze9q|<UJR?eQ(Zc:/jtUGR0V$a&ܯ_}qXhs,W7DvIZ(Z$kyV?.8xķL4F(R;]1\0R\ryWxt-#4n(CKnMjh\rD$ݖS\ZI\Z\\c4qX@YS\'5;Eӛ}]KE\"ʹ1vde\'f\n*dNt}ú~NH8îzPTOTfYbst1ʢiPXUU9O2:u\'G+J鵉a\ZmI8.,Hc21KGS[	+}.\rscc>{:3\\3\\E,n$J;ӬuƓ)#Ffm2t)<$NZkhbh=;utM2\rMg}Jiιx!rʬ\0H<eGVs\n5*t*<ҽYb0JZ4}TӌէZHq8/cg[B4fgQNc)ƛ59KܞSW[yEc[؛yzC\rմIlw2Ly%&113:>ch 	1GsO*AYCWt5]4څ$[GubFċ+UM}mRZ nhys3QR\nDb 8px*JӝCNxj28U*r¤Ӛp:PpQ7kyncƃ^/T^tڭRJTԡvJG)5+X\r$}\r\r9ZxohvUC9r8iY$jtl\'\r9#>:\"t+4WbMsm^I<IgyBDfDHf}k!SI.#1x!,1PHMƒ e澀\\Z0ZE<^fwBUFJ4%\n\n8jԝhFy}+N)\'\ZjN7;rTf?dy&Ƥhɻ4:0vWI嫋mRFKk([r-~<=gx5aYÇ	nimfak_K)~c{őojAo)h?`؂$,K[\'TWkL\ZZ5UO>ݖc\ZۗI_.\'2e\\QI=`KP(w{o(omI4#[oڥIӫl\"HeRQITsr*r+$z\nntV\ZZqT$-$8ykMꜛ0[Gs{=ͽʲK,weY&@!hA$z:,w;ɤ_K	K]CP@ wi6Ȓh66{[JSo(KFW\nM\"y3<[T\"Jl7\r˘hnLvoa,rf\ZT\n_/dA-m灣ʷUVF1j\n9T%wQӜU\nSvX⽾)Jq9U\\Pr8.[WR鉭纎Yٮ4g5de;Dr-DNQeI$h%b]kYbh$bsOpђb+6:KŻODh..]=ZKI,Z!giD(K<³\nK&\r[hXZCopjr-%N\0̥<%<ul)\rSJѾ&SrNҪJ3jN5=+F(s%9ʤEE:P	r3:Qmzh8}\'JiQ$k}wu:7-4n)<k54g{qH fH#@\0`qEk˄)/=$S_,R_TZ^_ӷ]N=[Ul\0]HKe$ݛ.\rVW\\;}Bxmu/Ymmjv--x\'m̄G[ܶ\ntNd\'*	Yr/%Ӿ{\Z[rŎ2J-9$:.%Hb(.\nyA<2\'q|iX.n[=6ңGWXY`=Ŭ&G\0}<=HUCAMl/:S:+ti~ZNn3U*a\ZJg\Ztь\'*\"J\Z^3iF2|9E?q1VͤgpKx5yY.m:VlR]ȶ\'Tqz=+@m麄xIg29$hQKu,k;<T2\n˧kRm.ͽ5^^u6H	[t$QE6\ZuoE-@^E|\0gIxw\r0\Z, ?\\MXӣQӆW1iVF)˞N7BqQsr93ӎpZ4dJԩCNrU.IFn.Pn\\ߊ拮1|E#[Ě(d]JlX#؂4;VFqyRpoIm~Ѻg$d<:Wot}峻\'1\\<#8!(pd%J&% zXjfarM$2\Zs#K;3K΅7s(\\7#p*xiXĔ-Yҩ^ybr\rbezae+і#1*WI1I%dxBѬc~ Hum.#:O1BhVEĖ}6ZV_ٰA{y[_{RCm	LCmZ,+$38jFKPwB೷sd67\rl-R(-.g.deMR[g1Eimn\rHE|&7Z!hYx-ǇmJuq)}fᅧ,&\"𰒜 Fs*W9+sX,jHUy>iҥJ*xGCH5$ڄ}|4dJt<{2\n=-Ӊd[).B[96	jZ=[[˝K>-.Yx좊	.\'JZȓ#\'H{]R\rHjotlmKi400yo:7A\Z*[\"ogkunp`^w.&&v!,.\n0F̿*W[\'B	*U(ΝS(SiŶZNVh\rb(*yjG\rQՍhέܥ9)V|\\=qj4{Ifuov7<7sĂT{K6,tiOJU&)5KX*\'yNOy>%ksvŚX!mr$*5F-myhmw NHSG-[ƓE5Y^Zi&$#A%«\nʭmthЖ\n2tʵYFT0^q+njb$\\u_k)խZb(U5FU%:\r/F.MV[iuK/#kɯcXHH0-+[XU^;#\r%,=f$7xmL\'-5;$kYd݈eJu+K;g,]lxᶚTse\Z夋G+*LcuԹ{	w[XRXۅ25ߚaKd&Y$}Ҟ3ԫ*ԥ:xi1GR7/;.zJpѣTnCT*M[퇕;)+TVy6u]vR[E{ӫ iZd&Lg\']t֍kpZ\r=WpDoXJȬ	$I.L\"\rB{${M.=T H@Go\",v̊_`=\\=Mht)CnHQa-//a0<*ةT\ZIhu!ݿiiVXfSҴ)%j1$FXU4T99=QIǑ4)eŎ2MVg3	k6QfasX4XpC3}Kkxm}܄MeZilf\ZVM,so)mi$H;`O$*bu[A\"n.ko5n5k[P)Vx.#x;[(\'ʳȖ7&Bl=.\ZIchU$SQ&j(ᒧzrPMoJ+>\\#WMh8\'\';U活}3N]N0Chl`Kkwhd,9YJiWV+hZ\\-JU#H$FYLv64ƅiqw4$Y.Z58$`e1g28/ufԼ=3fXKek{Wb\\RYBơ\"V`Y*Y}<cciN8Ӎe(R2qOتtҏ\"$iYp<Q)ruc?Ikʹ)^߸iou(,\'JFY/pna1G,=Hfـa碻Ox,Θ=(K(|\Zwi$Z%qI7Y5<Me\0DΑCڴr<ex ?h4+C(n뗰3Xei>[]i&	m巹Vw[=O̾id|ˆ9Tq9\"<9M᱒WJta)B4/RrTsju9SS9eo4:4ӫ79.iՄӔbSϖ2/٭C}4>VͩY,I}H\\7!\'KKN1/Yxz#h-ذxc\Z	[VI_ay$EBp~/murEqorSK4Z4YьB\\JX\"+̏.{9-/m{ab\";YO)Ln\ZiVR%.e汹f2(\n1*uatUb+BQW&+??͖2tJS:ʅHUVf]NPEiM`(uxlL63X	\0v7da+u+6t*imLc&fvHxT,a*]	\"ynU\"|$xT2\0#S>AůAamu$&m6P>\n]UϺq{$KM-miJ:t3	TQ9>XIe*ӌ*t0Tb%)ΤShF-Wej:\"x[,KQ*!$9$9LC\'wRXo4dX$ekkNGn\r\ZqIuid/j6˧+W#KHckH\'.#P6\",%vb\0O[^[(;4$͸Mh|PyVd7j\"\\%\nJjSwVpjqJU)%OaX,:,=4ÕN\\SRNTvVpo.dW7sHJ,D^I`\0`HǇoYҥ\Z}iq7̚4	F$,&IdKL>wQnbi.+\\¬l!^)LD	d>E.6խ1U%;f|\\<bI&	\n%AQ2Ml.6W^ZIF*8NδjB,\ZTy4n\Z+h֥I\'R4ӷ<mQnN\\sM$tNx<y^Zل=J]%ڴq2St?wZh\Zu߈<M=Fy4:e\"ki^{{S#+YK.Adۥ\"Zgg`\n>!I\"܏u%=>X{y1BHd/*Ivo*D9#,ܺ\'R8&J)ǕR<T%*.#^){NFg&:<~&4\'q69h]]ʗ6^tnO[\\H6J6_<$\"#K:gݮbh\"[{&Jg226ˈu{K_/͇{wb\rRR$?,Di0TX1_^[]sA/u>uKy3.h 魼_-^[aWཾ2t\ZUBhF:JrqPJIvey$yTxB\\oT7:4ZU%.77Ȕʋ\rFj6H@kwxmd&%e-BF-X\0mY\rL]WU,\';xn\"_ºu%Vv0p3\'u,wXe{.KWMBi$Zgf*f}ٵ5Q%o\rsj\\Y^G<p0$O6|3&*rN\r1uKF>Z\Z\"*F!)QsІ{NxS(8\nʤIN4(UЫ(mRsjlk=Ml/uiac\"ZIj]ItVȅ0Ko]I%Ԛ{yFt,<d`eRl2(n7F/c5n7_0*򵧳KinR_K[oM^ei-/\Z:i\'V,ZG7$[zHw:|]<71ih<Ȓ$h\naGR^aqZmmuqyososq,byʩM5瑹K硸vusn>ɚMO@4!s T{|їO4IOB*-V\nT^PF:\\_M\0~ve9L,UХVWIm{MWiygB@Qm{ŒIVgv\'tEsҬVqj:]֭iQbIFn-PF-mp=[[ZPIM$$RyoQl\\q<Ak~.l&dm )e$\r#v%*Vc}>:F89F0YԵ_~t&zhYΝXS[\ZZr|ukO<Q:V+E$[KTOť	\ZydoY%4XĐyX$\nj_^]Cqme!4\0Jk֑I$=AY^ix-4\"ꗖDm$F}HS!\'tu#կ5Qj\\i6dˏ1b6gP@/o$BPڬ<6/X\ZuE*%AJpu\'yRiMr;ӂjN9F4(D-2<A᛿:uؼ%|\"{]>EJ]-R(,\ZI4}MΝǤjvZ|d:ؚ^tC$<\Z\\<[\"d#wF-u=\'VP;moj\ZP&],c6l,FMKYŤV&(d2#@X@1:\\+VS8{RኩR5%ZT+TpN6%RIzyeSJ:t\n\\bGtci9YIIMkZ_E{y,I]SG,t$0!3<Gc\rbuʹZŒn\0f(WX&h<OȱN6z\\_ޤKX-Ȑ]䷙1,F$BcN~:5彄i.uq\"WvfĈUiY\ZEJ\r+F%|.gG	V**:2Njѝh<D/)FZbiTVF+aTwbe+]6I\'wopfGoa\ry:II%\nGh{]\'R=o#ӧ$o%HnJnvB 5EUgb[v^0ycwt$u7{%r\0)opRq.km29\n>ՒYgK<j%WfI3Q\0>ƞgӫ\rIb!W*N\'*5y$\nn2\"<>S_\'9ε?Tmӫ6Q\nr嶨}έ)[ۍK][ymKiou̒^%慾~NBxmIyxvن_q3%Z\"(9㷺$ueM{Qɬº[1H.ˤ2,230,ӻe(!_C-m/ua-%jduc$>\\;Exd	DW|ׂgx$p5a#7_\r哨US^\"kTu\\c5Z7hYg\\*zz*~ҟU\nNwg7xYv|\0	myx-m#\"1aC0Kc-fzMu+6)KUmkItFdx\'d{(#)!M{iMbO*D#o{4n\"\'n\nysX֖ךej7ڤk{9{%kIԶ;e,9x]l>.xIѠu\ncRUc*ptT\nV8B\'F84Nj<%R%)ʌe)9^-%\'y=Κ?khM4=2tQrd;f?<Nϯu\0E[wA3+Iyn.lmK<^JG]\'xdg此irDVBh;E;}se;w5ojK+V\"H&e5\"+\\ڼ|frjs,l6F\'VΕZSxڲϞ;*S:N4|X14}X{JJ#͇28Q樤ҋ|ɽ:\0MkⅣYVwp6EġL$O)!/s{n-ݝս9?!XeXfl\\Kiyo-laUz%V䑵+v\'K{|[C̭,R^ɾ#_9Լ=4IooA,QشB	U,E^&!w[+/#><󚙾4\Za()R+)T5%)NJ_^ZTkub^#ԧ(݊*vVi9kм5ff5&wwx-cK(-ᝥ-$\nLG$/RN&DӚ7Ɛʖ2CoqDfxF^GRBs5x-涐Y˧M\r1NKh<1S)^LE;3&7+i!g\\隭k{[U Q-B?Fd#@h @Q6\nSCʎh\ni8JJ\"N2툊ܥ%ln!OUgAN5NrNSs8Qq,I9ɶX\\^4/3\\khJǒϳ&igF,ؚօq|8nĲ!m-\npr6i@qim)>Zw$y^D9$Wz#2E<~<V&״{@-]tfDQ+:69o[*i1QRXzHuRQ7֯9EӍEJ	rNqQ*Riƾ%iUNԤ(Fj\\uGÞA5+˘nO&;~Ȱ[xd$U\rjzSچ#iЭfc>l]|\nfn/)[\\z]443$d-2.4	C۷X/[X72^^5,Pyp!R$Bۣc6\rt0\n*ZJ\n*qTiF7w]XļT%\n5/	B\\tS8rI]Yޣi	4PZ44S\Z9(	/19dI=0ZSd\ZiG3mo,k\ZJ#J]\0+\0GXxYS	cqa-P̞{,YOsp!C$TWS>&ҮHȒC\rRm	&9#	p\"h䝖+O:VF,/gk0F4Ta㇎jUN6xҒEs>^7t18\nXjB5IQZu!rB./~%ΉYaSCd{f(ma$kED8l[\\JIxbdI#]xWr9P+_а(kv3I*Z8?>h\ZfJ<\"$Ү̾K&~(BH;|!X!OG\"VWT#QZ.pjJ*QKYJN<-|\rN*Mb\\8FQnOKFN+Gs_ú\Z[I^%$k2u4ֱ<I-;Z7ڤ.C$wcA6ľh\"V\'-_&̀276\\WֲBoSC2r@q+1^[RC:{Q\Z\\-᷒+f\"K&&VNJuÚ-5V5j1rY{KU^iҔ3\nrT8Ӕ|Tsi\r騻sYy?hlu++H#czܵK4k)g&ݨ4c:Johzޢ}N-Pn.FKCdZ(&y~W|hۢ2[ĚWYMyAxg\"fh2qrvZkk{}yeqo缛PƛUv\n\0(ors2E<;UsdEE.J|R}76Spj}HS(bk/k\ZJ5eNӚΒZڒ-/h%$Y\Z1$ȷGL֭7q[$3\\l\Za5i\rhƁ[\0~ʾT~e?Vգg\\DGk2I<1KF-b-EtUV\'xnq$(<-vx#eyE_.\r8n:U0!Z4O	*?U|9<E9{H%AƟi]{Ez<X<=|]wFUiUܩ{8Щz+ʧ=ڊo|\Z+Ϋ0GLI\r/)m*5ʬČAFHZfc4Qr\"!UrXEDpӴ3؆{=zBjm\r\0;zObo-I$~E<߳K\\-i\Z AR@ MKGk;5s6iЫΌ{{a*YCc&z$?km[[ϙI;E4jFAߴ!Q	 @3J$S%-BbPE#C\n8VFP\nBܥ<KP\\bZjOafT*9խI\\\n>U)89\'ͣKQer0swY<ΡNPVV:.EβTe\\Pw®A,Wia̫i#k8#fHG	&agM4	WF$`i]]I/V1KYsӛ8A~KQ]9\\\\d䔗-5$\\\\1YC)6/jFqZP|i\Z5-:墱Ӯ/M%4w3ݹBYD̎z\rΫl514KXƁ.>m70\\V4uZx+/]] TI٭\n\0%bx%Y1!m2JNp<iYbct-fdc<DУYpB,qM̩UXVOʾN%BKaWV\Zsr%A\'*x\Z\nPG5¥*i:H˖*>X%IJm7dYkG>\Zn\"Ew<ұ8%c`%c\ZBmBGRu+{`Y/\r	i&tI!H$A\\Ii{[6[vKyin$i\r`\')Q]yk˻R_\Z-=v6}mLWo*s\nq&>~+\rNroVQZp1pSVjn(rӌh+VjԢ*17NnXyXPQ(-JVnO❲-݅E2$y	nCimqK$G\nG\Z*ܟ2Ҽ?76P[{jI-K	&s,NҤQ\",%W5+MM[+G++`Ts\rŽr&$y&W3}ug(\"hH]$	yDD*Fn0\0\nYbg^a)GK	FnRW*^MIE]ͧY\'	>>\r8UXՆR>iU|QSQoS>	xv*4E@oU3[\\H8UY.%e,kHN7;[]>g_ncE͕\ZIcHX<%	GODjPGo$`ltb-2ʷ-dKhʑ\\cqr؜}G+ogi2q -4)\ZE	,,/5Ju:rJK:>zE-m{)Ԏ.+t:SNI;Q7eR>k5_ۮ=]DAƱ\'61%3gZM#-LcAqn^&hQ-dwXa8\0RuhnFoǤ73Y GnuS\'fޣv	htA6bv[\r\\>[U#7e]([*tZܴ9RtKauaUU#:U[VyƝJJԛSQ⸵}>[DdUHu+,\Z;Wm)aB\ZH䫤sI4G¶P734ZFf]q&[kT`c+]F{T*17\nMa	F-Ӥ(-ƛF}nhRMoI{7pF\";C%HifQ:yn!4rFnV+{9F­Hӯ9b6swYbR0ѡƵ8bg\ZJ*JMI[^7M-s|𕌽;Z-؆c`#GiṾ-|E>מ\Zw5X?z	|ܲ$@	aX%׹Ťj:ķ4ٕ\'\'=P{ure,hUlz[k:ng~E+_,RC,%{%2! x$W*\Z_F?sS7\nju*Ε:pt:U%9{5	8֩W\r*);)9Nqkxevև\\]?F[eer.#1o0B*+I1\ZB^D]#l55Mj[촷(-gZ8KgZIq(Ybm<m]ϫk\ZOo&5!#dxkŸ Ʋ$̭<Rr>mj}vpڄӢ$pC<\"h%cVi%U1)L.-՜~yjukաrr|7(v6\\4(}c>GNiTVӴ9BPJVݳK+y4ZzBP5[K\"m\r07%rϙ[m4(k\r%Ŵ多95I\r\ZPv&1*C5F{czc\rJѬ,=nE\Z-Y<_sVQ6[bgٖ7Y$(WhB+|1XQƞQю\"4\'NSJS܃NM(tfQl\ZuΦ6\"2mJqrmUs%~nJ7JJj6j[sbukx-(-%ʋdsE)#,Qn6jFb5YW򭥸M6XT<M\0頰fo_K~VvCZT\n\Z\n.4\\ZZ_,s\ryj<қeQ,f	p蓄iՋ<x<6;L}J:8._cNծ>Zkۓ[yUN,8a*Ӈ4cz)ՌMGF|wZ&<AjoSiĶhH.o<$o潹\\I\0VBC_tM6xdUU2%fiʴ1G=6[`hbq(ŚQ˅ۗVaG`Zl^*#2@nDMM+eGa(io<%WU11+F)ƥd%\nT%hjiy*u[êxxIaNQU9(dי.${cnP|yiFjd8RKC\Zfts[xHt%2Kby6χe\0MYEΤZii6\'yn#w|<Q\0lekQ:յeA%2N\rO)`D(G-JPO\r\nPLE9MU57ʟ4g\ZjKj^Q%u8ݖU/ï˨K\'DVpIi;cib.\"2I#luiYԴ\r/Fy4{lMwf2yVCo)0x%ne*{{X.%M)ަ)g\r52%iHX\\([>pH̳Dz8qņeVUtTe[U{j4ܚ?SeWѩeF5ejTqv/.͐i^%mRmLideY,㉃Bm$#M	$)Nާ\\j:t7CH6\'HWU7ΐZF#B6@sB?k:tcc<jZE<%\ru\ZmDP%TObnG V3o$6E\"c$ML)WNXe\'z:1PZJ4\Z4c$VJ\\Pn<Ix)ХISsFT^&J0nWҧmc֗n\rMWUC,F4xI-(YAU\"zvFLڅw]K$v\nBA;qD-Կ*lmIk-fwOE2&\"y%E_\"5HϵUZ1Y:C=֗o<11n1;JYۀmncj\\q	S+zƃU,V1ZQN\rԧWe0nb#^\Zt΅*9(ɹ5{r^EbA.-+\ZYF	W2D]mmǓpivkymjHbxwI<ެ+x)ޥݓ^?jm6O{[{Q[Kv`m!2LQfs}2U-V+F^F_%cʩq*20|&\\4HER8MTsJ^;RTOݱ.\ZgNcNcF%%e(YM\ZN<xj/H]<NxsErOù~n8!.H#\'$\rB%Wo{\0&^_t>-ү-tmH>U6IvhTA#Dckle\\I#yLI4[}.ݯ% }hyB:eC#Rlt@^j,KK=:C$wA,	q!SGKgo#\Z	l]^ieY\',;p$i1@^bwN\ZP͇aNTKsJ^~XBJ1qrC0jq^5a3I:qVڔbCֽyys-Ż&SmdkkXG8mn\rsn.2ZZ5(bX(hdk0Y̎|pXţؤ\ZE+w\rjfGHbx䌵ɸI. rp0p^xk-rbKUAЬi&kXܫڒIJsVQRu,*U|edMB	uk,2c)ƌ)Rhu=aJwwrIOt>m\'YѼ+kkzMe%,\"cN\Z57V|~n4.d2bHWfmq2D\Z5YSJX#}A2KKb#I\"1Evp[G]&vfkCVIX,`rrPD#Xhb}zt%\Z0K^\nxs*4כV.REF;khJj;ү*s:pu*ʌcNQ<c~Uwv7\"y\"66w`C\'ڌ7t@ahxe#k4}3P_եi鵡D#8X#[FA*ҨB!, ԴNL^Y!n/6+C;IwNixD(f5h%TtdMoq%ױƭ*Ki$-i6o>Y݌1T8!V*8z,<k_ݫR49ǙGKZJ.;	UL&+4P^Z}pGRiZ)qu5Ho.t73,jѮeXC5adi+HKyZX$YcuUE|DAv4:]ƖmѢQr5^F41`C3ILۊ0KR}b;6+-\"iL%f1kop幙/\n\rR6QBuF4*=)8|TRVL*TsNVb\'ZqT]EQs)n3JQ抎mģksI%H)9%ͬRm-RCBA潨}jJ.21^xmh!%1\n̡X25K<r_jkR४C.mEؘ湖Ha\ny@qsxr}\Z=R=<S[<Q慠[i$7T䔴Dsyب#J<H)խ\nYУa7(GB2U#$~URJ2oԥ\\d:У)ה41Sjq|ʚm[ݡ0[-f{ۈ3X+2ZZ4xlnQ%]ŴvpL҉.e0NJf(,*2M+L?A]ٮڌiy0G5q([WXk1#3RcӐjCmk<^H/\Z).1DncJxЅ<&\\Qѡ*8H*N6R\\Ӕ+Wi*4o;i]|:+Ӝ9Wrۄ|䂊	:ORvRҮ\\Z^<owJE,\ZmHq+fO3{GڞtֺX[[,Mw=֠yeX`XԳ\\4j\0\'ם=?X^K=DagOOmR(ASuMi{KFA)%\"%Y{IeH8ͺ \r󘜷T<:Qap؎\\DJ^J~ЫV+ڝJn0\\$^o\ZESju)N)ƴ85*P~-eT$I+l{1㻂Mk#Vk{t1v%\0*^%]YnL7\ri\\o\\B\Z,R\ZK3:ޗ\0kg6d5[Yc6oEMp1:MK#L%#E/b\rFKfKiQSI\"f*O,1)@񧃘K?éGVԥ)Ʃt 8F9FRPIJPtr׍QUS:xY+SRSe\njQ喋Sė:sVҮtRg1cw- bP!cxV\ZKM[]\n]ś<F6o\n:D8[uΫ},R\\%ō˧3X hc<]dI45K(젷5soP\r&Y\"EHZ(ܙA,qA$\0hG2jԨІ3\n,$x	WPNISTcaBeFqpi9Ο/2Qv5RntŢ4>dSK~ctl-ȰkxL^&4yNTAu=$sHJEyA2;\\G;jZ\\d5ҵwmo%tS$.1wFdح>Jݮn_(h6o*Y\Z%%UE\'VmRƹF\ZEVhфyYNP!)I*VZscF]`B\Z%\"\\4&4ojvB$/\"25٘\"C+ƤƫX:.,z,q\\cNdX\r26$_dU3E5MFAE\'\0TXΜ$\r:r<0@a`o.M+Śύ-Hu8\nj7jk5ݬr^Gh%Ҭ&Ca|[6KWə0++`cb15OBMOXn4E9JTRRa~,%`eSmkYQ9%r猔:OWZ$G 1+R	\\j\'SkVermxmmRIB!%\\^\"eZs>ep*)kO,12tq&ldfķ\"C0UR*91ڹS#K7\ZkT9tjnhoF\"Im:[*8*Ҍ\nqe엿߻}vvi~Gnf,(7U1E+D\"Uc1\ZL>(mT[{{U٭o}o*Z}r#fI$HUALdk{yZX(JH)m;$wk:_-ntNqmŋ.`G\"5HU,[I\ng8ggK\rZ\rU(רVJr\'\ZrS\ngTqJX̾&\nT\nPqj\\[xov|-z}BmO\"[aL3K%G\"9xTY$Orѯ/Z+o[y,\\tX+DIW}365(ȌG$׫E,,N+%0y$[[o*U\ZSx2:bKPuW,*ܳMv<flÒG\nyHխ*\"*\\DiӪ^U$JQj4I7ߛffkT_G;s:\\\nj\\*	J>ﺤmϬZ,д̚9Wd\"]iPF8ɪK^9VivJ9(.X#\'NOwGM\"<RnQ\"\n(Y9\05[XHW\rap2+=n.7@y͏rȞ[r2l0Щ_:4eN\n0NpHFSjnջ?ʥJ0\ZNH09eVn+-OjZܳœa\rk {y`o0#Ōݢi !Ѵ^voJ-˼RNś|19_ߚZz|VHⵟUZ;*Y}\'US,\n=\nO&K?J,`X浒)wja\rKow[|$4.v>8eX:*XT0TjK\rZV?BTңM\\3Tn52=	8>*x%bhʼXN^NصV~qp9E=d,]S߈/ү#u+=t6Vhl-tm>ّYZ%c6obܨLk]^ZHkż\"Fa8>&L>ma|#kB\'ayw5ԑA,*C8wGE*+	^ŉ얱KoIxbd\ZbdnnXsUᬫSK	Z<Ƽ:)b\',%/o9J0I)7R9AE4}Ƶ,%l\\iRJk0N%KY4I|MI&Q,m7$\0B%2rvJW)[ҊGRi8<E|7\0V}G\0s7z]?.m~EvMOzfioI6$roonKJ.- 	$ f\\H1<?UӮ,OS9!3Ψ5O堙!y1$&f)&4lo`5S=ŴVѣA:+$s㘬Kӻ]Y:/kM}okXyb)]Dbe1]Nw2K弛Zq嶽~[Jia+baVUhq=T+e{F40*VE*RJ:rQII~2Imi|t95X61-ctpK%yBynfNoYhFŶ;\"6ݦ-̱sBR:ZǤxβbtɮ\'I1Eyirb^3^HgB}Jm\Z]MAYLVOm77/4,1=o))bkaJ:TqrVh)RJ2)}Jkdƕf3w<;pS8SyTn:E{Wi-_zwZ-k/-67!q+	9@3U\Zz[o\"l^^٥MFK܆SXmK(%	q#rյ]2=Q.-	Ze6<eg)KU0C]_ZjMu+X/M{aGrxli9H·e3`5;KZH)Ÿ(MЫUTF6ڭ^;1x*h\0[\'\nT*:[i%~h֙\rԡ6{Gp[y%İD%~uo6 ieoO\n]xKo4،Ng/y?2{]$ȑ\0Yk\Z౎ 97s?yˤ:*JCUR.5MNC\n&&d$Vkqu(.ʥԈ-]UVӻ]d tfYQa1E,Ez^ZQV\\,*{oe5UFt)VKԛ^eRGS8aЫxRiAӄƭY{vi)(˗X&EѣS[y-й(;K$	526m:y^iڥ0Ztm줅evhVLBܲPmxd~\"״]-b30Oi4CbK#3ezƏST/1,?fK!݄wP[i`GXZ,)\n.+Vy,:2ӣ˹Bg\ntԄ!R0rJr\\i>c1kb*R\ZtVKNuQSpK$\0.|7PWWl{uP!# y^(Ǜ1No赵v֗wjr%$V,I$\ryI#њeNmm]J$߬qʖ}4lFev&<Yw{Zgi8\0m:VnI[J^}-\\E\\^5԰Ա4%FLU)Tbֳ:EJ.I+xhCx1JiS!U$\"rPi(Qܺ\ZLzޭvdm{\rbG5G?;3̡¨%xm-j\ZZ雷\"C-c	\"n.\Z[qsGxn[]YKl]Nݬ/%kkKXrK\"ɱ]ӼE-kiiֶ\Z7Bbϑwy9Qd($^<-<l\\WJ4N:\r)_tW\'$쓗=vIΟ\'EFqrrm+U6yX/Ƥmg}]$=`HZOB<.$ӻ17gTPRZta1){ao4I$9x[>шKcK:rhE.,C-Js	+2L|@*>sM`Su_<!mFC<~E,39Y>hf49G:rZ|Kg,MIBNmB%NN	NQ}y5\nkJ*i\0ATj$9)F*97Z\'+#]\Z=&fOw{47\\CIu-\ZI4ٞ{\rߛ[μY41^\Z-^Hnb7W%33$Rƭ#5zռ\Z$k8di.%rY*%őZiqqks/>[oOwJvS܉-d83ʌLK\0Hq>/\Zy.\ZTZOoBuIӯ*tV\nt\ZvWᬣbiN$a<E%\n\\zxU:\\iǕ=#Am}+mOT1Kw{.=G-(\"3chbdI:)tk2ؗeWHFyPB87\Z($x>MbIԵYiт-ZK-I2X(K2*\ZiEgV)UtI[\'Mo%r܎i;d7pFckw<e+a`ƮЯ,m%8NJYQƣʽJ2哌◣O$`#lVG]ӝHa+4ESTdrPPb[N*qrP.in+E-(]I$m,.1/@	Sz,-4Kuykm%%eJ2P<w(wfUI&ֵF}cX˫dyMѳ\r#]]H;)&V\nm67_hu=2{[{p77E<Vn-^F[hy\0T%\ry[C<Рܯb+t滋>1\0f,^\"\ZR(iRbI*M8>hI}vh[ږ+6^4A<Ѭ<Q8rJʌE sRĚ[YXϢ4]<fd{O!sJ&[hL!BHi+_\rcwpҭ[<Wi#o\Z\"p#af2QѦoE-ZIwM|_*hЉn;vnb6<Dj|̲jFJS)JPq߱uKsUJU9oz.j·Y1PXxU-Y2RqJbiQk\rܳ.+qIncycI?u4zHe%XͶZhfڼmkqwr-V{xQI|Me\"xph\Z꺌z5ȑ}Y[=C4\\\\yl7:\Z-֥ţY6l--[ӢrIo#Jd3D:i`+գ:xs\Z\nf7ѩtTR9Es/NpWƞ#*q:ԩ9^\"߳`jvZ;_:~ jlPe!M~<pxwYƫ=充5V+hxG4eQyfH]1k%o:MI-죈YJLom\" N%#+1]iJ-DIGQ]<I\"\r^\Z9$²102#Q\ZKJ\"TEn\ZHMuG> )BN*Uq_ܥ	8&Q\\}l@}N{S,\0d[Y݌ro,p&Gy?HaG)Q%OI34C\"Gr`<9^˫hH`\rum4H~D9BEH\"|5|;j׺uܚ}ދ~r!3o-$.d癢8uH9E|N\ZX99VjABJ\\ʷ=:uIʭYr\nmߋ㉯ZE:xjRJ17\'g8\'IBѻWrvgj=^|;qѯ7.^x[1]}DcR#tχ:%lsrXj%Jd~Tk#ˉoO๧4䷼B\':d3#e(#y̱F?e_{&/LK\"65\n<erd?!	60Ø)b+9F=*sPF5*\\ԩ)NM>g9r8<>1ua)Qjv5jN\0^LKk\"[bXo%in`H4ǒ4DH]-H̲\0U|vYIu3gaHb·kE!]#xfYv;0RXamV[.=<%Cnd=i^$.Q,aDT1ǕeN-ŴS^Jn.EImq*a6H\0\rV:58(US]J1J˒*to>IʣR烓JmrƼЫ8)*Ѭ0IǖJO9:j7iI$sW]#jũXs,v pc)3SwJIy2$uY{bvI~$YW&=GMnul-Ey0Fl.!2Ѥ휞\r5\rRm*u3gzZLf+,4]]HZYʊ,Ee\\IcZOCb}ʝh.ibWXTIy:U$,i.)4PORXs%7Ѕ:vJ\n)TnOޕg[[$:Hby\"8vEgNr2qEmU_/-u\"6lU09U\\m\n]ǵX쮾_GhߢۧNglbݿsCUuo^#Ok^u\\6{MN74-\rY-/]ن6@cg.H猃;ᾴ̮^߲}vmH,r#$_ݯ}\0?k=Q_\\xoBռ!gok3U;k6EI.tqwå<h~Z78qnWx>HƁK_ūEhzjQL%е/CۆRL1R)00x\ZjPnj<DiT)QUrf,XH\Z\0YR5O>jU\Zb8F1gZC,\"EKaY⳽.R47\nQ%\rw+]ͲN}Ji1]hYIkٻmwe#ZZ7alnM5ٳP$2;Zd}K\\Gx\ZhxF@5K5{{IleO>^m[@-4\rkM*jյ\nsg$mIlF_\"{,O-Ȫ)ԔʵE|:匭({6t\'o{\'jK\rV8.KJ*mZg)e\'nŚhY=~wPӮž5CozuGGow4Qo\'e/Sj\Z-vp[_Y\\4=Dm!MRM͵y8{Enw/M>~x\0ƶ6PksK`^u֥gzvpm]L}H/xOS|7}{M@v\ZR94[.`Mvi:WfK{y`F\Z34RPp<T㊌%Vp>i)BUQJ\re0X)Ԇ>MQʬpq9S=muOO4mcCiZ&!k1TmdUSZՖbk`,n-+<K\n8~^!oijzfᛏj66v3\Zuj{yK˹xKNJo/ZVvSj7zsn\"d:\\)X\\çmuw$$FUigi猖\\Bsb9hƌ_՞\"-Nyj];~I\'氧XhUaJ\nsI%I׳lj|,.Jy-,\nL<sAu\"h.eDE]_,LrwxQ0}=vy,m|!x/q[:@@Ky\\N:Nf^wM}C5X>T.>yr\nJUXV,rI$/x]ӼGs`$0^O֭HԢMy*l?Gip%>.?q_m\Zt(Nm<M;8xW[aN^Q)^i(Fc݄c0xb*cC.ND{U	TMJK~rrֶGWsZrJhm,yYI|\rfx /W{\0-NR$&=apnWOiٯm/\0-?Ub?kqsk{w77ZXԵKD-[+W[H\'Яt	5_K?g,\rF[. D׼5:&=`lPG0E|:Pdո޶<F`0qL,߳RZta\n\ne:EYF![Q~L<6a\nα8AW:4B1ܡʜӋo	/-*k;Z[5Our-s\rd7f0m#B\"7;gJw&&I#?%%3d,RK4Sݝ?	/|^l|sO=53ǩNmk{m,jҤV<M\\[+g\0`!zG\"xĶV\0W4\\Oݾ4J6ӯk@+}itE\\U)1qz/%VqREJ2cgRR\\Rj)fSgWʎx<UybcIEUJ$gJ*HF)6k]]V\Zҵ۴Ku\r&<]&hHe\0xWt4>ѭ5gڄvbW-lEqk#![he`2¼Y\0O?Yf\0BAw^+=Bp:~oqj^\"$\r>bڕl-nmؿ߲MޡCc@^=2BA<W]NW[<r-\'LUk9|.N(xUROЧ\'E<$*qRTs5$׺{\nc)e?R[^rN(ГHIݔ_#&~ {MZHзKaFUI&\'[ku[+	iD*$w1KtAn~&D@:Oa4\\=#X*|W=\0=__,ETKյtzHkR>(-;Mlm?L%\0/=ZN_a_Y,[Q\':fj6ZrZ?\rh{jvPψ74ĺt+2\'G8BVTԖe\Z*Kr(IHXY,\'*{[TS8ק)\\qOjt6Ւ(l,\rȋP@ҋfmđ7̂U嵿j\'?hI+@+[lKm7S_[m\nO\"yo9Yecq?\0=5\rFPտAq.[Bg}PD\Zs[x,%⵿Я XEgc~:_~\ZLtzTv:u/?\rt2;k.fM^\rB\rHh\0m\n@xb2̻){SmNF4S%\ntrJ1Vm	ҥ*Ӎ\nTUJsVrIss7yjũҖ>ּHmQA}eZIȥ-GY-.lAo\rٹ1,,SE@&D2\0~Ƒ\\7|uM#UIuK$֗-pO5[[,ck3ө{Cp4kQZ#[8!.Ih-LRI$~H2,%wVXҏeYabν\\%e+K5u\nR8$rq~fYNcU&J|VcIӂU#ɨʢƝt!{?&oynךvʷHJufrXye*I\Z{k?t#o!m<bh%Enl,\rieQ&K;-^[i5bڭH\"Z1l94ʳP2ȱ2iKmW0JL}V[t!)!\"~o&G\"˱Jqug^߻)Tөʟ,(J?IRcpt<0S5:u#)Tnܑ7\'ݥN2/4;+:kQ팎fLy[42 Fѳ^ouIcy>d-WeK{bFj1ğ2DڝKh:`Z]~17S&ss<jI\n[<g,Zo6S[;K;=Xdњ8}Dw9X[xḞD\\Q9*ss?ӧJHկEOT\'\rc2I^.93JSe\nrqR6){Y8rM;NOG떚֦go-ⱚglsy4ҥąV7($9/A!EAIxAYf\\H^Gđ=ıq	xs#Ӽ+ߋ9${˻kY}hNigHJ][/W!$4-BlnJ&8D]έ՝k\"MKfYV_(TTҧNNjT`NwiSO1Yste0Wf$9B1VWI-.o<Ke8{c%o:$Z|\0ƤfXw-t;;m;Eӭ0As\Z]IlK},2M3;U]Ә*7y^s/ݳxKtk<JQ+3msj絽I_W.:44\rH_wy.-h2еH!OYb\"h<}W˫Щ^3hBurfh5g-/-PRJ\ZQF3Tg\'Ȧ][dZ;.7fh.Ilxm,dWrɵ+GƷsVn,\\M귭`ى#X.HIf0fL\"OV][p8a-m&h,Qm-NY6[iqZiֶӒ_4	#[}[ .X7CTx<Va\npSpSt)FV*qTe(oV8x<,)ԝZ*s8kJ\Z0ҤW*0$\Z\"E\r<Zqg]<UQHUl*pP^S6o1YOa<yboʶOjy\"AX^Wo,5WQxn]cRA.PAm+K}&%wey(ә᫿xofA%ʥ2C+V;h#H..|it?=jMĹז\Z;\nTTԩҞ,g=*ʜlRmWἒ2FFJ7S*W׽ڒq[Kh-tcܿCx.Ibsq[X5&XrE*ǵ\rM\Zu4Qnd@Fk<mLHG3j<ŠkkŬVZ麽,U,_&[ʱYt# _\Zd:ܶenv߼\r$r\ru$3/VsIU0T|CJ<UJ	P)BW,m5d/0\'	My6UI\ZQٹ^	k$i`citeT%X$	hZ\r7WPcnEq4rŮ#,ٙ,KIbNMR0q^-ɇ4X,ɤM&}l\0&ƾ\Zck;z\'SV^\0(4Q\ZB=#ܼZA.I\rZi|_CxkX|sIxSEog᛽.jZ@]^W^bte[iD⮣cJms&x[[	?9?\r%ѵ;//Nh\".XIl؟\'u[/çxyCm5O!Ӽ!jZ5ׇum\0S;>m$#\08K[ fWXӯ.&Ju\"(R\ZJ9e|K}RXx}Fԩ!NQ%^^xWS}~s^ډk\Z{hg][<M>\0ĥԭ.[_Ew\0-[͟t-վxoKv6iXhã/]\'K4WhB?#4mYxI	wC.ouɦͥJ\"|?\Zo=._i\ZGUSx~wxPm+RέO4UWԵ[OkvI|M6qjOlq]yRg8\\6cN*RʒΜ\'{V9UvQa<\"3JVJQRM˙[Td2SӼ#a{_\nj 7m5sOM{×\ZkMK\rNy҆q~Rz_6<gPx¶:~Riom5O\',4_M`UXJ5M{RԣŌ~wgY_xZ?X|= 濮hIuki763\\6{k}-\"u=fد_\n<OZ	i)h<+pRD :͠沞2o U\Z59V=GOp)7zG/NI\'O$5>I),=YfεWR8zS5KJqJQs޲V|C/>.?\r%Y\r\ny=G]KjE4{[Ky.z6l|wx>\0W4OƱ%:m\\i&}R^mg\\ְ\Z[|Au}\\jڷmK\Zn:,iz5Cuwq3ژtw?vvG.}^j>߈x-P--uW-mgBѡbiúIB3C1Q)V痽&|*7\"\Zqu*ECrÓwc(.J_u~&^thSXiuXx1-Ƈ7Nh4^E35߷_<;\r|IytY֥wJ\0rjږ4i:q5Iig}yaw>?YZ@vSwWoqw^eޥ:k5zMs;X~|bO|; Ӛ\Z:a{okM\n_IÖGonPFjX|e<Ej9.*YWZgda^QNt%G	S;t{/х*X<q4S(棄9$NM7Vt<GZO0WѴ{=[&KC3Awsk%-5O$S5MOB֗Sj#cCĺf-Z,6:nu{ˍNG7ZUw6zDVڅğ|7qm%|5aIt[SC;)&Pm*;u8h\'Otභ{O;M{\Z_XӴ?\Z&]xgG_Դ˭SOj}oV{Eq=PxT!\ZQ#NJ$3?kR4\nr*xJQ\Zr\"|d%ڄ0r(.X+P\\>,EWH;8-lɭ-}ms6i-ԷOlTx#A*]~~_t_\Z7|O^.(]P+w6w,rjZR-\"ѵk5K;Eږ_\0\n^\r\0[Uyzx\r2Ox]N.lu|;h(Յ:UXk1⍭,z!}(a%5F\Zkev% l[{ycK;^8jfeѩJYxZjj\Z\'%:坽˒`#\\^\"+N.<82Ime=ŶkW\ZlM6i Ӣ/s9_&쮵+\r_Oab]fVK\'̟\0d:-\0Fڼ߶H/DN,\0W\0V.m̳I}go$~5&8/u}N/O\\gqy_I463[#kqȚީ?ues#]}CZ޲%/eto,N:kWx{V6Z?bolY3mmjNQ\Zja%F_WʓU)E.IsNu9nW}1{xJ9A4)*zr8u++¯\'G/gkG|/OZ6!5]nUD:ZZYXX>[uSIC\\zvgmA`^e&Mާug>x^QTX.7{}?-5RZ͖m~?ؾiu;[KۈnM/ҭR˪6u%Ui?t/\rK񞡭Kq$r\ZuIw=V/DZ]vxTk籼m!*U)Փ*4F}y~b*Ғr`,JviBT)JrkJudJq>e=RC%͏m_]nuMGF)uhcΑ]_jK05{ļҾ\rS^6bcGNxDŞ\'5iR\'O7m?=b=rm7wiZtױZxCծ!Cq˩n|Ht˟i/^]mol4g[f\\YO[q[wZ7SKfޡmZk)t{o<A[ Zjz]KssCe/j9SYVn\'(Fkޛ|Qr&iiZ,LᇓrUaNPZVwmsC\0o|o<Wj㲷}x|֗\0k[!,OAaۘ%Ԓ]Y}|Eu|8{mKźhLoym1jO|-_Jխ1@\'$vOLxŚQnM?L4K[P82gҴXhIKIeԟ6:vhOC64]j=/ú^ahv6(-,-m,~cKZ\r>\r.F-eYOxFml#~teN&\Z)M{%(Q浲gB8yeʄ%g¥4O]MI-nOomKM[	u\nH5լFem54UK,bv]2]=Zٟͦ	_xOUEv:е}GHͺ;a8AR\rnR5{Q⯂\r$gþ_Z6?Yj\ZFu;o躎-5/yƯ[I5\ZPnn%	d\0\Zf.^MҼUtjLѬG^XX/O-Ρy=VQZOĸьIVnUi?giΔ/\'R*-,\r\ZN55U%)¬ڻn1M+E-_O?ڗ%7<+H\Z[}ө鱝;K}7F\rFY{55i\'/O{&Yۙ,|]b=1]IaYf\\]<Mo*㸶?OvO}xE~ӫIkXƊjd׬~fH\0-boSў[;31xTHPm#5,}F--;V)\'_[-Z=F10Ҥ[^HT:R)O:ӴbVg&;!Uu0\rO;YaJRW?\0\02>.|PբO6>JӮ-zn.impV}?~NMgMK<+yizDnִKuұoi7>![K5u[[ѵ/-\0^>Vh\Z=ƫ\'}KCoM*mBóxVFӯ$,túbkrWMЬ\n\\A\rΑnwFt5;MSL`EqngF[HVmykkvm٦Wa<U:8tpMҧN4U\nQ[JS\0apY~]C\ntԨJesNM9\'+;GD9+<w\rSC^֡Ak#S-VPMi~m:Jm8xWYGh^\rGBSY\0*[\0\rJL_H.m$g.[XY²[iWhaeĵoXZд.RlVxI_ZhzR]&{,GizMF?>&\0,5o_ú|>Or^Xq[|<\ZB\"NڍVxjh|/uv}ԲL:TXxά^TrN4Jr͸]fx:҄<L}\"<rs j>]ZAk:-ޱm7:.ɫj\rO[լ4#F;kVu}2ܬܴ3Knyd | оڵ揫kz/t\'NY4MJ]H}zmJP{jRhZ{H5KbO\0#x+Z]gih^!Mе-xO\nwRӯ5x~ҵzwo~|%[iϡͤɭXO>>J,nO֑\'FŮ-t~k9<>\n&\nr<VT«U	F,s5|ʣvxcNU\'S*n\n\\є\\=|ќۊ, O@M\rm\ZyO֬t/˭KH\"mm 5-3G4\Z;A5_f^y_i:E~04%NdXŢxOym]4?COa>]i>-ŇQmt\0x,\0Xxz\0S5O|f.k>)\0RM4 5?GX>s\0j:?5%}#UӼQLu·i>iPcxK[V6\0\r*-ԡO؈֧u*Nuㆍ<BU1YNUʇUF(ߗ$r΂JF1*qqT9aFi.SmJ+CƺWj7)xsZ|?xKm\'C{<aqƯ~(5ƇQvfMuǢEe#Gr\0dHSPk`^\\B*,g=\'O9-&_v|3ͬY/4ˍ?@2]hUkv\ZMggFW|i~H|}%|9.\0Vϋan5\\RZ/ek}:뚦Wpu\rv)%ݾ xkTEYXb3J|6\"5:찳JQ\ZEU)UUiǖ3:ɥ	ROjJ1*MJNzTxSIj./\ZHo	xcfVP{9&yb\\$Τ>Z^xBKk&	gqQAmVDLрa+E~K5{:𱊒䇽ϕϩ(\0Z0ijzio3x\0Ocs\0	k:\'OX{K\r6OXO;ojxx\09ᕮභ5ix>@ڜ\"]3L\ri{soa/bml!O3J׈_\\SxM<\'ZMlޜmjj\ZmtR<3\r᷾Dt;<oeIj$ޡK\Zg\rs·pCkQ+K}vD|jYVc8L<T\np)xhG,=%_N9F8aEԋ+LcqXLN]NJJgE|<J񴮗/i6/_\'Q:|Au{ xsYO\rþ4GZkL\ZD[a64xƿ|Kswxᾟ<OtmwR:uŴ<a}b/tkNI0izƣxA}Cɾ?j^\rk>CO<Xo|_}Ķ`4}.R\r}!c񇇮<=+g4Oۿe_A}>s\r-GB߉|-xJvJדðRGy ^MR|1v=Lf#9B7YIMT¬58u~R9NrS<[aySRQTU:UyTڕ}t_x+Z棣xZ%|GjךΘ^?EWuK[}~pxͶm) ,ŒiUΏ૭2VzA[hzPѢ{E[C{5ėڊmj$j?mcMΈmόf߈%<TPStyu;?IΒZmnNv5/]KD<siھ{.dQ4#uY_İìhbKX [(}{FaV2_P)XƜSp!N0J*䔓tMO\rZ:91Prg$RZVku}B95[kˆI4SZiw<w,wV\\FX[&b\'Oe&IFyţ4ƞlۭfR+ۦmt[D-M\Z+&\0\ZP(RxD\Zt6r\0ĿiA,J2_ׄn<\0<q9\0\nS[-#Rj֢49oE[kK:FoK̥K1׫F.2HSV\n*t(žMT~S\Z1x]աNHҴӄ.hEUzN`/C0x\0\\ךׇ}g^&R</׌[Il]\"MV}[H|Imkw3Z3}/zFG\ZTz?l5hvjk6\Zt-nw垡Zo5QW,BΑ3{iFJ\ZZ<PiV=^]jvp]G&?5}?W]4mu(<_csYѦ\\ ƥUtrLOMV┇/\Zx㹗\rRK}cҫ*NIRQ5	T=T\"X\\ƢTƼ?UT:ܐ%ՓU J/M)$7@>-C|/|uϪx^!5/RӼ79mmkZ-Bv-fBMNɚ7x.-?ÚER<L5\0\r|IkxcIN֠iW~OWcqoHx|_q-\"&Դ#KDν:$)m{,0h:!2eWm? ~MM{;i<<N6G_\nڅxĳVIOqj?\ZU1Gtѕ8ʜU1ijNKSgR5)NQafJI_4^g_^&Wt\05S0\\Nu_ÿuGX|p?/K_&^F!4\'Sox><>Ҭl4\'@7,\ZK}Z\rjChSKMJu)%2i~+|HwjZ>#j%5-rALUixRKφK6N>8IBo/(wxǑ\\4=T5:%Ե-7IJ]M{=gkiz{Y_ׇ#\r*\\ʴj_W\nm*8Q+bZNc&_++sΝHݥ}_xPdZ.{oo|TK4\"V{\"JcզCpt𧌿-l.N5=NbxŬkk_lol#&0֩osMhǇ6MS\\Ե^9۶MKR\\m.},t%	5ׇmMiVscix|U6u5\ZeG}+̱keάbUKNEUu.d+ԆHUx)N4M{{OJ⮵1\'^9S撄	8wvըm6ױވS:f2Y.dUkB]}{1巛QҎVEu,[R\';4_1Z{ao+cPf޽ͼ{\rN֢P֕N{(K{[f]<V}og%.-\ruKuR4B\0ԆcGze腑/5߶pj`*b\"NtԔU>v)sǇ[4f;xjK-C|KPǧh1xmBh4=4[_/mԗֺƩf\\hz~4\\Ž\'vgoo>|څƗi\Z|6xV)s-cìړOkq궲`ue,RH/\0itvi-HI[I);^\\I_\\j֟VvhCQeux]Kox;{y\nލ\nMOM6]*_ælnJӓR[V{6uņ{~ק7/̨ӪuZ`8TFI/5\'f:8ԥ:1J2rpM=OK}[[с!qkgt=M<SWmY]]qw\ZVuJ墵.~,Ksu.i[].\rI&=;24=>].\r1&>q}\0Ox?u6ÿٗѬuk>Z2QmVnĽ~\'V},%i$Zv}ĺvmltOḳ![qqk^WW Z]*Upɪ~qDiTZvW\\g39\'\ZNxt}\"ԢEqwM.4B]3F{\0sR[^k)mi;6KՕVsfr[>,oWgJ6$׷YOO\nZIimk=4^kϬkEo<}4-@5\r6RekMm.o,tfwWc]B/ik%6zK[[i.>/\ZxJмGe|=.o-vvqj.ᄾ\nj7RInZ[!#5iRV<<jR*BeN1$㥞Rw[WoyYY\'zxx-ִoIcVM\'R\rBxN۩FRAmiVڇll\0A7.g4}\nU5-.%\0LE\ZT7xkGX\r|/֬M_񅆛cs[;WSZ~5V&/tFS}~ڞg`!]4¾(tҮtMKD-τ]vÉ=}-2R>Eڬhn1?\r[^ҴӝyFc:2*MJ\riZ;J0U8i6۵ܮӕ.]uX#k\0rhŕ֩ؽ\ZUAi0_ksg@n07M֙+k\r#_ѫjzuV}@skv243AocH\"K[NΏ}8F&:ejo߶i:}eeZEqx	KWYQS:?{L%qCMm֚R1]hvWd~\Z;]?a(uhcIƇ\"N[NהK]RSeynZ[vkc_\ZU::ƏSK𮡨^}n&\':cW6_ph?Ri|CuLlFg]\0g*Je-k[vI/\Z3kZ\0:G֤AgwjX?\rh>>i]k#\0JRU)V!O\nxUυmkpT:ϊsKΖ|i6v)qKԾuBaV\n8LiMEFui ۡ*ssPb%F[pR+I˕]Y+;UFsxyk:Oqŏeh5q{{!\rvy/=_^I)nekT}1㻵`nod2OiplmM̖\\Q㏋ږ\Z=Ϋw{~\'IcICuWWO=w[5ݘJ\Z5ƣgK:\\[P_T54cMmջXA<5GkYgjd,m%d:5^%Ғu9ޔ8Un5J\ri6[#Vy!+E]$\0-_\0tq.\'y:o	Mi7_ؚsMB9.t}&.<Uo6#,-l/yq8tV-7H<Wx\\<9xIFݴSFk\r#IeG$|/kwqo\ZqBIQu>6墺M\ZSQY\ZFsh-nRO]j[􏅿_-mz}[_{ѧk\n5)M\r>Hf6MbO*O\Z԰IF2?wTn.<\\\Z\Z՛Z{ՕiHg^\r\ru5K.$#\\lOfҵ>Keǎ	L\'?J=GIxsT%|7j<2چwjztkӬº\0\0fY׮nw?xU־xNoK]Toў=\Z?U:,bo̐_YYE[asaAqmi:?aռx=\'u\r{UKfvڅΜ[z\r]\'MҭWTj8Ւnirr(I(6[)*҄=IFQ\\p}e5wwzEٿ[Mk\\19^G5y⸥Tj2$r{t!_B韴_>QEBڣ^\\A7Va[\\N,yh	EfV#K/=-\0O~\0\"zwsy]z-WőOqYn t;mŚiZn\r>%ķxEU𣛛6>ݧ|+	;/ɨRza)Ci\nV%p=͍wki$z}wW_^\\K]v:4CaXlI\ZRHn-n^[ȑb62P<9ZE1-y=\'5;[j6Zɣt\Zk:}jJl SիN\ZJ)T\nP(Z-7u{HΟ*UII6-<I]><е}&_\rMm}d,-u/X4!VUa&;k4[[۝/x\Zog,Wv3]BU,_B}b-O\0.GVu\Z_hgxm5YՆ_w:SK^oeh7̖T6RuKk\\}<d./5+OxUt-._ԥ6aլ!Ѵ{=#@E%Ӯǧ@ڽΗM.pը0ҭY6߽	Tjt`N1һ$ZxlEJVN\ZqJkn<9\0bxgx[Ο]nծ<i:hZY.;\rÚɵij֝kj\Z-pYXYj1jq:Zf.4NKğh@M\':~hRt}#I׉/jƭhvhz^6&kL7&.x?9sO=A]M{ERz׉ om;O뚆kk[ZKBm+R0|K>T0Z4]:T!7RP7Zn1Yf*Y|99R	9K⽢{x.߰^Y:&cira\ZaQ^Qմ|LS;InOg_¯:ve|57<_7n@ [t_F|axQt\Z3m\'ufLdLv|RjSĎ2;=$xET񕏋3[ЗPִoh	7WDmm:VnO<}x]gA~ū0gO1<mjSeŷ|n5i冧ꚴ:c<U<:9ʢ\Z7P4R\Z\"KT͕a^_\nԮc5M6Ӛet/_3I~._h*_Ïx;6ỽ*ƚx\Zhi^w>tKQ5\"=C<E<qOk+5P4-G\\լF-\nDMas	-_IT\rCeexGK.i;u_7Y?xcJj5[>_Mׂk+}5|Nz|Iqrx\0PEoj>-M)!η\rZHǅkz֝eiqRcMEvig}&79%J԰J,Ej%Ut)U5)ε7J)s(߷R0!*)3UUʠk%vExբ[\0\rXXA5i,v6Sx%C4ioIk|WaJ\r^\r5okSj~ uC@h$UkZ;iͬjp1Zχu[h5	o}FYui-z=W]BH>[4\r$\\Zkv\ZogPOĺqEՆ_꺃iڒh7IYEhYNSE[ׯJs)NSɪQ8t\Zq+wmeJXF\rIb՜%eJZzuM\"Nе?Tĺ,1Ni/4	A\0	;hw׊tF\'74\rC⏃<9MAQs\n\r=O~i\"}PִC+kfٺmb\0Z/qxK\0Ҝ\\E{k%age%C#Kis{kyjlQZ鶲@F\0}#]>K]sz~Ois%֕6ii7i\'-];RNCk1Y*pOaQ9)ST6Tu&a]khFt8>x;yM1xJᅞ6wzOM2.gSlY/$mSߨ2P}V=sVsO^^Y]+LRn-.5}$O^xb\\64^Vvz}7\Zm\0	54=:Hg\ZAŹd[M|3kM&fZ[D\rv:ŽߧYxŲMxkMԼ\rioh>2[CHA𮳦^Kt\"մ>RluU,k<^bΜ-j1qrtµ8FOS|r|^eukF)Jrr#)>jε:xj%Şc];K=VJtSPүmkM:;}3A6::Lw~o[k}gڎmk\\,iM4ZwxG.oy.c{ꖓxKɻL͠[r^$ӵSQԥMUS9$ճ\'I_k:ۯxŖΝgEt\r\0cYTXSY{\0O	]G<<c\'KEHTʰї7u#Pܪ):*AVԞEMc%*\\FXyT9i(;u귍NןJK+W3xj??lyct9c4{˛H5uvzq;N4T[.ikj$\Zܤfu[gK~Cßai.|9ְ7Z^i-n4_3S:ƚ^ҵ-DP^4h\r)%xb Ѷkh[[	 x4H`kHX񐥉S8C^%_DN,u#\ZujA^RJ6WJiط/^Š%w\Z$qͨ\"+y+ۤ7(_wuo4aEItMkO\\twb{7S71-ī\rkVglA9o/Ie4?ZVfeoBP`Ԯ 2Koo3_hȺZ,s\\ݤ.zj>N(u%K/fM{\0k,pZ5ܶ:~EkMfoN%QBM5)U\\U:I%z\\P^T=Կmtmkzp~$uFTLMPI۫ŝ-I5\0shi[Lf^V/料Kn\0^;}XK}mpRE&{jzSC3E\'==.\07ajZ\\Oƞj!%iNyǧ[h<Iwoyp£\0j~#>:<VUevzZ\\:LZau\nXh$d-J[xѥå\n|1)֭NN9]yǞqr֑Z\\Z9k߸[٩CΧ#rJI%$fK]xBxn(]W3j:Ci\"<Cᩕo[NɦCwkf=\0hj7(YUn-5mkJuo\r]\\h->$qm:4w\"}ZHzfm&]mJ>{iRAw¾5\'|:nxMoV\Z\0Q1DI_ON?4o\0O&JҠuOKu;YشxƟ\n{1\0;Wʿ\ZxySqJrR)ԓHBn*wQ>*~_R5MG.nU(5g/vjm=_VvI}hWO%i co*jvSۦմ .,Xh>W;-/H\'Y.KR-CLmC6~^g͟V\Z\\W6xĳCmuM&P}Bv\r(ll/^<;CmZ.,tKER\ZS^~b|Soc]ZG}o^\ZհDmQ/\\\ZaD6Muq+\r^ti88Xov\Zє8+nyWէNreM{5}_^?\0f,4ۛ[M4W|]6io*yuzԚ83DWwz֍g*u)5t#mӵ#n⼍5Gww(T5qsPmun}H]̓si[x=N(cҮX.+u<m\0\'y{s5ysk=cGGP9c{}L<?jaTU]\'R4ۄZ*QkW>v8Ngʡegv{앷߱><Y[xM7_YE[XhieI;8Jf\0J|]i}>4FKCMRZem.hsLK{~\Zbi	;mGz;mIzj=+ZX_i֥\0l٤FۼOx.u_\njKcԧ\03SЦ[Mwχ\"}SPk\rW6QuNJB)hr%[2u(Rp/,5_.=J^E6+f6qjf}6}wj0^V֣bVӤZ<ۇ%7,Y־#k3K\Z#<Qqh0jQiVz[+Oi7VƦiZIGiE\'l<s\\IxSZV/K\Z٣̃ZqeXj1I-k|ڂ6fl|Mޝ7=\'{.<=[}x-5m\nT$2<7vWjXG^j0\'a]l<eIN5甪K3qOJ~1ZkTfEdn<^rki^.ǂ5xdL7ԙ6^K$W7mAǥhإl~\r평5\0i~(\"ACmf֗^N\r}fk\Z3|۶shڧ|MxjLW&K/x3K/dԴ\rVfm{!Q)KYZ57i,4\0%촛)4[CZX[hۮhWtJ3\ri^m*z!P֝X%=AB;5%VJoطfZ$y4|S.죪vk#~Ewo1ueOr^ Kh`pD*_?GkVѥ+tX-,,L6V(;[h!(QXE{\'OKլ=1\0uǀ\'}VXϊ\'ڍz4IcK,p^d<Gx+iPZjJx<[gCTg٬MiٵXZXMKVa<7y-sGNm:U	oq~.{I4ZhCaʭ<֖-BP[Y5>jڜ, _4\"-Mv\0J\'4GKou-feu|V5{hakHdO!VFq#JSP85&)q|z|bPҥ(O 5xɥ8&S?i	YO^IxկJYgӴmK]mBEݧXZMms)uONѲ|Gq?𴺾keƁj~x6F!dVw=zK}7Ud`վ}i#xYW<?}qn/C\r2Oi-2_QW\Z>\\ZT^x/]Zug\rE>:x{W~xW?͜\'^Z֟X\0gh\n-i{i̖R^e}om~&̈́:y=:.8T3EKUxBFJ.ӻM_0(J4%V*T\"M8sFJAtz}G¾G}c׉1$>=^WY*t_x]u4N;0xRR:&ִ9\Zt5\\BF>\r7Mk͕Ιevfx}-ݶ,5|DΧai)_IXl\re(t+vVzMߊ5Y-GƤm</OZ|K-E=k[Uu\rOZNA/gu&Qy&m>W嶃GҞjGV.jEOg8\r5\ZOkuQb+C	MS*F\'ww4i?\0]jڎw}Bo\'֒dԦ~`n\\{}uvњ}9 1j>8xR6\rhCTm5Kxu;m^I#LGQ:ex<?xt˝R弸m\"[_OwdzԺN>~#[95+[Xm,n#0|?|7Imb$E=_\\Z͵Z\r7vq4:؋8X6e8,>2T8e*T^I7U1ZJf趔e:T*a[xU\\Ԕ}R\rեD|QXi+ҵ??>ϡxCoiz\0>h\ZG-th{bE-\ZKm:\rI|Ce_HmM>|U+]cZѼCýr[\rN\0öW:旦]X^Z.kyMGQ+8Mv^Zڟ	4j>(߇ǊW|_69^I+:ϣT+m]VR֞\0NQӾLY])u\"\\A^/4\"ͰXtkCP5uk[\"|p\Z*\ZT!B5:Xu*a#8V)(N8q9GS\rV7E֊#ZrQN1TjOڛS7h17:CT<AuhQ:Tz~)kgY{=VI,a+gRդA3xK,]3SL\"5ƓiZG;W\Zz&`c./cMEͳ-\Z\ZFyKq\03i-c<5Zk+\r\ZR\ZH-Fڵbse{B@\ZizZ,:~mAj:ΏsgBVSqc&>5}n\"a\nUOTT!5[J5.Z֧tl.5\\0SWJTi5jdׇ#xY<-cxCų\Z^eGwH6ͫj~ZFc}%埆{BC$<@o|EdVۧ4^}IImֵm6ᴏWf:^ij] ~w:E?5i^)t}NM/ĚF\r߰k-G-Kz>ڮwOKjf\0}uhtcMd]?:F:-ޓhEZa6w^	a+`J:ZN2sVuSQQpyh+\rVr	b-ܜ\"񳗮_|7JKHԭ=KKtK3s4NY5pזP\0j@X7Sw|#xMƿ<i<-⻫SLRiŮ?Mn#Oxz:wiv80\Zڎiw\Z\0=s੒KHҤ-5OWoUңtQ=)L<uhGC]]3+M;\Z_y64/S񍮣/~ px1xV6چ㷷3zFa:ZI%J9mΌy\ZUSRjRz+/C8F\'9ӒF1unԜe&lmgnoĺtmF}{iJ[}royfk7Yh.m>koq^.~w]֗se?4<J+hLGNQΙqxN+yeJ׮}Ims׌<góiifo|/-l_ɨ\\Xhh\02y-nMM%w3ɛWdCxD\r]4\rGZ-|oZj֞15>\\Yҭ4i_KAn=8LO򯆇%$bgS/::\\җ,\"\nc<\r.xԼy6[rN>>_hg<m>}/\rG.^*؋DZt\0ij4]TX]X鷚NAwk\Zc{g17Zգ^M[j6P|qOok&ian1Ak[XH) 4ݘhdi_d+oONv7ik[mVu	zΕgGWNm4]7Wm5m;?ڗ-c[6yZ\\Zϖl.lgym.m5-BP+I/\'XIb\"*pS\nT9e(T_4fZQʄUҬSڹKEg&ڣu7ez/\Z~#\ZkyKy59ZJ9l&(ⴚ}?gk3]t\"+f.dV궍q-q>饺\\X]\\h<6O˩k\rsY,$Κo\r&;]X}n\0j\r\\4*\r3Vk5\rAu$6a4k(wWrYG!ĬqߢG*R\'cBSդ\'̟,:.нg^r88*ԡQR-/RWvwJឹxvV֮u{-wwwPiӽ3O\r䳽Ω=.u]>{o,KA>=SkWZ\"׼Ol	KokZxj426%:n;tc]Y/]\\nQk9^{O{4\"2\\g>(y!m~Ωx/5[OCXj/Ciw[[]k7kͯY5\rB]:k8i6?m^N%FUhUuڧG+)Gއ\'=%wP\nqrN.k8Տ;(^J2ߕȆWT燠[OZIiSe\ZD-um˨\'گ|9Ucgs\\[Ǡ+AsZ{x[K6XQox2iLPid\Ze\r*6fx/X4ӣ/$9sk	gTe6[vWؒXO\\iYصͽ3omƟ{=Ė6\Z4:ZjR^	IahR)MANRn<ۧdlݏR*ʛ5Qn\\~r|VW凍doυ.t=XTU<vzu]Qzj:i#jA0]g|s[O\\xvo4#·v-4kfaR]jJM4qSIO<YŞ%m-eM}[Q=Zǈ4Fic$lOZY~u|MCh:iƷsmSY.b-n.川5\rJaj7:eer-,凡Pҟ5j<Ds7=a\\oyJM;i}TbTTaR\\o8٩E6:4hqGj^ֵt6fkK\'B:,661V!~`E=ys鋩]YeY~ҶwR k&\"?q-O؄繵+[<SetwoIdl٣X-Mi}3ZHXve:TSO᤾tk]{4Dѥ{\\F\Z	K_[͝4yAx^8--$9gFt)*X~shN\ZnszE0i3BUsfW\'emn%m:^Mu|=*=fݴjF\"#}ԠQttfK;b\'Yuht/n\"H-*Fեn5GGOM=|Uַ~Sn7>iK	^wZj3iQk^-)[ZT`52ٵ׬]Yi\05׉7j-;UmKLq\\h)kknu=3GL͝tD\rVS*5\\ܩ*ӍTVN>Ӽ\'˚7KmϢʒ8S5)նRIYkMZ=xr\rK>#;,oDˍKEoi1\Z4	4oM]%S\"#~Э<3}⯙c~ѵmZXhxM=JE6PtmeH|gM_Ɲqid|K֏uxLMj-PHtgN[kfiXm-cm:WҦYu-gOҵ(?emqMA\ZE;VR^rqT*Q)J\'MMq$\\=y,FPN79[qrOyt[\r3TVM#R_LQI|Yt&ou{XirbU,e]GkE֠]\\iڵW\"Dmj--,aea0=Ǹ|Hͼ\\gB^Ew[]}[-RQxkNCRޗ\r/gk$W2MibY^>iZ.H&m-5?ÓEקuem<ݍ~\nu*u\ZP猪Muu6u5yG*Jjjх{VjqmZ^I+/6Cqrsy廖deYIrfi^R#$_?{{Gt\0\"9dH|JO){4[wt\n6cp\nU+IV:7Y[\neo&]]cjgf^Gc-Nn/n	{aqjN\rOTբYK`sO}5-6a-Hv5[i>sܭUĶ;5\ZIrח?mv{i43HȆI+i-WxMNu[wDIwpK-)x̖Vks9hW}ja^4֕w,yy\\%$ϏvRdjꯥ\0#\0|_>+=r\0BԴKfEy<j2i%YX7/xMPk\r\Zjvmmu.J9׭OӬ&k\Zr\ZikmEu\':ţ\\B[+XMuu+E%֡%,rd~~<uе߷떶zR7\ZΟz#TnbV/.Se4-cpYN2G_s*u^51QJ*RNe\nrJt+qʕ#JxL=G]9V#\n^Qq\\I\\4?Z=S:$|Cx_IԬ6\ZfW=RqvnV\\{g-6\'sA]UӬuio.5|Y`l\"kԶǦ[ko_Pȟ/\ri]7MŘIXЭt:+?Kºzs:__Y\rհyM<lilm,o,,>ǤmȏUGee(G<HoW.$[wFիƵBQquN\n4\\T%)&VHB9TJ#f:6&j0QKK-zq׋$ԡ>|3w6)dХwx\'AonTck-sLQiۡ4Mv>#񎑣k^G&C\0k\Z楩7|:ƓjEQVv[n?9shѼ5ⴸG-d4[ֻwu4i-ՙy$k./Zo^]\'O%[MJ;uMF^5at4J _(c8<V]|Jt+QcF:1xJXaZn؄g	S\\zsøԖ)ae%JmFU=\'{\'t-_w4j5|Y\0dDix\Z.4~XaՓQp`!6ڭz}\\Imkzvqh˹-4߷ukuaKa*	)Rյ\'KZӮ<9q7ĖkKJ%:3h\ZuݴIknw¾1 N&o)zD5Ս$\ZkBqx^{X&0I˳,3qR+^XNNRKJmƝl=HQq`&VӋѫTF0	)NTjͪV$:S^\0Z<K[cVWVj[]GlGCRR+cOGQ/4Ok7wsxm7.u(1jI>$oEh^#^Z|Oc:]ΗehVLmJC-,jU&;xd^b\r2N⼸l5XBW3%Զ\rchHhHWB+JP5TkTg(Ju-\ZVùRMEF#V8uiE8)RVN.6Jڳtj\Z;MqtRGJ/첶}k>vQ[>A!}b\r2mB\\GJKfN-.ỹg2]7ohp^	gqϭDڛ:R䳰1Y#2Ʒ}]ZfK*XVxLO.l]+uf[(3iK7sOo-W%WWQJ@֔gMT^prN➒ojU^xW<6\0;4q[iĪd˫^8\ZiZ]ɸ=2LR<׿\n>/~u3xR7vW&\07z冄.Z_/^.j7XhU?\r{m?\Z{ZFmigGk\rZAe#_է}ueei@_>\'aJ\'A<g\"5;YyAlnM9JkYR+(kUeN<\"+OZj9Fۍwti-$Jec!%V57R0x~w\'ӄܧFFˢiٞKUŝ_LԢwo?m΍s|BB찋ml5n;{km2[]3E}B]+Rj>cimh^ <Gk7quw/nOalu]]٠N]V--u>/\'۫fbGŞ<+u]߈/%7zϧ<MOVGX%<GZiW*пCy!VZ͋iڄwΗVQ^jw_\\_j7ǧyM3`VIƽT)*puqԠF͵nTb*iϒIR%5wZ}~G/jZ}[\\~_.єZoS{Mh,Җ	<X\n-k>.az|}°YxK){xJVmZmv\\M6s5:%Qmq5\\T3x~K𭟀t\n{-DxuuS-5vm:m:1oj\Z,A%Y-{8\ZfvM\"Wu*~FTkwῲﵓnfZbm򰐄҄=!F!\Zh5YA?z59gj֊I:rmsV\\n][f-8.bMZVqowɧ\\z\niZQj72a5i--n9?Pք˧GKmYQs%\\<Qi^Ts̅6>}k\Zشnu\rLhὊ*1F\Z6$yㅭ㾖Yh2K:]e\nC(daa湕	b5yQ$d2~ң,T5*JrnrrJWe>JZNP\n]}7JMWmN\Z^ͣK&aqp.),rh Oy-ĺ\\^MvZ[-oڿyo\\hV]2_X}mjzAϧp7kwS5݌Rwڔ~yɡj ҝm5abhhtJo$ѽa2xulew-^5tki-3Zm弚m4W`&YntjOa父	)F\"F\\NqM$mz9]E欭6Qm+?\0ﮇZFejļZnڝgv)^	eŖws|uC\0%CVԮ7T7u弉ki0I7PG,\0];Kq&\Zӵ\0|E%Ɵ6jQK=ں_\\η?&kzd?fKOKm#:kInga\\R\\jGu%żu11{\ZQШR1IR9sBjＬ3hӝ	)25F⹭#=4-yz_n\r+M];:ƊCg{Z_Yj1A\rZ|V4Q-p[q=F)5o/xAASiZjSBǦ[G\rƗd[DEɺki:}͗|\'idj_YY5=R5M%\"R.ٺg4aiUs\"K-Z}7HHM&!\r&[g{^#Z8¤(zt?i9\'\nj7PEhi3\Zӧ+Jn.QwqQ!&i~$l}ɧئXI{ڦl#Ai$c\Z=>DrF%hѴFOךº}UCl.b-7Adp\0PL\r^KneX/uy&Jä[Zڄ24{wPZ\\i=,AXJkzWӵl-ƙ6/`\'S\ZtUWZLD\r]MzEܺxzoSx=GhEETQ%){+FH;YZ2׌hS*m)BSGJD~+<j>7rSK^ϭv\r(xnL-9#TtI& ҞZ\ZlAi5entKt-?ImiâR=Jwkzd&SLRn,%ӭv4??x\0M;\Z߀|qi]72˧h:Il\rqiwizSOE24ZMq$\ZZ.SźG1=+BOG	MfFc5O_Ms@ɡj_ImY4݄1c:*e\'Vua	MՌf̤ۍ䤙*N.1P+8ɵ(Tz;IРfm_],\'y5{kIr	95em56pMu\04\rxvV]+\nxWTZ]{ygwFiZ&5Zް\r+isF}VXkM\rw:wqMjڽ潿k{wK5_\",>!}kL#t[ŶwS[\rei<=kZ\rz=28o\'6k\r֙S)G\r\Z:~RQO8F&⬧%/z5^Jzi78\Z|$NQM#u=SZ@Ğ+.EJK{fQt4WD{@]\\궷\Z5\Zwa^aQCՖub+{#JM5rNhHXtT[cOuKi=ig=ioڵ&xn|Wa.X6R_LW\0]nt2;JX~ Q5싽M漹\ZrxnPč7N4Ngm:mSRQnJFTSKU\Z%x7W0PO^7mMvu$I)Pd[\rgW&c2q+Aci7<`oa֟7vqR%9D*\rK>vTy\02\0?\\߿mcIҞmfk,zP\\	dܬVizѬ/-uuŖZw\"d9^ky\\בΊ	>\Zq9U9Ԡk,ծo[#4kp#Es|ı= T9#smMvwD5lSI˹yh \nL/`1R^)UҩYөTc,E5V)R%itF\nt)ʛhSQRQө$QNɦNɫZ:Ω\0g-2XsB]IiI\"N<	,.-D>w~1o	54K\"ȸShtIdDpֺh_F,...vl5!=ԺUũGu{{?*EܳNn;*̉,rPחA$<r\\%\Z5\\J,XR}+nR<]Kn8|>FXxלe\'PJsTN_5FrW4)GjNҍhJ:Q$qUjk&{5MNSamfk{Őj1<0w@\\\\!2 0	QM<ijogrҬF\\Y$CZP3n\Z [s,V->Mn_5kV0.FV{u<u9x[0*lhK{>Hr}ZG7_yM*4Q̊Yfb(r:n\n3Eae\Z{\\\nJ3qRN1oj5vrG4Rէ\ZjUtrW5ikguzg]EttA{\n[­q\n[h[Sp.uNچ/Ē_\\hWԞtgӍ>jZOkoynFҵ_6X\\]k_Yvr湖\0Ɇɬ[+-ca$5}_&0ri:$US[=|wY\\eCRY7bqxSOQT)NƗՔM{Vjdzxj0e\Z4*US5:|tRs#չV]xW)o&HI%Af[m6(mbY̝F(Vk>-4]iATV()|[[,ӏ4Fg]Jn5s7Tck,miM4j\\Y<E4dKu\r\"iO<[.>4D6G$\r{9n2-4.81-ѻrl,b1JGc0*GP쓦۾y%AS·VVu)O*㬤WhPρ_}^Þ*!ӯ-u{R;m乹-Okg%f)-nj۽V[}{k?k}>e8PDW	yqʭ:*>$pE+	\'5EW4x+IWy,5[}3QEӵUSjĦVKo:EDKپ}r|[6ᡊ[%i$3\0eђ4;pͩՄiRהOK\rWuNҧ\'*o9]YsB3tJpZ3L>RTJP|:&nSjqͣi\\	hggmVHI;ThۼEZ$DNdݺ4\0A-n@tӢմF]:HE4Zv+KfF}6gei6ЬrBCkctڅKĐ8FD[\\YbYcR^[-oጋ5]]My3nEqB=\0V\"[_8pCQ~HNiFU+J<\\n,4KI%\ZMs9nNۛUwo\"k1TԾZ+Aѵ5?HXZFHu\rRsvF̴iPsZChΠii*=n(uRh.dVJ6%-\\MSM\"[[Gߑ/mloml\ZE)2[\\Dn.F+nJd+ (ž A_i\"MrHK>YsK	HV]QYVD[K [W\rf\Z\ZgV\ZrH()J1^\0=7%{FJ7o3ЍX\'JqtQ~Xk:y_WֵI$dKǦ۵ޑx+1Z-iB02ysޤ\0nxE?\rIl70zn䙴{~-m<0Kl\rw>axQ2jIӮeգ7XYi-ʶcjZI(WDfqռ-C۫xut3茚_E<|S֚mpm:5n]X\\H,<ѡNpARjM$Ӧוsu+S~Κwm.]/mwwI/chƥk*xw<3y9};EeKmmiWq#Hg.5\0Mz67gc<Aͤ>4\Z޽P~լJ׮uiĺ+KZ=ծ]6vx#l5+\rk\Z>\Z-Fxo|)Ijx\rR/euAIyv:Ex^!7x\0dlaO<D*D?Z\n:ttq%+ev=:Р\ZQuAzIsrZ֛ksu忆,4i&Fӵ5gi]j\0ĹDfO.egRsim.Ep]UF[]bKI<\Zf6\0ďE<O\"i˦G_pkcJy_qMjj0}1#XeS@!\"+e]Kq\0IUV9T83m	5yѧ	׌jN*I%B9U8޻Swڋ>WNu#N\nrWm)Blbek+=NPg};Q6F+{}A?xeyq$S\"!=Votgkxẖlo7h\r--aK;$WԎ.Y>5R	#^3fdxecϪK\\9I׭Qz_Gvmo`Ӟ]*!{-wQ eK75\n\Z`;NsW\'NN4wmY&9a&ۯ\'f,Zo\":u*ކXҴ;[h5}WD}?ɋ>u+ZC`^UgH;{\n\"\r?jhy,Piwvw\\k7yƍhŧvWNu=ZOycrܗZ敷N:­udK@u%`]).jeĳW7K%ݚH_J)Đ3+I\r-+JjQ6G*rn1m&Ҳ-u](JjTܡ{sJRj?N[6&oh\\j15շ,muC2$Pan%ۂIUjC9֚{,mz6\'InE;rm5_-gi$.iu+R{6&8»CI&狝\Znh+8\'_:#,{%6Vs4cK&`m8i5x`N\ZыRr(oKQX-(ק	ө^HNP4(rRI6W{u4}>/^ꉭKaj-iWw$Y%Xg0Ig/7-mxX\rkkkoc7VQZL4xN{M4|5[9mgٞaݝ͔_P:1B2]H扭\'--05^(U}<7{\\ZE`jvtf|K,6;\'B=Ei)²iΜ$*qRSQIm+]-Z254M6c%9N.袚P}x;Fm_Ox>Z0YoVp1=	8/5{{$=:񦻧޽[4:fuqqMoqgb[OFuۛI)wu{ݺO5$WKZ/M2۾A*pKmKq2Z0Z_>g-.4ѬGh]\n/\'Gٵ^scJlM!aoN:~K:qyߖl0Pu;N25\\/do;yoC]݌W.ky؂3jW:-#yơ²M4+o\Zsq-d3_MúT3/ztWvw\'KZS[6HL۠\"(\ZȧirÞZA}w66n{+HYo[OuktEfx[t^xEu	[J-#5oT:ռRG&W[G\'.E\"=ĜXl\nКN50^1qa\nE7)Sv|ֽ}kb_-GzJX/WKZ}BuX5=a-mu5(gR\'S%\'t\ZmF^dPF&2xx=}#[?>=]AMWW\\<Emnjqaw\\XV\'K-ْ]8,)xZwVzno7-CJ.Al/-ݢT򣻺K{dYlH]k޹^F,uw6ˣEyg\\izw]\\\\i:f{^h{*pJ3:U9Y94(9&vS7ct)*=g:΋nmUӍ\\ͭ}>/|3D񞹧\\*\\izvہIo&,%,/,Fʖ%xx(j_SIbU\0J|;CL@O༼Imsww77DOr+y2ioS/|?;}\n;iO[}^}?9\Zյ\rVHѥttfW2IriѢQou3oY$ww5Dң]K͖+99Dqhرq$MyrLQq9xEt>R[=rW:	<2io[Hw.|hF^Z<eVM-z$..\"mĲD%o2MH峇+燡W)ue\nүJRk٨VSQQU$rK屑^Tc!*)MI-Sm9)T74Z\\4h$d|iaZfKe_ƛRR``K\"Mwk,PK{G+Vmxlm3һB>&Tm>i, @\\B%_)F4le`~\"]&T\Zh>jo@2^Peںx$sy=lF+\'*UjVQ[N<+Q$Eh]R*EF4ڥ+VvuivV=o[\rϧ>`ԮM1V+ynȱ$\\/l-\"RR*9#ay-ⷎYЪC:]ƃ-!`Xh&mB7y\'0K\n)C/qv^\"Kȥ`1 r+JgL\'XQw.%ޞ7UƳ~աrJ*Wv֕DM6䛓JǕC\nv#x5iW^z$էwDGnGZOo+[\\57q,jVy$=cwT>h\0x-͟|A-/.[qp+oos#Ҫr%,d1W/᥸ӭⶳrFmnXCtBͶY.Z+s\\ZY\\VP[iZj][CHtkMj4Yb\Z^<W䲚/<l!噿6T9U%RMZ.4l=]KT:7VdiFXXBe9\'鷻Rjz5v[Kx}P$W/\Z7k}qY=ӬII\\yŦuu}wyemWM*\\_^X`\ZѪrV!.oa}-k~!C~<=MȖsꗐ>okr[\0s#n$m@9tCn,2yZLdۣad֓<v/.7Vrq̓E\\-\n8DV5\n.l<_,EX)WWR\r4F^漘\ZTiѯ9AS[r֍V)Jx7zw\0Yh!t\Zr;I4Fu)TL\\4Pᛇ*PO$kKgiGya}%\n<ѩ^a=9A[ɥ6sp/\'moc-Սս15ͪ-d!\rRM,Lz\0c\ZEͨ/s<3Eu=MdX+{f<K%ǧOU*a^sX:#*nɷl\'haf`$燲rZn3ON?\rS}=g]\rixv<&[fyD].rf=biׇODPI.OukfAneknoټ϶/2>t8n\'~jWz-E=K7dpInax9/7IM}msQY\\[MYgd)o%Y.gTU3I8A/K\Zm<e9RiL#Q*A򃋕U%~:ZJxG	(Ӕ%J6JһR,{z>MkZI=[ռ;s4V2.[`ѴpfIt2KO*-[H.jL\r+EY^LK\ZGدeea0HdY^\\>P}BK.&B>M_op-0[mnok@AHo4;N4c{-Q{/˽$\"2!gp${T*05+խ\Zo*NYr:< כ`5OIb*2G7%(Y$>TMִ͚LZX[i7\\Xvwb2BmX]4KjP%(Zŏ]Ӑ]\rN&mU5;.wɳ1yچ3ˡKh|\0OiY떗ZZyeছ%[Lv{E 㯴RY\ZNYVY^Q[Śy;aKqp\nܖ[qu$­ER1M2ISRQVԋnʤQZn٩S%;vIBu%4dkxzMwvZYiR7fy=T$e\r>١;;;nTj:ƵucM2\r.[K-,ui	/m8K˛4tFu+y(\"!ΛrDӮ\nX.~]xkHu $\'b\'K\\@OOMX+\ZhCyۻkw4K<(gK[}~oOFNUJ88Nܳ:!)ܦT5N4StiBfYI7\\ʹU\0iR,ົ7>Ul\Zev{`pdRIVβO{tVZbckf-#h`8-g,RIt\Z,;!G!DC皬vk\0Yb5{;[6˶CġQdCcK-\\j)~>g\r}mjZ.39f\Z5 a\'fu:QN]	ʭE)*,L\\P)rwVLku)GIJ:w֧+MwT?z;I4dq66]:(w$0ܵ3+N<f7:)nn.Kd{)]ia-Ҫ%&v)xm*Es?	n{8t\ZcdE?kVe\\[_7/m5$viH-ml[+HNKծ8o0͡{6㇋Bjۧ䍽c%vX\\4dKQ|\'k6tw6^+YbdXkY]J^5#Ya`^d@L`Gu9-2i&85\"K[ѪHyo\n֫y }C̴듥^jK\Zrf{&.c$qGdv1Enȭ`_L&=ZRjzog\'Msuaq5ŭr4L^SjуծrT>#U;\ZwIEq\\ST$nܷwtm7.g<KSk\"\"8Z4Ycwr!An4his\rݤy-::s#E#\\[R;E?ŗG[nnk7{zmQZoM	ʳY1ϯ&QYmf[[(гK43Z@nawg2C	1)mm2:>TF\ZXiЍ^U*u\'\Z.xFJMRe5-S{{%\'%鮝IKM<ڲ)4Z5xu)#MEoO$ӗR@F:c7ڦr=۴sg[ʑFD/&VUc0繂q:ŦZ4mzAs/-0.X$Η֟Ѭm1帔RC;[w28La<TYc1AЛф)>IN45RTym7i\'f-`\Zuf&`ium֖JiOhd^Hn.VKu,?gfw5m_׆k}ivvgW{MX$K[I[t,m$olexƑëZxDt7F\ZYK(Qqk<%yry.V!\ZNj:֣cj+].OƄ<*oXP!hPG[\'FT<g>INj>Tۚ:V|tW\rYT+z([JZGjHM{\'cFLPGf,m1-&dQ	qxm\nuƥ\r5ƙ42֞Sĸ{ |[n\\[\ZM[\\D$\n`ƠֶR|r3hx|U8L2]ɟ,{	m7ڮ%kBZ5\"H|֚i\r޹eRr8^1QM)`}\'k~]+O.Q\\쵽k=MzFӴx<:j5+\r_Zn$K~MĐ^	.͔2y)po> Ԧ[Bf̴n㶸ԢX,u>\rKk5[=R46֭vgtoH.?:ndiWksXG5u[/[Oqj}\'ġcԣ7wKoxT%3Ne0\n\\X/=Lƭ81Rܱܽ\'WחT|{5ע߆	kx	1JMՊ$#6hBX/QXd3E%LI(\"*գʘڥ>B\0+(y^!;[\0#og˅\0t\0{Gzvsfh\\C#fd{;bcAh$.& O^K]3J4,~SI#ndt|;`ylƬ:\'#h`\01BDN7СFK1NpXH IWY{?]c[ڄE(Zdq;D$(b>1#*Z_7$%I\nܮJ7xiTEt{%$Q`Ib&uRutRo_5$t-8Rw\"],2\n-xGht۷E͕[s)H|Ԓ\0Hr*l5+Ifl.2̙s+F1\Z(WVl	Zo4D03Ql\0!@70\0i㰒\n\\T$SJNYIN{Qvm42L>T1x|bpI*ssˑƝ~W-hZFl;q=s\0mp!<U`њWx٤!v@7ٕĀdO 5Bͽr, NӽIuM+y\"9QeY>|eD[w\Z/gjNdMMoq1!eKȝ,cKu#]bqPX(C\'B-{Q%9<vMī)b])UT\'UF4+Ih,fzu>g28\'x.i (Ώ!P\0rƷ-_\Zy}Wzp}e0$˥E\Z]3B\ZI$M1Z\0A4,;21Gx\rs{p\n8QB&f-SQ-5Ÿ	5bE$72M$h!+<4^/|E/eWY1*6\Z<T*nJ)*G׳MzRB3Q;OK}_S~\n3Yk\Zff{zݍ$K}9[Saol;/Z_ Y}\'Z7S沆I/MDo3M_Yf#hm߇o%Ƣ6pV|qk{@Cs]̲%ʄ}O~|Ce۸[:SZ{UPy`%.XΛ*٣?-۬vm✦4(9唥VNƅmV̜Z97\ZYM%,&GsrkF3JS7JVҒ+%N*V1tWIny,[u(le+88wN\'i#XI#mybzSvuŨLn.6~\'wku9;Op#Yi`IF6lw=ĆitΣPd+(4lSJΗvɩ]x!^%~Iq\ZNf E,2fUF%yƮ\nөb\neRqJ)KJκZt*JQŹQT\\єhsӋTMMZ񬖩;:޵ػ7[	yT[XILKזP\\?~WӟYK;I\\iv\\^Ak[5Z]I>ZBx\rJ6wi3,D]PGfnbu3V\"GΖk\"O.!lIrG\nt*2OLUP:\Ze(J8O(qrJK)\'dI|.Y%*ң	PN.iՏ4\\tԓ~D]RSs]՘f\"%HE(4Y-VDHe䖹!\rd˖xAkpxE+yP)d+]Kº4Xy1,GFldoڧ[Iso\"Al,Nq{gyqs^KibYp\\LZF1C+\']6+<WC+Vce*冣RlGQTȡY5?i99^Ms+Fuq4)Ԥ::ty1qs\ZJ%gh24:)fZ	cL#,ooE`igVWD\Zbynƕlr\rauIaɌݴW2JRe\"6kW6očqtE`\0HvepM<q18h7	m㷾[m)1dFW\"\"hHV|ꅙb(5?eB8V\Z)4UJkm5JeӪKӭ%*̛iB.QJR+j;vflb5+W.X[-SqomrҳEm\'$y$F;Iou>(iFK/Sw\"no\0PHbӣY$[V1I2\\\"n_08e엓eyk9c*oR@C*Ѥam\r{o4MwN]C fM\Z!X{l\nXӌiV䯈)*{FjjvRu=`iT:NWFQm/iU^*1NMxYͬm{2+O/PAerb1O4]Hf_1_|K}{^>=4W-ie1kilm 4EPl\'I`1tzu[;it[[{Rݘ	%o yyAkr#<0\0ҟJqoeAk[>fnỹ2[$7g0G`42[5J8-5^1>rʝ<,):kJNT#\rZQNhN?i2UnQ;Z5%m(41-Un-KƖxܭ!XBy%ˈz.*4ɴ Xrv\'N&糘][]k&SʑX4s=x΋msk\nB[i?SdCIՎ仑&;khn-\nߪ[5a0k[זF^y	oxM}fSW8ΫtiѧNeN+T%<=4JPqYk)7_?Ӆ(4	άI.JRڏ3RR7yF-5ABnwi7sA[FHyhm-m7.:L$]\\rX^8Ei-`Y^wdo;\']>0iMZ\\Fҽi3	v%qc]w}ekwzul/A-nXm-K+4SHm,rmB\"\'7J\nR#\'8IIEF*\\aҍJqVR, (8ѷV{s.{/詢Bydۛ}CZhjaŔ6vqfK6I#ZzvųOoo[+54!.yQ{Vh䐬r^PꗚVu,i+&խdT&!>-l.RbDɍ_d\'M[V?67\",ۛSN9%[eGL,uV6Jsɇȣk̜\\U$yԺ/.Q9,}qԍfԜ,ךMlHu}^MD\\9\'XeRn_a	^XoAsp^xDE<\"2DY4\\Bmfk%9m5Pd3;APxIik++G%U;[CgMtę 8`#MEM\\@6!wwsy۲N\ri\nHH*H|f\n+Ubξ6Tʔja$U);5ɪ:xMU(az3SI%~XPoɾ=]6\r6-ͨQ^KAY.\"\'kĺV7Lk$ܬ9n\0Jǈ-5=Z-&yi51<6eV&X\'e{9N[fh w`\0{vZ/7\\%o7ܮ4nh:ko(2iF9=LC32kFHE*kGܒ߻)J\Zq|іѓn+I^ǛS~ڝnyRW~GyΈtsce[M:8Ќ͑m*YIg}O$,xt~f+~oN{[MBIRϖ\"@9Z\'P6KYn7V-qvCyv%F4VOȍ&XU3I]O#9T0<VUXZJ3j1N7Z\rSqGi+%q}6.wO}b,ڲܥHq\\]\\ip,vG24F&tuRMokcosK$zC[]=J5CnٙXmۭD,|:Jڥڌ+Z;(b&{3#HZ<isrGk,CXluu$&k湳(#B$Nxe)IӞcF匛s:M(^Vi\05m:n-+IU_N5Qx;W8WHfD$ȡb-pcU &VT+VO/Igi_I$dHyr+1儢>~I[oj[4IgHEIecˬ(%m$f	u]+Mxfvkb6FąR |v@Qܢ;YFHl-7#Q\n@)Uab>f\'OU).dlfImH#23!feibQR8YQsɩB2MFU5V4!	I]K^эD2M?gSͻ;%kFkapm$V(ސ	Ha\n3@,嵴[3(qce0I$Yޛ0ICk-Sztƣ6[G,73-uhRfD0iH!$ƁMu5̶:a6RM(Rk<ej$TSVxl5ZxrJI*+g<E\Z|,aNcJkMjU)O٪B1nNKV\"po-CC$.eY|2Kp/;<N[]\\5|>FN#BY!Ҙ^UFG.Hk0Ǩ\rv(2C+H>dU\'%JfiZHt۵Cuh-qI¤Jd֖E@2ٱ~{l3RㆨTTa=;rR\nF.:ǚu9}sӝjsZuTF)r%˖Jg5Շ4/itAk9<Ba\"ŉ%\\u;K$!%V\'-Mb6nd;v\"^Hnc,jr9%ZMC0>]/eV[I\'8xVw;܋i9LHDK:~QvR2~W9+b-G	NF|+T&9:2NMN\\Tp1`RúNUTu\0s;ԂMǫCk=bV:Nh\Z4pܳImr,1ͪ[Jc7C\Z)hŞ\r|;=ZZޭڽ֙뺎Gks}ƺӚ)ik&8F\0ᾱҴxNKS{k>b_[K*-qu.m[xm72+>ϩi\rBՒBM6M?HKXibܑ<-.~}_9V>`0NUjJ,FY\n86c9W)x,Y!ԧb	᱘7FΏ$jS9TJR|++}w\ZnGZ^m5ޥ6jZ亖2M]fYfdB;bKɵ+X2G$M;2#\0J\Z\'ĥO|9i}7Z<qu)oA)]cF\0>Y\'%oF֩.qpInG#utv[eXv]e(/aĒ|)i@!͜{1L>q᲼>_xZb*x\nNcB\'Br7^\':)Q~`-:~*x<\"lL=*F-*5\\|.\"ط	dnnnG,i褈FmXsIs\0\0Ax~mCONb+e\nn^W1G$-tIFC0Dacg6˓R.uͷ<y<hg[D^,mb)ٯ/帴T{s`QW7yD&Xqy)b*ε{/ЧUSRu\'RSQ|ehŞ*4V5TiQ҄jӜ9!iB,bԓqX֯VNkktO\09cɄMs;3\\nY$q`ۼ]tfn.dǙb1eFJ2\Z]-P.4Rk[hRK;\rkH;q}[MfI|sAC$Z]goV)fy]}ų4پ#^]/[DSjWjBsNT䧈+eʔ^_OJwN:T=iBS4zPM$_˸h7PDHȹwA!0JLX]\\u~֩ok$茱cLD>stty=C\nёkueڤ0C#C<HC\n0\0M0#EIk\Zj#l-.L$FK$ZEpWb3HL|Wza*kƼ^٧jmӒ\\ム\r\'%R*ߴɫr;_y&\nړmJfVtFtK}CSF|1Z;o)Y?N+5]M-y-K$ׁ 	i7Y{kkgX]c0ҔE<w\'fF`	ח˵Co ix.TeaF,ËkKlIbZJRt/z(B.⿆)PZOi}X1JT	]\n5ZQS]zR\"v(6&FfhVY&b\n6V,%E12Yd6}yɨZhYa{e;-T\\,$ec,,CgP3S32Vfty_,ݤTm;&+xdq9i\nA卩$pBH\Z%qJX¥^IE;R ԴN敢\Z֢eR\\\\4J1jNNk{C6@ffM$`$snn5fxRK[C3lZ;)$d:M5#ګ%R9sϩjv60\\)[K͜;!I!ؒČU\0E^iCje}ߛy56M0y#R!<r$WƑC2	VBTn0Tgwèc\Zpwr|94	F{I9F!*=R~wtITn݆+%,%WA6i\"Sm12.$\"zܽ񏅦͵ߤ֚܆{{n$Pc\'ڤ-bn1XY~,O(&E=t(S9(He-f}iiV&YfPV˷SWiQl,n/\rV5pV7,ì\\UT䗵N~^\n0*M.XBQTXI\ZX)\\V׳}R_@+=fYmuX-``(mb餕:~q^\0h}4eSk,GlblDm:đY[-ɪNsifM<3iўPEdk;S{H`dy\"?/7Zz}cM֝bwik5rALVd?c&;h\"Qs8U=YaFNhѣKTaRrRI\r<<*_m5FPIcqd凩Z3J0tӒ8pSKm&RSDn\"_&TbǭKƷu+Xumb44_QXQi8-$e,\'/YZ^m2[[s{6L]*-%\n|[jsjBm<=_Eϴ.&ybٚ[vspMP\ZjK0ʓ\'N)aNnHUKͨԓ梤ԧ	х[}bNZq({x(\'Z&aZFjmo-Bolw[jV7/%[;Yev, ky&vs}Z@pZ4FEr+7ƚ]uM[1Ei7G-\Z\0Ak{s%-u%ƛ؅q!IaV?,V_{i-sXZ)^59$fs\ZSLln#B2&+9ҭ7KVa\ZptQpJZiKbaKKFxƕHՌӨ{ڢeמ-+hVdr_Ɩք0\Z)L~ff\0UY4\\,#a[*!6嵬kwjHnm!Y<EDV0d}εqo!<ӣE&2o(apdt:\\񾖷F;i/3Im=gȳA4RBZgDUIP\n(f:t	Qԕg:jjT\'B\'\n)4T)}q5N{xW5-f-V+w߷[W\0u!s\"C=kWi	usQ+(yR\0z-5`Ji\0s-<ZlR۽(GgtGȰ>cFL-ZZVҴ]tYnYXef$</Q\'.l᮵˝*Kcy줒S{A-	`E!	PaZtIC7RTybӡN:OϚK]*P*jOGEJ$wV]z*[PVU֝:ȢEK^epJ򥪤 !DUW$TPE,v\Zh;M)PdF4&rwp\rE}zNGk<\0O}El,FUG/6yS*n%9@5bPP<ڦak1fIͶRVH86%n澷Nw@pXnZERt~	^3s6IS\'k#A,*2yecf,<LhSW*K\re9ӎ\"X]p}Zw?rJUFj*3r瓚vPKٸ4Sz{>\Zmhuëxj[#=U)Eoq	RKn(,,<^P\ZHݥvYcN$IXy6Z(1=vdSm1mn0iu󭤀ۢx.e\r4ghխ^UeV{yrD\0qcyV孎a)sxXZ2JWNӤUsQ~MJu5J/c=N,%H4:挟7W0NیVf>)ecq\nzN;\0hRP+tvjŝ\'M7LeMqo[p?d!,a:1O+eX,^;љ\"HccEUWC/wyC:&-&HWV<e\n=*?ʓJ2Jc\Z񍚓\nT\']ic)8Jt=j7*ӤNOݒISڳ:}?\'3/{M೵:M{<&3<FLmYo!0t[X}D7K*yq]$Ybb˘F!}RHtvbJHR4?4[ FE$2 vU/3]Yuto;܉\'[uH)BrF؎_/	kV*c	fG23\n1	O::ѥ*KBTYA6\n`iH,\"|/xz\'R*|ܯ\\G6棢[X<AMfN5=26ўiB	%Nt`^Y6Q[4\rjK<be#(y.$:19\Z)$6܏#\0U^F*d;i 쭭n.t)9\ri$I)X^+	K1`0p(UF*EbsiӯN5#\nsN]H,uTyӧFJzZ$I7?/ԥZ\0iY(ݴ^ڍ/[hcba{{h.d`m#Y[ZNNuI;5{BC.Ki.`m\"ծOq%$1+k\\kqy!ť\Z>,,ͪK	Zi46%`i5ϡ OH(Dm<;g#}nNJۄ	I-8\\.`p_:l]*(bª<B\nupss_\n_QTK_]MQ~	Ԕ9ƣ<cV2t8lhW3Mwem{=卬:|ku]EEP[ۋP<iM:ż6}O8Qqgynm\"vӮeA\0%2E}&O[x+X-*5K]T[I\Z2!r֡Ҽ9_j[^ &pujA}:X/4b;hIؔk[YjC𸊸)(STajNT]|=Z-NpԪVъwR(b*Q{єiNrʤpg[y.딆FQk=>\"Bё*1вG-M0\"=ŦE/trMY|<l%kU`!њYf,o2Y<,BV[^fO}+$r/̨7~Eo@0\nùbqXo[az\Zta)T)w׊ʔ_lNrRI4%URTQSKo嵳0%j\Zdw\\PF۬v.i#I\'%iX6iC5+s\rNd1fZEm;y`FR`YGE\\ƱfwB}6sV[pfFrGI8%\nKE6OM(E\0_<Z#TݭrM*uiZEV3ܮy#^uhק)&Zr IZ䒜#)6psb*TAPUm\ZurrNYJis,\0͸$nb;\\KoJ-\0+2ɑ\"TA\"nK\r9^d;uy<39ZREUI8M&X^[prK[\\f	gf<oyDv\n#)uT:hg&gW5LeARP!Ï*F$3KZh_iJ|SN4ҊRrMK]b28ӧN2q8*3$a˫\\WNڙ̮Z} [4SuY\Z%,UsN6E$r7LDDET^Y!yCrDB\"eYk3y\n2,Q|!C<g#YM߽Q]וkXn.˛I[U.I(MO6V>lȻHWV+T:tuK4Ѡ{pn^*2Jj3Zӧ^YT\\[䴝<67<#_@$v(a[fVXGm&	PȻ#	\rO\0kخXMIg}[RRP7Oe[cq<\"9/v<`\0Y|D\nb޿(*]?ٍke\0ngU{KXdf$K1N\nxJXbe^P劔i78V\Z10SJI*iqN[UKۚm)(.Ւu%y2-$\n$.ci!!&dXj9-2Ig}x#֖>lR[EVlF%Oyc\n=Y7@*M;;[7H-GÁ+l.NRBImaOd5Sn[Q6%vI,O˼\\Ikn7%_\rK\rFJ:IG|R8B5Tn4}Vi-О\rIJ~Ɲ9ӴT8NOv3>c\\xO4!Ԯ4Zw\Z|%]Z6Neweŵ>5[yR[khXA<7YW2EiukunCɶ,mrs|\Zީs{mlTI$5Ա0-n`aa序ߕ:]bٵm!+r\'}+R3pX7:lћ]aԣQT@1l`a@B7S&ʫk5pXH*J#\\iдT\\\"k\\C\r,>a:qqQ-:Xu\n^sVn3u#:칡i~%tO}]X\r9I,EݕVѪ\\9ѡ*O!~5<g]\r.;IN[\Zmkk+<zK{-Jv+o\"_[%{@kvA/4eƖ\"PdB&B6H=?T*ksڵo5/O\r^\rŹ2h/sje[Q9/5>Kg[f5#<N+YŹԡG6ui\nEJ?Yv7(F.m_2Stҡ#9XhӛӇ\\\\,|g?m<9G_YhN3D	Zꖚ#IҮYy#H푛rdQWS3*E$cUψ4ǶX^ZiඎHRKBAblof0[hx=*>c0{\r펠,b.ݥZGB;y`_~#0d8N\Z-L\'f>eWRrΕf#^RWX|5J(=.<},Mi)P\n_rnRMZٺ͵;<8bx4&/:^@bܳnɔ ˹iEK$hnsoY-mBPڪ5ZkWo	VI-DҺ-EG[ h\0Th$.o4ۭzVQ,JU.%![KyϹBZy<}VH7aST/8*\\JJ-i3Ϋ:	N*pJSc5N7N|[4z&m.=ZM*iK\\ybuk51i._bt;bXdaeg4\\پ#6 $sIqs2]:qscO-hԗNmu+@a)ܷ1js|H0C|k@LӴ)MKI0Ũ=İi@HVW-i-OpfifwY_B&V36T%\\SM7|8ek/\'Fj:?gl\'[WI%ugstw|-383M;fed$94V<rItM-6_>\0ɛd[m9Vζ_}jboYX\0>~o\\\0h$~Z.h?\"EʱQ,ʅ۲X*4(vA`\r`Kb	<t\\?hdt*(=rj-@ϣ#Nq0ܒ(SCJ:	F2Wj1Rm]~WN18tߗcy*YKdI×H d3kwztg^yKs1,nSf}9zd_Mks#[GRdwhp?+4id*X:EA1zu/O\r%\ZR<қkŵkE=\\>:]^JH*u*$i\'{_~W0!q<2YLRW؉p&8f2Fҩ6g|5AT,s\'ɜy4 esW\'5\0\n|jX[ӕbH##N+<MJ8<5nHt)aJGNvmKCҦz%;(a^E5k\\ڵ$>вnMG\"$m73j\r_Dm|\r\"@?TD5䪉͵Hg*\0@\rkDpY)ٜ(Ė$<Tq_Yʡ[RㅴT!R5RIT8FPI)E.c\n^R4⢥XHCR]E%\'{wlX!-O<F HRܥ4dBD4+J:/n\Ze]5ō4K_Hw^\r |$#BU$FtgY%EcT={gk{{mGPB\'~ j\ZD8}\"(L45{%R%͑ʧD,.ziʵ7ZgOB)IXrSN:sxsq.HMSn~Ӕf;vxP$Z:*Ao]O{&Mn=%^kX;xCETW__^i\Zeyںw#\\흤O\rŗٚLo{rIzWvwM(xwI0r%NggK׺g֧mF{ml4X]Մs[#1RH~QZFe[,6a<Lq:TSc41\'IBH*Նk?kYr3\'3\n\Z5*sL%=ZQ0U\'i+BR[úV귒]Iq)K_Meq}FcV\\XCZX[,oNh=q\'Ҵf\Z}Lhom^)004 W9V<Q4VnۚG*|2KYym22/7M;āL$6rTx!bBw+HQ,fT$3gUY>R+:Y-IѠ\'8ʣJ28,+u\'W칹ca	DfӍ+im.%{I\roo|VF-3m4Dr;G$+]&}_k:{fʞv﬘/lI㵛b<i\ZYVR˽e*dBO1àYY^6>\ZTy:Pc&(dlĀl+7|B&8\\.VzxՙTa#Vz8)Y򌦜5:#/jXԭ~F8,(A4*P\\ny쩩%̡)nҿcelPl^yWK	_&nm{^Hvtpu|>ZKz=YZ7b\'RKk\'tml-GX8NyHyd{f\r#ZYd`I$3RH {3KmJOfS5V+6Qm,@7Q+\0s,\'&Cѣy^st1RRR*؜NJa)i)vKaաRtXҦKd3u~IA+;\Z8>2c<+4p\nWX[h$$*Er8P#IHY=[\0(ӆ*%Hg\n:;n$`rI$I9sqh%bAtT7!v*\0O\n\0$A\'5ظB7cJ|\\b-S1:QjsF*nnJ)INkݽ[h2]\'tegX|䐉tk򴃘9>Dq<s8g(EGkpX\nb ٩sq[E<heA\" 鏔sYr*:I6#eà\nOP>=(¬hOY(PՍnNVһ0iYUgQr;Z&kr~FE:)h58s)uh.b\rDpdu\rک[ķyoi	X쮯b]LfcO\0\",1\0l܂GU1*c,K(U \r\0/aӭXoq\0\rW\np:sdj<>13bNJu8%IJ2\\Mɧ\'h#5Tl#FztnN\n~޻aM]P$Ӿp\'o<$^M܈pA=\'@\\O4\"QG\0s09 <Ҭ$Nx4=mإ39uY-0\0\n|!^]Ks%N\\FE%$vܤG=Ly_ppr<f\"05քkٮhB=ԣ(.WR(cr\\~ΥX<5)N*^)FjezkX+>о5iVvͅ摧quEk~-65=!\"R-fpH懦Mqweew{K0\ZT%%[yHn+!>8t\Z=($	e,EU*8DC(<wM[=JMt7i-sc)`Sf*\"8˞z|lc1UqTF̧Ns#ReR?ee5(rF4p\'[K6U7VtE>ʃre/m7.fkGCkmkĚ<V\ZkhJ\\[ǩŧJ\0iX%\"kfӢA4}Eocis;߈-j\rY&94Vx%L6Gw>\0Ӭm<[F\0ڷֆv(0[2۳4DXvC^???>?ifMdT)g6{p$)r\nE	S݌-xJPZ/}\n\\uIaZ:)Ɠ䝜KGG4b,0\Zu,VЍJ*98Ŵ+Ifs\rRK.OғtڻèΐKH]ͼm\"ȩpm._/1y..Q$Zo+PU(b?\\\';KH.\ramceSz04=Es:\\=Lb/i<Z\Z0-z\\:־{?b)}Jxf1B)NI2:RqST۟5l/qIStc8s#?-)Fjiɢwëfvv#^-wy#D1,3!GtB\"`3-\r?\ZnOu=ԉkgp+&y`3g\rq\\Oe\nCsdvדZݮn9e%ڌN\\V]12qa\'>k۹yi]XaVII]hZ9e\\$ke1#ĺ<45*RS(TX%)eӗ{2&l>\"tcN:5iFNRnoꚖogG5\"4jk!.m<8i\0Zq*vX[\Z;[{XӋ(#i-a!wQʥFCēP&K%k;x?,&IgTkkK\0 Ɠƅ5UsO<e5̐ʳK,6#rL1vdR7,k`B\\qԦmQPj8Ǚ)8[<Ol5hBiQk8&֫Xm캴),K$<j\rb6elʝەN289fY#vy%ݍ,噈\02I<\0=srjU^Z2|$	kyF2E{',0,0,0,'','CAJA',0,1),(25,'','8888555244','','Segundo Producto asad',0.000,0.000,40.000,0,1,0,'Producto Terminado',1,'\0JFIF\0\0\0\0\0\0\0C\0\0C\0+\"\"\0\0\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0}\0!1AQa\"q2#BR$3br	\n\Z%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0\0\0\0\0\0	\n\0\0\0w\0!1AQaq\"2B	#3Rbr\n$4%\Z&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0?\0LA1NmJ.ٮ.BEeD3,!F3\Z(4VkĊfm5˓\rͽaŬ:\"Nea+M4 N4y/4[K[oYcU󢺾Bnw S=!Vj|:@X-.⹞	݋g0,\ZK+R%\0J]\nVnթF\'SީBcNj{J*N|P^W?H`8FP+Rdof䣫MS\nj<ͭ][f5[m:kحl7ϛ6Xck-w{Ʊ_w,9zνu%\\ɨXa9\0O6dGZƟ\r4סݤiDrۈ#f-b{	(rHOK9Ρ;!f71ȑOQ4.\Z9#wh4bd:9MrQtgT6۴h*RhQQJIxznXt\\7UcQ1O8͵V)EIԞ2Z[U{ۻR7L.F)^9;t(Lbuk&5ݩkˋ˩bMӒ(IKh%ZhN(-u^[C$|`K7dhEkSUi\"2E-εGce,P#],m\'Ligw[CvV[{THf25^(9\n^&,ppНW+teRG)*iW)ǒz˙%UuY^Э^3=*)4Ӎ?q9ME\'~\\&K+E&^tՎ\'%m9-Ɲ=3mEVNբK)tNŮe}JVqè([Ȓ*,%+inMwrO̅١v`?٥F%Ey0Z}݄	-\'ehAiu&y-qx#)6ԣRxsQR4eJ1vVR$2xjUhPbp5P犩)VN	:rQN*_5ˋfNV8E&x`i7SyscuCO{iu-zSY ZmUkcXأ=B>QLY\\7%gHHh/!KwV1%ٵǞ8$1	Y xcic&)xwF:Uio5pG^j7[$1h<+/26qL&k>=el$*ⰵPJ$]:XXRWQR*r<*ͧ.Db׵U**JqSӝ\\UKFT5\Zj3Ji?{{/+Uxd\ZK*mX#P{9{	n3ʯ4palldym沐z!$e \"p`3bK\'nzti:Wnn&%kh/mlk,Z+HC\rҤ!u.s63,}m-Ålc\"{2Myy.<w>vF69֕L6\Z_h먼2Bk?}{\ra:J5Zt(4w*890ѧJH:^8䮢%.K]Fsi7vfYlZ.l-nӈӬf+wnm/%F7MzOw,7⼰a7>BY^2ƶaɝ3I{$)&s3ŧݙIެ6vJqju@F\"c	FaIT3Zy\\ZhdOٻ}\\EZ[L]K6x`-7hFU}z<E|.\ZtjWt乡\nP\n+ը[\Z6G\ZpV*tE)G(\niAYOH}5*IR(%{hP[<wv.b,m.Emn/{[K9on0}VfI^1=qKvLRy篣ꉦjvK6Im+[ٴM\r^IXFnq@wuo	\ZBI3kBƬ\05\'*p򭄭FqS>H;K%ȓkc\ZOFJ&Egl4\\շvYhG2^4]ΰ<Lƻ$h1\"#F٭<\"[{{wWr]Lк,8#f,:-L7xy	\r\Z/o:,L[%Geג^GU7j\r1弐/o$v4\nXt7I4-$aӉ&FW6n#.G&H*ԩ®RTB\nJrt\'Ms	({Fa%SJ\\{cNl,/Х\ZQ+Su̹6֮.)٫زlS]+_D4(\0fȢK[&KxH>17Hv.wwd,k$wn\"+x@ʷVEĭr!1);6is_]q}ZOwO,-۬ѩL./\\*<2T/5*]iZVp}P6wzS]شZ2-ų,Kތw<=\r,CN=UTXz|TŹSL5vj<,e<L%uUFڥƔiӕjr|n۪˭ks1lkt\rIR[Iku{n+W 8?.u]J1=ź/u!ϻD+%sK,\Z괵TaXW$̱XG1Ư6I4ݥȉ9hM&ѴK4q\nEmmEXR.d\rtьUkЫJz!I73N2+&ҏ$hRaBȩNUMiRҽ뻩a%Z#{q4+똜,sKLǯ[}JZyy.#6qK*]\"-٤y,Kih$g+`Ma!kYoOp_f&	m$f2ɶ`%c멢\0[L;;,RY#?Iˉ \\..hU*W5zєaneI)J5\\ԛjN2oueR:M%KN%(8JP\'5	F)ův.O%݁--Q-kwP,cb_R5_YjiSuiioo\\[[gHSN2-k2,V.j\Zwm<YbI&s$-W[RFH);W_O\\&3[ܗ*\'u9hm\\YnhuG(u#(ʕJ315*UUiSZuqUmee^okFNs´\"ф*Ӌ(F<nd=q-5^k\'KdSB\Z@w|hf?X/mJQNrC=յ0[(ZK[m	{Vn?_\\vk\rɴZͮ\"GO:E>c䪖tsᵷ-B+\\;-!w&XKkKdʶ>eQNRcwV+Ngu8UzMRΖ\rL֞\Z\nЄj5#	Jj:oP~ɾIrl*׶5ݼ!%ߩMM4RWA=[j}0fB=>xfX\\wrU0JK;+Ho.g6{)(ݥh`m\\9SU<ĳ[hԵ].u)g,jJȒEn3Ir\\J%a\"o*|/ae6,&rNiK:RRĨiY:T>+CNxMNt%%	rd>T;{FۄG\nw7%gk\Z@Y-gq|v|tij^Ku<KC3ylm9^_mDdZVfBTG\Zgo--bS<s{%یIqo`8]N]9 \ZF}]G:+Iwu{)$y>H7F	/_Vc\nUSʞ	hP);{H&-a*9F1Ν\nҝrUJIRT긫/u՗Co~HἽJ8!ìxcEs\"FI$r/|քcPyB[>KWVi5fc\nZ82o|FHDH5L_+B4y7* \\Vn5+94&n]nn;MHRosr&&P%KuiF:u*Tri)=a>Xr.5j#Ro^eeehB$\\|S{quR	5C.dYmeY#xʌ\"(MZ--7iqϴ$39\"D$,.wY\0XK,chY|DJZ4El|<DY?!8Z.wNYˬBC:ixNJdWKNteFsj&U\nܼ񃜫֌$Jgg΢U<<IF$F3j7GAn+N{M	f$I%^9$gy#RV7f%F%G\0QQ\r\ZxPӤ D6VS!,J_Qvmsvo`muo-9#1WK;t\0meΝkOo5K\"[cɑ#ͳQkEܓ]Kp&e8\"HӦ:uԙf\Z8X3m5V-І[%J4oIۺ}Krڒyn\0H&S:ȲJhBE5t{V\rPw{<qNy%OYf,$xLʭ|4L\\i0J9^R|\Z4TR+pRvV\'a.zcWxTrpm4Nm$[[5R:koe-,WW˳;baG$\r\n\"?oeD6HEIKȖ[5p^8%6k-ûK3EƁ}--;AnaD.ŁcI\ZInaFTAu+k6L>imkT+$ְO{1Y1Lyou2aR9)Fu1\n,CIF.q:UR%	^n|ӕVO_:thYqVtJ~Tڋ%1崵wZ^a`{)R)\ntwlxcSfRgTysHyooc2Ik/<w>>q1y3\'\rv[Z6ejie5ݪq\r팗ö$٤g{I4HjkioƷ~rMRd8H\n[@͕Wi!#үc&b#*u\n1ҧR88FTs8MS=p39\n9ZJ0HU.T%)9\\`Vvbc6SnC7ŃLIFll*|4uD<DqqçQmO\07	{jpCe,]<6Km~V[t3G!2<k{Ms\\sm$#I\"\ZoLNak,M,eԮKq\"F$Pk>uTpT(ӫYbQTjV:XUMTZs~petWCMIӄiΒU*>W+%V]7\'ֆ\n=#Jgkie=辉bBk$\"5ZڛbjGtȶmMKEאٵʒH#ʹ8UMk4ve{(j-FzAs,%aA-#4ܪJM<eu\0Gi1^J~1-E9&&]#xSzM\01XL\rj֧0u=Juk)SRoރcΝ\nUTXz󏴜Ӌ/g\Zhx_[pYصV\Z^Ϩwpq,L_r[9dz\ZD>D4KH.;bg\Z}IusH[[|j`.Z8kξ\\E<Iqftm[vT\nfOηR#kOe,,ZZW\nY^YY 76moylqde,}4>_꘺֩bpO8SMB*0(JM*:~[Ҕa7Vuzu*эmXV%-.(s(Yx${=H.YBGvKL7@-[;K\Zk!!d0[;^;(dXQۆYdMqw$\Zu5ڕ$%[{GX\0)(Ș&o.n-ZnPQ0}$FFBmxV`Mjc0Hz1:TOeʜ(ꩩF)Jk{_k\'ʣ⡈jƦjƬj:QN>)s3]Zng5mͮYCpC6\n,0ȗ[/J\'b^K4ˋ/m&k{{6P-Ħ;u+C<]$R#9Z5nVQCqotsa-Օ&A*Av]⶷1en9`H5O߹7ɨOkcI@#\r$Z?	t1>¥x)*Vy60qgJ4J|K8/vMz(SBjtBO	ISr\nR8{q^7\'DMT.y$am&!gYxioaH-D1Ƒ$^}|-<\"3sV7W:Ə{{k{{A#DJWmdܼQ\rJi\ZOn-;_<ѥ\"wah!޲4)\"#GX\\ԷNĖi0\\p4WWБ$4MqAc0W\\{xRQPUQZI.o:XO	W{Gx_>IЭ9[1iICR3n̵\Z:=Սk?6n\Z}wۀrunӲܔ@\"ws}]O}jmӥ7Ao#iͱ;f+)ǟG yi쒬L:vBa=ޝtJtX\"mMowpu{y#$Nmu<fĐCvV	vO$r4ouҔӍL/)J8.MZ85N5#VHu*6yC\r%+rB*5M*ROb98O{Yix/,sXE̳)7?hQG$L~[X(58%,du#uJ4Jy)V{wci/eT9lm6Y+cg$mZG q§s%RIk+\ZR:,:\n[Km;G)i&KG1$XrέJXz*qqս\Ze9q|<UJR?eQ(Zc:/jtUGR0V$a&ܯ_}qXhs,W7DvIZ(Z$kyV?.8xķL4F(R;]1\0R\ryWxt-#4n(CKnMjh\rD$ݖS\ZI\Z\\c4qX@YS\'5;Eӛ}]KE\"ʹ1vde\'f\n*dNt}ú~NH8îzPTOTfYbst1ʢiPXUU9O2:u\'G+J鵉a\ZmI8.,Hc21KGS[	+}.\rscc>{:3\\3\\E,n$J;ӬuƓ)#Ffm2t)<$NZkhbh=;utM2\rMg}Jiιx!rʬ\0H<eGVs\n5*t*<ҽYb0JZ4}TӌէZHq8/cg[B4fgQNc)ƛ59KܞSW[yEc[؛yzC\rմIlw2Ly%&113:>ch 	1GsO*AYCWt5]4څ$[GubFċ+UM}mRZ nhys3QR\nDb 8px*JӝCNxj28U*r¤Ӛp:PpQ7kyncƃ^/T^tڭRJTԡvJG)5+X\r$}\r\r9ZxohvUC9r8iY$jtl\'\r9#>:\"t+4WbMsm^I<IgyBDfDHf}k!SI.#1x!,1PHMƒ e澀\\Z0ZE<^fwBUFJ4%\n\n8jԝhFy}+N)\'\ZjN7;rTf?dy&Ƥhɻ4:0vWI嫋mRFKk([r-~<=gx5aYÇ	nimfak_K)~c{őojAo)h?`؂$,K[\'TWkL\ZZ5UO>ݖc\ZۗI_.\'2e\\QI=`KP(w{o(omI4#[oڥIӫl\"HeRQITsr*r+$z\nntV\ZZqT$-$8ykMꜛ0[Gs{=ͽʲK,weY&@!hA$z:,w;ɤ_K	K]CP@ wi6Ȓh66{[JSo(KFW\nM\"y3<[T\"Jl7\r˘hnLvoa,rf\ZT\n_/dA-m灣ʷUVF1j\n9T%wQӜU\nSvX⽾)Jq9U\\Pr8.[WR鉭纎Yٮ4g5de;Dr-DNQeI$h%b]kYbh$bsOpђb+6:KŻODh..]=ZKI,Z!giD(K<³\nK&\r[hXZCopjr-%N\0̥<%<ul)\rSJѾ&SrNҪJ3jN5=+F(s%9ʤEE:P	r3:Qmzh8}\'JiQ$k}wu:7-4n)<k54g{qH fH#@\0`qEk˄)/=$S_,R_TZ^_ӷ]N=[Ul\0]HKe$ݛ.\rVW\\;}Bxmu/Ymmjv--x\'m̄G[ܶ\ntNd\'*	Yr/%Ӿ{\Z[rŎ2J-9$:.%Hb(.\nyA<2\'q|iX.n[=6ңGWXY`=Ŭ&G\0}<=HUCAMl/:S:+ti~ZNn3U*a\ZJg\Ztь\'*\"J\Z^3iF2|9E?q1VͤgpKx5yY.m:VlR]ȶ\'Tqz=+@m麄xIg29$hQKu,k;<T2\n˧kRm.ͽ5^^u6H	[t$QE6\ZuoE-@^E|\0gIxw\r0\Z, ?\\MXӣQӆW1iVF)˞N7BqQsr93ӎpZ4dJԩCNrU.IFn.Pn\\ߊ拮1|E#[Ě(d]JlX#؂4;VFqyRpoIm~Ѻg$d<:Wot}峻\'1\\<#8!(pd%J&% zXjfarM$2\Zs#K;3K΅7s(\\7#p*xiXĔ-Yҩ^ybr\rbezae+і#1*WI1I%dxBѬc~ Hum.#:O1BhVEĖ}6ZV_ٰA{y[_{RCm	LCmZ,+$38jFKPwB೷sd67\rl-R(-.g.deMR[g1Eimn\rHE|&7Z!hYx-ǇmJuq)}fᅧ,&\"𰒜 Fs*W9+sX,jHUy>iҥJ*xGCH5$ڄ}|4dJt<{2\n=-Ӊd[).B[96	jZ=[[˝K>-.Yx좊	.\'JZȓ#\'H{]R\rHjotlmKi400yo:7A\Z*[\"ogkunp`^w.&&v!,.\n0F̿*W[\'B	*U(ΝS(SiŶZNVh\rb(*yjG\rQՍhέܥ9)V|\\=qj4{Ifuov7<7sĂT{K6,tiOJU&)5KX*\'yNOy>%ksvŚX!mr$*5F-myhmw NHSG-[ƓE5Y^Zi&$#A%«\nʭmthЖ\n2tʵYFT0^q+njb$\\u_k)խZb(U5FU%:\r/F.MV[iuK/#kɯcXHH0-+[XU^;#\r%,=f$7xmL\'-5;$kYd݈eJu+K;g,]lxᶚTse\Z夋G+*LcuԹ{	w[XRXۅ25ߚaKd&Y$}Ҟ3ԫ*ԥ:xi1GR7/;.zJpѣTnCT*M[퇕;)+TVy6u]vR[E{ӫ iZd&Lg\']t֍kpZ\r=WpDoXJȬ	$I.L\"\rB{${M.=T H@Go\",v̊_`=\\=Mht)CnHQa-//a0<*ةT\ZIhu!ݿiiVXfSҴ)%j1$FXU4T99=QIǑ4)eŎ2MVg3	k6QfasX4XpC3}Kkxm}܄MeZilf\ZVM,so)mi$H;`O$*bu[A\"n.ko5n5k[P)Vx.#x;[(\'ʳȖ7&Bl=.\ZIchU$SQ&j(ᒧzrPMoJ+>\\#WMh8\'\';U活}3N]N0Chl`Kkwhd,9YJiWV+hZ\\-JU#H$FYLv64ƅiqw4$Y.Z58$`e1g28/ufԼ=3fXKek{Wb\\RYBơ\"V`Y*Y}<cciN8Ӎe(R2qOتtҏ\"$iYp<Q)ruc?Ikʹ)^߸iou(,\'JFY/pna1G,=Hfـa碻Ox,Θ=(K(|\Zwi$Z%qI7Y5<Me\0DΑCڴr<ex ?h4+C(n뗰3Xei>[]i&	m巹Vw[=O̾id|ˆ9Tq9\"<9M᱒WJta)B4/RrTsju9SS9eo4:4ӫ79.iՄӔbSϖ2/٭C}4>VͩY,I}H\\7!\'KKN1/Yxz#h-ذxc\Z	[VI_ay$EBp~/murEqorSK4Z4YьB\\JX\"+̏.{9-/m{ab\";YO)Ln\ZiVR%.e汹f2(\n1*uatUb+BQW&+??͖2tJS:ʅHUVf]NPEiM`(uxlL63X	\0v7da+u+6t*imLc&fvHxT,a*]	\"ynU\"|$xT2\0#S>AůAamu$&m6P>\n]UϺq{$KM-miJ:t3	TQ9>XIe*ӌ*t0Tb%)ΤShF-Wej:\"x[,KQ*!$9$9LC\'wRXo4dX$ekkNGn\r\ZqIuid/j6˧+W#KHckH\'.#P6\",%vb\0O[^[(;4$͸Mh|PyVd7j\"\\%\nJjSwVpjqJU)%OaX,:,=4ÕN\\SRNTvVpo.dW7sHJ,D^I`\0`HǇoYҥ\Z}iq7̚4	F$,&IdKL>wQnbi.+\\¬l!^)LD	d>E.6խ1U%;f|\\<bI&	\n%AQ2Ml.6W^ZIF*8NδjB,\ZTy4n\Z+h֥I\'R4ӷ<mQnN\\sM$tNx<y^Zل=J]%ڴq2St?wZh\Zu߈<M=Fy4:e\"ki^{{S#+YK.Adۥ\"Zgg`\n>!I\"܏u%=>X{y1BHd/*Ivo*D9#,ܺ\'R8&J)ǕR<T%*.#^){NFg&:<~&4\'q69h]]ʗ6^tnO[\\H6J6_<$\"#K:gݮbh\"[{&Jg226ˈu{K_/͇{wb\rRR$?,Di0TX1_^[]sA/u>uKy3.h 魼_-^[aWཾ2t\ZUBhF:JrqPJIvey$yTxB\\oT7:4ZU%.77Ȕʋ\rFj6H@kwxmd&%e-BF-X\0mY\rL]WU,\';xn\"_ºu%Vv0p3\'u,wXe{.KWMBi$Zgf*f}ٵ5Q%o\rsj\\Y^G<p0$O6|3&*rN\r1uKF>Z\Z\"*F!)QsІ{NxS(8\nʤIN4(UЫ(mRsjlk=Ml/uiac\"ZIj]ItVȅ0Ko]I%Ԛ{yFt,<d`eRl2(n7F/c5n7_0*򵧳KinR_K[oM^ei-/\Z:i\'V,ZG7$[zHw:|]<71ih<Ȓ$h\naGR^aqZmmuqyososq,byʩM5瑹K硸vusn>ɚMO@4!s T{|їO4IOB*-V\nT^PF:\\_M\0~ve9L,UХVWIm{MWiygB@Qm{ŒIVgv\'tEsҬVqj:]֭iQbIFn-PF-mp=[[ZPIM$$RyoQl\\q<Ak~.l&dm )e$\r#v%*Vc}>:F89F0YԵ_~t&zhYΝXS[\ZZr|ukO<Q:V+E$[KTOť	\ZydoY%4XĐyX$\nj_^]Cqme!4\0Jk֑I$=AY^ix-4\"ꗖDm$F}HS!\'tu#կ5Qj\\i6dˏ1b6gP@/o$BPڬ<6/X\ZuE*%AJpu\'yRiMr;ӂjN9F4(D-2<A᛿:uؼ%|\"{]>EJ]-R(,\ZI4}MΝǤjvZ|d:ؚ^tC$<\Z\\<[\"d#wF-u=\'VP;moj\ZP&],c6l,FMKYŤV&(d2#@X@1:\\+VS8{RኩR5%ZT+TpN6%RIzyeSJ:t\n\\bGtci9YIIMkZ_E{y,I]SG,t$0!3<Gc\rbuʹZŒn\0f(WX&h<OȱN6z\\_ޤKX-Ȑ]䷙1,F$BcN~:5彄i.uq\"WvfĈUiY\ZEJ\r+F%|.gG	V**:2Njѝh<D/)FZbiTVF+aTwbe+]6I\'wopfGoa\ry:II%\nGh{]\'R=o#ӧ$o%HnJnvB 5EUgb[v^0ycwt$u7{%r\0)opRq.km29\n>ՒYgK<j%WfI3Q\0>ƞgӫ\rIb!W*N\'*5y$\nn2\"<>S_\'9ε?Tmӫ6Q\nr嶨}έ)[ۍK][ymKiou̒^%慾~NBxmIyxvن_q3%Z\"(9㷺$ueM{Qɬº[1H.ˤ2,230,ӻe(!_C-m/ua-%jduc$>\\;Exd	DW|ׂgx$p5a#7_\r哨US^\"kTu\\c5Z7hYg\\*zz*~ҟU\nNwg7xYv|\0	myx-m#\"1aC0Kc-fzMu+6)KUmkItFdx\'d{(#)!M{iMbO*D#o{4n\"\'n\nysX֖ךej7ڤk{9{%kIԶ;e,9x]l>.xIѠu\ncRUc*ptT\nV8B\'F84Nj<%R%)ʌe)9^-%\'y=Κ?khM4=2tQrd;f?<Nϯu\0E[wA3+Iyn.lmK<^JG]\'xdg此irDVBh;E;}se;w5ojK+V\"H&e5\"+\\ڼ|frjs,l6F\'VΕZSxڲϞ;*S:N4|X14}X{JJ#͇28Q樤ҋ|ɽ:\0MkⅣYVwp6EġL$O)!/s{n-ݝս9?!XeXfl\\Kiyo-laUz%V䑵+v\'K{|[C̭,R^ɾ#_9Լ=4IooA,QشB	U,E^&!w[+/#><󚙾4\Za()R+)T5%)NJ_^ZTkub^#ԧ(݊*vVi9kм5ff5&wwx-cK(-ᝥ-$\nLG$/RN&DӚ7Ɛʖ2CoqDfxF^GRBs5x-涐Y˧M\r1NKh<1S)^LE;3&7+i!g\\隭k{[U Q-B?Fd#@h @Q6\nSCʎh\ni8JJ\"N2툊ܥ%ln!OUgAN5NrNSs8Qq,I9ɶX\\^4/3\\khJǒϳ&igF,ؚօq|8nĲ!m-\npr6i@qim)>Zw$y^D9$Wz#2E<~<V&״{@-]tfDQ+:69o[*i1QRXzHuRQ7֯9EӍEJ	rNqQ*Riƾ%iUNԤ(Fj\\uGÞA5+˘nO&;~Ȱ[xd$U\rjzSچ#iЭfc>l]|\nfn/)[\\z]443$d-2.4	C۷X/[X72^^5,Pyp!R$Bۣc6\rt0\n*ZJ\n*qTiF7w]XļT%\n5/	B\\tS8rI]Yޣi	4PZ44S\Z9(	/19dI=0ZSd\ZiG3mo,k\ZJ#J]\0+\0GXxYS	cqa-P̞{,YOsp!C$TWS>&ҮHȒC\rRm	&9#	p\"h䝖+O:VF,/gk0F4Ta㇎jUN6xҒEs>^7t18\nXjB5IQZu!rB./~%ΉYaSCd{f(ma$kED8l[\\JIxbdI#]xWr9P+_а(kv3I*Z8?>h\ZfJ<\"$Ү̾K&~(BH;|!X!OG\"VWT#QZ.pjJ*QKYJN<-|\rN*Mb\\8FQnOKFN+Gs_ú\Z[I^%$k2u4ֱ<I-;Z7ڤ.C$wcA6ľh\"V\'-_&̀276\\WֲBoSC2r@q+1^[RC:{Q\Z\\-᷒+f\"K&&VNJuÚ-5V5j1rY{KU^iҔ3\nrT8Ӕ|Tsi\r騻sYy?hlu++H#czܵK4k)g&ݨ4c:Johzޢ}N-Pn.FKCdZ(&y~W|hۢ2[ĚWYMyAxg\"fh2qrvZkk{}yeqo缛PƛUv\n\0(ors2E<;UsdEE.J|R}76Spj}HS(bk/k\ZJ5eNӚΒZڒ-/h%$Y\Z1$ȷGL֭7q[$3\\l\Za5i\rhƁ[\0~ʾT~e?Vգg\\DGk2I<1KF-b-EtUV\'xnq$(<-vx#eyE_.\r8n:U0!Z4O	*?U|9<E9{H%AƟi]{Ez<X<=|]wFUiUܩ{8Щz+ʧ=ڊo|\Z+Ϋ0GLI\r/)m*5ʬČAFHZfc4Qr\"!UrXEDpӴ3؆{=zBjm\r\0;zObo-I$~E<߳K\\-i\Z AR@ MKGk;5s6iЫΌ{{a*YCc&z$?km[[ϙI;E4jFAߴ!Q	 @3J$S%-BbPE#C\n8VFP\nBܥ<KP\\bZjOafT*9խI\\\n>U)89\'ͣKQer0swY<ΡNPVV:.EβTe\\Pw®A,Wia̫i#k8#fHG	&agM4	WF$`i]]I/V1KYsӛ8A~KQ]9\\\\d䔗-5$\\\\1YC)6/jFqZP|i\Z5-:墱Ӯ/M%4w3ݹBYD̎z\rΫl514KXƁ.>m70\\V4uZx+/]] TI٭\n\0%bx%Y1!m2JNp<iYbct-fdc<DУYpB,qM̩UXVOʾN%BKaWV\Zsr%A\'*x\Z\nPG5¥*i:H˖*>X%IJm7dYkG>\Zn\"Ew<ұ8%c`%c\ZBmBGRu+{`Y/\r	i&tI!H$A\\Ii{[6[vKyin$i\r`\')Q]yk˻R_\Z-=v6}mLWo*s\nq&>~+\rNroVQZp1pSVjn(rӌh+VjԢ*17NnXyXPQ(-JVnO❲-݅E2$y	nCimqK$G\nG\Z*ܟ2Ҽ?76P[{jI-K	&s,NҤQ\",%W5+MM[+G++`Ts\rŽr&$y&W3}ug(\"hH]$	yDD*Fn0\0\nYbg^a)GK	FnRW*^MIE]ͧY\'	>>\r8UXՆR>iU|QSQoS>	xv*4E@oU3[\\H8UY.%e,kHN7;[]>g_ncE͕\ZIcHX<%	GODjPGo$`ltb-2ʷ-dKhʑ\\cqr؜}G+ogi2q -4)\ZE	,,/5Ju:rJK:>zE-m{)Ԏ.+t:SNI;Q7eR>k5_ۮ=]DAƱ\'61%3gZM#-LcAqn^&hQ-dwXa8\0RuhnFoǤ73Y GnuS\'fޣv	htA6bv[\r\\>[U#7e]([*tZܴ9RtKauaUU#:U[VyƝJJԛSQ⸵}>[DdUHu+,\Z;Wm)aB\ZH䫤sI4G¶P734ZFf]q&[kT`c+]F{T*17\nMa	F-Ӥ(-ƛF}nhRMoI{7pF\";C%HifQ:yn!4rFnV+{9F­Hӯ9b6swYbR0ѡƵ8bg\ZJ*JMI[^7M-s|𕌽;Z-؆c`#GiṾ-|E>מ\Zw5X?z	|ܲ$@	aX%׹Ťj:ķ4ٕ\'\'=P{ure,hUlz[k:ng~E+_,RC,%{%2! x$W*\Z_F?sS7\nju*Ε:pt:U%9{5	8֩W\r*);)9Nqkxevև\\]?F[eer.#1o0B*+I1\ZB^D]#l55Mj[촷(-gZ8KgZIq(Ybm<m]ϫk\ZOo&5!#dxkŸ Ʋ$̭<Rr>mj}vpڄӢ$pC<\"h%cVi%U1)L.-՜~yjukաrr|7(v6\\4(}c>GNiTVӴ9BPJVݳK+y4ZzBP5[K\"m\r07%rϙ[m4(k\r%Ŵ多95I\r\ZPv&1*C5F{czc\rJѬ,=nE\Z-Y<_sVQ6[bgٖ7Y$(WhB+|1XQƞQю\"4\'NSJS܃NM(tfQl\ZuΦ6\"2mJqrmUs%~nJ7JJj6j[sbukx-(-%ʋdsE)#,Qn6jFb5YW򭥸M6XT<M\0頰fo_K~VvCZT\n\Z\n.4\\ZZ_,s\ryj<қeQ,f	p蓄iՋ<x<6;L}J:8._cNծ>Zkۓ[yUN,8a*Ӈ4cz)ՌMGF|wZ&<AjoSiĶhH.o<$o潹\\I\0VBC_tM6xdUU2%fiʴ1G=6[`hbq(ŚQ˅ۗVaG`Zl^*#2@nDMM+eGa(io<%WU11+F)ƥd%\nT%hjiy*u[êxxIaNQU9(dי.${cnP|yiFjd8RKC\Zfts[xHt%2Kby6χe\0MYEΤZii6\'yn#w|<Q\0lekQ:յeA%2N\rO)`D(G-JPO\r\nPLE9MU57ʟ4g\ZjKj^Q%u8ݖU/ï˨K\'DVpIi;cib.\"2I#luiYԴ\r/Fy4{lMwf2yVCo)0x%ne*{{X.%M)ަ)g\r52%iHX\\([>pH̳Dz8qņeVUtTe[U{j4ܚ?SeWѩeF5ejTqv/.͐i^%mRmLideY,㉃Bm$#M	$)Nާ\\j:t7CH6\'HWU7ΐZF#B6@sB?k:tcc<jZE<%\ru\ZmDP%TObnG V3o$6E\"c$ML)WNXe\'z:1PZJ4\Z4c$VJ\\Pn<Ix)ХISsFT^&J0nWҧmc֗n\rMWUC,F4xI-(YAU\"zvFLڅw]K$v\nBA;qD-Կ*lmIk-fwOE2&\"y%E_\"5HϵUZ1Y:C=֗o<11n1;JYۀmncj\\q	S+zƃU,V1ZQN\rԧWe0nb#^\Zt΅*9(ɹ5{r^EbA.-+\ZYF	W2D]mmǓpivkymjHbxwI<ެ+x)ޥݓ^?jm6O{[{Q[Kv`m!2LQfs}2U-V+F^F_%cʩq*20|&\\4HER8MTsJ^;RTOݱ.\ZgNcNcF%%e(YM\ZN<xj/H]<NxsErOù~n8!.H#\'$\rB%Wo{\0&^_t>-ү-tmH>U6IvhTA#Dckle\\I#yLI4[}.ݯ% }hyB:eC#Rlt@^j,KK=:C$wA,	q!SGKgo#\Z	l]^ieY\',;p$i1@^bwN\ZP͇aNTKsJ^~XBJ1qrC0jq^5a3I:qVڔbCֽyys-Ż&SmdkkXG8mn\rsn.2ZZ5(bX(hdk0Y̎|pXţؤ\ZE+w\rjfGHbx䌵ɸI. rp0p^xk-rbKUAЬi&kXܫڒIJsVQRu,*U|edMB	uk,2c)ƌ)Rhu=aJwwrIOt>m\'YѼ+kkzMe%,\"cN\Z57V|~n4.d2bHWfmq2D\Z5YSJX#}A2KKb#I\"1Evp[G]&vfkCVIX,`rrPD#Xhb}zt%\Z0K^\nxs*4כV.REF;khJj;ү*s:pu*ʌcNQ<c~Uwv7\"y\"66w`C\'ڌ7t@ahxe#k4}3P_եi鵡D#8X#[FA*ҨB!, ԴNL^Y!n/6+C;IwNixD(f5h%TtdMoq%ױƭ*Ki$-i6o>Y݌1T8!V*8z,<k_ݫR49ǙGKZJ.;	UL&+4P^Z}pGRiZ)qu5Ho.t73,jѮeXC5adi+HKyZX$YcuUE|DAv4:]ƖmѢQr5^F41`C3ILۊ0KR}b;6+-\"iL%f1kop幙/\n\rR6QBuF4*=)8|TRVL*TsNVb\'ZqT]EQs)n3JQ抎mģksI%H)9%ͬRm-RCBA潨}jJ.21^xmh!%1\n̡X25K<r_jkR४C.mEؘ湖Ha\ny@qsxr}\Z=R=<S[<Q慠[i$7T䔴Dsyب#J<H)խ\nYУa7(GB2U#$~URJ2oԥ\\d:У)ה41Sjq|ʚm[ݡ0[-f{ۈ3X+2ZZ4xlnQ%]ŴvpL҉.e0NJf(,*2M+L?A]ٮڌiy0G5q([WXk1#3RcӐjCmk<^H/\Z).1DncJxЅ<&\\Qѡ*8H*N6R\\Ӕ+Wi*4o;i]|:+Ӝ9Wrۄ|䂊	:ORvRҮ\\Z^<owJE,\ZmHq+fO3{GڞtֺX[[,Mw=֠yeX`XԳ\\4j\0\'ם=?X^K=DagOOmR(ASuMi{KFA)%\"%Y{IeH8ͺ \r󘜷T<:Qap؎\\DJ^J~ЫV+ڝJn0\\$^o\ZESju)N)ƴ85*P~-eT$I+l{1㻂Mk#Vk{t1v%\0*^%]YnL7\ri\\o\\B\Z,R\ZK3:ޗ\0kg6d5[Yc6oEMp1:MK#L%#E/b\rFKfKiQSI\"f*O,1)@񧃘K?éGVԥ)Ʃt 8F9FRPIJPtr׍QUS:xY+SRSe\njQ喋Sė:sVҮtRg1cw- bP!cxV\ZKM[]\n]ś<F6o\n:D8[uΫ},R\\%ō˧3X hc<]dI45K(젷5soP\r&Y\"EHZ(ܙA,qA$\0hG2jԨІ3\n,$x	WPNISTcaBeFqpi9Ο/2Qv5RntŢ4>dSK~ctl-ȰkxL^&4yNTAu=$sHJEyA2;\\G;jZ\\d5ҵwmo%tS$.1wFdح>Jݮn_(h6o*Y\Z%%UE\'VmRƹF\ZEVhфyYNP!)I*VZscF]`B\Z%\"\\4&4ojvB$/\"25٘\"C+ƤƫX:.,z,q\\cNdX\r26$_dU3E5MFAE\'\0TXΜ$\r:r<0@a`o.M+Śύ-Hu8\nj7jk5ݬr^Gh%Ҭ&Ca|[6KWə0++`cb15OBMOXn4E9JTRRa~,%`eSmkYQ9%r猔:OWZ$G 1+R	\\j\'SkVermxmmRIB!%\\^\"eZs>ep*)kO,12tq&ldfķ\"C0UR*91ڹS#K7\ZkT9tjnhoF\"Im:[*8*Ҍ\nqe엿߻}vvi~Gnf,(7U1E+D\"Uc1\ZL>(mT[{{U٭o}o*Z}r#fI$HUALdk{yZX(JH)m;$wk:_-ntNqmŋ.`G\"5HU,[I\ng8ggK\rZ\rU(רVJr\'\ZrS\ngTqJX̾&\nT\nPqj\\[xov|-z}BmO\"[aL3K%G\"9xTY$Orѯ/Z+o[y,\\tX+DIW}365(ȌG$׫E,,N+%0y$[[o*U\ZSx2:bKPuW,*ܳMv<flÒG\nyHխ*\"*\\DiӪ^U$JQj4I7ߛffkT_G;s:\\\nj\\*	J>ﺤmϬZ,д̚9Wd\"]iPF8ɪK^9VivJ9(.X#\'NOwGM\"<RnQ\"\n(Y9\05[XHW\rap2+=n.7@y͏rȞ[r2l0Щ_:4eN\n0NpHFSjnջ?ʥJ0\ZNH09eVn+-OjZܳœa\rk {y`o0#Ōݢi !Ѵ^voJ-˼RNś|19_ߚZz|VHⵟUZ;*Y}\'US,\n=\nO&K?J,`X浒)wja\rKow[|$4.v>8eX:*XT0TjK\rZV?BTңM\\3Tn52=	8>*x%bhʼXN^NصV~qp9E=d,]S߈/ү#u+=t6Vhl-tm>ّYZ%c6obܨLk]^ZHkż\"Fa8>&L>ma|#kB\'ayw5ԑA,*C8wGE*+	^ŉ얱KoIxbd\ZbdnnXsUᬫSK	Z<Ƽ:)b\',%/o9J0I)7R9AE4}Ƶ,%l\\iRJk0N%KY4I|MI&Q,m7$\0B%2rvJW)[ҊGRi8<E|7\0V}G\0s7z]?.m~EvMOzfioI6$roonKJ.- 	$ f\\H1<?UӮ,OS9!3Ψ5O堙!y1$&f)&4lo`5S=ŴVѣA:+$s㘬Kӻ]Y:/kM}okXyb)]Dbe1]Nw2K弛Zq嶽~[Jia+baVUhq=T+e{F40*VE*RJ:rQII~2Imi|t95X61-ctpK%yBynfNoYhFŶ;\"6ݦ-̱sBR:ZǤxβbtɮ\'I1Eyirb^3^HgB}Jm\Z]MAYLVOm77/4,1=o))bkaJ:TqrVh)RJ2)}Jkdƕf3w<;pS8SyTn:E{Wi-_zwZ-k/-67!q+	9@3U\Zz[o\"l^^٥MFK܆SXmK(%	q#rյ]2=Q.-	Ze6<eg)KU0C]_ZjMu+X/M{aGrxli9H·e3`5;KZH)Ÿ(MЫUTF6ڭ^;1x*h\0[\'\nT*:[i%~h֙\rԡ6{Gp[y%İD%~uo6 ieoO\n]xKo4،Ng/y?2{]$ȑ\0Yk\Z౎ 97s?yˤ:*JCUR.5MNC\n&&d$Vkqu(.ʥԈ-]UVӻ]d tfYQa1E,Ez^ZQV\\,*{oe5UFt)VKԛ^eRGS8aЫxRiAӄƭY{vi)(˗X&EѣS[y-й(;K$	526m:y^iڥ0Ztm줅evhVLBܲPmxd~\"״]-b30Oi4CbK#3ezƏST/1,?fK!݄wP[i`GXZ,)\n.+Vy,:2ӣ˹Bg\ntԄ!R0rJr\\i>c1kb*R\ZtVKNuQSpK$\0.|7PWWl{uP!# y^(Ǜ1No赵v֗wjr%$V,I$\ryI#њeNmm]J$߬qʖ}4lFev&<Yw{Zgi8\0m:VnI[J^}-\\E\\^5԰Ա4%FLU)Tbֳ:EJ.I+xhCx1JiS!U$\"rPi(Qܺ\ZLzޭvdm{\rbG5G?;3̡¨%xm-j\ZZ雷\"C-c	\"n.\Z[qsGxn[]YKl]Nݬ/%kkKXrK\"ɱ]ӼE-kiiֶ\Z7Bbϑwy9Qd($^<-<l\\WJ4N:\r)_tW\'$쓗=vIΟ\'EFqrrm+U6yX/Ƥmg}]$=`HZOB<.$ӻ17gTPRZta1){ao4I$9x[>шKcK:rhE.,C-Js	+2L|@*>sM`Su_<!mFC<~E,39Y>hf49G:rZ|Kg,MIBNmB%NN	NQ}y5\nkJ*i\0ATj$9)F*97Z\'+#]\Z=&fOw{47\\CIu-\ZI4ٞ{\rߛ[μY41^\Z-^Hnb7W%33$Rƭ#5zռ\Z$k8di.%rY*%őZiqqks/>[oOwJvS܉-d83ʌLK\0Hq>/\Zy.\ZTZOoBuIӯ*tV\nt\ZvWᬣbiN$a<E%\n\\zxU:\\iǕ=#Am}+mOT1Kw{.=G-(\"3chbdI:)tk2ؗeWHFyPB87\Z($x>MbIԵYiт-ZK-I2X(K2*\ZiEgV)UtI[\'Mo%r܎i;d7pFckw<e+a`ƮЯ,m%8NJYQƣʽJ2哌◣O$`#lVG]ӝHa+4ESTdrPPb[N*qrP.in+E-(]I$m,.1/@	Sz,-4Kuykm%%eJ2P<w(wfUI&ֵF}cX˫dyMѳ\r#]]H;)&V\nm67_hu=2{[{p77E<Vn-^F[hy\0T%\ry[C<Рܯb+t滋>1\0f,^\"\ZR(iRbI*M8>hI}vh[ږ+6^4A<Ѭ<Q8rJʌE sRĚ[YXϢ4]<fd{O!sJ&[hL!BHi+_\rcwpҭ[<Wi#o\Z\"p#af2QѦoE-ZIwM|_*hЉn;vnb6<Dj|̲jFJS)JPq߱uKsUJU9oz.j·Y1PXxU-Y2RqJbiQk\rܳ.+qIncycI?u4zHe%XͶZhfڼmkqwr-V{xQI|Me\"xph\Z꺌z5ȑ}Y[=C4\\\\yl7:\Z-֥ţY6l--[ӢrIo#Jd3D:i`+գ:xs\Z\nf7ѩtTR9Es/NpWƞ#*q:ԩ9^\"߳`jvZ;_:~ jlPe!M~<pxwYƫ=充5V+hxG4eQyfH]1k%o:MI-죈YJLom\" N%#+1]iJ-DIGQ]<I\"\r^\Z9$²102#Q\ZKJ\"TEn\ZHMuG> )BN*Uq_ܥ	8&Q\\}l@}N{S,\0d[Y݌ro,p&Gy?HaG)Q%OI34C\"Gr`<9^˫hH`\rum4H~D9BEH\"|5|;j׺uܚ}ދ~r!3o-$.d癢8uH9E|N\ZX99VjABJ\\ʷ=:uIʭYr\nmߋ㉯ZE:xjRJ17\'g8\'IBѻWrvgj=^|;qѯ7.^x[1]}DcR#tχ:%lsrXj%Jd~Tk#ˉoO๧4䷼B\':d3#e(#y̱F?e_{&/LK\"65\n<erd?!	60Ø)b+9F=*sPF5*\\ԩ)NM>g9r8<>1ua)Qjv5jN\0^LKk\"[bXo%in`H4ǒ4DH]-H̲\0U|vYIu3gaHb·kE!]#xfYv;0RXamV[.=<%Cnd=i^$.Q,aDT1ǕeN-ŴS^Jn.EImq*a6H\0\rV:58(US]J1J˒*to>IʣR烓JmrƼЫ8)*Ѭ0IǖJO9:j7iI$sW]#jũXs,v pc)3SwJIy2$uY{bvI~$YW&=GMnul-Ey0Fl.!2Ѥ휞\r5\rRm*u3gzZLf+,4]]HZYʊ,Ee\\IcZOCb}ʝh.ibWXTIy:U$,i.)4PORXs%7Ѕ:vJ\n)TnOޕg[[$:Hby\"8vEgNr2qEmU_/-u\"6lU09U\\m\n]ǵX쮾_GhߢۧNglbݿsCUuo^#Ok^u\\6{MN74-\rY-/]ن6@cg.H猃;ᾴ̮^߲}vmH,r#$_ݯ}\0?k=Q_\\xoBռ!gok3U;k6EI.tqwå<h~Z78qnWx>HƁK_ūEhzjQL%е/CۆRL1R)00x\ZjPnj<DiT)QUrf,XH\Z\0YR5O>jU\Zb8F1gZC,\"EKaY⳽.R47\nQ%\rw+]ͲN}Ji1]hYIkٻmwe#ZZ7alnM5ٳP$2;Zd}K\\Gx\ZhxF@5K5{{IleO>^m[@-4\rkM*jյ\nsg$mIlF_\"{,O-Ȫ)ԔʵE|:匭({6t\'o{\'jK\rV8.KJ*mZg)e\'nŚhY=~wPӮž5CozuGGow4Qo\'e/Sj\Z-vp[_Y\\4=Dm!MRM͵y8{Enw/M>~x\0ƶ6PksK`^u֥gzvpm]L}H/xOS|7}{M@v\ZR94[.`Mvi:WfK{y`F\Z34RPp<T㊌%Vp>i)BUQJ\re0X)Ԇ>MQʬpq9S=muOO4mcCiZ&!k1TmdUSZՖbk`,n-+<K\n8~^!oijzfᛏj66v3\Zuj{yK˹xKNJo/ZVvSj7zsn\"d:\\)X\\çmuw$$FUigi猖\\Bsb9hƌ_՞\"-Nyj];~I\'氧XhUaJ\nsI%I׳lj|,.Jy-,\nL<sAu\"h.eDE]_,LrwxQ0}=vy,m|!x/q[:@@Ky\\N:Nf^wM}C5X>T.>yr\nJUXV,rI$/x]ӼGs`$0^O֭HԢMy*l?Gip%>.?q_m\Zt(Nm<M;8xW[aN^Q)^i(Fc݄c0xb*cC.ND{U	TMJK~rrֶGWsZrJhm,yYI|\rfx /W{\0-NR$&=apnWOiٯm/\0-?Ub?kqsk{w77ZXԵKD-[+W[H\'Яt	5_K?g,\rF[. D׼5:&=`lPG0E|:Pdո޶<F`0qL,߳RZta\n\ne:EYF![Q~L<6a\nα8AW:4B1ܡʜӋo	/-*k;Z[5Our-s\rd7f0m#B\"7;gJw&&I#?%%3d,RK4Sݝ?	/|^l|sO=53ǩNmk{m,jҤV<M\\[+g\0`!zG\"xĶV\0W4\\Oݾ4J6ӯk@+}itE\\U)1qz/%VqREJ2cgRR\\Rj)fSgWʎx<UybcIEUJ$gJ*HF)6k]]V\Zҵ۴Ku\r&<]&hHe\0xWt4>ѭ5gڄvbW-lEqk#![he`2¼Y\0O?Yf\0BAw^+=Bp:~oqj^\"$\r>bڕl-nmؿ߲MޡCc@^=2BA<W]NW[<r-\'LUk9|.N(xUROЧ\'E<$*qRTs5$׺{\nc)e?R[^rN(ГHIݔ_#&~ {MZHзKaFUI&\'[ku[+	iD*$w1KtAn~&D@:Oa4\\=#X*|W=\0=__,ETKյtzHkR>(-;Mlm?L%\0/=ZN_a_Y,[Q\':fj6ZrZ?\rh{jvPψ74ĺt+2\'G8BVTԖe\Z*Kr(IHXY,\'*{[TS8ק)\\qOjt6Ւ(l,\rȋP@ҋfmđ7̂U嵿j\'?hI+@+[lKm7S_[m\nO\"yo9Yecq?\0=5\rFPտAq.[Bg}PD\Zs[x,%⵿Я XEgc~:_~\ZLtzTv:u/?\rt2;k.fM^\rB\rHh\0m\n@xb2̻){SmNF4S%\ntrJ1Vm	ҥ*Ӎ\nTUJsVrIss7yjũҖ>ּHmQA}eZIȥ-GY-.lAo\rٹ1,,SE@&D2\0~Ƒ\\7|uM#UIuK$֗-pO5[[,ck3ө{Cp4kQZ#[8!.Ih-LRI$~H2,%wVXҏeYabν\\%e+K5u\nR8$rq~fYNcU&J|VcIӂU#ɨʢƝt!{?&oynךvʷHJufrXye*I\Z{k?t#o!m<bh%Enl,\rieQ&K;-^[i5bڭH\"Z1l94ʳP2ȱ2iKmW0JL}V[t!)!\"~o&G\"˱Jqug^߻)Tөʟ,(J?IRcpt<0S5:u#)Tnܑ7\'ݥN2/4;+:kQ팎fLy[42 Fѳ^ouIcy>d-WeK{bFj1ğ2DڝKh:`Z]~17S&ss<jI\n[<g,Zo6S[;K;=Xdњ8}Dw9X[xḞD\\Q9*ss?ӧJHկEOT\'\rc2I^.93JSe\nrqR6){Y8rM;NOG떚֦go-ⱚglsy4ҥąV7($9/A!EAIxAYf\\H^Gđ=ıq	xs#Ӽ+ߋ9${˻kY}hNigHJ][/W!$4-BlnJ&8D]έ՝k\"MKfYV_(TTҧNNjT`NwiSO1Yste0Wf$9B1VWI-.o<Ke8{c%o:$Z|\0ƤfXw-t;;m;Eӭ0As\Z]IlK},2M3;U]Ә*7y^s/ݳxKtk<JQ+3msj絽I_W.:44\rH_wy.-h2еH!OYb\"h<}W˫Щ^3hBurfh5g-/-PRJ\ZQF3Tg\'Ȧ][dZ;.7fh.Ilxm,dWrɵ+GƷsVn,\\M귭`ى#X.HIf0fL\"OV][p8a-m&h,Qm-NY6[iqZiֶӒ_4	#[}[ .X7CTx<Va\npSpSt)FV*qTe(oV8x<,)ԝZ*s8kJ\Z0ҤW*0$\Z\"E\r<Zqg]<UQHUl*pP^S6o1YOa<yboʶOjy\"AX^Wo,5WQxn]cRA.PAm+K}&%wey(ә᫿xofA%ʥ2C+V;h#H..|it?=jMĹז\Z;\nTTԩҞ,g=*ʜlRmWἒ2FFJ7S*W׽ڒq[Kh-tcܿCx.Ibsq[X5&XrE*ǵ\rM\Zu4Qnd@Fk<mLHG3j<ŠkkŬVZ麽,U,_&[ʱYt# _\Zd:ܶenv߼\r$r\ru$3/VsIU0T|CJ<UJ	P)BW,m5d/0\'	My6UI\ZQٹ^	k$i`citeT%X$	hZ\r7WPcnEq4rŮ#,ٙ,KIbNMR0q^-ɇ4X,ɤM&}l\0&ƾ\Zck;z\'SV^\0(4Q\ZB=#ܼZA.I\rZi|_CxkX|sIxSEog᛽.jZ@]^W^bte[iD⮣cJms&x[[	?9?\r%ѵ;//Nh\".XIl؟\'u[/çxyCm5O!Ӽ!jZ5ׇum\0S;>m$#\08K[ fWXӯ.&Ju\"(R\ZJ9e|K}RXx}Fԩ!NQ%^^xWS}~s^ډk\Z{hg][<M>\0ĥԭ.[_Ew\0-[͟t-վxoKv6iXhã/]\'K4WhB?#4mYxI	wC.ouɦͥJ\"|?\Zo=._i\ZGUSx~wxPm+RέO4UWԵ[OkvI|M6qjOlq]yRg8\\6cN*RʒΜ\'{V9UvQa<\"3JVJQRM˙[Td2SӼ#a{_\nj 7m5sOM{×\ZkMK\rNy҆q~Rz_6<gPx¶:~Riom5O\',4_M`UXJ5M{RԣŌ~wgY_xZ?X|= 濮hIuki763\\6{k}-\"u=fد_\n<OZ	i)h<+pRD :͠沞2o U\Z59V=GOp)7zG/NI\'O$5>I),=YfεWR8zS5KJqJQs޲V|C/>.?\r%Y\r\ny=G]KjE4{[Ky.z6l|wx>\0W4OƱ%:m\\i&}R^mg\\ְ\Z[|Au}\\jڷmK\Zn:,iz5Cuwq3ژtw?vvG.}^j>߈x-P--uW-mgBѡbiúIB3C1Q)V痽&|*7\"\Zqu*ECrÓwc(.J_u~&^thSXiuXx1-Ƈ7Nh4^E35߷_<;\r|IytY֥wJ\0rjږ4i:q5Iig}yaw>?YZ@vSwWoqw^eޥ:k5zMs;X~|bO|; Ӛ\Z:a{okM\n_IÖGonPFjX|e<Ej9.*YWZgda^QNt%G	S;t{/х*X<q4S(棄9$NM7Vt<GZO0WѴ{=[&KC3Awsk%-5O$S5MOB֗Sj#cCĺf-Z,6:nu{ˍNG7ZUw6zDVڅğ|7qm%|5aIt[SC;)&Pm*;u8h\'Otභ{O;M{\Z_XӴ?\Z&]xgG_Դ˭SOj}oV{Eq=PxT!\ZQ#NJ$3?kR4\nr*xJQ\Zr\"|d%ڄ0r(.X+P\\>,EWH;8-lɭ-}ms6i-ԷOlTx#A*]~~_t_\Z7|O^.(]P+w6w,rjZR-\"ѵk5K;Eږ_\0\n^\r\0[Uyzx\r2Ox]N.lu|;h(Յ:UXk1⍭,z!}(a%5F\Zkev% l[{ycK;^8jfeѩJYxZjj\Z\'%:坽˒`#\\^\"+N.<82Ime=ŶkW\ZlM6i Ӣ/s9_&쮵+\r_Oab]fVK\'̟\0d:-\0Fڼ߶H/DN,\0W\0V.m̳I}go$~5&8/u}N/O\\gqy_I463[#kqȚީ?ues#]}CZ޲%/eto,N:kWx{V6Z?bolY3mmjNQ\Zja%F_WʓU)E.IsNu9nW}1{xJ9A4)*zr8u++¯\'G/gkG|/OZ6!5]nUD:ZZYXX>[uSIC\\zvgmA`^e&Mާug>x^QTX.7{}?-5RZ͖m~?ؾiu;[KۈnM/ҭR˪6u%Ui?t/\rK񞡭Kq$r\ZuIw=V/DZ]vxTk籼m!*U)Փ*4F}y~b*Ғr`,JviBT)JrkJudJq>e=RC%͏m_]nuMGF)uhcΑ]_jK05{ļҾ\rS^6bcGNxDŞ\'5iR\'O7m?=b=rm7wiZtױZxCծ!Cq˩n|Ht˟i/^]mol4g[f\\YO[q[wZ7SKfޡmZk)t{o<A[ Zjz]KssCe/j9SYVn\'(Fkޛ|Qr&iiZ,LᇓrUaNPZVwmsC\0o|o<Wj㲷}x|֗\0k[!,OAaۘ%Ԓ]Y}|Eu|8{mKźhLoym1jO|-_Jխ1@\'$vOLxŚQnM?L4K[P82gҴXhIKIeԟ6:vhOC64]j=/ú^ahv6(-,-m,~cKZ\r>\r.F-eYOxFml#~teN&\Z)M{%(Q浲gB8yeʄ%g¥4O]MI-nOomKM[	u\nH5լFem54UK,bv]2]=Zٟͦ	_xOUEv:е}GHͺ;a8AR\rnR5{Q⯂\r$gþ_Z6?Yj\ZFu;o躎-5/yƯ[I5\ZPnn%	d\0\Zf.^MҼUtjLѬG^XX/O-Ρy=VQZOĸьIVnUi?giΔ/\'R*-,\r\ZN55U%)¬ڻn1M+E-_O?ڗ%7<+H\Z[}ө鱝;K}7F\rFY{55i\'/O{&Yۙ,|]b=1]IaYf\\]<Mo*㸶?OvO}xE~ӫIkXƊjd׬~fH\0-boSў[;31xTHPm#5,}F--;V)\'_[-Z=F10Ҥ[^HT:R)O:ӴbVg&;!Uu0\rO;YaJRW?\0\02>.|PբO6>JӮ-zn.impV}?~NMgMK<+yizDnִKuұoi7>![K5u[[ѵ/-\0^>Vh\Z=ƫ\'}KCoM*mBóxVFӯ$,túbkrWMЬ\n\\A\rΑnwFt5;MSL`EqngF[HVmykkvm٦Wa<U:8tpMҧN4U\nQ[JS\0apY~]C\ntԨJesNM9\'+;GD9+<w\rSC^֡Ak#S-VPMi~m:Jm8xWYGh^\rGBSY\0*[\0\rJL_H.m$g.[XY²[iWhaeĵoXZд.RlVxI_ZhzR]&{,GizMF?>&\0,5o_ú|>Or^Xq[|<\ZB\"NڍVxjh|/uv}ԲL:TXxά^TrN4Jr͸]fx:҄<L}\"<rs j>]ZAk:-ޱm7:.ɫj\rO[լ4#F;kVu}2ܬܴ3Knyd | оڵ揫kz/t\'NY4MJ]H}zmJP{jRhZ{H5KbO\0#x+Z]gih^!Mе-xO\nwRӯ5x~ҵzwo~|%[iϡͤɭXO>>J,nO֑\'FŮ-t~k9<>\n&\nr<VT«U	F,s5|ʣvxcNU\'S*n\n\\є\\=|ќۊ, O@M\rm\ZyO֬t/˭KH\"mm 5-3G4\Z;A5_f^y_i:E~04%NdXŢxOym]4?COa>]i>-ŇQmt\0x,\0Xxz\0S5O|f.k>)\0RM4 5?GX>s\0j:?5%}#UӼQLu·i>iPcxK[V6\0\r*-ԡO؈֧u*Nuㆍ<BU1YNUʇUF(ߗ$r΂JF1*qqT9aFi.SmJ+CƺWj7)xsZ|?xKm\'C{<aqƯ~(5ƇQvfMuǢEe#Gr\0dHSPk`^\\B*,g=\'O9-&_v|3ͬY/4ˍ?@2]hUkv\ZMggFW|i~H|}%|9.\0Vϋan5\\RZ/ek}:뚦Wpu\rv)%ݾ xkTEYXb3J|6\"5:찳JQ\ZEU)UUiǖ3:ɥ	ROjJ1*MJNzTxSIj./\ZHo	xcfVP{9&yb\\$Τ>Z^xBKk&	gqQAmVDLрa+E~K5{:𱊒䇽ϕϩ(\0Z0ijzio3x\0Ocs\0	k:\'OX{K\r6OXO;ojxx\09ᕮභ5ix>@ڜ\"]3L\ri{soa/bml!O3J׈_\\SxM<\'ZMlޜmjj\ZmtR<3\r᷾Dt;<oeIj$ޡK\Zg\rs·pCkQ+K}vD|jYVc8L<T\np)xhG,=%_N9F8aEԋ+LcqXLN]NJJgE|<J񴮗/i6/_\'Q:|Au{ xsYO\rþ4GZkL\ZD[a64xƿ|Kswxᾟ<OtmwR:uŴ<a}b/tkNI0izƣxA}Cɾ?j^\rk>CO<Xo|_}Ķ`4}.R\r}!c񇇮<=+g4Oۿe_A}>s\r-GB߉|-xJvJדðRGy ^MR|1v=Lf#9B7YIMT¬58u~R9NrS<[aySRQTU:UyTڕ}t_x+Z棣xZ%|GjךΘ^?EWuK[}~pxͶm) ,ŒiUΏ૭2VzA[hzPѢ{E[C{5ėڊmj$j?mcMΈmόf߈%<TPStyu;?IΒZmnNv5/]KD<siھ{.dQ4#uY_İìhbKX [(}{FaV2_P)XƜSp!N0J*䔓tMO\rZ:91Prg$RZVku}B95[kˆI4SZiw<w,wV\\FX[&b\'Oe&IFyţ4ƞlۭfR+ۦmt[D-M\Z+&\0\ZP(RxD\Zt6r\0ĿiA,J2_ׄn<\0<q9\0\nS[-#Rj֢49oE[kK:FoK̥K1׫F.2HSV\n*t(žMT~S\Z1x]աNHҴӄ.hEUzN`/C0x\0\\ךׇ}g^&R</׌[Il]\"MV}[H|Imkw3Z3}/zFG\ZTz?l5hvjk6\Zt-nw垡Zo5QW,BΑ3{iFJ\ZZ<PiV=^]jvp]G&?5}?W]4mu(<_csYѦ\\ ƥUtrLOMV┇/\Zx㹗\rRK}cҫ*NIRQ5	T=T\"X\\ƢTƼ?UT:ܐ%ՓU J/M)$7@>-C|/|uϪx^!5/RӼ79mmkZ-Bv-fBMNɚ7x.-?ÚER<L5\0\r|IkxcIN֠iW~OWcqoHx|_q-\"&Դ#KDν:$)m{,0h:!2eWm? ~MM{;i<<N6G_\nڅxĳVIOqj?\ZU1Gtѕ8ʜU1ijNKSgR5)NQafJI_4^g_^&Wt\05S0\\Nu_ÿuGX|p?/K_&^F!4\'Sox><>Ҭl4\'@7,\ZK}Z\rjChSKMJu)%2i~+|HwjZ>#j%5-rALUixRKφK6N>8IBo/(wxǑ\\4=T5:%Ե-7IJ]M{=gkiz{Y_ׇ#\r*\\ʴj_W\nm*8Q+bZNc&_++sΝHݥ}_xPdZ.{oo|TK4\"V{\"JcզCpt𧌿-l.N5=NbxŬkk_lol#&0֩osMhǇ6MS\\Ե^9۶MKR\\m.},t%	5ׇmMiVscix|U6u5\ZeG}+̱keάbUKNEUu.d+ԆHUx)N4M{{OJ⮵1\'^9S撄	8wvըm6ױވS:f2Y.dUkB]}{1巛QҎVEu,[R\';4_1Z{ao+cPf޽ͼ{\rN֢P֕N{(K{[f]<V}og%.-\ruKuR4B\0ԆcGze腑/5߶pj`*b\"NtԔU>v)sǇ[4f;xjK-C|KPǧh1xmBh4=4[_/mԗֺƩf\\hz~4\\Ž\'vgoo>|څƗi\Z|6xV)s-cìړOkq궲`ue,RH/\0itvi-HI[I);^\\I_\\j֟VvhCQeux]Kox;{y\nލ\nMOM6]*_ælnJӓR[V{6uņ{~ק7/̨ӪuZ`8TFI/5\'f:8ԥ:1J2rpM=OK}[[с!qkgt=M<SWmY]]qw\ZVuJ墵.~,Ksu.i[].\rI&=;24=>].\r1&>q}\0Ox?u6ÿٗѬuk>Z2QmVnĽ~\'V},%i$Zv}ĺvmltOḳ![qqk^WW Z]*Upɪ~qDiTZvW\\g39\'\ZNxt}\"ԢEqwM.4B]3F{\0sR[^k)mi;6KՕVsfr[>,oWgJ6$׷YOO\nZIimk=4^kϬkEo<}4-@5\r6RekMm.o,tfwWc]B/ik%6zK[[i.>/\ZxJмGe|=.o-vvqj.ᄾ\nj7RInZ[!#5iRV<<jR*BeN1$㥞Rw[WoyYY\'zxx-ִoIcVM\'R\rBxN۩FRAmiVڇll\0A7.g4}\nU5-.%\0LE\ZT7xkGX\r|/֬M_񅆛cs[;WSZ~5V&/tFS}~ڞg`!]4¾(tҮtMKD-τ]vÉ=}-2R>Eڬhn1?\r[^ҴӝyFc:2*MJ\riZ;J0U8i6۵ܮӕ.]uX#k\0rhŕ֩ؽ\ZUAi0_ksg@n07M֙+k\r#_ѫjzuV}@skv243AocH\"K[NΏ}8F&:ejo߶i:}eeZEqx	KWYQS:?{L%qCMm֚R1]hvWd~\Z;]?a(uhcIƇ\"N[NהK]RSeynZ[vkc_\ZU::ƏSK𮡨^}n&\':cW6_ph?Ri|CuLlFg]\0g*Je-k[vI/\Z3kZ\0:G֤AgwjX?\rh>>i]k#\0JRU)V!O\nxUυmkpT:ϊsKΖ|i6v)qKԾuBaV\n8LiMEFui ۡ*ssPb%F[pR+I˕]Y+;UFsxyk:Oqŏeh5q{{!\rvy/=_^I)nekT}1㻵`nod2OiplmM̖\\Q㏋ږ\Z=Ϋw{~\'IcICuWWO=w[5ݘJ\Z5ƣgK:\\[P_T54cMmջXA<5GkYgjd,m%d:5^%Ғu9ޔ8Un5J\ri6[#Vy!+E]$\0-_\0tq.\'y:o	Mi7_ؚsMB9.t}&.<Uo6#,-l/yq8tV-7H<Wx\\<9xIFݴSFk\r#IeG$|/kwqo\ZqBIQu>6墺M\ZSQY\ZFsh-nRO]j[􏅿_-mz}[_{ѧk\n5)M\r>Hf6MbO*O\Z԰IF2?wTn.<\\\Z\Z՛Z{ՕiHg^\r\ru5K.$#\\lOfҵ>Keǎ	L\'?J=GIxsT%|7j<2چwjztkӬº\0\0fY׮nw?xU־xNoK]Toў=\Z?U:,bo̐_YYE[asaAqmi:?aռx=\'u\r{UKfvڅΜ[z\r]\'MҭWTj8Ւnirr(I(6[)*҄=IFQ\\p}e5wwzEٿ[Mk\\19^G5y⸥Tj2$r{t!_B韴_>QEBڣ^\\A7Va[\\N,yh	EfV#K/=-\0O~\0\"zwsy]z-WőOqYn t;mŚiZn\r>%ķxEU𣛛6>ݧ|+	;/ɨRza)Ci\nV%p=͍wki$z}wW_^\\K]v:4CaXlI\ZRHn-n^[ȑb62P<9ZE1-y=\'5;[j6Zɣt\Zk:}jJl SիN\ZJ)T\nP(Z-7u{HΟ*UII6-<I]><е}&_\rMm}d,-u/X4!VUa&;k4[[۝/x\Zog,Wv3]BU,_B}b-O\0.GVu\Z_hgxm5YՆ_w:SK^oeh7̖T6RuKk\\}<d./5+OxUt-._ԥ6aլ!Ѵ{=#@E%Ӯǧ@ڽΗM.pը0ҭY6߽	Tjt`N1һ$ZxlEJVN\ZqJkn<9\0bxgx[Ο]nծ<i:hZY.;\rÚɵij֝kj\Z-pYXYj1jq:Zf.4NKğh@M\':~hRt}#I׉/jƭhvhz^6&kL7&.x?9sO=A]M{ERz׉ om;O뚆kk[ZKBm+R0|K>T0Z4]:T!7RP7Zn1Yf*Y|99R	9K⽢{x.߰^Y:&cira\ZaQ^Qմ|LS;InOg_¯:ve|57<_7n@ [t_F|axQt\Z3m\'ufLdLv|RjSĎ2;=$xET񕏋3[ЗPִoh	7WDmm:VnO<}x]gA~ū0gO1<mjSeŷ|n5i冧ꚴ:c<U<:9ʢ\Z7P4R\Z\"KT͕a^_\nԮc5M6Ӛet/_3I~._h*_Ïx;6ỽ*ƚx\Zhi^w>tKQ5\"=C<E<qOk+5P4-G\\լF-\nDMas	-_IT\rCeexGK.i;u_7Y?xcJj5[>_Mׂk+}5|Nz|Iqrx\0PEoj>-M)!η\rZHǅkz֝eiqRcMEvig}&79%J԰J,Ej%Ut)U5)ε7J)s(߷R0!*)3UUʠk%vExբ[\0\rXXA5i,v6Sx%C4ioIk|WaJ\r^\r5okSj~ uC@h$UkZ;iͬjp1Zχu[h5	o}FYui-z=W]BH>[4\r$\\Zkv\ZogPOĺqEՆ_꺃iڒh7IYEhYNSE[ׯJs)NSɪQ8t\Zq+wmeJXF\rIb՜%eJZzuM\"Nе?Tĺ,1Ni/4	A\0	;hw׊tF\'74\rC⏃<9MAQs\n\r=O~i\"}PִC+kfٺmb\0Z/qxK\0Ҝ\\E{k%age%C#Kis{kyjlQZ鶲@F\0}#]>K]sz~Ois%֕6ii7i\'-];RNCk1Y*pOaQ9)ST6Tu&a]khFt8>x;yM1xJᅞ6wzOM2.gSlY/$mSߨ2P}V=sVsO^^Y]+LRn-.5}$O^xb\\64^Vvz}7\Zm\0	54=:Hg\ZAŹd[M|3kM&fZ[D\rv:ŽߧYxŲMxkMԼ\rioh>2[CHA𮳦^Kt\"մ>RluU,k<^bΜ-j1qrtµ8FOS|r|^eukF)Jrr#)>jε:xj%Şc];K=VJtSPүmkM:;}3A6::Lw~o[k}gڎmk\\,iM4ZwxG.oy.c{ꖓxKɻL͠[r^$ӵSQԥMUS9$ճ\'I_k:ۯxŖΝgEt\r\0cYTXSY{\0O	]G<<c\'KEHTʰї7u#Pܪ):*AVԞEMc%*\\FXyT9i(;u귍NןJK+W3xj??lyct9c4{˛H5uvzq;N4T[.ikj$\Zܤfu[gK~Cßai.|9ְ7Z^i-n4_3S:ƚ^ҵ-DP^4h\r)%xb Ѷkh[[	 x4H`kHX񐥉S8C^%_DN,u#\ZujA^RJ6WJiط/^Š%w\Z$qͨ\"+y+ۤ7(_wuo4aEItMkO\\twb{7S71-ī\rkVglA9o/Ie4?ZVfeoBP`Ԯ 2Koo3_hȺZ,s\\ݤ.zj>N(u%K/fM{\0k,pZ5ܶ:~EkMfoN%QBM5)U\\U:I%z\\P^T=Կmtmkzp~$uFTLMPI۫ŝ-I5\0shi[Lf^V/料Kn\0^;}XK}mpRE&{jzSC3E\'==.\07ajZ\\Oƞj!%iNyǧ[h<Iwoyp£\0j~#>:<VUevzZ\\:LZau\nXh$d-J[xѥå\n|1)֭NN9]yǞqr֑Z\\Z9k߸[٩CΧ#rJI%$fK]xBxn(]W3j:Ci\"<Cᩕo[NɦCwkf=\0hj7(YUn-5mkJuo\r]\\h->$qm:4w\"}ZHzfm&]mJ>{iRAw¾5\'|:nxMoV\Z\0Q1DI_ON?4o\0O&JҠuOKu;YشxƟ\n{1\0;Wʿ\ZxySqJrR)ԓHBn*wQ>*~_R5MG.nU(5g/vjm=_VvI}hWO%i co*jvSۦմ .,Xh>W;-/H\'Y.KR-CLmC6~^g͟V\Z\\W6xĳCmuM&P}Bv\r(ll/^<;CmZ.,tKER\ZS^~b|Soc]ZG}o^\ZհDmQ/\\\ZaD6Muq+\r^ti88Xov\Zє8+nyWէNreM{5}_^?\0f,4ۛ[M4W|]6io*yuzԚ83DWwz֍g*u)5t#mӵ#n⼍5Gww(T5qsPmun}H]̓si[x=N(cҮX.+u<m\0\'y{s5ysk=cGGP9c{}L<?jaTU]\'R4ۄZ*QkW>v8Ngʡegv{앷߱><Y[xM7_YE[XhieI;8Jf\0J|]i}>4FKCMRZem.hsLK{~\Zbi	;mGz;mIzj=+ZX_i֥\0l٤FۼOx.u_\njKcԧ\03SЦ[Mwχ\"}SPk\rW6QuNJB)hr%[2u(Rp/,5_.=J^E6+f6qjf}6}wj0^V֣bVӤZ<ۇ%7,Y־#k3K\Z#<Qqh0jQiVz[+Oi7VƦiZIGiE\'l<s\\IxSZV/K\Z٣̃ZqeXj1I-k|ڂ6fl|Mޝ7=\'{.<=[}x-5m\nT$2<7vWjXG^j0\'a]l<eIN5甪K3qOJ~1ZkTfEdn<^rki^.ǂ5xdL7ԙ6^K$W7mAǥhإl~\r평5\0i~(\"ACmf֗^N\r}fk\Z3|۶shڧ|MxjLW&K/x3K/dԴ\rVfm{!Q)KYZ57i,4\0%촛)4[CZX[hۮhWtJ3\ri^m*z!P֝X%=AB;5%VJoطfZ$y4|S.죪vk#~Ewo1ueOr^ Kh`pD*_?GkVѥ+tX-,,L6V(;[h!(QXE{\'OKլ=1\0uǀ\'}VXϊ\'ڍz4IcK,p^d<Gx+iPZjJx<[gCTg٬MiٵXZXMKVa<7y-sGNm:U	oq~.{I4ZhCaʭ<֖-BP[Y5>jڜ, _4\"-Mv\0J\'4GKou-feu|V5{hakHdO!VFq#JSP85&)q|z|bPҥ(O 5xɥ8&S?i	YO^IxկJYgӴmK]mBEݧXZMms)uONѲ|Gq?𴺾keƁj~x6F!dVw=zK}7Ud`վ}i#xYW<?}qn/C\r2Oi-2_QW\Z>\\ZT^x/]Zug\rE>:x{W~xW?͜\'^Z֟X\0gh\n-i{i̖R^e}om~&̈́:y=:.8T3EKUxBFJ.ӻM_0(J4%V*T\"M8sFJAtz}G¾G}c׉1$>=^WY*t_x]u4N;0xRR:&ִ9\Zt5\\BF>\r7Mk͕Ιevfx}-ݶ,5|DΧai)_IXl\re(t+vVzMߊ5Y-GƤm</OZ|K-E=k[Uu\rOZNA/gu&Qy&m>W嶃GҞjGV.jEOg8\r5\ZOkuQb+C	MS*F\'ww4i?\0]jڎw}Bo\'֒dԦ~`n\\{}uvњ}9 1j>8xR6\rhCTm5Kxu;m^I#LGQ:ex<?xt˝R弸m\"[_OwdzԺN>~#[95+[Xm,n#0|?|7Imb$E=_\\Z͵Z\r7vq4:؋8X6e8,>2T8e*T^I7U1ZJf趔e:T*a[xU\\Ԕ}R\rեD|QXi+ҵ??>ϡxCoiz\0>h\ZG-th{bE-\ZKm:\rI|Ce_HmM>|U+]cZѼCýr[\rN\0öW:旦]X^Z.kyMGQ+8Mv^Zڟ	4j>(߇ǊW|_69^I+:ϣT+m]VR֞\0NQӾLY])u\"\\A^/4\"ͰXtkCP5uk[\"|p\Z*\ZT!B5:Xu*a#8V)(N8q9GS\rV7E֊#ZrQN1TjOڛS7h17:CT<AuhQ:Tz~)kgY{=VI,a+gRդA3xK,]3SL\"5ƓiZG;W\Zz&`c./cMEͳ-\Z\ZFyKq\03i-c<5Zk+\r\ZR\ZH-Fڵbse{B@\ZizZ,:~mAj:ΏsgBVSqc&>5}n\"a\nUOTT!5[J5.Z֧tl.5\\0SWJTi5jdׇ#xY<-cxCų\Z^eGwH6ͫj~ZFc}%埆{BC$<@o|EdVۧ4^}IImֵm6ᴏWf:^ij] ~w:E?5i^)t}NM/ĚF\r߰k-G-Kz>ڮwOKjf\0}uhtcMd]?:F:-ޓhEZa6w^	a+`J:ZN2sVuSQQpyh+\rVr	b-ܜ\"񳗮_|7JKHԭ=KKtK3s4NY5pזP\0j@X7Sw|#xMƿ<i<-⻫SLRiŮ?Mn#Oxz:wiv80\Zڎiw\Z\0=s੒KHҤ-5OWoUңtQ=)L<uhGC]]3+M;\Z_y64/S񍮣/~ px1xV6چ㷷3zFa:ZI%J9mΌy\ZUSRjRz+/C8F\'9ӒF1unԜe&lmgnoĺtmF}{iJ[}royfk7Yh.m>koq^.~w]֗se?4<J+hLGNQΙqxN+yeJ׮}Ims׌<góiifo|/-l_ɨ\\Xhh\02y-nMM%w3ɛWdCxD\r]4\rGZ-|oZj֞15>\\Yҭ4i_KAn=8LO򯆇%$bgS/::\\җ,\"\nc<\r.xԼy6[rN>>_hg<m>}/\rG.^*؋DZt\0ij4]TX]X鷚NAwk\Zc{g17Zգ^M[j6P|qOok&ian1Ak[XH) 4ݘhdi_d+oONv7ik[mVu	zΕgGWNm4]7Wm5m;?ڗ-c[6yZ\\Zϖl.lgym.m5-BP+I/\'XIb\"*pS\nT9e(T_4fZQʄUҬSڹKEg&ڣu7ez/\Z~#\ZkyKy59ZJ9l&(ⴚ}?gk3]t\"+f.dV궍q-q>饺\\X]\\h<6O˩k\rsY,$Κo\r&;]X}n\0j\r\\4*\r3Vk5\rAu$6a4k(wWrYG!ĬqߢG*R\'cBSդ\'̟,:.нg^r88*ԡQR-/RWvwJឹxvV֮u{-wwwPiӽ3O\r䳽Ω=.u]>{o,KA>=SkWZ\"׼Ol	KokZxj426%:n;tc]Y/]\\nQk9^{O{4\"2\\g>(y!m~Ωx/5[OCXj/Ciw[[]k7kͯY5\rB]:k8i6?m^N%FUhUuڧG+)Gއ\'=%wP\nqrN.k8Տ;(^J2ߕȆWT燠[OZIiSe\ZD-um˨\'گ|9Ucgs\\[Ǡ+AsZ{x[K6XQox2iLPid\Ze\r*6fx/X4ӣ/$9sk	gTe6[vWؒXO\\iYصͽ3omƟ{=Ė6\Z4:ZjR^	IahR)MANRn<ۧdlݏR*ʛ5Qn\\~r|VW凍doυ.t=XTU<vzu]Qzj:i#jA0]g|s[O\\xvo4#·v-4kfaR]jJM4qSIO<YŞ%m-eM}[Q=Zǈ4Fic$lOZY~u|MCh:iƷsmSY.b-n.川5\rJaj7:eer-,凡Pҟ5j<Ds7=a\\oyJM;i}TbTTaR\\o8٩E6:4hqGj^ֵt6fkK\'B:,661V!~`E=ys鋩]YeY~ҶwR k&\"?q-O؄繵+[<SetwoIdl٣X-Mi}3ZHXve:TSO᤾tk]{4Dѥ{\\F\Z	K_[͝4yAx^8--$9gFt)*X~shN\ZnszE0i3BUsfW\'emn%m:^Mu|=*=fݴjF\"#}ԠQttfK;b\'Yuht/n\"H-*Fեn5GGOM=|Uַ~Sn7>iK	^wZj3iQk^-)[ZT`52ٵ׬]Yi\05׉7j-;UmKLq\\h)kknu=3GL͝tD\rVS*5\\ܩ*ӍTVN>Ӽ\'˚7KmϢʒ8S5)նRIYkMZ=xr\rK>#;,oDˍKEoi1\Z4	4oM]%S\"#~Э<3}⯙c~ѵmZXhxM=JE6PtmeH|gM_Ɲqid|K֏uxLMj-PHtgN[kfiXm-cm:WҦYu-gOҵ(?emqMA\ZE;VR^rqT*Q)J\'MMq$\\=y,FPN79[qrOyt[\r3TVM#R_LQI|Yt&ou{XirbU,e]GkE֠]\\iڵW\"Dmj--,aea0=Ǹ|Hͼ\\gB^Ew[]}[-RQxkNCRޗ\r/gk$W2MibY^>iZ.H&m-5?ÓEקuem<ݍ~\nu*u\ZP猪Muu6u5yG*Jjjх{VjqmZ^I+/6Cqrsy廖deYIrfi^R#$_?{{Gt\0\"9dH|JO){4[wt\n6cp\nU+IV:7Y[\neo&]]cjgf^Gc-Nn/n	{aqjN\rOTբYK`sO}5-6a-Hv5[i>sܭUĶ;5\ZIrח?mv{i43HȆI+i-WxMNu[wDIwpK-)x̖Vks9hW}ja^4֕w,yy\\%$ϏvRdjꯥ\0#\0|_>+=r\0BԴKfEy<j2i%YX7/xMPk\r\Zjvmmu.J9׭OӬ&k\Zr\ZikmEu\':ţ\\B[+XMuu+E%֡%,rd~~<uе߷떶zR7\ZΟz#TnbV/.Se4-cpYN2G_s*u^51QJ*RNe\nrJt+qʕ#JxL=G]9V#\n^Qq\\I\\4?Z=S:$|Cx_IԬ6\ZfW=RqvnV\\{g-6\'sA]UӬuio.5|Y`l\"kԶǦ[ko_Pȟ/\ri]7MŘIXЭt:+?Kºzs:__Y\rհyM<lilm,o,,>ǤmȏUGee(G<HoW.$[wFիƵBQquN\n4\\T%)&VHB9TJ#f:6&j0QKK-zq׋$ԡ>|3w6)dХwx\'AonTck-sLQiۡ4Mv>#񎑣k^G&C\0k\Z楩7|:ƓjEQVv[n?9shѼ5ⴸG-d4[ֻwu4i-ՙy$k./Zo^]\'O%[MJ;uMF^5at4J _(c8<V]|Jt+QcF:1xJXaZn؄g	S\\zsøԖ)ae%JmFU=\'{\'t-_w4j5|Y\0dDix\Z.4~XaՓQp`!6ڭz}\\Imkzvqh˹-4߷ukuaKa*	)Rյ\'KZӮ<9q7ĖkKJ%:3h\ZuݴIknw¾1 N&o)zD5Ս$\ZkBqx^{X&0I˳,3qR+^XNNRKJmƝl=HQq`&VӋѫTF0	)NTjͪV$:S^\0Z<K[cVWVj[]GlGCRR+cOGQ/4Ok7wsxm7.u(1jI>$oEh^#^Z|Oc:]ΗehVLmJC-,jU&;xd^b\r2N⼸l5XBW3%Զ\rchHhHWB+JP5TkTg(Ju-\ZVùRMEF#V8uiE8)RVN.6Jڳtj\Z;MqtRGJ/첶}k>vQ[>A!}b\r2mB\\GJKfN-.ỹg2]7ohp^	gqϭDڛ:R䳰1Y#2Ʒ}]ZfK*XVxLO.l]+uf[(3iK7sOo-W%WWQJ@֔gMT^prN➒ojU^xW<6\0;4q[iĪd˫^8\ZiZ]ɸ=2LR<׿\n>/~u3xR7vW&\07z冄.Z_/^.j7XhU?\r{m?\Z{ZFmigGk\rZAe#_է}ueei@_>\'aJ\'A<g\"5;YyAlnM9JkYR+(kUeN<\"+OZj9Fۍwti-$Jec!%V57R0x~w\'ӄܧFFˢiٞKUŝ_LԢwo?m΍s|BB찋ml5n;{km2[]3E}B]+Rj>cimh^ <Gk7quw/nOalu]]٠N]V--u>/\'۫fbGŞ<+u]߈/%7zϧ<MOVGX%<GZiW*пCy!VZ͋iڄwΗVQ^jw_\\_j7ǧyM3`VIƽT)*puqԠF͵nTb*iϒIR%5wZ}~G/jZ}[\\~_.єZoS{Mh,Җ	<X\n-k>.az|}°YxK){xJVmZmv\\M6s5:%Qmq5\\T3x~K𭟀t\n{-DxuuS-5vm:m:1oj\Z,A%Y-{8\ZfvM\"Wu*~FTkwῲﵓnfZbm򰐄҄=!F!\Zh5YA?z59gj֊I:rmsV\\n][f-8.bMZVqowɧ\\z\niZQj72a5i--n9?Pք˧GKmYQs%\\<Qi^Ts̅6>}k\Zشnu\rLhὊ*1F\Z6$yㅭ㾖Yh2K:]e\nC(daa湕	b5yQ$d2~ң,T5*JrnrrJWe>JZNP\n]}7JMWmN\Z^ͣK&aqp.),rh Oy-ĺ\\^MvZ[-oڿyo\\hV]2_X}mjzAϧp7kwS5݌Rwڔ~yɡj ҝm5abhhtJo$ѽa2xulew-^5tki-3Zm弚m4W`&YntjOa父	)F\"F\\NqM$mz9]E欭6Qm+?\0ﮇZFejļZnڝgv)^	eŖws|uC\0%CVԮ7T7u弉ki0I7PG,\0];Kq&\Zӵ\0|E%Ɵ6jQK=ں_\\η?&kzd?fKOKm#:kInga\\R\\jGu%żu11{\ZQШR1IR9sBjＬ3hӝ	)25F⹭#=4-yz_n\r+M];:ƊCg{Z_Yj1A\rZ|V4Q-p[q=F)5o/xAASiZjSBǦ[G\rƗd[DEɺki:}͗|\'idj_YY5=R5M%\"R.ٺg4aiUs\"K-Z}7HHM&!\r&[g{^#Z8¤(zt?i9\'\nj7PEhi3\Zӧ+Jn.QwqQ!&i~$l}ɧئXI{ڦl#Ai$c\Z=>DrF%hѴFOךº}UCl.b-7Adp\0PL\r^KneX/uy&Jä[Zڄ24{wPZ\\i=,AXJkzWӵl-ƙ6/`\'S\ZtUWZLD\r]MzEܺxzoSx=GhEETQ%){+FH;YZ2׌hS*m)BSGJD~+<j>7rSK^ϭv\r(xnL-9#TtI& ҞZ\ZlAi5entKt-?ImiâR=Jwkzd&SLRn,%ӭv4??x\0M;\Z߀|qi]72˧h:Il\rqiwizSOE24ZMq$\ZZ.SźG1=+BOG	MfFc5O_Ms@ɡj_ImY4݄1c:*e\'Vua	MՌf̤ۍ䤙*N.1P+8ɵ(Tz;IРfm_],\'y5{kIr	95em56pMu\04\rxvV]+\nxWTZ]{ygwFiZ&5Zް\r+isF}VXkM\rw:wqMjڽ潿k{wK5_\",>!}kL#t[ŶwS[\rei<=kZ\rz=28o\'6k\r֙S)G\r\Z:~RQO8F&⬧%/z5^Jzi78\Z|$NQM#u=SZ@Ğ+.EJK{fQt4WD{@]\\궷\Z5\Zwa^aQCՖub+{#JM5rNhHXtT[cOuKi=ig=ioڵ&xn|Wa.X6R_LW\0]nt2;JX~ Q5싽M漹\ZrxnPč7N4Ngm:mSRQnJFTSKU\Z%x7W0PO^7mMvu$I)Pd[\rgW&c2q+Aci7<`oa֟7vqR%9D*\rK>vTy\02\0?\\߿mcIҞmfk,zP\\	dܬVizѬ/-uuŖZw\"d9^ky\\בΊ	>\Zq9U9Ԡk,ծo[#4kp#Es|ı= T9#smMvwD5lSI˹yh \nL/`1R^)UҩYөTc,E5V)R%itF\nt)ʛhSQRQө$QNɦNɫZ:Ω\0g-2XsB]IiI\"N<	,.-D>w~1o	54K\"ȸShtIdDpֺh_F,...vl5!=ԺUũGu{{?*EܳNn;*̉,rPחA$<r\\%\Z5\\J,XR}+nR<]Kn8|>FXxלe\'PJsTN_5FrW4)GjNҍhJ:Q$qUjk&{5MNSamfk{Őj1<0w@\\\\!2 0	QM<ijogrҬF\\Y$CZP3n\Z [s,V->Mn_5kV0.FV{u<u9x[0*lhK{>Hr}ZG7_yM*4Q̊Yfb(r:n\n3Eae\Z{\\\nJ3qRN1oj5vrG4Rէ\ZjUtrW5ikguzg]EttA{\n[­q\n[h[Sp.uNچ/Ē_\\hWԞtgӍ>jZOkoynFҵ_6X\\]k_Yvr湖\0Ɇɬ[+-ca$5}_&0ri:$US[=|wY\\eCRY7bqxSOQT)NƗՔM{Vjdzxj0e\Z4*US5:|tRs#չV]xW)o&HI%Af[m6(mbY̝F(Vk>-4]iATV()|[[,ӏ4Fg]Jn5s7Tck,miM4j\\Y<E4dKu\r\"iO<[.>4D6G$\r{9n2-4.81-ѻrl,b1JGc0*GP쓦۾y%AS·VVu)O*㬤WhPρ_}^Þ*!ӯ-u{R;m乹-Okg%f)-nj۽V[}{k?k}>e8PDW	yqʭ:*>$pE+	\'5EW4x+IWy,5[}3QEӵUSjĦVKo:EDKپ}r|[6ᡊ[%i$3\0eђ4;pͩՄiRהOK\rWuNҧ\'*o9]YsB3tJpZ3L>RTJP|:&nSjqͣi\\	hggmVHI;ThۼEZ$DNdݺ4\0A-n@tӢմF]:HE4Zv+KfF}6gei6ЬrBCkctڅKĐ8FD[\\YbYcR^[-oጋ5]]My3nEqB=\0V\"[_8pCQ~HNiFU+J<\\n,4KI%\ZMs9nNۛUwo\"k1TԾZ+Aѵ5?HXZFHu\rRsvF̴iPsZChΠii*=n(uRh.dVJ6%-\\MSM\"[[Gߑ/mloml\ZE)2[\\Dn.F+nJd+ (ž A_i\"MrHK>YsK	HV]QYVD[K [W\rf\Z\ZgV\ZrH()J1^\0=7%{FJ7o3ЍX\'JqtQ~Xk:y_WֵI$dKǦ۵ޑx+1Z-iB02ysޤ\0nxE?\rIl70zn䙴{~-m<0Kl\rw>axQ2jIӮeգ7XYi-ʶcjZI(WDfqռ-C۫xut3茚_E<|S֚mpm:5n]X\\H,<ѡNpARjM$Ӧוsu+S~Κwm.]/mwwI/chƥk*xw<3y9};EeKmmiWq#Hg.5\0Mz67gc<Aͤ>4\Z޽P~լJ׮uiĺ+KZ=ծ]6vx#l5+\rk\Z>\Z-Fxo|)Ijx\rR/euAIyv:Ex^!7x\0dlaO<D*D?Z\n:ttq%+ev=:Р\ZQuAzIsrZ֛ksu忆,4i&Fӵ5gi]j\0ĹDfO.egRsim.Ep]UF[]bKI<\Zf6\0ďE<O\"i˦G_pkcJy_qMjj0}1#XeS@!\"+e]Kq\0IUV9T83m	5yѧ	׌jN*I%B9U8޻Swڋ>WNu#N\nrWm)Blbek+=NPg};Q6F+{}A?xeyq$S\"!=Votgkxẖlo7h\r--aK;$WԎ.Y>5R	#^3fdxecϪK\\9I׭Qz_Gvmo`Ӟ]*!{-wQ eK75\n\Z`;NsW\'NN4wmY&9a&ۯ\'f,Zo\":u*ކXҴ;[h5}WD}?ɋ>u+ZC`^UgH;{\n\"\r?jhy,Piwvw\\k7yƍhŧvWNu=ZOycrܗZ敷N:­udK@u%`]).jeĳW7K%ݚH_J)Đ3+I\r-+JjQ6G*rn1m&Ҳ-u](JjTܡ{sJRj?N[6&oh\\j15շ,muC2$Pan%ۂIUjC9֚{,mz6\'InE;rm5_-gi$.iu+R{6&8»CI&狝\Znh+8\'_:#,{%6Vs4cK&`m8i5x`N\ZыRr(oKQX-(ק	ө^HNP4(rRI6W{u4}>/^ꉭKaj-iWw$Y%Xg0Ig/7-mxX\rkkkoc7VQZL4xN{M4|5[9mgٞaݝ͔_P:1B2]H扭\'--05^(U}<7{\\ZE`jvtf|K,6;\'B=Ei)²iΜ$*qRSQIm+]-Z254M6c%9N.袚P}x;Fm_Ox>Z0YoVp1=	8/5{{$=:񦻧޽[4:fuqqMoqgb[OFuۛI)wu{ݺO5$WKZ/M2۾A*pKmKq2Z0Z_>g-.4ѬGh]\n/\'Gٵ^scJlM!aoN:~K:qyߖl0Pu;N25\\/do;yoC]݌W.ky؂3jW:-#yơ²M4+o\Zsq-d3_MúT3/ztWvw\'KZS[6HL۠\"(\ZȧirÞZA}w66n{+HYo[OuktEfx[t^xEu	[J-#5oT:ռRG&W[G\'.E\"=ĜXl\nКN50^1qa\nE7)Sv|ֽ}kb_-GzJX/WKZ}BuX5=a-mu5(gR\'S%\'t\ZmF^dPF&2xx=}#[?>=]AMWW\\<Emnjqaw\\XV\'K-ْ]8,)xZwVzno7-CJ.Al/-ݢT򣻺K{dYlH]k޹^F,uw6ˣEyg\\izw]\\\\i:f{^h{*pJ3:U9Y94(9&vS7ct)*=g:΋nmUӍ\\ͭ}>/|3D񞹧\\*\\izvہIo&,%,/,Fʖ%xx(j_SIbU\0J|;CL@O༼Imsww77DOr+y2ioS/|?;}\n;iO[}^}?9\Zյ\rVHѥttfW2IriѢQou3oY$ww5Dң]K͖+99Dqhرq$MyrLQq9xEt>R[=rW:	<2io[Hw.|hF^Z<eVM-z$..\"mĲD%o2MH峇+燡W)ue\nүJRk٨VSQQU$rK屑^Tc!*)MI-Sm9)T74Z\\4h$d|iaZfKe_ƛRR``K\"Mwk,PK{G+Vmxlm3һB>&Tm>i, @\\B%_)F4le`~\"]&T\Zh>jo@2^Peںx$sy=lF+\'*UjVQ[N<+Q$Eh]R*EF4ڥ+VvuivV=o[\rϧ>`ԮM1V+ynȱ$\\/l-\"RR*9#ay-ⷎYЪC:]ƃ-!`Xh&mB7y\'0K\n)C/qv^\"Kȥ`1 r+JgL\'XQw.%ޞ7UƳ~աrJ*Wv֕DM6䛓JǕC\nv#x5iW^z$էwDGnGZOo+[\\57q,jVy$=cwT>h\0x-͟|A-/.[qp+oos#Ҫr%,d1W/᥸ӭⶳrFmnXCtBͶY.Z+s\\ZY\\VP[iZj][CHtkMj4Yb\Z^<W䲚/<l!噿6T9U%RMZ.4l=]KT:7VdiFXXBe9\'鷻Rjz5v[Kx}P$W/\Z7k}qY=ӬII\\yŦuu}wyemWM*\\_^X`\ZѪrV!.oa}-k~!C~<=MȖsꗐ>okr[\0s#n$m@9tCn,2yZLdۣad֓<v/.7Vrq̓E\\-\n8DV5\n.l<_,EX)WWR\r4F^漘\ZTiѯ9AS[r֍V)Jx7zw\0Yh!t\Zr;I4Fu)TL\\4Pᛇ*PO$kKgiGya}%\n<ѩ^a=9A[ɥ6sp/\'moc-Սս15ͪ-d!\rRM,Lz\0c\ZEͨ/s<3Eu=MdX+{f<K%ǧOU*a^sX:#*nɷl\'haf`$燲rZn3ON?\rS}=g]\rixv<&[fyD].rf=biׇODPI.OukfAneknoټ϶/2>t8n\'~jWz-E=K7dpInax9/7IM}msQY\\[MYgd)o%Y.gTU3I8A/K\Zm<e9RiL#Q*A򃋕U%~:ZJxG	(Ӕ%J6JһR,{z>MkZI=[ռ;s4V2.[`ѴpfIt2KO*-[H.jL\r+EY^LK\ZGدeea0HdY^\\>P}BK.&B>M_op-0[mnok@AHo4;N4c{-Q{/˽$\"2!gp${T*05+խ\Zo*NYr:< כ`5OIb*2G7%(Y$>TMִ͚LZX[i7\\Xvwb2BmX]4KjP%(Zŏ]Ӑ]\rN&mU5;.wɳ1yچ3ˡKh|\0OiY떗ZZyeছ%[Lv{E 㯴RY\ZNYVY^Q[Śy;aKqp\nܖ[qu$­ER1M2ISRQVԋnʤQZn٩S%;vIBu%4dkxzMwvZYiR7fy=T$e\r>١;;;nTj:ƵucM2\r.[K-,ui	/m8K˛4tFu+y(\"!ΛrDӮ\nX.~]xkHu $\'b\'K\\@OOMX+\ZhCyۻkw4K<(gK[}~oOFNUJ88Nܳ:!)ܦT5N4StiBfYI7\\ʹU\0iR,ົ7>Ul\Zev{`pdRIVβO{tVZbckf-#h`8-g,RIt\Z,;!G!DC皬vk\0Yb5{;[6˶CġQdCcK-\\j)~>g\r}mjZ.39f\Z5 a\'fu:QN]	ʭE)*,L\\P)rwVLku)GIJ:w֧+MwT?z;I4dq66]:(w$0ܵ3+N<f7:)nn.Kd{)]ia-Ҫ%&v)xm*Es?	n{8t\ZcdE?kVe\\[_7/m5$viH-ml[+HNKծ8o0͡{6㇋Bjۧ䍽c%vX\\4dKQ|\'k6tw6^+YbdXkY]J^5#Ya`^d@L`Gu9-2i&85\"K[ѪHyo\n֫y }C̴듥^jK\Zrf{&.c$qGdv1Enȭ`_L&=ZRjzog\'Msuaq5ŭr4L^SjуծrT>#U;\ZwIEq\\ST$nܷwtm7.g<KSk\"\"8Z4Ycwr!An4his\rݤy-::s#E#\\[R;E?ŗG[nnk7{zmQZoM	ʳY1ϯ&QYmf[[(гK43Z@nawg2C	1)mm2:>TF\ZXiЍ^U*u\'\Z.xFJMRe5-S{{%\'%鮝IKM<ڲ)4Z5xu)#MEoO$ӗR@F:c7ڦr=۴sg[ʑFD/&VUc0繂q:ŦZ4mzAs/-0.X$Η֟Ѭm1帔RC;[w28La<TYc1AЛф)>IN45RTym7i\'f-`\Zuf&`ium֖JiOhd^Hn.VKu,?gfw5m_׆k}ivvgW{MX$K[I[t,m$olexƑëZxDt7F\ZYK(Qqk<%yry.V!\ZNj:֣cj+].OƄ<*oXP!hPG[\'FT<g>INj>Tۚ:V|tW\rYT+z([JZGjHM{\'cFLPGf,m1-&dQ	qxm\nuƥ\r5ƙ42֞Sĸ{ |[n\\[\ZM[\\D$\n`ƠֶR|r3hx|U8L2]ɟ,{	m7ڮ%kBZ5\"H|֚i\r޹eRr8^1QM)`}\'k~]+O.Q\\쵽k=MzFӴx<:j5+\r_Zn$K~MĐ^	.͔2y)po> Ԧ[Bf̴n㶸ԢX,u>\rKk5[=R46֭vgtoH.?:ndiWksXG5u[/[Oqj}\'ġcԣ7wKoxT%3Ne0\n\\X/=Lƭ81Rܱܽ\'WחT|{5ע߆	kx	1JMՊ$#6hBX/QXd3E%LI(\"*գʘڥ>B\0+(y^!;[\0#og˅\0t\0{Gzvsfh\\C#fd{;bcAh$.& O^K]3J4,~SI#ndt|;`ylƬ:\'#h`\01BDN7СFK1NpXH IWY{?]c[ڄE(Zdq;D$(b>1#*Z_7$%I\nܮJ7xiTEt{%$Q`Ib&uRutRo_5$t-8Rw\"],2\n-xGht۷E͕[s)H|Ԓ\0Hr*l5+Ifl.2̙s+F1\Z(WVl	Zo4D03Ql\0!@70\0i㰒\n\\T$SJNYIN{Qvm42L>T1x|bpI*ssˑƝ~W-hZFl;q=s\0mp!<U`њWx٤!v@7ٕĀdO 5Bͽr, NӽIuM+y\"9QeY>|eD[w\Z/gjNdMMoq1!eKȝ,cKu#]bqPX(C\'B-{Q%9<vMī)b])UT\'UF4+Ih,fzu>g28\'x.i (Ώ!P\0rƷ-_\Zy}Wzp}e0$˥E\Z]3B\ZI$M1Z\0A4,;21Gx\rs{p\n8QB&f-SQ-5Ÿ	5bE$72M$h!+<4^/|E/eWY1*6\Z<T*nJ)*G׳MzRB3Q;OK}_S~\n3Yk\Zff{zݍ$K}9[Saol;/Z_ Y}\'Z7S沆I/MDo3M_Yf#hm߇o%Ƣ6pV|qk{@Cs]̲%ʄ}O~|Ce۸[:SZ{UPy`%.XΛ*٣?-۬vm✦4(9唥VNƅmV̜Z97\ZYM%,&GsrkF3JS7JVҒ+%N*V1tWIny,[u(le+88wN\'i#XI#mybzSvuŨLn.6~\'wku9;Op#Yi`IF6lw=ĆitΣPd+(4lSJΗvɩ]x!^%~Iq\ZNf E,2fUF%yƮ\nөb\neRqJ)KJκZt*JQŹQT\\єhsӋTMMZ񬖩;:޵ػ7[	yT[XILKזP\\?~WӟYK;I\\iv\\^Ak[5Z]I>ZBx\rJ6wi3,D]PGfnbu3V\"GΖk\"O.!lIrG\nt*2OLUP:\Ze(J8O(qrJK)\'dI|.Y%*ң	PN.iՏ4\\tԓ~D]RSs]՘f\"%HE(4Y-VDHe䖹!\rd˖xAkpxE+yP)d+]Kº4Xy1,GFldoڧ[Iso\"Al,Nq{gyqs^KibYp\\LZF1C+\']6+<WC+Vce*冣RlGQTȡY5?i99^Ms+Fuq4)Ԥ::ty1qs\ZJ%gh24:)fZ	cL#,ooE`igVWD\Zbynƕlr\rauIaɌݴW2JRe\"6kW6očqtE`\0HvepM<q18h7	m㷾[m)1dFW\"\"hHV|ꅙb(5?eB8V\Z)4UJkm5JeӪKӭ%*̛iB.QJR+j;vflb5+W.X[-SqomrҳEm\'$y$F;Iou>(iFK/Sw\"no\0PHbӣY$[V1I2\\\"n_08e엓eyk9c*oR@C*Ѥam\r{o4MwN]C fM\Z!X{l\nXӌiV䯈)*{FjjvRu=`iT:NWFQm/iU^*1NMxYͬm{2+O/PAerb1O4]Hf_1_|K}{^>=4W-ie1kilm 4EPl\'I`1tzu[;it[[{Rݘ	%o yyAkr#<0\0ҟJqoeAk[>fnỹ2[$7g0G`42[5J8-5^1>rʝ<,):kJNT#\rZQNhN?i2UnQ;Z5%m(41-Un-KƖxܭ!XBy%ˈz.*4ɴ Xrv\'N&糘][]k&SʑX4s=x΋msk\nB[i?SdCIՎ仑&;khn-\nߪ[5a0k[זF^y	oxM}fSW8ΫtiѧNeN+T%<=4JPqYk)7_?Ӆ(4	άI.JRڏ3RR7yF-5ABnwi7sA[FHyhm-m7.:L$]\\rX^8Ei-`Y^wdo;\']>0iMZ\\Fҽi3	v%qc]w}ekwzul/A-nXm-K+4SHm,rmB\"\'7J\nR#\'8IIEF*\\aҍJqVR, (8ѷV{s.{/詢Bydۛ}CZhjaŔ6vqfK6I#ZzvųOoo[+54!.yQ{Vh䐬r^PꗚVu,i+&խdT&!>-l.RbDɍ_d\'M[V?67\",ۛSN9%[eGL,uV6Jsɇȣk̜\\U$yԺ/.Q9,}qԍfԜ,ךMlHu}^MD\\9\'XeRn_a	^XoAsp^xDE<\"2DY4\\Bmfk%9m5Pd3;APxIik++G%U;[CgMtę 8`#MEM\\@6!wwsy۲N\ri\nHH*H|f\n+Ubξ6Tʔja$U);5ɪ:xMU(az3SI%~XPoɾ=]6\r6-ͨQ^KAY.\"\'kĺV7Lk$ܬ9n\0Jǈ-5=Z-&yi51<6eV&X\'e{9N[fh w`\0{vZ/7\\%o7ܮ4nh:ko(2iF9=LC32kFHE*kGܒ߻)J\Zq|іѓn+I^ǛS~ڝnyRW~GyΈtsce[M:8Ќ͑m*YIg}O$,xt~f+~oN{[MBIRϖ\"@9Z\'P6KYn7V-qvCyv%F4VOȍ&XU3I]O#9T0<VUXZJ3j1N7Z\rSqGi+%q}6.wO}b,ڲܥHq\\]\\ip,vG24F&tuRMokcosK$zC[]=J5CnٙXmۭD,|:Jڥڌ+Z;(b&{3#HZ<isrGk,CXluu$&k湳(#B$Nxe)IӞcF匛s:M(^Vi\05m:n-+IU_N5Qx;W8WHfD$ȡb-pcU &VT+VO/Igi_I$dHyr+1儢>~I[oj[4IgHEIecˬ(%m$f	u]+Mxfvkb6FąR |v@Qܢ;YFHl-7#Q\n@)Uab>f\'OU).dlfImH#23!feibQR8YQsɩB2MFU5V4!	I]K^эD2M?gSͻ;%kFkapm$V(ސ	Ha\n3@,嵴[3(qce0I$Yޛ0ICk-Sztƣ6[G,73-uhRfD0iH!$ƁMu5̶:a6RM(Rk<ej$TSVxl5ZxrJI*+g<E\Z|,aNcJkMjU)O٪B1nNKV\"po-CC$.eY|2Kp/;<N[]\\5|>FN#BY!Ҙ^UFG.Hk0Ǩ\rv(2C+H>dU\'%JfiZHt۵Cuh-qI¤Jd֖E@2ٱ~{l3RㆨTTa=;rR\nF.:ǚu9}sӝjsZuTF)r%˖Jg5Շ4/itAk9<Ba\"ŉ%\\u;K$!%V\'-Mb6nd;v\"^Hnc,jr9%ZMC0>]/eV[I\'8xVw;܋i9LHDK:~QvR2~W9+b-G	NF|+T&9:2NMN\\Tp1`RúNUTu\0s;ԂMǫCk=bV:Nh\Z4pܳImr,1ͪ[Jc7C\Z)hŞ\r|;=ZZޭڽ֙뺎Gks}ƺӚ)ik&8F\0ᾱҴxNKS{k>b_[K*-qu.m[xm72+>ϩi\rBՒBM6M?HKXibܑ<-.~}_9V>`0NUjJ,FY\n86c9W)x,Y!ԧb	᱘7FΏ$jS9TJR|++}w\ZnGZ^m5ޥ6jZ亖2M]fYfdB;bKɵ+X2G$M;2#\0J\Z\'ĥO|9i}7Z<qu)oA)]cF\0>Y\'%oF֩.qpInG#utv[eXv]e(/aĒ|)i@!͜{1L>q᲼>_xZb*x\nNcB\'Br7^\':)Q~`-:~*x<\"lL=*F-*5\\|.\"ط	dnnnG,i褈FmXsIs\0\0Ax~mCONb+e\nn^W1G$-tIFC0Dacg6˓R.uͷ<y<hg[D^,mb)ٯ/帴T{s`QW7yD&Xqy)b*ε{/ЧUSRu\'RSQ|ehŞ*4V5TiQ҄jӜ9!iB,bԓqX֯VNkktO\09cɄMs;3\\nY$q`ۼ]tfn.dǙb1eFJ2\Z]-P.4Rk[hRK;\rkH;q}[MfI|sAC$Z]goV)fy]}ų4پ#^]/[DSjWjBsNT䧈+eʔ^_OJwN:T=iBS4zPM$_˸h7PDHȹwA!0JLX]\\u~֩ok$茱cLD>stty=C\nёkueڤ0C#C<HC\n0\0M0#EIk\Zj#l-.L$FK$ZEpWb3HL|Wza*kƼ^٧jmӒ\\ム\r\'%R*ߴɫr;_y&\nړmJfVtFtK}CSF|1Z;o)Y?N+5]M-y-K$ׁ 	i7Y{kkgX]c0ҔE<w\'fF`	ח˵Co ix.TeaF,ËkKlIbZJRt/z(B.⿆)PZOi}X1JT	]\n5ZQS]zR\"v(6&FfhVY&b\n6V,%E12Yd6}yɨZhYa{e;-T\\,$ec,,CgP3S32Vfty_,ݤTm;&+xdq9i\nA卩$pBH\Z%qJX¥^IE;R ԴN敢\Z֢eR\\\\4J1jNNk{C6@ffM$`$snn5fxRK[C3lZ;)$d:M5#ګ%R9sϩjv60\\)[K͜;!I!ؒČU\0E^iCje}ߛy56M0y#R!<r$WƑC2	VBTn0Tgwèc\Zpwr|94	F{I9F!*=R~wtITn݆+%,%WA6i\"Sm12.$\"zܽ񏅦͵ߤ֚܆{{n$Pc\'ڤ-bn1XY~,O(&E=t(S9(He-f}iiV&YfPV˷SWiQl,n/\rV5pV7,ì\\UT䗵N~^\n0*M.XBQTXI\ZX)\\V׳}R_@+=fYmuX-``(mb餕:~q^\0h}4eSk,GlblDm:đY[-ɪNsifM<3iўPEdk;S{H`dy\"?/7Zz}cM֝bwik5rALVd?c&;h\"Qs8U=YaFNhѣKTaRrRI\r<<*_m5FPIcqd凩Z3J0tӒ8pSKm&RSDn\"_&TbǭKƷu+Xumb44_QXQi8-$e,\'/YZ^m2[[s{6L]*-%\n|[jsjBm<=_Eϴ.&ybٚ[vspMP\ZjK0ʓ\'N)aNnHUKͨԓ梤ԧ	х[}bNZq({x(\'Z&aZFjmo-Bolw[jV7/%[;Yev, ky&vs}Z@pZ4FEr+7ƚ]uM[1Ei7G-\Z\0Ak{s%-u%ƛ؅q!IaV?,V_{i-sXZ)^59$fs\ZSLln#B2&+9ҭ7KVa\ZptQpJZiKbaKKFxƕHՌӨ{ڢeמ-+hVdr_Ɩք0\Z)L~ff\0UY4\\,#a[*!6嵬kwjHnm!Y<EDV0d}εqo!<ӣE&2o(apdt:\\񾖷F;i/3Im=gȳA4RBZgDUIP\n(f:t	Qԕg:jjT\'B\'\n)4T)}q5N{xW5-f-V+w߷[W\0u!s\"C=kWi	usQ+(yR\0z-5`Ji\0s-<ZlR۽(GgtGȰ>cFL-ZZVҴ]tYnYXef$</Q\'.l᮵˝*Kcy줒S{A-	`E!	PaZtIC7RTybӡN:OϚK]*P*jOGEJ$wV]z*[PVU֝:ȢEK^epJ򥪤 !DUW$TPE,v\Zh;M)PdF4&rwp\rE}zNGk<\0O}El,FUG/6yS*n%9@5bPP<ڦak1fIͶRVH86%n澷Nw@pXnZERt~	^3s6IS\'k#A,*2yecf,<LhSW*K\re9ӎ\"X]p}Zw?rJUFj*3r瓚vPKٸ4Sz{>\Zmhuëxj[#=U)Eoq	RKn(,,<^P\ZHݥvYcN$IXy6Z(1=vdSm1mn0iu󭤀ۢx.e\r4ghխ^UeV{yrD\0qcyV孎a)sxXZ2JWNӤUsQ~MJu5J/c=N,%H4:挟7W0NیVf>)ecq\nzN;\0hRP+tvjŝ\'M7LeMqo[p?d!,a:1O+eX,^;љ\"HccEUWC/wyC:&-&HWV<e\n=*?ʓJ2Jc\Z񍚓\nT\']ic)8Jt=j7*ӤNOݒISڳ:}?\'3/{M೵:M{<&3<FLmYo!0t[X}D7K*yq]$Ybb˘F!}RHtvbJHR4?4[ FE$2 vU/3]Yuto;܉\'[uH)BrF؎_/	kV*c	fG23\n1	O::ѥ*KBTYA6\n`iH,\"|/xz\'R*|ܯ\\G6棢[X<AMfN5=26ўiB	%Nt`^Y6Q[4\rjK<be#(y.$:19\Z)$6܏#\0U^F*d;i 쭭n.t)9\ri$I)X^+	K1`0p(UF*EbsiӯN5#\nsN]H,uTyӧFJzZ$I7?/ԥZ\0iY(ݴ^ڍ/[hcba{{h.d`m#Y[ZNNuI;5{BC.Ki.`m\"ծOq%$1+k\\kqy!ť\Z>,,ͪK	Zi46%`i5ϡ OH(Dm<;g#}nNJۄ	I-8\\.`p_:l]*(bª<B\nupss_\n_QTK_]MQ~	Ԕ9ƣ<cV2t8lhW3Mwem{=卬:|ku]EEP[ۋP<iM:ż6}O8Qqgynm\"vӮeA\0%2E}&O[x+X-*5K]T[I\Z2!r֡Ҽ9_j[^ &pujA}:X/4b;hIؔk[YjC𸊸)(STajNT]|=Z-NpԪVъwR(b*Q{єiNrʤpg[y.딆FQk=>\"Bё*1вG-M0\"=ŦE/trMY|<l%kU`!њYf,o2Y<,BV[^fO}+$r/̨7~Eo@0\nùbqXo[az\Zta)T)w׊ʔ_lNrRI4%URTQSKo嵳0%j\Zdw\\PF۬v.i#I\'%iX6iC5+s\rNd1fZEm;y`FR`YGE\\ƱfwB}6sV[pfFrGI8%\nKE6OM(E\0_<Z#TݭrM*uiZEV3ܮy#^uhק)&Zr IZ䒜#)6psb*TAPUm\ZurrNYJis,\0͸$nb;\\KoJ-\0+2ɑ\"TA\"nK\r9^d;uy<39ZREUI8M&X^[prK[\\f	gf<oyDv\n#)uT:hg&gW5LeARP!Ï*F$3KZh_iJ|SN4ҊRrMK]b28ӧN2q8*3$a˫\\WNڙ̮Z} [4SuY\Z%,UsN6E$r7LDDET^Y!yCrDB\"eYk3y\n2,Q|!C<g#YM߽Q]וkXn.˛I[U.I(MO6V>lȻHWV+T:tuK4Ѡ{pn^*2Jj3Zӧ^YT\\[䴝<67<#_@$v(a[fVXGm&	PȻ#	\rO\0kخXMIg}[RRP7Oe[cq<\"9/v<`\0Y|D\nb޿(*]?ٍke\0ngU{KXdf$K1N\nxJXbe^P劔i78V\Z10SJI*iqN[UKۚm)(.Ւu%y2-$\n$.ci!!&dXj9-2Ig}x#֖>lR[EVlF%Oyc\n=Y7@*M;;[7H-GÁ+l.NRBImaOd5Sn[Q6%vI,O˼\\Ikn7%_\rK\rFJ:IG|R8B5Tn4}Vi-О\rIJ~Ɲ9ӴT8NOv3>c\\xO4!Ԯ4Zw\Z|%]Z6Neweŵ>5[yR[khXA<7YW2EiukunCɶ,mrs|\Zީs{mlTI$5Ա0-n`aa序ߕ:]bٵm!+r\'}+R3pX7:lћ]aԣQT@1l`a@B7S&ʫk5pXH*J#\\iдT\\\"k\\C\r,>a:qqQ-:Xu\n^sVn3u#:칡i~%tO}]X\r9I,EݕVѪ\\9ѡ*O!~5<g]\r.;IN[\Zmkk+<zK{-Jv+o\"_[%{@kvA/4eƖ\"PdB&B6H=?T*ksڵo5/O\r^\rŹ2h/sje[Q9/5>Kg[f5#<N+YŹԡG6ui\nEJ?Yv7(F.m_2Stҡ#9XhӛӇ\\\\,|g?m<9G_YhN3D	Zꖚ#IҮYy#H푛rdQWS3*E$cUψ4ǶX^ZiඎHRKBAblof0[hx=*>c0{\r펠,b.ݥZGB;y`_~#0d8N\Z-L\'f>eWRrΕf#^RWX|5J(=.<},Mi)P\n_rnRMZٺ͵;<8bx4&/:^@bܳnɔ ˹iEK$hnsoY-mBPڪ5ZkWo	VI-DҺ-EG[ h\0Th$.o4ۭzVQ,JU.%![KyϹBZy<}VH7aST/8*\\JJ-i3Ϋ:	N*pJSc5N7N|[4z&m.=ZM*iK\\ybuk51i._bt;bXdaeg4\\پ#6 $sIqs2]:qscO-hԗNmu+@a)ܷ1js|H0C|k@LӴ)MKI0Ũ=İi@HVW-i-OpfifwY_B&V36T%\\SM7|8ek/\'Fj:?gl\'[WI%ugstw|-383M;fed$94V<rItM-6_>\0ɛd[m9Vζ_}jboYX\0>~o\\\0h$~Z.h?\"EʱQ,ʅ۲X*4(vA`\r`Kb	<t\\?hdt*(=rj-@ϣ#Nq0ܒ(SCJ:	F2Wj1Rm]~WN18tߗcy*YKdI×H d3kwztg^yKs1,nSf}9zd_Mks#[GRdwhp?+4id*X:EA1zu/O\r%\ZR<қkŵkE=\\>:]^JH*u*$i\'{_~W0!q<2YLRW؉p&8f2Fҩ6g|5AT,s\'ɜy4 esW\'5\0\n|jX[ӕbH##N+<MJ8<5nHt)aJGNvmKCҦz%;(a^E5k\\ڵ$>вnMG\"$m73j\r_Dm|\r\"@?TD5䪉͵Hg*\0@\rkDpY)ٜ(Ė$<Tq_Yʡ[RㅴT!R5RIT8FPI)E.c\n^R4⢥XHCR]E%\'{wlX!-O<F HRܥ4dBD4+J:/n\Ze]5ō4K_Hw^\r |$#BU$FtgY%EcT={gk{{mGPB\'~ j\ZD8}\"(L45{%R%͑ʧD,.ziʵ7ZgOB)IXrSN:sxsq.HMSn~Ӕf;vxP$Z:*Ao]O{&Mn=%^kX;xCETW__^i\Zeyںw#\\흤O\rŗٚLo{rIzWvwM(xwI0r%NggK׺g֧mF{ml4X]Մs[#1RH~QZFe[,6a<Lq:TSc41\'IBH*Նk?kYr3\'3\n\Z5*sL%=ZQ0U\'i+BR[úV귒]Iq)K_Meq}FcV\\XCZX[,oNh=q\'Ҵf\Z}Lhom^)004 W9V<Q4VnۚG*|2KYym22/7M;āL$6rTx!bBw+HQ,fT$3gUY>R+:Y-IѠ\'8ʣJ28,+u\'W칹ca	DfӍ+im.%{I\roo|VF-3m4Dr;G$+]&}_k:{fʞv﬘/lI㵛b<i\ZYVR˽e*dBO1àYY^6>\ZTy:Pc&(dlĀl+7|B&8\\.VzxՙTa#Vz8)Y򌦜5:#/jXԭ~F8,(A4*P\\ny쩩%̡)nҿcelPl^yWK	_&nm{^Hvtpu|>ZKz=YZ7b\'RKk\'tml-GX8NyHyd{f\r#ZYd`I$3RH {3KmJOfS5V+6Qm,@7Q+\0s,\'&Cѣy^st1RRR*؜NJa)i)vKaաRtXҦKd3u~IA+;\Z8>2c<+4p\nWX[h$$*Er8P#IHY=[\0(ӆ*%Hg\n:;n$`rI$I9sqh%bAtT7!v*\0O\n\0$A\'5ظB7cJ|\\b-S1:QjsF*nnJ)INkݽ[h2]\'tegX|䐉tk򴃘9>Dq<s8g(EGkpX\nb ٩sq[E<heA\" 鏔sYr*:I6#eà\nOP>=(¬hOY(PՍnNVһ0iYUgQr;Z&kr~FE:)h58s)uh.b\rDpdu\rک[ķyoi	X쮯b]LfcO\0\",1\0l܂GU1*c,K(U \r\0/aӭXoq\0\rW\np:sdj<>13bNJu8%IJ2\\Mɧ\'h#5Tl#FztnN\n~޻aM]P$Ӿp\'o<$^M܈pA=\'@\\O4\"QG\0s09 <Ҭ$Nx4=mإ39uY-0\0\n|!^]Ks%N\\FE%$vܤG=Ly_ppr<f\"05քkٮhB=ԣ(.WR(cr\\~ΥX<5)N*^)FjezkX+>о5iVvͅ摧quEk~-65=!\"R-fpH懦Mqweew{K0\ZT%%[yHn+!>8t\Z=($	e,EU*8DC(<wM[=JMt7i-sc)`Sf*\"8˞z|lc1UqTF̧Ns#ReR?ee5(rF4p\'[K6U7VtE>ʃre/m7.fkGCkmkĚ<V\ZkhJ\\[ǩŧJ\0iX%\"kfӢA4}Eocis;߈-j\rY&94Vx%L6Gw>\0Ӭm<[F\0ڷֆv(0[2۳4DXvC^???>?ifMdT)g6{p$)r\nE	S݌-xJPZ/}\n\\uIaZ:)Ɠ䝜KGG4b,0\Zu,VЍJ*98Ŵ+Ifs\rRK.OғtڻèΐKH]ͼm\"ȩpm._/1y..Q$Zo+PU(b?\\\';KH.\ramceSz04=Es:\\=Lb/i<Z\Z0-z\\:־{?b)}Jxf1B)NI2:RqST۟5l/qIStc8s#?-)Fjiɢwëfvv#^-wy#D1,3!GtB\"`3-\r?\ZnOu=ԉkgp+&y`3g\rq\\Oe\nCsdvדZݮn9e%ڌN\\V]12qa\'>k۹yi]XaVII]hZ9e\\$ke1#ĺ<45*RS(TX%)eӗ{2&l>\"tcN:5iFNRnoꚖogG5\"4jk!.m<8i\0Zq*vX[\Z;[{XӋ(#i-a!wQʥFCēP&K%k;x?,&IgTkkK\0 Ɠƅ5UsO<e5̐ʳK,6#rL1vdR7,k`B\\qԦmQPj8Ǚ)8[<Ol5hBiQk8&֫Xm캴),K$<j\rb6elʝەN289fY#vy%ݍ,噈\02I<\0=srjU^Z2|$	kyF2E{',0,0,0,'','CAJA',0,1),(26,'99998655','152366','','proud ada adjasf',70.000,0.000,85.000,0,1,0,'Producto Terminado',1,'IM;iN-Fv_nH$Cү.)˕[B	A3U?1c@cE.2G2ۜs|v=>R1jHY%@\06(P8PBn\0uӷ;zwo+OCM-g{/n[6^\'L>HIUz+\Z),23G*7A<95*FDK?\0>\n\0=ԏݲI+kUªm8aʁZՎ|wweף_81\Zg*Rrn^j1/Ue}Ƿ+:?2Y[Ρ~.I	\r9 O5zͻ:5bȲ#+<q68$}\n-5;kL)&2˕ !\\pFC\n졏&ԗ+n+{^]S^svR]\'{=:Y4qO,p\0`Ð0z\ZY|F2Iج?#\0wUxG&|@܍leʩa$` c#umI=CHq  돼zW_<fI*mr[MmtӸoq>nAQvt`pa`(1\0yrF:ԍϘ/`:%[;H;1_e)1(h:߲KQ]@VA\nRD*}I!OlsOF_vdexLd8QsMCH6%O9˜z	2ՌN\Z<U~T`PL\"ٶbYYbOO$~+&WXhq	鎤Rh\0Ze\0{yyx\'4SF&dw\0\0U9\ndKT e>\0dh_0[xʖBuXGdq\";ߞƽgD͵W1f-aB3l2)m_/pZut>߯cǄ5(4P*F7Kތ՝zVeX$.Kc 3\"8c4fien~T\'n9qCL#	u/eHbI`x$kF+<\\f9@( +Ն\"J:KF~V:5a{۞\r6I_Mz\ZE WI\0xrpAXjtF8!l2{9>HZ0X;ؑzǎg9	¬/,\\	$&շgN[{4խO7?r1-0n9V#;(f*R7^2~CH,TBDJfw\0#edeCS\rb9%\"~I\Zǝ1p6G5\ZMⴶ/?CRi-Mڽk|Hgz,H<CyԖqlvr1&F9X*wcDe6[\"=gv\0[aeу2W}}JkF̢&O/O0G$pAmAI\n\nPt׽)ZZmkǯS;\\iQmTMIٶm.iǦ~!l>DWf/\rj80d\0l\0n_{$%72Ƒ樉!?#8=p+$AMho~}$=0cRH2U?=#?b1zq,4m+Zn>	|:7^Z^UW2cdҋ쬷:+VkI߀񞅤,OBw)T&(@b2HPv$l;@.P\0O<(ܽ\'UF`F\n6}1ڹնݶ}[{tӋTlEY$mKG{MPfXH3XTs*28Fc\n@$eO2F}gK9R7\0-4rmYc)\n\'\0DNJ1HUrJ%ۣ>B6u)a\'p\0R4O_iJJV[zv׽aͲ.O\n#DF0Ř)Sd13DU21?a8[\0g%\Z0Y	-er`C3:H2%~i	hS<Lf֪Z\'mU+I(gV!$Gsq*9%NBe_nH{V~dXF%Y( /C\'6X$gh}ۇF\0V OA[*$S}^5RM6k=nƄea򘝈Qsx 0oCB:rc4,y\Z8#qr>U=z<\nT䜕$u֧nK*OO݂$⟷ʾocEE]g[]\r,FW([t_GWTy_ұ.nwL4n1]{A\01܌x#>wE`Np8##.	ն7~Z.\'InĂB228m%.F}t}qWNec	]QJjJ-l;Y&\"#$lTmܲ	8=NzӜγ*F\Ze䂧w1A8\\q2nw\n~N0Ao>٣,o(\'̣lL	K@<cbRK;{O<FW*<kG(FW%$.YŌb:l$wO^hl6pgARXg۸f!Ya`!˴|lv69H{Fko1F@<\Z錣=bZ/IݍkI[G{YZ虴nQ;aZʲ.Hd\\`dKnHNy,dS\'*B[\r#9wVHa{瘂bFˠN]t9iJ(;b@)P@\'# \'99zFiitζad(䳹r08U+SF~FF`0r`W=zs^u	Cn@{mBy\rI,k?eC]\'\rp}@5:)2v%T{v<e\Z*Svq+[y6种ZلK&mc\Z<؀AWPč0G`>r(>Yl\0cy,q+24FcʐzOFI%YEXHOBHkO>Z~{hMTi(wvdz})BP+1x*z+#$0FQ3YR?Y:<31^Q%yy(Rx*r\0+FFr5{`Ҕy3(8H\\<`Je<g C1qM5w0I4V7Td}ލ\'Vz铊+_gr?B?)hatя>\'/y|NB_\nOUK?I7987a`h*;O-9aF+w,\0sO)iD˛k$`3FbTO SBW0{=z鮚$\0??#rX?iJ.Q\\JѥdJvj-\".#u\n\0< Ŧ2:Y3.+l܅0\0<^ho\n2F1	S]o<IdVWaP\r,%Hr	\0kjXBKJVy5):p|i(/vrOQzвq8 \\/ۀrsAQ#yaHD-U88L̬F6 Kh;vVxW*]*X8Na7h{jjEMV]󸌣\r\nah5+65}Z]ݵ	Q_E&.\"\\gibUc;pw;8\'!@25>|7Mm_s\"rxg;6YC\0r7~BJ+(yV; q4YsNsm&&։+۽d)&hFݓV=[IM̪#Hy1!O*0TqQflqf%8R:oGQ;#gmc#hTs w\\5I>M\"ȊcY3x;]5Mzveg#y,jܥ۞Bd0D3p00T;dR0JHqqX``1*v8ʑu+eY>2ԦFy022x1ۻp:TȦD]䈒\\>ZDwǯp!e\',	%GcN9EqVR^]U_m[o\0^9ȏbxlqzm@xy;qUpaDH );T<8툭dt619\0`qrz5SRT{@eTP[恜2sH8I3Rqn>v@3F}$c¹nzsh$#1p#؀{PD̚]n[HdbprQgLdv\\z&@Ĩg8϶\rx/\"MĆX+4]FA#!!b;\\><qJ	Ne$Y\0;^6mr8\'4w;sobD	Fm!\n7:rI)rIʙz v7*\0D$z\nd/bE5h=4P%m6ߢ]mV\r\"<H%pv&@ǃg9JD)\ngO\Z\'iQ+]-Lf\\c$UcN1g[g)*.xR\"68#A=A}h8gG^WM\'JJ\Z]?{~a2ܬ\"\'k<dm<e%q?@HR[tC2.9dp5FF*>2mw%v8P8S*FA 7&Bq!Q3nCJ3A\']Iu	@662]dX(Gh\0ȭx!Dȁc6>Rk\r*8b1mCA\0gkNTĄH%UG$\rD#v\0\0.\"\ZqvKmugٵfՕ֟+[\\HV0mpSdnu(^YN`2)s1\'H\\*#r	Ȍ2T\05;$1[GJ\0#b>18$FeV;Qvny2ۜe+MY]֮ڋ~㳫9xՎ8;NI=3 .&Mp3َ?OZ\r\Z8v9!vƊsI\"4F2<ņF#8-ԝ\'qҷ&t۩~QW,RI+juu. i&hsbHo<8;yae!pQ\\#1HIe\0| V{@)$b]\0bT1/PZ)V@dg!+))[T욳^tGZ3Nowm2sP\0݊&4C{K6@Gc3s9H\0Vx	shNfb6Q`ARaV~Б%(w)=\0ve8ReʮWY^+\'\"DwSWe?	|vǧS$!؂Lc$zE\Z\0KcW{u\rre]ܱVnl&:\Zwoo| b2ZǞĀT㞽*!0HÐGPs$/9x\rF06jLN9;=~V\n|dTsNOO\r^k|1m`̒i0E@m7\\y3Ź\"S\';x%;JF	6̐8rvsA+1Jۂ)t\'H\'`?#Oh˖Q}lkV_$e$(,uMuVL`f,I6+F\nr%d9%@8`+0Kk<S{1n]ԌhKp;fŴ$;	#G0EHNfHJB\0d=lgetuIʝn\\Sw뾨Ԋ2|ApA\n,FO@\n[|%PF$r܍wsHB	#\0x^yY#,8Qsbew%%kY[+XFS%]tO{@(cbARr=C\"J51-e\n#jrwz+ծ❧B<bL*P	=1[_UVtg~eGNw\08 )PrpBkY\'5059rE(]+G\0o\"FGwm\r\"Xр;%`5Bg\0L \0]Cewl[|s\"\0U9d]ZM\028lckE,oʋnz{YmދnBҳT+2p6728>#(B0$FOp#,T\08Zਁ,\Z9\0	#tr`g\0?lnGg*ݖ\0T)(9]6պz*\\qߏ=\0F8sϸ94\0;H[q<d\0{qQfvNWtyy+Ab?iižvӮC+~\"۔O֢̫tNNGHc9E1Nˆ9F\nXUqӜu#u&̮q-15]kOT9Ǽy潿֝f77@p0=O! VȠu,QY@>:sU8e*rZY8+\03\'#]I$RF y`z c#~\rW94ZMkN̎9YFF6\r[yUlK(B1/inu\\aܛؕ?6U\\++=Pr~b{M}\nj	ZJ_y,s3gN@㕶<鑚d̳)qlk+8<`qUQ<abUc}V,Km̄pIsqAH2V\\ikӲykp˶qD{ד=rKSp\n@#sׂ9P:\"ZY2<(<NxQAb0ppzTvm6\r	\0>e[wrexM#&@yh#dv_.PdDKTlg8Vp|%!Z3ٷg8`ČX\"|G\"1B蛘q	BGBH$c\',dL9M8>hJ)]5kߥ˹Z	^7La#NpXXBR9vH! m8AFxTF\"rd\0`\\8\ne]l2,\r<r	$H5#a*<\"ar@MI\\ky+6\0w/咜rkj$$sBТ%Sn\0Xi `A8<)ƽ r/`#\0`PxWU]V`Ls7.6J6?rV$`ݚ%FG˹>c\"v&O-	F&.%~\0XJaUW&ҺM7ZQ+ðs8;H;ppp[s4/!b8fu]4Bkq6v:*qE.ʎ#x1BPdn0EPݟ 	\0u/ڨAXek˸7KSN\0~HӆV9A#ȹ<\nRw[ $taLaAx$V	Sշ\\Hp1j)f2BBt\0\rxjF-ViSNQQە9{_ݕy[ϻ\'kWqٸ&N`.~P90(Ē`bTQ0TcI8$<Xy,~^*oO^_|ϛ.]e 4[ g\0o !p1ЮXHb;)Bl`>ld0\"1BS8=\ni,<mvx`\r£G\'5:Mm]48o\Z-ZWku{Z},$3:\0K\"lcF#R|.gi\0#Qc8RXt~\0,\0z0A{EɕJ!d>\\ITgEk:im;Lg*NTOV:\\Q%RNp؆/o~nW(1EDLĸiv\0),P(nʄ9H88i#Gh}VbF&ER\\Ef\0l#$u:#Q9:.[k}\0GqZ{wGu3A\0\0n1?K7sRڳbwFʞ\Z9U@P;˂IQ0̅J$SD#\0JAxHy$p^T*<,r	^\0sM7d}FSPQoJǗkRh]հͣqA:3pڱ.`A4!X\n2AQ#?L\\d`0DC8\nqen8;>Wdn/0\\VJɷi+dAp<x*vf*IsЪq&1+`W8$lʩS0ϓXg~h$d1 uvSVo]\ZJ-7vzaCʟ6Ge`.YrK4J II\"0Bxyha\'~r):]Hq_4Q\'1c䍓RbZ_lajE_K۹v9eEdPH?1Nٹ\'Bv|zWʔ,ΪKݒYDh\0H`_gEWRDH܄v{zvjQM]_yfgM?.PȀ#bA1`2;	$uU=gtT\nzuyUɍn].FP\0|g\0dFJ[.BVvwe=8 aO9 w}RY^Pv}w,-`\0̓/Ȭ:@RNjdf\"\r\0e#z`Q3jFA|@\0,v%%sonn1!j!O\'4ӳO9U6|[ݭmoďv%ތHq\\UU8K36X\06EcLc4+Fܹ$?.x/ڧ<w*\0*`Ē;p(\nMݷ5Tm5?u}\ZC b`	`s$jUE`KX&8!g,vy&4\0ƿe>\\@\0|.ܑךxV3(\nC) G *^*`6d\0\0K\\-a~󺽔oG+.;DI=	69<#I\";hO30iN+I\0H\0\\ce9Q ۠tqE(Q!8NTc\0g:N1kVԠ[787Hsp~[!$ᝋ`6Cd$>\\IW~B#6\00Cc8C$tyЁ෡j{K2*p2\0*#Uu}vRtyhice-!\"_IYK%}~ey;JYQ#ݐ6&6Afnvv\0+f_%FbPU䇎bN:`w9!KڒD9Fxp2vG#uïXeRE4`֒ӋIuyܤ!/ R/ X$QW dHYfHf_-gf<Ab3U$ |?;P6y;0\'VpT4rIʩ(,@ 1\npG_?31wzf;5kzl6ܖB`Jd\\\"+JS0:*\r2K(ݗ3#vVCpI\005w;[K4:>Ѹ`p2컐2+B帔[1Y-U$f񵄂F#f*E,@\r[Blk{2j&-F?e]:;ǮV{N9<\"IX\\	r2:r=ECH((1FpTm#bTdcRD{q:!^[\nNL\'5\"	P%78#nޥ$^:E8IkvoNKIZ+-`&$ /	\0b=˧~w߷\0&xⷓm$J\0N\0G\\\nVEU\Zdn񝙍 J\\*ra*3aUI,gs0UnEܱv6	bs=+.龗~˧f~\')>oQwnmibԲ#ۿg¯KA,F9<ɏy[ܷΡnK?RA7:`˵#Y60ʀghIGXe-<e8vG l\0T[mML4qW[OO^usDs%u;y\Z@1j	9-8NLBt`.bTqЍ8*x\nfvr0=>H\r>YW!UW\rIhNq<\n-+{:]5Jɧ-\ZVmV{FxS2W9\0aBzV-dLJL*Nz\0pZ/$1z\r\0@+6xwL2O/2r@m0HRq_^6Dꕭj]v]+C\Zdɇq:p	9x$Ȟ~p@0oKg*\0m1Zύ4hIa#0>b\'zTv(DR[\0A79\\n`۔erc-i6\'\0+*[Yߕm~b K;:22R-F,v;F\'Mx`s}PonYcdRL1gd@,3,R[C#$#*\0#U}n\n$ﴥu\0W!iůyɭ]e`&۝HLn B0\0fd8\n7x⹕l0SJŷ\0>T+*X<j+$1U~95ד6T\\ D\rGu.)ur1vZƷOjim`ݺYºfJDQʹUQ>\'\';p\'˝8eG*ふ1H@1NbB6q|wK+jyY\ru\Ztb:Ҥr4SvO];;ۯ{-qqWue޷>?:fRXeeYJ\r㎼\"H£Rݜ;uvGN]ɁسYA#n@\\<J-IUg2\'T8Û*\Zs__={FŨBU9\\`ݤo͝\"F1,}t`$33\0@[ފ6\0fghV2!RH<tԪi\r0D\nI(|Io<O*4RrXT|8Tҽ**	NkXJ:nڷZA<xiJ3N1,{5$p&ƥ6Xv\'NjHH%jFTPAf\r\n¡.bgsFWo\n=ǃ])]lFwRkNj^w%	2\\˜\"!Bg2p :<19L8\0\nqĲ;Xc%s$4F[G74? \0#)ާ%i7OqAjɫm-fI;LO\0Ry,vVX-漝J%R\\1\0*h]vd5`zc=jedeb2b9+\0$WSӃfVn[;ub<jpN]̏ (ʤeH4_hv4(aQ{g9\0G<Yb@|bx8Q\n81rHS:!H[v`Yhm^{@Up<(թySv{WM|\'M!Ű\0<o;x>=E#;)*U=s֠;(kBgI*|1ImT$i$`g`P\'M5JQ骊K^\0iJH\r Q|fM9̥\0h簧ar%nO	 ]\0)Mw|Ⳃ3)\\+n?r e\0͌OAq@^\"F eު3c$@(d|+[D\"Y$Y`2!ۂUq$dUi\0\\hVth)#i}ī;  \Z1\0с<v0lB9*GTЂHƒβ8b3x#Tʭk<m˪Ogk4ݯ޽[^鴀aٺHUAsBdR7/\"P\0TNsjDghbb.\0HrN?lKN%WF!KBg3uKְI-X\01w@BN6!QE_~dL3PpB_j1o}K]?B&Ue*G ;-3\\&b$Ҋy+{ߤ%k~wfYf݇CL`/,\'$gTK),C	)S9fـqf\rq$H\n0a0#dȠ0Ɵmd	vLĿy)q\0~dB*~m񶚧F{I-x#,x8eB`\"O7|;ڼ 1](9TWȅh$L$atۉ8`r\0G*euY(KJ[)*c$9;y\0];a*sF^nEhW1FdIRZ	S\'Qک3,ad%Hy;F@\0 $ȋIV1P@mnʜ7d82@]$mn1>c؊]?-tm{FwN1%{4O_;טG5FX$Dg+6YON3	#&PpQK+	 aՌNIB1F8*w#mQF)y=+<	W.RCOĂrI;$k-:eӇ2v+v^ڵmЀwOd9en\0&n^DBy6#ma,k26G-,wgP)DJMH9WmZ 8*9PwX/2XG9 l)wP@P\nnM4iۥԯ~-}gRP~\r6,FTBS  cb4~TkA	T `Qy99rl*yo\\5H0b&#\0Cw\nWR%`mE.&Fu6C27q\\]j+[m:L墂tJWbI#eBưl~Fp]Qty\0	Y,ȥ(Z\nlQH/j\08f\'#nb/*C\"Aerl\0>;2()-.\0\\Mtw[J]-{+tQ{\r[!Kl\0I:V]BbٖPn/&%7.lGEZ9H,3*pfܒ;[jK0]L;#!Qo%3X9Yz~O]{F;5\n[ݨЦ-//$Bfe\"x~IwbA ān-$nFR܎`(8vs]ǘیVE\n7FOԑ¶]<<e\"ĐۈRGA2#NqvP%^,eTR,wQdھQH^q %DO\n`2v6.TP7\\c\0;~\\_*W\n\0s |rA!Էȹv$TkGߺW) UBeEmB9dՓm+K⿳[\'̾dmuZ׵exBYw23|#)#n?vCu ^Njt_ vUMcbUrs#I<끰>i!Cc%#\'VxYbvpU2cʹd*BT_4yD巩SI\rJw{$K|ز:\"`1b*;\nCH.[an;GAE\n3YV{.@?gH.	7V6bW@H22H0l	WݻhʌtS|ɧ%mkhZ9\nɭ?w9UӽI=4њ+,#F*eY0+2ǂ%Q[*UTSXw#FO A ȇ\"ë.C+\r@XAy\0YRN\'i._lMvSf}Uﱊ⬢֑oWս{_]Q%,RC\rBv f3#,@=M9¼J38y0x]ܖ$EPd݀`%9FHa0\rD7390EReF8N0.8( c8hO%^rR꿑)>7 0\Z$ʶr.1*@U[8|3v\0cIz)do3)䯘bvP&)?6H&qx~Rm![\n\n\n$qgݣxy^O}lErWFIܫ;ynW75g@p*$,ŒF`H_:.cq! Gq@078fyr\Z|{ue<CmU9$dxrӌ[M#MSw>[䅂c3wv1U]3ۛC32ogtS\'mfadħdFd|Kve\\RxMW*UDeڻX6T0R>TӛM}\rei!q\rS&FS\r99`66&W2}UOl$ED`AV+T#*g;	pQA!#@Kas2{Mު䬙\\Q(9\0pr]VvnvڻT~zl/\\Ci@22<N:d,ʪU\0W<9\0y>^~_Ց#hЫ4Rm7څTnPwAPZ>Rj<9\n2ygDaU[~\0\"\0f\"O1#.$ݍI8xӦ8\']5CeJ7y$,A(\0df \0~flŞfygyDۻ\0n\00E@r;ʶff$W~Pc8ySNy?yLTֽwF!u\Z)J/\0%v\"73HW*m$pHhqW9!NA^Japm<Fg8+m\0(}\0|((\rqfrIɫ7H\\¢5K<^9ZmMyk$Z;=Gm/ol6IwN򤎳#݂%DN\'9|w\nI`>qmK2v!2%2W˓MGzHkR8;dp?*ѕ]AX\0\0#a\0ÿ$t=Th˷:pw\0柳RHOT_I3̛YLWSFV-	e!\0 H뀌D;wrTi,-lr	`\0[w^)沅qFYYE-9v@\0v{%wfޝ-]|E$SM$pr}[J6K\"!T@1Hw.8VwmT͛{ ?4r]HQ%0pWxU*n: AUB\"@y_>(x3$RsM5-\"R%J]WkN{>fJUTocPhn\0F6:@	ݓ6yh-sf-%W+prH6r8RUS9@3ֵm+4w9ztK\n\r>pMIڝ\nu%Z)]m͊	F]qn]\"*C.U8²2YvaUK9m8)nnP\0ƚ36)c<(?5xٕݽK.Պ<\r<޼䨡vWmbxssu%$SmOIhވ,?D˴\0o*W NҬк(TOCkMm?y=K|Oޫ#+9g .q8?!In1xg<0\06Gӧ	Y;7޵iN\0/:K2Mm)=\\Jr[,tnUVFZx-*|\">PJA]vImۧNNO^O<vYUT:(m9l$~b qZT;⢹nTM\r.K8vG:酼+m<Hە~UW9Q².4&1:9٤\"6|70fݸQ\0H|%&xӨb|\0iUֳshđ$\\	)ՕԜ#~m9\r%R=<5/ҝ]%nr}63,D(n!	$V?4\'~%[pƽ,7r\Z$g#o,pj\r-5=H)4(8 \Z9AW>qx	f$eRH:VK38˖xoXB)J۵8EiT[}WW!V$adpXm|	%26;T[{S@V8q2d\n9mpq\0k1?\n0q\0׮廽^&8c\'V+0z\0#RR匵}y\\bVls\nԡJpK\nS)=}n\'tCMS!YdFDQ&A9ٕ9%`-+67scXC9B}@vK>B-׮I5S2F2^íSj$vdϘF<gSe\'I&2r4]a7p\04#7q\0-T1c05w\Zm;FHbq+\"\0yiKR2QpcC䞃h.m\rIq+Ƿ-c`v@	C`ɄzgZH\'96`J̓22Fzc\Z8Fr*qmӣ]C0i$H`\ngi$,.UvΣ*CҪ,;T$\r·\ZUon&Ckᔆ\'rU=*݉$OOڢ\03!*$䤮?i+67_?+l!Dap`᝷p2V!G*ԑР+0+yc\'i\03FO9r\rq3\0\0tUugǫw<еI9a䒓u:1pm[6vs3EPG_QAj>˥[\0',0,0,0,'','CAJA',0,1),(27,'','asdfasdf','','asasasadasdasdasd',26.980,0.000,35.000,0,1,0,'Producto Terminado',1,'\0JFIF\0\0\0\0\0\0\0C\0\0C\0+\"\"\0\0\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0}\0!1AQa\"q2#BR$3br	\n\Z%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0\0\0\0\0\0	\n\0\0\0w\0!1AQaq\"2B	#3Rbr\n$4%\Z&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0?\0-\0WSZiK{Y/&i*Go;II^z>CƚO-|g,6W:\rckMlCA}\'V&\r],#ԭ-^G?ŏ-Nݽ]zT%X{]oR\\JygUcioo$>(<F]_eO髩MkڤW7ڬOr5Q&!	+Fpdx_20۔*FAڻq8$gV\'`ծQԭ4(f[4%HVR!M\"F>bu՞FR\\k:tR!rfuoZMī%;6MxwX<K\ZǩY[y֚Վ&ӵ;aukI>yorisipD@ ;htɦE|5V/cg{$1#̥٢\n yY#oQoR[-w[𕎭i,>uEWpKXV4ZţfynDauã5WњPkE|M6-Y{[ϔ5Zݦso\rAupqc;&MDeDƀ<Kfx$1y!I8[6l5̒4%ԶЯQg.mb2\"ވ,ꄲ fEu[;%\\-ymܴ*P*HPd.\\mlilV\ZSdya\ZH27d\0|.03@qgdDK\"Qwb!\n3!IcoxTI<-cs5UgHoe+mHpL>cH\"ʍ|<q;KmKM\0-<=k8N<DD\"H{\"OԤkX\'SM1Vf\Zް\"n]@MW;vۣI4@G;n#tBd7\0	<egSE`\Z}s#Kfx%\rd2ʤ)\nUԇFd!~	x\rX躇`ܫa-uE,Mj#VcIgciQܬ\"Yb\ZŇOxm7:DV~\rdNmRg\Za^EO\rR8*y.|ȺI:a+;ganhNpY^6bÐ-uSڔikDvN6Wj.\\Kf1f@0b4߂ մ+_sG 9_ދMKi:`1HX2	\0\ZU`xn[Y?4O\"hm>7xOCw\nƱo\Z}RMJ-\0\Zg5\nwնhZkZ=n2FJm-H7\0o9g]oMi8\\N u%A1ȶ[nIcg%Qh6z/ \'t=[~=H*xn.w:ޅa\r灴{+[sUV<zTh}\">!~ܞ&t|#d-3ټWhdRO#E\\\ZKlg5\'|iV\Z|<C\\xzE^*-cVX`<ch^tt*Ño#ko&OQ~c_u\r_Zi\n6\\\\֖]ɨ[C]Otahǟ%	m?\01?h̟k\r?eD|EG*I<mJOmhW7f	KF&̶3\0-輇QQQF<r\0bxo%${uxƷwu yݓ1\0+l/זi?eKM#d,S1s<$,wf,.0+`\0̤@/۽?m-&\"mK\r#ںj7pEsDuiZrJʮD1pTL[ho|m\0x?x[^!/_Cm^IahcHVu4&<-a>\'wm^0tfkYxAxPZ\\7?6\0೿ޡBxe4-\"qqZF#x-!uWYId\0U\\u[a.5)h4EeFv\0>;	\ry?a3xjV!}鏨G5~k{-\r\"RYӇn.,6/-m),OP\0k_?\r}[Ij|<[4gZh=2\r$z2\\hq5r\rCWc%}KK}WHH-+@Wuh-u.;່jp6Z\Z3@/7.-Ōnm.eafM	h%a[úDd\Z7\r73[h[e\ZeKY҂[V[덖v[O|=}Nu߇>>־\Zg-m=W>)baρ-/W_1aմѵ;u\n\rqoV֩*Kmqk˺G\nd`wd)Re\0|2oB/?O\"S6enZYWVPMr+ _:Ux~{g=67[KxchZK찻ƓA\"Eo߃#Yº>4ڐ-K&Ě*=?>`0u\r1I=	\".NVO<U2|E-|i૭;@~\"xz9x{Ò:L>`%J(\ZPz?/(gE\rǪ3\'ֺiZ3$Q4l#ʼL\rU\0Lk[m	YR;BE\\HU̱\0uҾ!jꚭ­ܖɭi;mia`ںFA-jKs2PӖ2yƛW[+w`q\"߳y捃U\0<];jVm\Z}iu$\r*,ݧa!\'1 9\Z\rafV\ZjW3[ɂUs:3iRCsAYcLi k#kV$3ʑ1=kPӾ]c{g~*+ˍ+]=:&7/ 4QضurPiWzeݴ`2x᥶NTg<1J\"l{x 3\nGeBX)Bbp~A:vk:I5Vt@Gxba*f++ډx|0͚%H.hgR8+<\n;\'c)F@ͬ֯U qFʞǽkxúo?-QdyEq#K?J\"\037^u69J:>Nd1}Y!i,0ʗri:kk:3ӃQ[vdXm`ZmR4WQҭdfb4\'!31bK79е6n<H-$ƶխ4Y/Qԯ/oP\ZI>˧)@\n>i\0K_QN]K!,Vqyt-XWb@A^ڐúqI\n6y%RS3䶋k	2[A%3+@TQE\0{i^3n4\rk[qI4qhׇ53uJVE6wFii#:[_W<=Uo_XǫEj\Zy]G=YBm(SpHI7>A>jzN^Xiټ\'C[\Zarnt!㸚erѐWljéCۛ;{KQ$w:rıw\n$ʲcDɌFE) O\rYܣkyT\\\\Sl(!(UC,A[j--tOOmY[hEq#r[%tAI.,Ѧ	{н\'ͳ9c<r/2ʑIR͑玷IՖ@.٬I\rI3}2YѮf`N[Lg[E\'\rm?Pҵ;Xy`ִ;VH\'ɾ5M2jn4COޟpMz|%g6zB di5Sm(Aowy+,nvQ3$??E~\Z~ڬoo\ri_~K+TԼmQKx.xswue$ַcHV3m\'\"61izOcPмWFmc<Ri\0{Gk[E1 Vcgs\ZAAV	Q.[BoeH\Zk;l@`uyrUDpo6.C\0 z>8xj^F	58i|7\Z+߈~+IyL^Rw/	;TU\0\"g\r֗]>,̪C\\p\ni@v\0Z<&82ntA\Z		/k2ۈH	d-^&aEXxvZ?=>\"ui&2سukK02oguqc$i q^gFucgaαx<yb2Q$⺹ѧBeJ	Td?.\nA۷<+!\'|C\0^/\Zr}7&\0wPV72DխZwkcqA\",~ue۵ݴӠx/	[8!{.{i,\"6\r.][PdQ\Z;=ׇq*GNG(!8+\"ȭRF%\ZXǑ\0-\0\rL\ZvKK$ڦ+jz%ާ۝\"܀yx4hZ早iVi⸈,\'v*g\0%֋gᴶ/YIƶȾgtx^XKԚ;Mϰڞ65|iuưth.㔙!6Ts.p2<\\/\0ƺg \0֣BMylQQOiPO:TkJs]BӮBd?>\n3\n_\rx*-ǈu@ ׼Q?Kq}xPޭ,HpZZC\r__l?gv\ZjYψ/Y.cJt{w(l\"^S{,#˪3,WK!OPA6$|,(䜄X%ЦMqs\'&$)u6>	fiSXF*I$6v\Z<k\'<]+xo6%\0?	?g/?h\0?m\0ul[+W7Jam[\rxIrA[\\F	a3W<lVF՗Dö/>=ĚՅĈ]u)f4?~Zľ?`\0^Ѵ;Qu8邫s5xN<Ǜ]6䟫~8Z/دWX_#u;Ok?Xb+{_,\'t\n#7~EP\"X@4?5>P«\Z]X٥)XnA%v~.|:5͝Ƈ\0N:Y|?y6Yp[x2fim-1\0mp\n7K%[x+l58kdj4&:(B׫j?\Z-\0ko&w.??~\0ɩX|=[U{ǖ77k:mo%hͿc> ?cC~/?zi>={DO{ZǇ6G4m\"W_F+>;Ҽ?qiVxK-ޙkڍͮc:j実Z\ZMrw#ϥ_=8h\0GiLWL\0\r%.YnZi$\0YfwO9]#7jp[_+oڃ%|QyB	i\'<ѯ5H̀S|\"\Z[\Zox\\eN66F_Q655V:%鶨V΅5,0qc~Ůg_,ۣFnHaO	AO+mc{Nkڗ~3V/MhMF_+?OaW	DY:,<Qƿ\r$mgߍ-.Svzr\rρ||/~-n°{7OZMи#\\ٸ\"H-Cr&~^Nx_\07aKO7vږcŞ	\\iv#w~ޣM\r6mk7czǃ>}[Юdkkg6c(Y4MݤQC4\"`\ZݛI/ZC$jg3X]w/-36	[;{[o	\0?_^_}֛R߉hZ͵ݵݛ\"f]^43kq)7;;Pw	d%7C]>}^w7^ռ_Y^;Oumak\ZYٵRe+iHOj0qhYlW*dT\nF0@=/jn-5ŬVyHr^;[uQ%ԉ\\֋4^O\"\\KUl@ѼaT;B~5·zj$\"D&$2qБ\0@xR[wƊ-anZ$)fM>B;N@<ZޑmP׵,ZWԵ)bS\nIqķ1q<r\0A1\'x^\0ůh\04RwNmbrXxh>!ִm@<Op$\'䵾BS7:V?f\'ÞĚQKҰ_tK5EO$\0K|\n_kQDeǇt:__ox{_,ĳZm߈WAWI4B[QnVWkSZy%\rUA\0\')k߉oAo|eY>}i>m;ke>&xN4{XII#uS\0G#6|0߃~!fgӼkHuQ\0zǊ:OV\ZڒEﮋ|-ώ\"x3C?4_\Z|IikIgt\Z|)ĿxZ\Z\Zo>xV5ͺj~+d+ğQ1K/H|+[WKoֱ^$v(>,{KmuCEi_I<#-s珴7῏>\Zxmœ4WIo5,M_0]~4y4W-Vo<wRxzlU]QTcouAgڤX[.5+[KUз챥P\0C\0>#<Y?7u7Mk>&񾭩k\'wMgHŖ|xM_~76>\r/|9w>մ\0\0M[oٛ/ڛ	==|u~m[^Wsi_:hx\\l,/R-ּHe(\0|	oXkZZD72[^\\߉淎6a\'Ｉ᷻kX,C7qI}ELxQ&\"2#Q~?{4{r\\\r?|s[m]:#RKuiAtK;oQ.=xc ֵ:MZN7}a3/k:Ƒ߅|sbMմ64i>2]t[wcygav[W,>q^|]%,,մ0-I5 a鑋hҥ<s2x9r\\YA0|e=}j\Z}ޙ$5j;nQo1gqı#ot߉ִtj\ZƏd[A؉|G_,-͟[#M$m/TaUִh|1\r#\\[>35͈K3C:Z^k~\0%>_GG	E\n΁t~xaKeiAɷ\0Cɠ\'\\,`]KrN7z/ƹf^iڶL4Z	.\'Ub-G\Zdmg\Z\"мSsŖwV<SY]xHXRA!07gU\n۳>dRG$u|cIώV3uZf\\Vyef/yyM%j[b?8ojI$Z$AF/7XФ-.M=.Ύ3`̢Hc$!op]\Zve#\0Auhh\'6WXeNղ!d\riE{Z771<;ukYWl洌2c*W;N\0>0hVV0цZͥjЛ!u\0B@6p7\0lc\r\'?ڟc=oķ6ãPI\r%)K{-wɷq6z>ƛA\0\n\\`m,G,]\"d2*B(LE%ddl].\0~VkyyJ(W$Y!Qp^BdE#oRc>?ӚWIUMc++%4W\ry,4311]ItE5}2+ƹKkC%\0sɎKxe6\r͛\\_M2DfV[P_on\rBFݧſ5BQ5ƑXNסi-1ɫ&{{oT~,J\09@Ӵ\0eO&K߁e[VEM.=Di7\0U_ǫi*ѵ#a8e#!6rfk}?&^8?I.<S{i?&giڟ=V	\0)|Xъ\rQdr\Z]\" Hai\'<]Ҿ\0G<RthMڶj͔12\0xvHC#.z߀[tuc=7:eTM9̈́\0;X05|wO[7tu4e5֡~(֢y-~h\n=\n\rv\0mo3I\r[ 1vaCa=滨J1ړX\Z\0\0s_~?㦢\0C煼	İM[Bïٵ\Z[Q/;z?+χ-2{YC[x;7MG#nE?xd$HZ\0k>w%տ/-eƿ|7c;*Ѽ(4;ݾ&w\'V{۫LKo||g5ѷpa|gyc?Kmxٔa@\0b>8hWЧdd,M%ׁ 2;\'\n~ͤ_OF\nE3W\0iX<w\'-̩>H@7Qmwk=.BΟO\n#<\0?H\\J>*G\0xo&lD=esxïNx߄?G\0M-ǈ<#?û-RHeվJYNxg͊5\01~\0HaQi?gOڷۋ巟OiK8KVXBmo}T:>9ߊ-Z\04Ko.7NaG\r|DM(Z3qonT[xPy?F\0uO~*ִ_~?M_|Y_e&@%ퟍ~ıoT\0<|i~~?bsfᩥq$>wÓn~.{id,m\rgfm>\r㿁/i660xc\'6$bZ@Ywtαv)9[a=\"\r\Z]γx@SȚ森7<=\"~*}NumfX&KEs~Wgx=XY<W_P{&Bú}2[+++eo\r1bDET>$x/ƧA|Uo\0o<Oz\'.ot2\ZTԼ\'a=I_WЭb\r=!?9קhC~˟|o:lpv ⃭\rY?ݯz`K>,M$ufǾ>t*iu+!K+[H\Z-Z\r@>$rG{R[9^dW ޣڃS\0\0hߌcS.~+\\B-c+l%\'sKh-p>ǁg%ɧ5V$weu274eLp[HK\n!2:HgvZ!F4\"$ukHv|BOgM6O}m{Vu{)#,5	4tyLΝx˪5߆  ]\Z+9rylg(p1ͼ*J[Im>>){<Iu5|)y.)|]Xl5i\Z` \'Oqʋ]&28\"0Sd̈́s%aV?gxG]kr=}=:P1\r}$T0.-P$p]U㇆\'×\Zΰ73k{Ũj6j 4ÍC~+ohex\0ᇇu;_\r]|=Ugws=şY5ೆ^!UphWW,CZprKo$\0?#K ֣\"jskjw6],z֍8ITMۛi(.\"2ȉm7oxz\Z\Z<6%5JMg?<Ko{\\#;eі{6yj׻\0<C^ߌ/jl\ZԞa/co->!}\r!H5E[6GH|$UhA{oۛ7\ZnI:Wv]Z[?YfDQXe}Zm-~^7Hg<B|W57_֨|\'_kx\0Ak\rZEf_.#77>|΁z/fũ^|!5ƫM7^}0^Z_YXgZ<Ŀ4[6ZG2+w{ltf`w+Pl=FKKiw֗,ksN7>4	]Sa\0Cx[GTMhr%	k冏ZvȾ\'Woөij{_?{\0K>~߳eޱ]3/x/^!ſ<=yw߃ڶė~*[YԵXj6>$xMRE|<Ew.\0~ ǿMoztRmO:9\0h#[-v/\0n>2[BzGWwxGyݤ!<(M>3e]_%ǟG~Fwix/Vwb5_O\Zhu	gmfvu}j~\"R2vm.\0!4QEY~Ǘ,!6iQ|<S#Enk\'P-]\'VC-yJonx/cxn%Y.<֒\rLۯkO}o7sx3[.%AYIt$XO28\0=/8:L5kVԴR/w-F|CJuj*i_izer*x}c<\'km\rrV> -cSVi>neY--#%֩NyFk{+I\Z9=ռ\'20@!)㟀|kZ1^ҠChD(^HGԭ__hBB;ԓ엲(5E,I02*rBU ,U=m-,<m]V֚nZ-դio#$\'qMcJV7}WC_\n|\'fwAx_H5_i6W-ZLREg>M{Y%]&ks̖\\	,uIFF܌,Y#b,7B	Ej\ZlA#7F-2nLi+-UEnuC˪iL:u,oEA=\0-I/w?/Cze1fN]\'o4w1\ZXhE$3E<yHݬk~8u}P:Cr`De}ט/c0s˕vYPd\0IJAYA\0-)p)6_i\'nI3B3Ƭ\Zi$3E,3]\0tVwufС	\rm*V̫{\0\"1;Lo|!zйK\nIf\Z8m\r+Z9t{R䳼;Vc}cz|AxFp^ŮcZ\Z&o[}N	;W:HWj0ZMmsuAfZb$muQ4ƈy~jn3\'gQ.M&Yu\rAo\Zv4_eY{:?\ZJ-0|QmHMZ#HMmrK1;fg0T\0H[xğ	Kaz^^ٽ49cI%F\'Fc_?Nkڿ]Xx#ş\nL~3|\"X<3]嶧㱬<-4\0i:f]:*>_\0a\r\">Yv.A<)FVku8>+Vg[3]LS;^8k~i\0{T5ջ|r&ݱkx_$ƺЍ	?Y~,~|\Z?~xT9z\n~\rxºi+@Ց<o[$wv\0ğ>\ZΥpKGoO{aj\Zڲ/Iurm~ך[Q<MDִthΚrѨ9Kk={zX+.?c	x6#sΗpI&Ҵ<kۂ#K|rF@r㖥^{Y>Xmg)xF-mUUDO5(c.^?b|=bؿx:Rjvs\0?oῃJxYD4m\'_>;WI۾MVq90*`1h)~+sycڃ\Z%\r94OK,C%V){Uʖqs\Zo\0h0,h?\0|-h5\0|A\0NӯX4?ϗ쭤\0~ߏdBdť_^ iŵa$[v.FF\0.ȕlg<E#EŽing>a?;ωO,c\n/~\"xX-=͆[F=`x+\r>{d3Z^],kWW?^οGji/kw|7\'Gw߇	xG[[ۧ[.M\n^]ΰ7Hbe0\03_\0T\ZGh?/P|iφ|$ TZï~+~?x[>k-^Wt\r4sBڦ~?eO;xr̖k5\\Ox\\WlFQSf߶	B8<Wz^	>$x3m/Kg/7`>[i?KmEo<1(/lƕTݳwr\\iױ3%༵m4~$^5TW3&c_j7`E3ԭfhJnSlmoGZiZoCr-?\0J?gZ$_XC]ZQM?ZӅi.x%?y?/A>x%ڶ=:ߊy).tJHz?ci<WE*tۡ㟋:<Qk~~ŭ[|w<kۅBH\Z6o\\3\\\n^6|C7OozNx#v;oi:-BX|ȢJaִ[,k;+Y4C:2Oׅ~)I7Z6\r9QGHxn2Y\'qus=\05Il9,4M-55EK\roNypCIi<y@>)\04z\0]{/ľ^ÈMi\rK=7iq\'jKEs:<]\"{0y-f㶄A Is=AY\Zsu_\"j)c-g:ycpA^!oR-.DHY|(<MK=:ENƙ\ZjVa%ȻNm;x-&pqo9^׊|O_Mb&Ks%mYSy-YCiP\\A`\rE|JGu~\"4\'Y\07jt\rN{]GY1	\r\"SBIn4 6,\ZJ\0MMSeTϥ+m?5J|=񝴍橢\0jiϨݒOhzD6v~ǿ`\0*iVW|X5ݼ=]J3io\"Ks!gFo\0<_xRuuEH\rN.KUM0$\\eL\"?b((i(~ؚno7J~|BXT\rIwZQ2%Vk%ŬYkF[|: Rm{mA}L^Zt;K-u$q۝\0i*Cv\0l<W7!\Z%x,3@|KAk.aQimi4> 𭼱\0A\Zie牵w:VO\Zx[-m	\rB/I-\'ԭDd|1Kueu+ismleև;E5|@|Wj&X-Z-&{{p4=JdvYuAbമetj]սCFғwz-m]W+F\Z\'\Z<xB֭>\'xu+PS%,%C3/yoh|پloOѾ\r8aoYQ\\uyM7ÿ1)}&ME]FVmn<11ҟ/0<wn,fs[o]ԄIn#29>,x+Lak,KIgOQXjzOh\Z<smontr{k?jSvosM@:d-yn8M\0~9lXķ\0\0~(	|sEv\ZOuo-#M7)k\Zz4\Zq?:g\0eگx_Ci+=߆^&45]?PԍM/j)w,W\Z%w\"˨_WZw7\'\'4,[4;]MiA-Ƅso}iO|-ieΗ>uw_)x<;İxC7㋿3ú\0[Dt3hگ|G\"g-A?ͩjPǣҝݭo`k5mk2($OwRn,LbZ)m>ʱyyMrnV6x	S#]z>|l-]褟bԒ;ign.#.b|Qyׇq&vL-$i#%h$]3PC[Irg%:i$IC<dѪ	J5(?ZTm4;)Om,bX5<EJ (dUO[{6:_][G<WhbߋKŧ|}_5M!6*FiWrx\'ҵV<T,w>@vrF3><TӃH5?X4_\rWO-&\0\Z=\"9yuxӃmoYY]?Z\\XHt\0u26b$[,Q0eXlMRD*5ó@fB *\"3?	o4tס֭$<\rY|Me]={MWNu;]B-E.m%VmhqHKo1@3K*(69ۆ|\02̀KWP3Ob3pI\0m :kv-*guTfp9X̯g#j&~J:nv_Ym\"&\ru9(w$)%h@.GYK5%<%DPiWAXEfG,NmYym {{>/wkkHw>}WJY\rSMi|SαX>~C,C~x\'58%EϰoO,uַw}hW.-:FʚR$Q{/g/TҤO%ɚ6x7-	`t\0-extˋP4~ܤ\Z?eզQҦ:cj:Q\" u2^[icfS4n?|?S\0 mYܠβZ~3X]+;Gk0\n+~-O\nk	K\"c<3	\ZE#[][6n{8txt	#x_x_8~_\r\0:xwFφg5!ݻ紾/g)#T՗>zuί$sx*2_?ip]/Ï1mf$p<K㏌!|9>y\nx6/,qXR$B_\r_-{YmBǟwnUϰhZX$w	@WcP1@Q<bmHX(_\"I4O=Qo,nDrg?-\0}eOxC<S~!,I{?i֖o:3Ԡ׿frO,??.~+h^,2K\r槮j)$\"0`|%Nv~+oXwߵƉ9\'|V~=Yp\0Eg%dP6v_P\r]G\"ntQm$5#n	2Fm\0{~pNwW{oW߉\'6u:\ZoF|\'\Z;28v~\'/Q6(&o񽬍Yö^xr	#[ԑQ`+<1_|K-wk^}++[VMƍ*+2Cl\\^C6?]u>,ؓ׿	|Gq$۴%I\0O9f\0/H\0h?>F3m&ϊ~=Ҽ9yιKiR#kWvKEai6p.	qLCpx#	x\0[_Wass65ԴoM}3\rJ=#+KM+)vO}(|\0o/\"\0\0v֝Eǎ<KZ.:y|)|w&K/RǞ*oa~~js?:³x_u=gS\rO~(լ4˽,\Zw\"Mh/8w,mG<LzP[,<Y`ӥJ5%AΕE:5Nra/szyYS17GN|_j))jn#\rBPW\rBJrN΋iN),-\0>:W=)uƳ|EokCMF|Wic]*X=Z|vz-浆/\0f\ZE|ocɧ_k>!=υ}_Jc%ݴڜeUS};/ƿIo}Rq~	\Z	S/ox|H䵄ifho]JMuߥ\0]z)%n]Bþm^qlŬM{\rV}^i}͛OOcUXf-/i<q8J.TjnBRq2,ff8F*<vF%ԧY*gMVtk~e۾.WͩxW,d7suq}\rR)<q̥@~b*\0{KJ|ZloswȨOa/\r+Cwm3͜,3Ž%FRױ/wܝ>fl\n-E̅yY\Z	1wv7WKHIy&XWs\0ž\\3qȡ^9?w$J2A\\ZxmպkX2wդK4{g$Cn.gåFDh~ᶡa}Q\0޹ix0$dJ\0iI׬VUK{jM_Z7=?ƏtBX|J\"yu\r<%]M΋*$wqJ-B|*ok::Co%+\ro YR9ཷQ46zO\'wD?Mu3#＞khmwYD+I([<Hc;HYb2\r>2w!vOi࿈V~^Ml&57z5ZF,/yq฾0|gr z+ǋ~jruK\ZZb)Oiv /o/\0w~LEhbKP$}MRut緺]SHUyelľ-^X;Z|R_KU}oak^%\"Z^&)l7k!Uo/\\huM_Nh\Z	#X.[K[92wkjV_\0f|kz}r|)>kZcf:oxkJ\\[]mZ;خo,%W5|s?w?EM9KScym{	XZ0R;M=uW\0>S{|o\\ec:mΙKynn,<Gg-ƒmJJ\0߲dO⯉	t\r\'As/Fխ5ȵ]3SΑ}[-ZmtR7h\\Xk\0;ym⢲O{Kh\r\0ڡGIR@Bn	,\n&eO+o?)6o>6GD_l<Ca-Ě=ė5Үc6[x\"?m\0w☆?LR%ڒz-.񯏭mMf(aZд^H\"P/؅Y/闆i?<mx7W\r3ζh~/.A0jYOMgĚɺKS/|=e;\\%ծo\Z&6W\ZֵCfC\r^yOo?f_| #xWᦥ\'h閑Şc7zAꚎjVm~ZVg=M=E\0\09M$Һmv\0|@h1-oN?`^\r/S⇃gcZ߀nnKK(tɚVh<-[Y+\0%վ|2MtN,Bм}ge,\'\rܗŜz]\0g/]wIt_}MA&jϿNsll-\rN+|!-yF7^~ |9{:^|XZt}[_o4&a0CAc4ZMEzͩ5;+t\0Z#(O\\1xZ]ݏmMT{Wn#Ķ6𤺆G2oYo-Ibv]R\\\0\n5m~\'d:]#%Cyxm+&rkoF7:nmk>d̿..4]zm_MxrSSu]?Un-u4F\0NcZ\0.ĺx7}HaΑ趯u\0mkmbڤ^bG:t]VI=:]|?\r\0+%hཱི\0K$Kf$-#/Ũx%#}%ݯ\Z->ٶq[Ai\r_Zqi.+mc\nVhcskiڽ\ZöjvUfXhbP4Z_]iM|3}*.\"^\Z\\iڋmչLy-<U-Ia\0_Q[\0Mtkv0Kux\'Y\r&0/m[K]cK[x|Afmk3;kn>\'\ZwΥw}◃G$xT٨G[h䛘 [5;XioWwO $񥞟F,OiZC\r9ך6mymykv!~Vv5Ļc|5p<-lN\nɦ4	5M41i7z(^j>R;ַַPDז\rլ̓,lTڿf2Mz_|<\\\\Z69\\OhZ>&RkXczWOŧ\\x:.myc/0xL35VE_IsOee5FúƣmkH6`u)a;+k\rBofypP4oi::qpj/\"HIbGhD.!;	t5*;Sq\0\n6(Y̒CkkrHn5WPѠeot[x;Kgkem\0]u=qu:;/4cXtx=v\r6ckk6@ѬCc*P|/_\rj.;vI!χzdOwZ΃\r- 2}xX2[kvVW?@#o\Z\'\n3ǳ,~*M&[h,|u\\ZhWMO:z:K4@\"B+OooQ[όu?WMi⟃)on<WMe\0S\";SEyޅ{{Skw}\rG/ڻ᮫-?Sÿ/RA|-4#\0h^!{yn9.ue^A-ש|\'caţ9o@#m<#9AW\08a^\\~&~O<Ӂ;K[ϦxF0\0d>;c{q\0?dK:bYԿh;\\[x{sBRFJfi-!x&U!237faծ -T/;ȭ@8_y5&y̢>>븖eźrI\"@-U=\Z0>\ry܆)5eCiPT\"ss\'?N\rϏ~\n7\Z;|W)c7\Zt\nhf9t,	A\0^8BU&)%ͤ\Z+Z~.G*Uv\Z)b\ZtцV\0}\0K\0*1{Y/s۷en|?\"˴BbgPd?ǿ\0)$\r\0g_&	_Ax|{q/Pa]Xi\'YRYOiX\0B~%\0\0㶷=\'<!]]KK{%yvk.&|*OvkC\0}un\Z]A\rB𯇋0Bt]UuweukGe9h>\Z{s^x▎\Zf\0Fwg!iX̡ X3|\0:\0J	zMZ47vB{9W:wǿY\\G%熤\rz~Y^Г:t9𞑤i3h[ֶ7,[YK/UCq.tlVjQ[ܾ%fKh/x E\\?&I\Z%u\Z?\0G\0eS\n!⯂EƟ\Zo}~H\'K,]e\0 fEΣo;?Q+nODl\0s.>dB)ᧆ<\r\0dj:΁_FdwH	\re1,<+i,){\0o<G;gưk:ƨIuws4Q<_[eogM\"axv6zhV߇ztE,k6^K$rwJ^kU\Z2|._O})R{ѹy9VIf{c3|N6MZ(aiN[݊ݫ5{$ɨpmg&trOY]\rԹ9	H	#?DKM{\Z\\\'JG+0;{7XK+%b-\\4j1=ᔪc4Q$ks=xh+f1\\Cst\0\r>, Kc?MhK4>,hY(S䞱&x^{	}oL@ZIw,, |\nR7̠+e\r{|QCmeDxEcWU[Q߫3\"yq(1sx@Pu\"{h>Ϩ3<Z%yY $IZf{_{j-YYdc7#\0<Q\"`\0#_y8j:ˮZOmqKi/]cNm{j6ׂmܼewG(AD#_6!-KOi$\ZfMJ!h\\WwFcMˢM[h\nBk4$\rH4\"ck_]~5Νa9X>VH[[D!y(AE\0@k?|?𥖿,Z++j,sI,Tq\\s_C).N,c.tci{o;Ǭ^[WaSM(O--#ĭIm\ZC\"I=ͬp4\\G%z?\0?\Z?:{G>-=~cWn}i[\'[7ÿ́e^jjGo>:oejZnxЃ7hm]`NCmskXoחu\\GiY[=Mj/lt5MQC&h|)8co)QU3܈aԴ.w{_7o<ڻwi4ZM3bY#Iי\ZDHіP\0\0ƽo|qsoί2Mi@|w$iRGmgm;P Ƴ絼\0\rW6i:j:^=sx%;$18TWڅqAHY\\@T)6֪g9j^NWm`> Xo\0;X^Q8Rb[y툛%-cVԗ:տm3ᾹOMK\0axQMVCW4<~,5t=N+}i?w\\|!$}Tr k5,cQrD߮\0~<x{;Re}w[G;M{si)𯈮d6=s%Z&m\'&%6ߥ_	\0\rCE9^XoEΞ\'og⟇}5kB>ŗO[+\r%]5b\0g_>|\Z|IqgOx\Zƨ]Ϫ^GUŶ5ԴCBΣ\r$lZ[Ca;\Z/ˮxWtf:>3i6\nkZuޗi_w_	˩E[CjJ\n\0:h~\n>\nM;fA$xíqkMMX5k<dv[[[	[m.VwJME%iy禊(/GN.7a/iW=\r=hS6}#pĿhDums/N h4۽UՀ\0H\'ou(#Wv\ZݜRml/big*w?ތA{\0kzbsd>I\",.4Qȳ3?h>Լ)\0&mkiogZψ5$}1%c_\rkws\"TGN/NΌAz|֚<`g	dҮ[.,6iho-Zt__I:9L|5\nY[M~ݦsz5mgwjStUfi#ѵr\nxUR#mQj##{[dn:{[aD0RVBUT@>Ѯ[%aCOմq	u2Ɵ5ZE\\EAkm1-It^<N{-3Řuy}6PG4Qn,vLqqe}[ۋasyeaer.m,?\0iSK,|E^_YڣZ|48PJb&N}ͭ;Kx\0os7TwE\re4X4=^#a$WuoiΓH/\07j~妙<Wq:6]*\\[Mm\'1Cq#x=s,,~$ҰAԄk-߇Id߻SM`ّ$l\'EOx$h\"-wNҼ!;KRZEկ<CZq\Zeբ[PT_0_[Kú\"^{m<rQ>>x.d<2M>#Լ+Yk\ZM\\Dl$#<.E$4rIͽ3Fei״;w^#+mcl.|G[R.\02!J5Ł|2VDZ\\g|4$w\'PZޢHLbQ}F|3@1I躝Yk\ZUΝv)UVŦfi343b)C͵ߒ(`UݐxԡEJ:V $09ZfXO+#J${φeGy;e.3P|g=ӋIdѼooshIaY5-h+5׊\'	YdEKw@=?\0w~׈?_<oe<Oa|^-[_>!\"9dRZ+:F̀w:5~&w,u-{T!?VV2JzN)\nւn?yrĨ\0|!~?d:ɺT4{WԬnRKok2@hch\0q.|Mx2M=W<Eck~+]:ow|.0$:j3G<OyrWǓid	VU\n#@fL-\0*~>xGMctK=ʎe/Q\r[eYc7{\r˦\"ʷ!<w_o&Cj_/M~Ξ%R/2_Oe{uS591E$:]^Ui=\"u_˯&.~߰?>:3qW{\n:[ZY+i|Q^Cu`HKLG,?\0yi+{%~3~,+\0)cX@%o\ZՆgK-\\<(\0\'=O_~N%{iOJC]ICYY1Uс$/M3;־r]>\\>#t^@m>msOMͳ5혷&	{~gg[t;\0ߊ~&x1|e\'i#Ǟ6c}Quji-p,v@ht)yJm@<wa+ڏ`ŽbԮD> xdC/?xrcK.4,qO?<7៌,|H!|m\n^uy[{T+KH!ujWOXu\rJ\0NK^~\0i1k~Ҭ?	>*|Pσd̑Zկs\Z}Jl5n\']*?	9>$=.|Pi_p>5./b\0{hG$Ğ0ܡDOKO\0iþ9ax^OX/rKiRkė1CXkƭv(\0)~?	<[etρ1h?gf$1\\|Yijb\\+G=:%\Z4\rJҖ|Y=mc<)|EO{{ԫ)j)J1z^)hy#*!87w/[r,cAxTcicⶈ/hz<\"jşaEt>u3D,0JoZ\"\0hGI$:]mWnUd@3\nC?/Z\rؼWKI%K>BH߂3aK,eJ-ǎ5\0\rh7bO,	f@~#𵒤+/eM/\"X~8t\r^k{[>\\yo%ʳ\'vH\n\\\Zx2n<v7z%jue\n=̓&Qʵh2I$gA>KwS[˦xJKԮb}{cG>G	<mtu]2(.0̘.4Ty(e$(t28<S:xG0Fږk}f(A͟v۝[t+yleGh\'a7\n;kMߤ̢K)o{lp%>[gsD$veH\0	:kw:uڤv4p\n\"VRvb>\\li\ZdsGIh֐gO{_Z<3\\:ax~`[;\0G7\0vmy[	n2ۉ:ob6*x5k0Ww\r懭XzF:}͞e0YRXIk$D3@폱i;6\ZkO-fxNaAWP{c`\ZxzzJAoyi5[]I%/n5N|%o.]?GIt1\04bݖuoQ5jkG~>nE,vvx1͗!w~L6> :iN7_|-7E4fYxFԬ5k[1]_y֋y.7v}x)NaqWQ[),ci<wVE$R]j|϶	c<)GwlA{o4KE塴mB=Wi>\"as45xToLִ{xMj\0}-`in^%Χ\"4kqCڳŨCg}]Z^m8\\+hm4Q.$T&m\nF:@YiO|vƣuwf)gnf\0Ӭ%-W]?n=!{Oxq 7֏Y<9h OL}c[[hڍerΗuAsnQofO=m_sxoRK{[AMhXtH嶼THaHx}molu\0x:֍x\Z-=\']7\r~.6?uiҭ5BjR|EPڿ]7m$/x\r¾\"Ἲ\\i>.мEa-}%5m[h5;$n.~)\ZcI\'<N43ZͮiᙚX/k&ec\Ziݻko}Ɵ~4i_h:4m^Sqij/\r>8mrGKMCZR\r+V\ZX^7WV6k i\0:CFo߲~fOuowVZ^/ojw:Ŷ$Ԁ?!WΟu	+f<9jI\0$iXc-ǅ5Qi+CtME>}[w=SE8.BW&KI$XyTwHv$b,dMmV}Foug}G=c ̱t{\0o&?|+1ֵpx[h-)P[^{:{T NsZI%(5~\'h	;x_@ѴYԵteıy%VU\r\0go	[~_@t\0gN_1s:\'xik6$t5K~ſ\0\0-<oXQjYj\rxƉm\"*iVeB.5#d	!yԮc)e*2*H 0U AL?Ks~\ZQӭΩi^/ҮiWy}%LJ\"x#+.^x&Vd.e;NKG\\ꤩ\0z¯ًVvk\r3^/+{}\ZE}UKx_]Y~.G\'7o_\\𾡬zn%&^7}+}j]+Rt3G# \ZӒ6Z65c[8:ź@4f{4Kguy{߇zhV[^\\Kw<)*gi7-t/iҕ[Q;,rҼeWxGеCP\"}2;;Zy#X$8ƱJA#ώ>;\nxk4~7qKIOƫii{x-9fkj\\[8?U.[?v_ZƕڅŴIg?3cv6w!/o[#;rO\0%4M3H/F[J[߇xYԼ]hhıiW~еoD, ӥ,Iq|GKgkWY#OC\'u\r~=</=*F+泔YEHy#V	\0w\'no/.k&]>ya\Z_Ě2gpK*2J\\ok.?h}\'ƶ	/:_6^\r%}~9RHm%OCOU^[tRy߅?BT~ 6*7/Ozr	U@DM\nIٯ?֐Gl\01+\Zg!\"Մ\ncN<;\nCoGaޝO-~&|3\rwcw\n|P]FdaЏi[Ob\"`Erݶ{\0=ㆱ4<AK+m:ͯ-㋛Q=;oA_.|<~|ÿ_i\rGx1&b\'dIgtqћ{{|?ue`↭Rǀ\0\\\n߿[\0ck9蟲\'mJ/|;miɬ>\"|<1N^7H~ͧkJd71MZ?)Sʰ 00kþѣcCҴ\r/WcX[X[u-}$vF^jy}u yy$I1=8 *D`Ĭ +\0*Oh<uρz;>4޷φڪxRGi\r?Ι<S|6>ao?χ?f5W@kV×O=ͭoUڬ1IZ/!\'4E^<}o?<Kc\'L}vY|\"zuO\"ѼOxM,)43Yݵ\0EmO~\0ş\\Io<F%B4S&7lKAuup2YU%\0Z\0/ٛK<?&_|kc\\/;K}/\nFL𭞛ex~G\\^FxR]W~.{<1n<AԮWQ4s9>ḯ[khEϮK H7g1,-[j}C=y5?zP\\5i^8=cZ[=JD:ޓvϴky9meO<=]7է[kGa&F)mHGTdvQx㇋MӾi\ZRt\r?s]|6ޗ\r]\'nxKu+).-{C)\0#|iOC?Mv4imR\\a<Y&qzmomg+qd9M*גZ̽ea&GI-&F\ZtŮ-<dIPk=VD,y.쭮c\'.e`P1>\\ѰHsW)Siknte#Bbi6 86\rlUAY㴙@9_\ZIΈ}N[]V$RXuXmbvM:kIq:-Ԣ&H![r2RDZ)\Z9cBF`FA\\|itdMwk=JV3ZSmUݣ1qUYVXӤRdmkh!<|q-lʡJ实1m&j\0{ci.=Ŝ$\rZD$,oF!?֢?	xyWw5\0d.Φ][NTؚH MRɌVi\"1pu70[ s<2K\r;UKs*:?+\'4Jki\rGIR5k~[f!Ծl̖#9\0ǎ>\0xH\r\0-Qkm~PLIyRI%ͬDUHSP<?Y/!dK{],/dmcbyLndiZApM[qg[me,m@Oōap^&7:uVs_HZ[ƃ]ёt~7xSOhxvJu\rn9F\"Un,{{/61]nG\"gsQwW#&[ҵ+-gE+MGHcaMj34$ΑM3^Aޝq⏆,&ðj~rgX\'VWԛͷR|aNu;H1_g}}~-MI\ZkG٬4lU_9HuB}Z\'4[*ʳӵ2t\nV]BGy֝Yqo4ɧ-ީ.}X-E;]Ao-&Ɖ\"bϗ%5H/kh:Z#ȶ2Cp-r݇e]^>\Zx_zW.9,.#ú~֗7?<2^e<CTŵ֕xYXVNJo&Cu%>FF]m\0Ţ(ܿg\nYx|g4h~`g[;H\Z8ά;%8dM[]-}]&mz6imnC[\0?\'V[-fhĺu;Ϩ\\E,eb5d\0\0QuO	ur/&ſGմHK?j}&%X٥S4i2۳r!`^<kqIVFM.MB$iuo,rCkMnp!\0Ny]bU8|,n,hMGghȿikX\'A=¢9A(8o,/OkM\'FGAi\ZUbK\0&EuC$vIT[&[+In4?_M\032#<}߈w>8g|F|=mqes3Mŵ\'m[\\V4֖ן\0d\0A?\nxPnc|}U\0.E\0|?i\'u+Xt4ft0>|1{Ýψ^/*=b:~i%YyVEk5ܗoua:IMƿ>|<KrxC/fk4F\rGEY{G:of,&YS\rw?Wޖ,oG%YЭm0Ikv.{Y3Y_Y0o8a>k.{:sxHotw춑js@%S4-&OSI-漟TZK?\"?~0@tOp<&߳\0\0|	t}*GM/\'Pou9P1oj{eeqx+V_k2#F-2-\"J$-\n̡PIgO%\0W\0|2`дgZmOOT\'&񏈴<u:Z/o43Yêyv\Z}̐~VkgUA\0`%R3YHmUM=m[x+~ f՝1S>t:f:2o!b1G2+[GHUGkkKK.MesK{+,ֱ\ZOe1)<1KxI>ŭ1-n!~$OqB\'4%X4bF֭ vڜZ\0uZ|?}3HrFJ^\nCw29]?8,χn8:-Ӻ]K--c7+س	wVG\0_O`u=\ZO?j:sMݢ<$]Xc7VҋUUY!3p6qwn$-kvx׎4C\nZ;/ƺ֧@>mD`zK%T]/T_>zsğ~ޓ4+;ɛQ\r<Vچ}$n\rWRѥX5)U!t>5%S>)u\'PmiPD\Zՠ{[ò.#iV\01ix៊lez>\\3~.4˝3P3A<!wm{c/}aGm#*͔Z|<Fľ*-]KHL&Qդ,3]ZM]Zñ6\0ԟR?@?[S?/Zu\0,V25Rq\ZB\0\0w3x(i??~Z\'?[\\]-Mv&MT̚wf6#n!oڵni0¿z5UuXc2}6&hus,4@iߋVoYßuNg׋|Bc^mc\"䵁g}ʔ%~M\\m~W]zz\0>\0v>~ܺwΕa<3-;6)v[NWdkm$1qz_Vzîj׆gKMyMHXc4TeTl\nYC\0ട?/-GN񞇨o;xK+mru;\nVtythu-\'>Neqj}.m-.m杁`ci,An pqJk?~O+o	Kt׼emb侷㋉o\"ƻpsVC |5|ARu+wk\n\0wvᏂ/>\rZKm\"&֚	u|=[t\\k:M6h?ԭW+	㟍3j+=cY(_xe(|CO\'35jW7JͪksMA}6\\OO_p?9?m<߁?c[E]x^/YxW4nZX5\r.G[vHY5C-xQn%\0\0<\'|?g:xNW*jL5\0\rGе+YS<)6\Z+Dm=]eWOxV7x#Zͧ[x+[˯ 4ViѴ3&3Ft___jsR)+|\']M$2+ƾ+Я$1l-WC.#Ynot\"+oq^Fo\'pMxL5\r83WD|6>Ec5{M?FY\Z[yP\ZJgTRY=ԟhynY2b_OAsƩn8<j>qh0d+SWsiAeF]0.[\'K$U]ǁx\r~[BJʨGR\0/uFnlghK?47\Zsf`*g<nnDRiv2xi`iA=lI*$o#լw!$bDz᷎t{{ȁ/[8\0Ӵ򋨢 tGq\Z:57[5\ZVFn.(6M)GNhEwEqcyż@V;h\n,$h>\"VvNԤaGExoVe[6Q/aS),\r><MđH`(T\"6)$l쌬{\ZxH[\'<A}#s\".IxY	ټіvqiO%cV,k	:ğ7ˠ!Ε33[=\Z?=j[uIZim\"N];k\ZXsoo2~Goxgլ%ѼM%ѫ۝scyq\"H\002V\'W-o\rwܖ	Dڷ<(&WY?wz?yi:[-:TOi)wuVek,)2\'ր8Ox|m4\0fN\ZZ{R[;+<VrHvms.:-f=0o)h❘I2emowu&&5qirX_IZ΅s6Ntg-LrUr+6*YHlI+2	4ϊ=?Rgg.]d:VOnO:kZuzZiTҼQcos0eHl֭qgx\'i\'7 ƒL$|2J LBY?Cg=mNV\r77wl^$K%HkO@=q\0Kvy\0<=FQ<2J\'!K&VEu2[Hڭɼmx4a:Ey~qq{@VyuĎceX-|S]/W\Z^[`QD\ZYA)=Eetx<Tc3n9z~hQE\0\\Gi]As$.X.[RGxOWo|;wĝ/zOcZX֗SmG5Ta]ysB|\'{gg̷ւxo-n$\\qo4Z\"U엑N&wz!HEշ7|ּxR%G;K$sw&Mդ0~U.cUx4F-@.\']Fkct+,\n(e+ \0_g*Xey]ʸCmcU<U%ǌ4\"Au׺樚Y#MDdtxoKO7wq_`Jݺ;a~&V#gşMn\ZWo״/.UWғV]6퍴C\ZG\0ο>f;Ѩk^$У\0fiZ槠\Z2\\0.,m-t/N9AYxKgMU[}JΈ?W\'>z#y-oF7i6\"[\'P]ٙ\'Vǿ^Pt3O;^մ㷺</j֟qn{+Ʋ0[4?ߵ|ro#:vZkoMXi&$̑CV:iڝP,M;}]/-e.e%$5M39viV7/\0\0aAkR~o{]5?YjN6iZY5k;\0K9Uww~<ePUR6{Zi]\0E\ra{IwOZ|I\0fcD߇.[iŎ=J]T?Diǅ2\\Go%i\ZJM\0yṰ.$FEY[&{[9๶U	\nR*+\"0*0W3\"j>ZUeM?ZUֶh}΃h׷Wims\rnvo\\h<Wm]Y[{˽>\\)-!SMR&6g.nhⅮ+cQ{YA#lM\ZBi_WӢ\Z+[hž]DW!^˥YGmws8ey[}.iwIyo4\'ʽFm爰1O^J8G%`C|-\'_Ǐj>_kIb-t\Zns,z5(\'m7ZH.\Z8c)ЕK(&ޗKJrQWn.=Ϛ/}/Ey%4}2\'s&Y<)j nQK>Y{-NI4]xSMFR9,\'7:s<w2\\ͣxMq5{p-.tWMҵKN[H[xযOxB{W644v^Zҵ$}KA,Mak2GܟvoK<Ko61=Ěά<aMIeXj8X5o[x5W~IF+Oj<jTYE~ghBU4Ns䷉VOjlOSPh(]^Jn1)ڟ5ۓKj][\ZYx{>/k-t|%\'#N{M40ij#hax|-x&RW^eiY)oBLϟIửYd#\0mOx\0Ǎ~<ռ#MlDR4Fw^Ashdzݳ^QOxg}~4~^[{-/Vy\'Ƭ!*Kwg-pRh,|Fy\ZX<J)Mʶ(ԩBi˙)ƝHJIy*XXbnZq]9Tף:iFRFike+|{x+B4FWFMZZ]v֯o5WOXccHZCv\"?ك|_Am>t]:O<s{VY]x+L7V\\^-:Vkw61/ÿ͟O|1\0ƿ/xOYt5\rC:7aYg>bk\Z+4=}6\0b7t7&[ixCŗGIe0!|%z#6wnm[JEmfYt*a\'.a\nu,\ZX|<TfUP:RtdH֮i:8X(Bu]RSPp!X<7֚QsF1\0\0\0m}b}wiw>\\2x~_OPc5(/xGԯ\0nAӇm4)!gC\r\0KxYZ\"D{T΍_\01Zÿs\Zb:Ncl%M\"Qy^OknV6OW\n\0eZj\r3s	W0Ӽ=<\ZuݬRk\Zk?Ww.mE䣂RjIBR[Z~ƚ:W2|]\\vZT*b)ƥzUJZ,>SuZFjJSQR8{\n7o*|V~YbbQѼi]Z45k\rC}y귶\\\0Io~\n|p;<~-<\\<6>F🈼[hL2Q\rFI<$\Zń6֖*~}|`|K8&?sKjڮ{޽93r{Zpuo6hݷb،u\0]Xؾ4)|\0MWIRqmY+tk.ԥׇŲ2\'kW8H3^)9SFݤzj:q^Km8FqiZQIV{;zW\0D,!Y6_InѼ;\\7Ϋhᴭ7VԵ[;k}2mVFPGֳd;Z=r	T,sWCgdCxcR\'G_Kh-&/[FԬ!mz.^@~iӼ!P]\'Kn*m:Y#xC\r-ľ0ZZ$qu0%R&CjJeR\\\0VtiSJ%(84yJ)E9E[o\rp(PnUFrߨ4}oK\0gi9};mKºDޑhelpZ3Hk6p,COn\'m/kZѽޟrIkVjOipZܤ7P,E9<_[\0ZQ<uR.kݞl,]x/-#-r\\ڥj:Fv{i\Zu\'Ӯ巹{9\rΉ\r-ldO\\yD(淹{kh\0j0W22\\BYX+d )ة0X|ȹ\nSӇ<]<DyeIՖ60\n֑/4{^٨ԭ~!<=Xn;[YV[-Jzv˻=a]]T|={a.욬tx[@<_am+M]Eۨ;YLD-\"M=[MU9	$EJdGP*FKdds&y>9cs}$d-ULeфsz|@vZG~\"B)lk̾d:ݤ\"O7B(.bH95K?\Zi\ZtxMI}HS5¶UoY5Uk1۝6#:Kc7HQX4D3bqVB*S4\'!sq񃜎?-8Qqv[T2ȈPyG|+`x{nU!;XN7G;6^͔vmզΫ<=!l\\R+6dHd%B( 68`9#\"#rX0\'Hi|\'떅ºˈsxwPfca$:}٧tO0Դ&OԭeK{yԤM6\'<W\nxl4X:(-vG/pEA]]Gk^9决axn>mi`MGGhnPjran,%KB̷l$)EP߱\'/wqi^ᗈ|AkRy:}޳-6{u]ށst\rO:[;4:oO|)oG<\\O,Bׯh.#ӵ֡a;ťyyms\"V,\0~?u~<\Z6w\Z]-$mi2YV鍬SEr2[H\nNA \0wimZ-|@M[ˠ_3@􋫻b[å=۶3|4_n5\0۴YW\Zr\':eŶh*ͰErrp>T[gP.dcG**yQU70l$/3\r[Zk=GOu_w\ZvL!.\r7o.+{4<Ī$0Tp;bOj0KjWWiMZA\"8E]쨸|K6sǺu$\ZMcUoeVIyt̷V\nFDr\"Vdwp\'^\\e^V]N-Sμ }72lu&sߑ\n&?xZNM&y]X]y6HϨj-K{K$Wo5];xUgk:~\0n6u3&cv4VehEZ]27\0HT]WJWEJn\\)#\rއhE*O7ѡ5y0hfoylʹ=kEKf5+ho/!L&I,Kd[m5UXfX|kg\"|1ei0\'ė\Zh\rdGk9j08+\\YS-cfKE\ryȠqhI\r-\Z]cطVVrWj×W\Zf\nSz֔}b[+iX+n(JZիݫ_[i[l\'֋m#O_>ӤEO<[*K(8y`ӵX7<H+GxSc[cő]i\"ffKuq6xy7Lr1{k(4[O|Uv$|Cr,o2jfYKc	4/|6;;>R֯iI-lx։%e2Q\'I\rz刍\Z8ĨNTi:|e)843(aB֫J\ZU#\n؎UEMxet)j=Þ>X^jhIVϊtA=&[i^Pi;\rc5&[?G*|W}мwk<Y-H&ϭl/g-/\0Uͬʬi+ٓ6mx3\'IZ<?FE:5φn0EQ*@u\rKkom&{ϋ5[\0x]\'xcĖz\0\0=\'1\\Y&A2Gwef!t{04PҬ+ҫK\Z~8qpT*5**5rI~q^Z¦_	S٩:hb)I^qWV?f߃_t?\ZhPW {/k\r+\\Cku|<)Ki\0&>ǆ]:u/ޗ?1[iQ,x5r\0ǿdx?k-&q4B-#X:Ϫ|>8S\\Eob>9\0,Z.hfmWIy-/!c>|=*Met%iO\rKbbcMХ(ƏS	RZ>.1Uc\'|l0MVPO9YB9P%	ѣnJ2=\'h5%WWCuK=_A|I_?Zѭ<XuރMfI\noDƫizJmGA7O;u}M^\Z\ZA}q4l Fy.Em?|W\nx-KQ1ǯx&w\rׅ\rOK]K^ݺE~MkOk\0|e-͇%mSZ&kkpc\\[_ۈK[wHt/ႥEa0F19ju)f|&%a`׻ɅFSi:9ӊ72f!pRexzk¤K%brNV+V\nKL=NJ>9\0b};Z>x^↵:|\\Z7#-JbTߎ5oxm-!ҵK^B!h~~>	Eh4$\"G7V<G\0:\r_Ԭ|U[4Y:lw77\0L~*ۙ|	xs\0obig)k#M-q]ER+<ae~4\0~^#{~_.|Oo3&?<?e[P\rCKռ/e<1f@fit\r#?C7k	_TSF`W\'7<dr\ZegJz\nnUGcΥ9f%N-U_R10?]LTITF+5xG$<I\Z%ďyx[焴-)<Gi:}ږxD|7a\0	O5QmN_\0Nt;KC\'<\0mK\r&C6-ⰁhTiY7Hƾ_i}HgmrZχ$b+\\\nYFi<Z9MG\\CYi⿌SLX5O\0gkW:)Jw-+ʗמt\08h8/}wh٦ۓmsY*9sM(I9$MY%z&>8<uoǒC״kvNxLv\Z\rΥuP	i)qkǋ/45l^d\rx_|/q\0k\0j?\0>~0#ˡ۟^<;u}yoQ=G7R\Zݨ,\'෺\0ߵ%.j]3ˏ~1bEҾh75koYx}_Lu}gW\Zs\r,Q	6c1x[=#ēxXѼ/_h[>><\\Wj^/B汾ۖNމ%t_qekeK\0E 6\0-~ Jg<e_NuGl4]z%$nl>^4fqG\0bW\'?~!xu\nÌqگMco!QH\0X\"6##G:5jEy*]\Z/X[j:|Ax[񜎠u=ڽԬ2$by\0h|i|;Iz焤4.1^7Wr<:uuc$S!`0GQu\0~>=g?ΟL\n;σw~Wo;Š6ҿ\Z?i1x7g>$wJ%kLs鰇F:Ə%톱\00?\rEׅ4]/Kk9n<S8y1Xxgk_h\0,o/5OxR\'R̻O\r&[BFwS2b-߇|2jxNŵ\"r\ZZ_]]XZ-ݬ\\[ȯ^M\"G|]\\`([NִgVLmh+ܼnkz}<Yv,՜xW,gvcY\'.B,%\ZdOjvkzƍ]\Zcun5ehU<OkrݵͼC<wVKGSL~K;95\Z<4;0sIwi\roʟB=D5ZgΖ1[D<5ӯ+Y`G-G%72}7RV\"K}\Z1\"&|#2+3\0ZҥmN.- y2Ιq,VLvɈݘ1<{Y\Z\'yiBR$®0HKnS6sZ[KZtȤuVѯ?wygpb{;%\ro&70w\"\\^>Y7dp۽2(q@K(f>3(w6),`xñV0*[kFHX5E-#15O<-	\Z[ݪApݐq{^3\r?ѼDdY4彼R闾C,H>צ1ՐH!fw:xZU?/YhJ_g}?:]:RkykYaPQ(:jڄzcY%+dI\"wt[hd%Km6n#k;n^	e}R+y2Z̍$Rݪ~3}UoxV=n5]F7:$_Xz.nt5KĖE/olVŭn׳`m3XiZ%w\Z,ѰyX<Ykf[M^0_WyK<֖ru	u\ra!hXӮ5m,Zlo6.ߴGkTYB\nkVBr\Z:asvӨ?4ӴM/#N@`dˁS<6D֝]ir../MJҨՕ#V}5갔H3р8eS!UCx#&l&nSiWl\0\0_$JU/T\'Di5_Pk5j>4=_@UYY?ͮgᘍ:\'{}	U/\rLwmIpC4mW <r\0p\0}6vjSuy,*Kh;yIe:(m[ؔU.wֿڳ%ż%D^\">$7i7Gn0j0*Ʊ_[>xkcjYSVM#Tu+`g\nL\Zgc\0cmϷZaCQ+e-\" u7\0\"</xOYX$xb&c%̭-\\Qses\Z>\\(h#ROmN&+o{ekOwy\ZM[	+I4Cg\'lno/)%ރsvn!>u]|\rǙ騷^x_R<	OO}խ-5x.\"u7 Xfj<&mKnuy#JZYt(vҽ_?c\n3/AImS_4_/7$mi%\r[úa-}ʹw~տGƟj\Z|+}[	x;V]ZmW0i^\"xzjnGUl(c߆,<?z<ӭO_fnn\ZmI\ZlyY&:w4|Ix~\0/_qGJ:^x]r#_\\6hڵ\0`4Uܕ,&*)aiG\rAR(NxjJF0\\\'566ܯ/x_&НfcQKR&]Jq5g)~wSN<?{\0e)OYSR4ߋt/4D0ix\ZmݽZ:6گ]YGkbo1$E}\">#ÏړῇdIZ_j-^>vZ⃧O{Cuos\rtF[KV+i\0#M#y-G(iv?m_G|l>h>\ZZX^]x\r-uۙ)K];j3[_L\0N?.i/C}.?LO\ZXxOz孭Ρk+*[P@Z\\JUTN4	VJ3cN.:]E(:#\nXOg챔ja*)%yJUT]9z\\Dm\"21\r>iWvF>X˧闊EuӼR9燊\r5LFu]pYoq`7:FL\\Q^jSZZ<SlHbLOMӼ1k/WT#}=K{޵umALRM:%\n`[/Y\Zޭ$泦]C]YMFnT>L^ANK_?b5YN8ʝZչjE)ӌJttӋW0ᾩ\'/F~:|W58b]:TE1md~mv\0u|O4_z?_|U׼igY6xOQ40N:ik/$SXE]Zs[\\C_|wំ?~k-%Zn9\0Y.OuxR.o.&e餹IؗQO_7Igw?/cvZLt強m\\[ftyFl~*ֵK(dӿ!:@mߨGpd?ͣj*PO.`EM:a\n\'dj+\rFJ\\)Ջx¸ڕغټ35rzUKFXl<e%<]JskkS:ta:7?_&At5W0x{SVntͺ[=nHUmBwGQ\0?\0Q߆iF/(g}eZ9Ks^k55f6d*pCE\'q\03[xWKaZ|+/?F^7~!ԥ*:5]ͪFL6s\\Zi?|K&|^n-m(װ[[\\sOhVt7Ј]䴞)mc7Cp~Uyf/|L8>#o<-V4xGRJ425,V2<f\'5):886epJ9=<TgF6CnmƸarWrVVt_>+gA/UҭuWۨ@~!êg\\>#-LʐH;1xŕ&\02KroE\"x-j&?1	wJd(_<9c7W.2j}mwwΓG}[VЮuSf_)L9RH;+L\0?Sc1_Ƭ6%-^ͮҒ`+OרΌ]EUKrQkx&vt:Th¯\rL> |@SCm+zԒ_:NxķboH9\0~\0e?f_&H4x,<mRşewylOxR0JAt~ZWX\0_:~-8Ni\rhY\r@J[D\nRoF=֕+ڒ3Ɠve`dS&U\"FxKBLWnI-ݥ7.{x\0F]y#\0d;?-|}J+4/x/V߽-%52wpVKyU	mž%p|TG7ot6^\0&\ZuG6vVwL\"6Rcom֎MB_VD<k`Exo(&;2[!c\0>5[G}xCմ-Fw1{]bk+C:9,PA\"KXc~]}_B hڄ23)@]eD- 1Ԥ,h1,,Śc!yr^c\rPװdoHkd\0ࣿO~?xZ\0zeKGϨ:3$~mfFi#HNc8Mia5H\n75EU]Z2AM6#5ƙv7Is<;ĤI><\\X瘱<֞Asa㔫P̻DbuRܫ2+tl:/|^״\r:&>(ӼbʂHm4|>#-B-[˶@<\0PӧӴ{\"\"yQYݾ[WfY^2=ɘ3ydM^u#$`0Nz8=}|45u\r\rvvOwP$4FlLR{9BGh{{*;홭?6\"U0uQ5B,^W>,K4+nd ϥ[Je4HItS =4	b 0Ɠܫջh:n6!9!8Hޣkz~wL｣\0Wsk#͜]C\0K,Fa\0FcΧae):Fm$\'{hM7c]_RE$zU_6}{Ś?	k\"𦁩/-5}b:Nqak}n-gKhٮ:y4FFK/;\0ּ?\\=* \\Q&he{ -${!K*dGP$(\0c~\\+?X;&4KStO컭Y<v6_L8滂-#{ɵ{S<v7oc6[XZؖ0McbZKH,uFmJ+tO\0f)u!r-FPVe\ZtoAk\"{;Qjd]Yߣ,hxf0ExkP\Z1OE{r<KhZ\r棦]ƐaH?1/f$W11lDѡ+b8Wh>Eƛ:Ol$dd1M2$h6]	>0\nJ\Zrz\\4wR]\"y\Z.u]cԬ/bU^tRRCl\'̅Z-&:@=&xo4Eҵv/^^\"uZڼ+LC,%ѩ& Լ]ɦ\\Ckoۈ$lu$sxkYekk\Zn#KZא]PZEۃ6#iWo.\nO͜k0CnQu\rvKg1\rk=ub	yt[IΧf\rbIX?ö\ZN:[luYK]+Y?!.%hm^7YE:~֯-m66L⼀\"%i0Y1ǖc+x1.<eHgO};]M{k%-I3MCZ\r[Oy<QKZ\r,\Z}㳼%^L\0&MO$	tjН\nn:xJ]*-wB[mGJb:}욖Z(4\Zh6y~(P{M^ i>|3u72I]C/D<@>0[Yj\Zֿj+jw\rw\'fZDݧ1\Z<qspE=2+3j\Z|a[rfR߷?O\'ǯ~|h]~О8ok\"o+K<bZ^m$ZN%Ƒᲀ\r֡+s;꒽Kt[|Gͨk2<a2[.\0	ծ`چ>#8\'-[a?|E#q_|a\r#_#\Zi/4_\r Y\\Oeq\\[K}K\0\0tx\n	߉>,~|#3]JDLSKZ\Z\"舵;\rbPԡw#Ś4ޅ<Iq^?\r{\r坞_<-ơZ\\=зBd-\Z>Kylgc;XZ*֣FRNxҍzMԍ\ZJn0RjRb\r]|RE:4+WTNU\'B\\Tz`qsla{bxM=*K?xzo\rU?_Ţo}@<5kSI]麝muo\Zֻ}=׋<OxAu[R\nJ[d\0\rTCuxcSK|ycXݖxz0.HJAQumB4xݎpI}I\':W,Uo{HkkGFkMߧԯ&7$}v?V|{_!-u/9ieG<m\0)ae@^\"f{ƖaM_go\Zvd:i!XVRp[o.c?Ӽm}hв?bY[p$s=Z{-yAĩ*yA|1c4Ua	5-MoO+Wg:p_I%Zu-㖭2|M<)oj߉#\\=4oؽΉ4Q4:%\Z\"8vDE!9.bXN:W|S\rCD׀8\01U$vT\Z-7~,Ӏ9-h:턐j0VSR?s<5hʿhm:43$xK?+јgzkA<&eI>>wcӥ<0gfU8Od4jWQҎ\ZZ]\'^Px=%Wg,dRo\\UEX~\0BeӿǏ<Kx_Fd2X!?=\0\ZY$\0!#և\'/W>\'д;˓xHKM࿷Rԣ-em	t/d}}24񧎼%x[-|	er=ޱuagakkJW\0s\0_V̟u/x{\0`S-o|]px=^X]m,oʳ4rj$?cqGcjS(SXa*xsB4KVUEC+̕e quL:3~kN0KKIRXGJg+TbeI{\'G\0wq|+tO环|M/4L:=ucoG}xK{TNլJj</4\0i*7I&,m=\n0=A\0F\08ſc\rik=/L{I|I\0H̸m.5_z[h꺰7w\Z&m/[z|mgioiXO߂UX#\0MoP>ߑGRV^K`?#IQi].Z1Ӗm?ߩx_%\0\rNi|=EIc}4\rG$r#5	x\"FM.6\0\0_o٪guLgY4;>*Mw[̆#uy6\ZX#hr\0?mw\n]MwHOi<_kV5On-mu|{s)_6H.Ew)x[~\"\0~^.W6[+IxR[> Km$O.r֩\r`<rn{GU7wjkwAX_\nG5&kO\rk(%	7{iMcYnMkmCNeFkKu7hFZ\\,WW6׶/KW/i/+/Ƴ_;G%|y춉l\"L-\'Qtޫ.44oEctRdf](\0-\ZK+OhdX3۱Tt)^FXn PeD|Ik4\0g?5\nķv^׵\\i#KNmLjlme}R*I\0O6nHLfT)=][̭\rլ<Eceȯo)ᯇ=iŶu|Hn|<Esé.=uͬkW7|-?^#,涚6A\"Y:toycuk}is[+9yGW>07Wkw|5o+^L/tk;6莭xWLH##gĞ-le[k~@xgVxM&HlȾZvi:\Z>kCxBh:CwhQ&ݠo\ZY`\0o\0|A!h|V9ku\r|J8f	L4\Zlť0S4UkkK6Y	Ց+kd٭m\'Wo~\'h3xWCCi>*h(rbMaܼpSBkmOkz\'{_o\Zeo\n++h<%[i<=3nyW]9w)GTDwLF,3ȯgeW2^Z+Uu;˼62TbC=\Z[i\r^Fac9{GڽƟٽ7XE;ў)e6x?>ލ\'7Ioh>o+4:W4\0h\"mFN\ZX/8[W2KWmZE)$]r\"HȤ|\\ӯml|Cٵ=մ+헊ҵ7#l1P\ZN<1GӵM6=\']\refw1}OGQ6k;.紿ZM^imע$s\"9PBXdHr((w\rXKDkTKLRCvKdg{5Y/3mo/cwf?jZAw~-[^qK^mo:9KL|i\Z~|5~-x.hZk~ֽx4.]m#EU|[wZ7,ƳOk]\rj_?𾱦kNУ-o >\\ag`{s iUݾ>]SÚW5>macM_AW]*PSRF-2-[}&\\mT,B~G2t1cqqsw?anPI5ͱ-42<\"쵏Zj~iZ\0h1eFo6I	UwkyȲsTӏ|TeY_>xZޝ,sov[ t~խ~IԼU_x6HN\"lU\\h.IfNycһ\Zdb{|6V\'qȰkbuҚӵVKEaW)pQj\0mlz>h#=V[2z65I,w<MOQbB;;\rNum\n]\n{x/A]?[qq%ƇF-EƑsv|8g\ZM ӥ׆~6ю-NOFE)P5 x Hu>K{x+|Ct-3/Kc}2Iƹ(x$RֲJ3mb9RNQ,|7i=\rh\"E־*R4dK1I?ڵ\rB[k+ybF<^okZŨxoYh?|4QrI\0̰7rƷZ	\0E\ZXXX5˛+xnGWE*yAȖ`ͤM!,_Gk\0?3?x٭1\0&`|C|_rft>\"{ۍWTG-|-]ڶr,hcz}SLpú ki\"0`\rJѢԴ\0y|?H߶\'\0`?]z^\\^\0=\rOzRGsi>0X/<3y-/`dM\'>	?in~~\r6ŵ=|h1\'n5	t\"Εo\\xZ|Hn/.5ߌ}\0\0jOx\0okV7:ji6	%3:P-홌L/Ķ\0yw>@ǄJt43NЍkKUeN*%lƩT_)?ٗ?Ghk/ǡxSԼ[wAX@:/Lҥoo/e.汎dѠWgi%}RZ_Ggmk<M8>#xfB]oQ,efBu[ Aԭu\0%o7\rN˩Q<-h_gKiaGfYe$RF?a*U7P<V>--ƁѣMG<:.[u~/2׭&A,s|XIpBxf.\nu]gVM[W-7WT̾ڷ4ۙntU~-U(\0<|Əxsฬ/ubTK-#-*&J6J\Z飘j~_KU=X\\^TMv&PAКK5K*|@\05Xn>$uimBֺ$Ƒu!2r2$e9H FG =WGum.頹\\K]\\C4oԫ_OK~Ǟ2}p׏\0ƺF{GӵX)7#[3H]\rcIJOO%*3<m#`Ahr|1w-ů|q\"j~[f{%RѭA5̿5Ύfef*5ôba(W6\'wI4ϖqi7\\;%jjQ2jt1g+UJRNjJ\Z*I}\06|A᥯/^Y]\Z6{m<a_*,%Z\\Y754(bk]o5 lcId};HwEZ(cx|Em*ټ3y:kzT\0f-Gxо[]|Ty|Dm74h6ң˦:k&h<֯{NI7_!ơk\Z{jwwČ\\Mq$,I,wH͹Ro0CQpye:OhJeRM$b䕹?ׂ#\\\01Gq+Ԇ&rTT>ҧJQn:Fo~\0| B?f\n[WG0?7\"$ך?o\0ln4{SEе\rrM[Bpη0,Nd?\0uR!ax~_	|:<zǆeu[OYk!4.mey4267p\"^{P5F[6FC)$vR[Id~m-N\0jɦ|VbѻAmq0KyFvbF۲Wzu?I쒻Z^i$\r?O^̸/BÚ<uu}P|AbR7cuiaEvzk{mi?|)\0:uE3ƚvr3-{\0	hccxfU/\0$S5\0+\07?m9Dk_{o\Z\Zf;[ᶥyigٵAɣMSC.\"QG>owO<(:cƟkimnuz|F</GaxKkd)|w9i<ῂ0IZg\r,{KK\0ee.Ρ-ǅo`F;/F)*$T.`uY1J#U?\0\Zֵk$.NP=~xt}eaq%dVF=ծl|KVҒwoHXed@%dVI+&)ci\"h4?oBf(O>k袍Z93@[{o+\'u]PԴ\0jpOo+#ZPxf&\0uI>usG\"<O\"=^5I4l\'d#ywVRX4nk36\0\0K3|5_<u_\\.X\ZҬVS]r\0?/;5ƷK[}/]V[Dk	CďsxM7M.ԟm<)\Z~iPZ[@^ۣ%MXryoBJHPE[:w6]V,V0L̆9aQ$VI\"TVIM\0!]POI>6۸ɥEv~.`L;AψV-5#H[mSOo}-j9AKI,帷̹(;5iyoa3Ve0+D-gp$h?pF$DwEeуD\n2:I*0xpuqqx(F+PV,[Ķ%$mĸ0*Ku2([j\0tOY\0\\çxKYCķ,PPOė`&MYe?`sOƇ#|%ׇm|EBy;ZK}(PC%֛iS:;퍖km5ź#moeB\0B:K,)Yr׫|:>k\'.=-&֥\rB]ĩk\n/fobwZ٤h藺zt:L\0:徍}?|:״=_\\<@RewyMerK\\hxGi=I>w֭[mD<K[i,ݷ͆\"VJBook63~o>o\rG8?ݥFVh̦;-WIIf[;|K5S<J Z\"yIikx#MiTo-mW}.M6.5ifQ@T_\nKf_	]^jω\'-<\'/<9ciwP^[UEm_\nk+3?<\rA&,b\Zu.xzĭiP5\0{ƚKJi-O~7xz|O7Z::^3[+GἸ^ndA2\\Z=Ŭ\0<ᯊ\0;mPR?{tЮ}GQ:n6꺇U/$/<+\'ـy4|ۣ	kҵ4h/`m~\0nGM{Ӧ^]K=ߛ74}>.K[ϲFmqgvRTeD/O>Ns5x(ke,W҉	.<<b$w^w&-g<16YXx;ҋ+dI.%K-!R̬{xsI.$v?>+CM_ŚkKEtZ.#FG0ҮzCw^1-㯆<aKZީ^j\Z>xu֕JMgZOf\r֟i9g#\n7#vXja\'HDWβt}BŤ[+s_Iks,w6\r^_^ynuF{{/R5lK]$bC#ZL줎m>\0|⏇֟\rKGn-gK\0E12MO̯$\Zm\\-LY4k;?\\O\"tмwĺ~%̭$m5׉<\Z 2_xs̆9\0>VKlIԓF_;urm=:탗[x1%֝xͭf409|*t+M{[Zi۷}\'P\Zwq75xV&<=x>i~\Z/^/ŒsM_HwtFiqnC}B	\05o!5~\Z⟆	|_Mi^3<oO[Ax{\\\"so~\"kk/5Ӭ\0\Z_&C,V!|o`%D-F~yIl֏ZkwP韴ox3TOk\rGzoW1\\8KN_\r;ŶOl_?/^P?]oύ?|W޿[y!ZW\0	7fD\0OӮ/!_O>x,4_hmcZeXZw4-:4hCeim`6*8ӭ{um?e%5W^)<G\0\ZʮE&4LΡ@\0e[=1.\Za_χï:uE?{XßA.?ྯHƹj?u\rB\0a/Xz/,^K{ax_ڰ?T/)\0_/\r~ϟ	?<7z?<{o)m;}.KH5vOh-S{so2dVm>+.f/g]F_&RҮR;lԴ&h4G	@(Gۦa2X5+vԌ1VW\"[\\uuos~տ7\0iOo|VZj>|)hmI\'<Cދaf_O{Z$yͤ}<PxO@fuA8GoJg8\Zʹa 1l#nbkErHnVX)bJKGH+FUрea\"Kb#HK<qG\'yܑ2XŸ$\\\0j:(S-OZe\r@V\09Ga}:\"p)8B3͈ߠU}˨k>׭=ISy^6rƳFs&p8Ir2FNsG9<cx5\r#GNv@v1?1Fhc\n\0yw\0^38ZC_j<n79OƟ\'CtukHѤ𕦓<pڪj:;^[l8?l\'\"MO5]GKǎMoǌ2kƍ|[.&!)o6f~\0G\'߉ڦ=\n|H\0O_Wu*MF[PIKikII.t]wNF\0R(#-?c&Z~^񾝩nm	}m,-Gā9\0{o\0\r?΍-gV@9\Z=;^$$-4cT[	c\"խm;?&?:\r_/km߂eмt|yBO5ּKhzBmXZ4qG` \08~/y\0\0\ru1\0	G,įGodHW?Y	`ӮY˦kz_m5p?j߂5ӼGOIkTbK]zx\ZH/\"Xv-^X.\0&+qo,<|񟈮#)4&|Cl䑾w}PYN3\r:s3~Ծ,\0>:π%YZxH&SwMniLPs1\Zmq/[Xw\'tĿO\Zf\0{Kac[Lȹp1eHYJF=;k\0\Z\n\0\0hV\0JxTsgnR7ڢ8Ŗ$6ƠXv\0Yj>QÊ\08Oc핵O>/&dF\rQ9}>pGh?{g!mJ,ra6%Rz+6AE~+Gf@.[oXAo;k_\Z3^Y\Zg/,nH&[[m糞dyS&z]0wA>IIBxw)W,|{_4Q[;Dv~rpB3\".c hBC|/wa|AWl+p]>Oi<SԿ-̟F/ǣ\\$N/Kx$t]s׉<%$I<@m,3-~Hr%RA>|F|\ZR_k\ne,0N\rgv1&,J#Иզk;im[9.mo44\re5[gN]𧎴`4k퍪Fu;\nxî6ݕȺ	m$|>+.]H#EܠsyYu	x\'o$\\e}wZZ\\Og{eqͭݼŝ.%	lK#WVPT5J/\\iӦ$\0hb:m,J|dxFE-NLX_\\ݳ9\\m$~a,T\0z4USE}L&[gK?VjGMv^w\riwk852fխ`;S΁L%VHA:̲[\Z\0Ck97Z>=Ņ6/CH/,/-|k%dc5$ؿqaOD5K[d[6)QeH	6ҵ	%fe}>0\\]{/(_\'Ë=Cw<\'>υ\0⯋[m3M%X%koxO)%?Ofmm>(_o#G\\\Z]ui\\dX^g&s5&odb	Դ\rFxfheYC@IvW*	8Wd|̈́H}w-Sx/RlIcIaAmu=<\\1ٴ69u5i/lbh\0<;_ė<MFd3A_S;%9?f\0\0\ZG4{yq߄NMaͯ=7B%to[CCTU\"i|#Ȑ2c=n*_ZoLml{m*c&ldY,;Wl\\ RٿXW~!Z.56îTV][Ïa> 7?ؖS>y,ӤϾ\0ǿL\no\rm즷VI,X2]|XcER+2;w2%1i~M4UWwuafq2Rj5uKHރMԎXC;(/GĭYKomk2</KH`׼=m#Nu#\0ῄE߄=+Ƭ\'wy_&{c|=֯iSK-3S\'tHh{W_\0⛿xN7NԭK.mM?U/mxu=6{a,EO1xgᆫx\'OkS>եZ\r\\hz,\0i(y	q,o5դw6Z3?x;7//w!|.|_C^@nĐ1Yuĉ5QFI⻂=3\\i-u\0]xw?k঳\0+$Dtet3k\\\\$\Z֟xUE%>NOmˍgE-\"oEįៈ^$u].JMeo,7	l+Eh⹇y\Z4.|/I>5ͥv7ku;%_^P3o4R[N,GM }KKUkinگt{g\"k{d,>ziZ}6;Gxecc/ClVXJ#htW+ƛ~ӿguNx\'o\0]Y^m\'Xoff}gNӮtK˙\Z+}NTkՖ5f[êGCY\"1[ȷq*v:1MKNW;Iy.#t7VkY\'|UGc-I}]Nl/pdTag,-.QHJ9yO:uj?iW\"+O K{&Hmvl/>wi3G:~&|6+|1A$~Giv1ᶂf>\Z(w΋?OX[:|ua_@*Nk_ry|sĚ]RK6iWWÉfjE}/\r	lsĖ\ZE:\rx\0T&ëZ6-eeh9\"ΣS`GBmN%\0\0\'\0o>\r|vׁMMohYֵvUV~qutQs~\\M3y#WxZVCqj-(o6Qmk:GV;DA:*\Z8\0Ohz#m~ ]i\Zk\'DK=vIɬӦW>ebӡx-<]iޏ$pjvHf?uK+{ŐqH\rԦ</SB~I?MKY#o4$)<r\"C#\0UR.<\"E$kqiu[{9rp򙢑2hdTYbҒ%V\0LHss@G+r(`~#\"E<CefKP.\Z\"ӣ\0vJ;NILY_3sP7(a[;o,\rݴmukiq$r\"$r#C)k_T5u-tK{X\\q(#3/wc\Z`,BZK K_	xQ7YS\n	j~7\0a\Zw-Oτq6뻥XAm$m}\"V{To)h~՞s%յ?hdoB&xpn9ia]\0\\k7%=¿U_{GMgQ|?xj3A6ϥV`.?d7%Ɖr<]Yx^!w!jGq~rqPitAw\Z;0C%¿ׄ͌?fxSJ׵;ϭ)˟jsZqs]czXc?__\rbe˭.SeUHפfIM7J5MrX\ZжSu[9\0x\"?M?(MR!k~<+ma>H-X,*=˻Zj/;q^i|=sxEȢYu@\r0Eb,i0\n-\Z>dXzk/^X/VU*O=+f\0<w_kv_.\"&h`6%EdXn!d96k	Ij<\0~ב#?4j2_T}Zpŧ8;Ӛ˓ڕ\08LKRTaF\0d\Z\0WXݹuhرqR%pO\0I\Z$aIdTmKRyaHO&4<C.Z[2*KF4UVy<!ʨ8\0?8\'iXF5;HClD;d\'h`p+ps_-OR^%NdMv++oج{0MJ{{Y` ,?q#ѵ6D>\\,r`#u\00;+T?7i\')*f-LdPI@`x$Fѐ\r?ϩxcSllNzE}jBhY;<؈mFd26^E;5.dc{x7Z=5mk\0\nk\nɧxF1M Y\\3ó_Ԭ.lk)Bɨ3$\"F^;6WFW-?iu\rf\nܿGp(aýUDK 4\'\0j uYlM?V0_3%ͭ(.~H_F()-[DP+<3F$2j0IV~Ko/Z/\rv\rjg;SC?\rN&{k[Ky-oº/_Wx5kS,8is4Zw<C\rkxCMĦ!{DZ6v[$Ob`QiYgq{hʩ,+..KʒR亳=!XU&EWX8dU:\\R +$s(2B\\#!rɱ%RрxY_;;&:~$nM[Hr͝$*@7x{>6lHkkI#mX+<3)IFBq׶W[]]ڵWHnY\Z?D9#!$݂yzWQka{$Mg>uhW1f|r$mT,wZt-e4Rɉ!C2KnYX٤U@Ff\0(\0\0^ԼRi{,e}{ug__xq2%~¾54\r;Z\\GYj\Zl5fyg,%T4EU\'%ƞMٽƕ}k?h-u;2MVP,VX\'hT/Gak\ZNx;Kmo\">V6Wd^x\r$SYgW+{r$GQ__W/._rE<[k\Zd]hOɩhڍ3_F-ORo$wtʚN\\cĞ5zA|Az-<+NM9id|S+)m-/4Ըfe\03W{CC>&|8I mae`1٢CHMۙ\'ѵIy/|J3\0o${+Hx.\0IKYCI\n!X#?F|_Yo5;\nPOxK\ZY_kCr4{>\nZ&joYj2|~\'|,Ҿ7|7tz_e-|Bƣ{\0,KiǃC>u	H~sZukKcV^gp~$_Lιľ[BmS~{ƺ\'+GXYom|}ZϩjzmiLo0.]/-䅻]D?uOhsMK\n{^R%HϜ1λö%]O~z]Ǆ\'O((8YxE\'xܥj*^EFˤGm5㝿}NItV\0xkroEkJԄ0FfO+7\0\r\Z]sᯏaxBZu,%[}GNV1_hF;-\'dt\'Hik0xCz>sc%ږZ}5sG}:xZ_Y]ђφt\rkCD&;ܩu4+Ĥn4{Lg9.?4-wW<ymWPϋ|\r=3>46:\\G]\Z;C\0bn-ǟNψbmL\0\0h;m\'@K[?F/p蚍kq-7|;vqgiS16ޗq%W9Yetmj\"ty&pZ#~3hzՏ\n3=\'Og\rcB~xD,cO{?ʲԭnmZCk=W_ŋ_~\Z?iƧxo<Gl+kkq\ni;h,27/4\0DF|੣S%_[%*btm([\0?,_(ď}Rao>VGg/n$s!|~!׈a>_=~[!_ѿN\\+8p\n|?s\\7cē\\xڅʍYI|.ӯI\0	+yl߳I\"?o2<;-3A;h|CI|Cgx_?oҾ#0<7>_ϦivXZͿ\'|U_:X\\xcS:&kE6m3-q<V6DmΝr_ZLH\rX|m5Y1%?kGO9ԣGnd,ZVӵVҼAYZLچiv\0?o\0_|X(5]\ZK+/:Bb^]VHo\Z3fҧI\0`+x:[_?mW->x_e\r7q[/9aӯ&w,kqz_S\0/44ߍvR}\'#á3ǟVsKIK\\Jn5\0o_IZq/>m*9m[j^0Id[jzy+\n*יe@?/\'\0.-oy|S[2J#<˙t\0	fdwm%$2`e	?|*gzO<\r*D+8t+GlcXm--a	1E|*ڿ\')k\n|,ֿfτcyf|M׵VG,[\r3U7麧=s𕷆tХZD[Юc	\'ܶyu	7v3\"ͯde\"I-Cf@#VM:,+h\0ȿ?Ne36V\\	YWlQ) RWymx4L9=@ $AKgxAzc,\'+kYfor̢\nC0xM|$RW5Xއhڝ֝B͖ny2LrW\0_f\0!mয়m-ms:XVHu*_q~ȿQ^9m_o\'j$hE_5Z*@dMH?,?\rVX56\0Q?`py_omAmp	<G?Oڹo5[!*i1/̬ F\ru>#\'?OQY	4F3=ʟL4/zIɣn[]ĩ<Af1Y׆W\0n&\"Kn>՘ƾqw e\0ߍמ>2YD/%ʥ[}F Fk ߧ].imFk\ZʕR#Եd#0;z0#{GO\rx>+vă1w6cP1x7\'sKit]-ugxwP\0Iֵ\nj+kP3<7v#\rq;gʹGP?L[:KOǩIu~^Ā^^D23ZBs\'$Q\\kh\"tYNV!/,ni-ln\nql{}P>Ko=8tiشz&V<bXr^-Suwb\'\"\rHk)fԔ+W2yy8|9w,>վ	ȼ.КV[-gDkK;.{s(ֵjKs$w7\Z}M1VW58䱾6%$tI%^\"Ӽ]:nIũF%и43n[XGs\\B\"\0g~?:G-|+oKQYI6Otl:jPjKKxvh~XO\\ԭA-Θza56Ma^Ѯ\"2Z\\,i$k~|*}/Ö\0>6?mWIdzsKeiz\Z\\atgyq\r~$o|HVoς|usm{{^&,5c{mź{Gê,/u[5?n1\\5O<P0pfvB\r\0>#YAn\0-kMV])c$fMmL&PbIca	ZXXHEhZśmsRf.ï&Oyt{մ|^\0O[J~yx\nya ];:Ys_Kj^ElgW\0QE߳gS\r+j\Z䷚b5Nb}]U0KFqt<#ZvUΕ*}U Դk>T[4[af&k4>H\0|)wA{s\076z:Ej76Ws[Y;#̚֐MK-w/u^CQ)x\r7^/nK=ͭ5#V	on\'\0W^{όuk\Z_>>פJEOwy^iVMeԦo$rFw-?e	CP[*:Neq<EP5\rjMWCA632wji֗|zӿi/v <	xC.\0\ZkA5ᯇuS(Kt*k[kz?g<=tٓX.mjy<t\nRkIV떾-W)bA\rKƫ%In&[&>7\Z#\ZFJ[eX3O_\r|X7r\0\0h?k|Cо;Ӭ/4~R|M-:H|Kq5GoQ5	|~%>_fsu՝%\Z.YI,;|3\rOc$]?@\r融Voѭtm#^L\r\0Ok3,]ZGi\Z\\ӹyDk/5ԯ Z\nӴ~_A\0\0|>\n/bӴ^5G4}S[u.ڍ팺w{iwįZǇ\rc.`u[}k9c$+%(|9\Z[x~m>YP𶵪v?d,uɩ[jEcvPn?E?OMOMPUJִ]E]I-坤hE-0s٧u\0\0\0xKᏌ<ag|#}H|9qYgkYZۉ/bjɫ}IŪ6}B;<\n~G@ӭ\0_uEBIIW@񧆵-Ś4sKqqai\ZvtJ8nOfwxN{=s_í7-@nڜQI{c^|55ƟG^f]H߼S_CC_!|Qo\0~)	4?X\'qyyoË@xgh\042oPͤ0zQ|UHυA dX&9:۵??b˭c\0wO\'ď[:^r0w!Mp|:eȤ3Xo?9I񕠳\rWJmnV#24Z֙m)-BnymjŒ8f?V~|}C>.Tmw,vX;	1*C,~tpwJ<?80GÐAzk(5R\0d6.ߒqumrM,PL?߱ٿ</gKonJ5$%4/=\0a[uk0:h\ZjpitR^M>6#@f_Ffcg0.ZLN`\\O%8$L=AQף\0~(|Oe:_Y7pj6old(	!(#`ǽyƣg&yqgp|&)pd\'\0nհ3YK\0~<ixKĞMִ$<Sv5-R(5Ge{I\"AiO総V}%ԼARM^R}.Fg}.y6.-^R,S,15hGӭ#s^;/-y֣1\rZƲIҋMH[~?]8ꗚ,Sh//\0h-_ZDI\"_+\"/W\0?e]\'H{cX\Z7CC l%oevDӱB_iqj/-\\#9I\r\rͭ,6P<\\KI_<C3:B$^.-e*6ERI\0o\0_?m#\r3\ryO?̗~%i/&6]i\ZYçi~,q+xZEϋ-YjEhڊ2Rh\\6>/.Y%2	O_\05{ywߌMS?.n~=ͩ7:UYDZt]#Y֯m_v?&H+FF O\0?.?i\0?5|2׾23[[t<C](Aqd5[k\n[GFKi\"/-%\0~_S\0ğt8xJɦkzπo#XZj Яa֍lou}9 Ե[G$Aiyi׮;[VnUWIGh#J$/\0ÿ/$MsP?iG?CKLQ⿁ZŹEki\rZxᎵiw_h?c.e\ZMcTkMOO=iw~5ɹ񞻤IgIh݋ƎISI?eW>:xo&xF\rǆ-|K&\\^^Gf{kkMuwpM4%kom3HҴm>Jt?M4H,t?Ob+kkh\"DxcHU\0\0۫ïExHG|\'x^7\Z^%fymu/ꫨgZGޏZ$,.i.k{\rM-^sYo|HD,2۴;<Οwk\"MsS;pܡVK?q.dSۅ>|6Icgi3eYGqK:Y\'94i@$k$mu\rcG\06~FvZ|֚fx4&-jM֍1iDz<n%6ؼHvZ|S,kxGVFd}j\nNuExo`i!WV4.\02%2`wʳB29VRFNó\0<iw\\?Oi,LBjsz-iRN)t\\wJ>|%>3.I𵯇3wOao\n]\0jF(9m&M[nnt{KM1M^5|l^\rCuAkĺ]Ow	)\0fԡi#BmfIQ۵Y<	cguLm\\j~4;]cU\ZƑWQ%u-Y[wU=K_ZE4-\r޶8Ma(\'\"c.t\r㳷}{JͼrHm[(dDi&{\'Dfk߃?OٶpbԏfO3# ܢĳ1~\ZɿPw	7l<o|<ǿm{e\0Ϗ|ExT~ \'<w˸]/P\"=Oᮒ4IqY!67>ֵkǞ=!?@ݴ\0dit{VؒLBnlm#^I4g^񖕪j\'mJF|:*|Htr3u\rƱi	@d}DXj6rZzjop\07#x@\0/߀G\r_K4OU\\_&l~)i[kE5ۘ\"şl][kwAi&ũ+VI,q9O&ϻ|{c%X\0}Sc4/|7]֝\"Hm|KTYеMX[V3_F\Zzt@Q@J~4a &΋{<vSP_[!{2#,o\n#:|Y5th8xD+\r~fԢ#.#xxTMoGά|Wז	}Q@߃\0k\0`~;Ǿ0Bu\0:sOcq\\\0jkǇ|.tzTƳY(iZM ߢ\00h>3񞠚|Q{ƚޗQӬ<=\rxlKmE\0dಟƟu-w~2|Q퇈|/5o\Z\0\'l\ZG]<GqxgBĿ5zhZέa_[oه[ooBAv5MSDi?d}s[5ȱ~)jFżKx<%:FZ^\r|>\0\0#IxYokl<[/E{¿=u;-xWڔh_o\r\r;o*/xh׏dӴM3:\rMKBaI`uiԯ$=5VS/\0(ο\0\0Rx\0īk0\0A~ZiiOj]冭\rfZׯk77Z ?Y&\ZWZDlgG[M\rW|B=\0mxgMӮnn-7O_7?mZ	\nx\0犼4\0xOGZ\\uV3x:).o=0#\\K޴8/\0O>o#ͥ {_]$\r>[ic8&y?n\0?no)\'}{\0\\.?~/Mw-WI=o[5K61LAewiPO{<_i_-1xA<MK\rgĐCӡnD..ZV\0ﯼAi閉<;9rgӟ|!e2\"i-$-@44(?眀\\m\0lXc\0~\0xQ@\'KMJ%y4sa;sir$p_Ofdw,LTw=J¢:}#]K\rkI,5=2_:)Ia7\n6HA_\0\0_W:>V	>%kv\0DWu燼%hc&uy\Z{mE\0\0quH0>\'[K*zc\0\0ȟFҴ|[_N5W9g%_Ylǆ[[gqwkݭԐ`Piu}>mW񮓨oGB+{`HV@o;o4{[Yr\0GxS\0hIi6n]7ʿkH+>C0MF_梀?_C\0>&]ǺR9J@g-%}%i֭\'/)㻡t4\'L//e<cZ-Kk4hYyq<5ѓ@h[whI4)~K{bQk6hmmn;[;{k\rT)-w>\r.Z /4/F~՞Tѧ#H{#dӮ++i+\0#?\'x^3y_MtZ^_O\r;YxxiW3X@in朜@V^(E-86-dim̖Ki6Erȷ1\"Moh1\\%Ie>C^{\0E\'o3;\r`U\rũoujzsjS7qvIQ\'Aok_j\'W#kw:eχWmq5-lu>KnKUIvHVMIO~\0\Zg;{V+㋏\0>!53FVv>k\Z>xj[_xrJ{#H=WHl\ríYGǌ|\rcGZ\0\'tKVԴKkwZtMFl-\0 k6)hX[\\l֠\'oŨGqAjF}Cͭ間YK\Z:qkS=PX^Z{vיC*cM.BB+(p,A ?J3|wu`*k~sC\r]_@ּm녟V5\0Z|Wou\'ZkƋ\n#cs\\!]*\rm<=Z(SwnaM6A42<\'TpX|!$rC$,N$r#xFсWF}w[|S\'캮=WP׵NGGW5+-<ۉ%؈dT`?',0,0,0,'','CAJA',0,1),(28,'','8888855596','','producdd desconocidoo blblaa',120.000,0.000,135.000,0,1,0,'Producto Terminado',1,'\0JFIF\0\0\0\0\0\0\0C\0\0C\0+\"\"\0\0\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0}\0!1AQa\"q2#BR$3br	\n\Z%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0\0\0\0\0\0	\n\0\0\0w\0!1AQaq\"2B	#3Rbr\n$4%\Z&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0?\0N݁G-9P2	\r\'Xdwa0  u(%`\nc\nllʀ2O>rX0?u!83os[֪%X»R0#wʤd\0Mҭ$ڴvDڳI+wz\Zq|V2gEH2H*18ʕ;C+K]\rL؆A*	CG89p0va282Ĝ3m$b%NT0~Q^`3|ÜHt0vRH^6S^7%d7åwݓ\\k谸geeuqktsdGgx\'\0.sYНEQ\\\n䁉6=@o^_c&ˑq|	BݸGD1ˁ˓X%[\03m%J.yq*<5yF6ʔݜRPV;)4=hf]yrKAvdc;P:UIEJ1Bnݹ]B\"$C6\"J|7߻ʐ UE!\0rIeާ-|yjNdsxmoSlf0~;:YIf[Jϝ[Z.TL)4%-}5KK\'k}6\'e\nr\n͵6\0wY6$&n!v{!$O1-XS d?)bgFplh(^WP@j\r.,%WXWQߙǞ.i.&՛IZI\'}<(정ۘ0؃\"I,n)њ3CC?2d1T+)ߙ݌-lVRHT8f%CeO:>!B//\\@$mVӧ7%$}/6g+-[n\\^;x[tբO[յMZʽ눿x_-yr$y,̸;y,Y}:7 aRR獪!U:vs\nN͡]pi\0cpRÆ_ĐX\0v`Y֞%F1wQN7)r./~owERKnTJɻ{f8h3BpAB|\0T\02!Im2\\.[\nUL>VVԱyrg%V\ZhՆ$Tz12YdvL\n;2`JH[/1\n#HW{f`N\nv*4]wj.M^Qѥ%x}ZŴ깒jݧ~-lNyUy06PWZ.pbv</]P+Hl9\nؐnW;Jݒ΀`\rl\0eRK.YNez6v*kh9UIo{nX&`cQ\ZPca,dY63BAZF^UW\neK6tUBX& \0+|+oE>rGAI<0܀p،ku\nO8#8sW//UW*崝ڏmFښGmmk+^|\rūۜ\08eÏ1FymJă(7:!6~옣\n;\0߼30m?(VqQ<h66ms\'yS\rSMt9B\\i]vJO7\r*Sw挼JoyآUU~JUc,\"o(Irۇ\'q(f*\\w:4lHqIݻl`*ݶ),cdeeӽ@K\0HG@rVT PY;rFVc#FIRu۴cvzCpqi^jWis{|m|j7|ɵ{KK}եLXlCcrnc32 YC/9T-W4ee+FRQ&d%(nbMh,xNv!@ˍ)F	ywxàUHf62D*B	o1FayL.gi/uYYuJI~Xݔr|z)%Jݹ9)!LLm,+1Q1gmu58|m\\&j\0+cqBQ+e@p35R89P$x~/S\0yN	8m\nC&,a*$!I}Msi\'\rZRqNVѩ(+ezMk#͵K\n`]YVRv8edgϴrwA!!b$).Iv%@f[oOk%(CF2c+;$Hlr$[o,2FNܒK)^@J5a̭ٸ>dvM/sMzKo5k٧暚oH*PB(eL#|(fA*(,3Ku,gk*8v9;ۓϨə R	r\0ąl`c |\0Qv@fk\r\r#.r)bʥލ՗\"l$ܵիr/gJ\\ҍѵi\\/G}uΠ\0O=Z@)\n \02ܴbsRURDb1\nRm\\ʒw]Fr$_\\H<!efHrdj{8.do>Y]O=ee̮~w{ZMm%dҵgV{5ͶcI\'iR g\0zA毡b3+(3bJ(?7pww\0;H(Kl1vd#~3̈́ 	1\\\0/e a̜}W{I-}et}Ϟm{[ݶG/9\"$\'59郸zO=h}8.pё&@H$}J)\0%<O_@fҪsnKe1Kx9}#l\"6˱ghPIPx-v\0&\\Xp`*Tk`ƣp8S6H.Ӵ3 {.[yTw\'RvWڻjn\nxW]\Zwzk-[jtiomo10\\#rڤH\n\nUs[@Ky@n\\\0RKTFKg4K,BF9\rAU}GBh$X)t*qViˑ{%v繅ܚjoɫ\ZvbƈUYF!Q|C17=*`嘜FpXlp*,9h	(^pFWn]ثnfX8$#89NWH	%rR@Ŏ~f\'Dqpn7qwӌyIkKnnӚJm2VOzFeBY\\vCcF##jlblLJ`K(Rd-\\\00P8̥;1*7<(òB~c\r9(	h܌WK*q)c\0dt^s*V\\v+RQ.z)͟p:j2KF.7գu+5__Bɶ	WeYar`Y`r \n.e!BMPǒQDfGUXʀۑ[.\\#`H%BBm\nSv#D7:}#`[~ۅ5/zWj߻ɫŷN]]sy,c$/{VZ=l²3x%k\0\n# `MYs8VlI\\79h.{P3*b$9Hr:\nͷ˶ȝp6\0`7B|US+w\'9JV\\*Z^ڥYdEӝ[nĬ|A@YxTc4\'aS*@;[vYTǇ/;\nXB#jcRSr5NPv1!2qYSH\"@@s6A\08 ;XdJn^Y9/y&e-uM;M]9h7匓s;4E=-֏fcg{*e*C!Yd7$hS*|eH۞UԒT]!8R6eV¨y!Tʬs>\\FFXyf`#N^\\({E5);|Nh+woK;lOaikݴWZr7&H9ënA6;ԶP%0lLEH\\w,\0Ж`M7?(&G2|G\nIi7 |ʣ\'~q\ZwI&죴I̔VN7J:ri8=onu{v),\rvV\0e	FfNø.ˋdt[\'-rsV`v(.aY6ߛ<@*`  R5U\nά\\)X`CUwE[/w\rVm1[^oMm9큏DHOn	\0Ƞ`܏5QNs2@(#Y0[\nɴz<ȁHrV2iheʀrAbW+wo~eo;ˎHjj;>bv`8ٮg(ŦVRQ|Ika\';kY5f) B+l\n feUBJ1F0C)i#4JQUupk[F17 3b~PFjExmbq5\n(PWnC9ce\noSj7+vw/+)=cJE)II>\\\\e\'.)Ѷ/+6sc\"J،S*rHZ5\0}Xc2F,\0Mʳ;ћBd@p+@\r$O-a!+dd\ZcYRQU8H\noDRqV\'ʞ/RҳNϚmJIRݻX>㫵RM-lU=PE@f-2QLAer7`:gi)rO\03U*!Av%FUT!UKr\Z0̀|?21PNؗ d5Ugy^WUv\'N]fxtvq*<n{[Kk~DB\0\0mΪd(X$\0w\0<(<vs!%H\ZJ,$VMc,8R\nWEwXJ1(,P+? !,we1Cw kzyW|5iJ8RrnWQ\0SKu/{IkE=i=nyƣPaSbXWC$8eARd*df.[̔8ᄘ]*w\"EG¨\06-f-\"B9Vh\nA\r-^TM윴_j׺{4)NKw+uK7nK>VQW.,ș,6X7adE\'w?d*RFF2}\nxP	ʲ71qUma\\(Ac @T9X;rT*G@:n8$̕kWuem֭7x\nM6m6溶rW7<*K,]y,C(@n 璼@_/K~aa+Wۇ\n?\0FaUw0m.`$\0n\r$\00NK;m\n\\V-Ѷv^wIS\\_0W](ٻh-4e5lͲ{rx+=܅\\Ei	vǓϐzZ({\n_?/??|^A\".Yc|>ͼoAu5idca$1dP]WhB]I8=YTe}\Z7^kS4	O\rέ;UE*w)WS.Iw|C-QqrMFm!YaeQC\".Ag9\\\nIET.Z.k+4t?m!qpNIFRRi(Z6QmߗF*ڴvd\0F!UL|j+PGKmnY Pilp@JToqsj68nL$dyARa7F<ʺ\0$v;ϽT$\'wqv*qI\'tjNZ6z0W4^\"u)&76Ytƭ;\n\\+`#2R5\"\"F[I|@ٓi\0#b͙\r\rGI#a-dOog.Ԝ|c\n)\nҬ0 7pwTQ\"XmY\'eʬN1m&nڧ<vQ%k9]km4ZY?;^+C,ICx+\Zẗ˨P/t>sLnX\0\n8r͐´6b˨ \0\\,fGlmcm7[Vǭh3I|l8]Xǰ\0vA -xy碓RRr0\\w%k&Kn\Zo\rVzMY/os[phF$\"j\r#8^SXJyHg+m,Xe0rY\0_r$I91幮DUep02qN\0#;G\Z|qm\'jevmlgE;4\'>:lUWfݢl`7g*Jf-$T=⥶\0\rT-,RFr\rnO¶1$\0Rx,\0RЧm))%oX;$ݹCIln$T.7)FaJHdQ9CXC%XpxV\rd 1@ӷFkR[URH·q8 r	#9bEP0 b%xRBi)Y-J/MM7{-odNUwߑ[ݝevep\nq!p\'`\0m1ƛ$j͹\0n?)26ٝXpbv<#nea_,0\0J˧sdu z\'))x6NJ1j>\0+MN7]ݴbC#2,\';x(vLN>Rj1oB99 y!;ƀ\00;$̓ۀc֏~w>bzV\"X-j.78ec#%Bp@9::4mBm++6$nCVRNɵgvkEl#U ay\r~ʪ\0S8\0.\\3.(# \0\n%Jۉm̿#l|,۲H:^d<ʨ\\|ۋn*\0u kVnJ6qzZ+hfzQJM\'kӻW1Ve;U\0aFv?ñym\0k\r!o]ONUw17\n-+.ܵvwJK0DT7x9 Hlmx$ff!F\0YIfP6\\fTdWJKUxܻ;{4kMFY[/-9+a&B0`I1D@KB*K\rmpw)ReFЫBW1UX;/i;J|I*elHq\'I_c*K\0r$wݷ\'r\0nI*^칮:wN,v^OfQK5O[ӕOkFZD)l\0d\nYxe?6AչlN0\0a6]NCP\0VA5a$ep*YrsjN\\$2?1\0+G^\'[J0vNJiFQM^:m$KWF嚵uE^MVC8ĳ#\0h\"Sێ@\0˝;Ubw|J߿v`b8(m`w\n	c*G̥ʤ_T\0B}F%+I(f$[[6q*~i)ɹVխ%vIڳ/zUZBYl1m(k\0Lp(i\"1P;J\0Ŕ;nbq7v\\l9`\rjj̯KRJa_	cu\npW\r{M]GYY+5i%uZZvI[F%ʾJrʹT.Xd\\䶀F/ICs\0\nC|.s\",ᶅQoH;~AbۈvwŘ(\0\0If#`Zu*kd^kFOZ]FʹEqzeeVvv\\n{BNGBƧz!plO\Zʱ,p##a9*+=\n\\0	2bILr6pG#$(RXY]-Ha$ HM;4z]{FIi澗>W1K6M$tWhnŪ,qʳnUFv3n̩Pac@$1`e[mR\"BC)U	\\+6r	\' 7-6Pbaa\ZR6⭣դ.Woow]Is/u\'+ZRWVmdqf|O$m	39`n`G=	1O$zS\0>/[-|\0i/yf?9utrnIa:7C/ad	(`  }rPUFNS\n$ ~,~0մn+[4KKmNufX4(oz&?j!I9儣#!$cs9`	ٌ\0ˀ315qV\Zxq6^VMV*R\ZQmɴR^SbeB*q\Z\'+{um(;hÅM.@\nvY[Ѝ3$@T<2@#-7ߵTTqBB0ڙP9,\02r		j*>H&9vڤ	eO%9\'?/RQnɤ۶v)-_MZoOE}zZ=3T\rʔS([;YX~\"6\rKϰI_-G\r.s\"[RYcgҢәIqw-D|:+BN%jX0ӤO,VFMI\\<4_\'gl\0eKC^AV?̚2ݧMaAug=]nI>n)YF+՚ק^:Z:wqQU\nN-ٌej<̳&[~FQIF:iL,*2V3(U/4X|AqN}`q1K@amgV!n4.%FH$n9m*.D6ynJQd\0a!Y>PYGֿ\"G7x959u[@<Gxz->Z[jLW/^^kzVkۖzm\'12;K\0`]ۜ!`m`\0~?c\np+G	N:oFJ4ORUe.iET	,aeЯ.\ZU(X^Utjaԍ5Z꺋B!V3JgZ0^]ʤ\n˓A\\7χ ׭sArd\0p+\nH]X,¡8$1_?zTN	\0r653:W%qOU%e׵m\"~)`R.^-i^}X2\nH o%*n>V6X]0l!~]6ܐ~RXv5r18q-q!I8>``)[jάpcf	B2s,Urך+/wOu.WxNY}vIma|l¿J);IgS\0\0 -l;}n,Y$(U>ӒC1-&~MnF\\Mz/Zm\0߅%F71\nA8-\08 E<]8qq%94^I\'kG#uqStmU.׷k7h٘h )eBv2Kry 9lgB,QW\0$cY6J;w-Ij\0.266KAr2ۖ#Z.MUI[Y=J*uR8\\ګ_d쯿L2\';@	$$H!h|1+d~7%\0e@3Dq	\"K0Ae 2~BAⴖ%{ֳ;4f(Ѿ-*J;]wek;?=o\Z p\nO$AaUU2\'!ul>ҊT1%pV$ĝT1_ld6,VY\00,;~lY{+F|ݿ;)w҈]m%}yِ`y|\r7af`hPFo`l$0d<(仂9*r\0@P::2a۞0V\0T30+ch[\n+E^6j)4URv=Z-8$N׽WWφ\'ybX|T([*	o\ZXWj8QON0s+(]*$\Z\0H`yVEOA+8*(,%gcJN*b\Z+5$e\'kGҔii:RKݭ߾׳1$ŉ\\m98f$Ԙ\n1$\0C*-)pC*`y*T&cʜeUn;\\`pk*RjIEmEԋ|.yZIenrU\"ԝNMsJ$3ے2R7,z3dno#	!Pnc2+rB9PF{TVR8eF\'qW2eYB\"pѸU\n\0,UIr$-`Bv@3^rMʛ㢼ey$-jYMZ[k˭^<2Q2G 	\0(rIZbl\0rpl\'*z?!KȎ2m\0;gp܁\n)ULO!%Gu8*b-2q7 p^\"0n-(;^䜜qqfԗcҝnM/%yuQ^~nT[iOj6\n+\0/C*㌶PB7;\'\'zduU 8Pn,B~nNw߅=Xg,\\1\nG7O{c(жr$䪪ʮr	|b.76Ԣմ{$ݴ򿝵>k0c[oɾMJC.\nZ6e\'v6P70\nx*pq$`⬬Hd\n>l7PN8bN!sihٶ1&>n,1#F\0D]IB^Z^*M+uV_/ᔔbܬ|ֲWXn-wf\0	d&BUc8\\q\\ݘMx@wb0b{c|`eKv6g#p:	v3)sbv	SȔO├uIFM]+4M;˖һ_Zri>c[бoE.988N8pےIbat\0<}t}g~o=#~<nt}sBKdd4eI\'n8B\r=NC5T up.̠h˫<{yg};)`[i/4(k[wlVM0(^~:־LG{֐dۉ$FH\nI68xj2TW#sU(V:S\\QJj-E){R1Yl3ln8ԭ8J_\":tV09N7&z%_-#219.2\\px\nv8څB2f`7	\0onB\nh󓵫m7cQMm֮r\ZBc09$3czhR2ƥ!`#!ZHKY\'pz9jGi]I\'E{;6֟pӅz3U)V9:IKitVGUjݞI{\\C}n&d6Gd$D\'G!%A_9Ti~x[gY5?~oqs>4]rRk-/mA=,VI<	\rbki[DSuUD&v(a:DW{\nּ_qľ%vjضek6wCKn\"KInKeXmGU#ʲ0U0isa(JjGV\\\'c8uM00x|h	:1UcXzԹ}U(9ЬEb/|Zo??j8jV?iִWBtSB9d1lI.}\r͚8$_<%}/ƺ]#oivE)|^3$ySDnw3Cfƿ \Z<Z+-y㺺x/&>d,9?ؑ/}mύ$<Wk\Z݇l\'4Ku[\\ܭլzUw#v$r$#?dYJ̱jӝ\n>#Ft(ab^%J-aTȕ:jIR\'|WSyW\r<:t:zƣ~*Y_WiB*\nij4Ժh+<L%f,\nF7Ƽ%FϴoL*.6\Z2Icʹff|U5u<xKkgڴ+KBMhlKHgfOoK	ag!yfdj	Wo,Frq\\TiΝHTF9JPFe*5#?ƫ%%>ViەTbhk\rBr8Td98I&\\[=S8 F8RF\n\'v*WHIÅf*1~@pU\0hU\'\'=9Xq[2  ,s,ۂ`/T#v8?6RQ[)7%}Zm&q&vMx5RyRiPn.eVPea($*p<w9\0!g$uP+Z*(|C	`@c\0l<\0eTd\0lm*Tp}j6A%Ԑv89 ֲ^q|$ݒrVqVODyY*MA飌#fV,n1.w{<xUdS1K\0TmvߵvvouBHQ;X+2,s# #HdX˔\n@7Y_:sh-L~Fa8|JIFP10,5JYӝUNR(^VbQry=eqTibQxQjP:*t麪J<Tg%8ŷ	%B6)ev$)]=I%\'B8ulo1㵾l\0#݂(QqZ31ݒe2:r`\"\n[*NW $1@O5rqN3溓i^E4ǿ\nSRikZZ}\"P#%NF	 %r>Rj4d!\"#E51*]*6Qd`T0(9xs]bi$;EM5tҔtuNM;]hN(9bw\'͑`\03/$VaK\nTo<|PI;˰2fU~P7snl9`XhKp7ryrfާCEY]7Z\\VzUBѥGY\ZnU@JqAc\0C>\086dHiRU=rTpw[8-Bfdf 1FN0AViJo@`(R<1WiqsݴM/z+t*G^m;zmﭶVN\0%\'8V##PHHM0$.*t̤1\\|ͰB7sONZó$\n~SoR\0mO$fSJ*.QOUmu#𔛄4bM4< -	;hY0aL@ v!UFnmo~K	#n\npȠB(26r7嘫\r?#h\0xpے\0#8bGuK..Yy]43vi)J+D.]\\+ef;_v+!e]ѯN\0ArjJI28vR\0S1j{!-w2B9˃Wrem\\c\01J29oH#/|2B1c!9JъK[YZiTזDXNSK6qJ6Vv\\#iC|h-dˡT73r7[ky,r.\\v7k#&@D]̊,n$+皸$Еv)T#rm2Uؐ^)&wO]];\'{]_¶dծGml]ݪʌf*cp6\n$p c!7<m?8fbsrs]E,rp0gRG8uT\nw>Cs\0\0%!C1-ʂHbd2m;%fzln͟?_nZ&o]ӹ_F3F\n|Jcr73RHk*[vp<)T FQע|/)v2O3ǔʹT@FY2	U0v\rp567{NtWNڤV?-\\NVmݿ3I]vziNI\' AI~VtB A &mS~\0\0N~\0#:}4[{>\0pn9dm5\rJ	s`9~xc^ummAggB\"e\"Ff$ʬ!*̭!R8N\0mN)\\|XWVM<*%,FMIMIIΤ)BrU(]Yc\n#\ZWgZ7\ZvI8EFXzeii74VP@!G|?PgPȵDtI5\\b\0\0n2E#wò_,AXI0<nxå1*9*ׇx§NY$&S\'qVr$\np@b\'\']rURcR)ŵf^i;9%ds-N3!\nxmhѳ2Me+$ki>^K\rC{uqtb	i$F.PH]]Sn5Fwn%ZYI[˦ydYH)I;X_m|Ru\rG%͚y1i6Nv^ܒTLPg%=m/.7x#M\ngjYN\0;`f+刜B<:N7-$kY79FVb?a0Y}WRX:tvUcJxFQT8r囻/]URU2ܙP@]VPr2y\n>GƟu5i	Yl\"Yv20PgC+/&J4{׶QDŕR8s>dk!Fێ_/*̄]es<<\nIsJ𕽝Z3Zԣ%hw-m\'$ݗXw3:MbөJ10a$d乔eRrktό\Zohy^%Ăd\",\rǘK<RH#|It+]\Z\\:ݵ#-&- e-2cxG1\\De$pN7OL!܌3]߂|_xCXִ=B{\rJO2	߀A\nQFYdeiⲬjTUiStrՔ 5NlS)S%\'/o<M,:U)bW1ys8))>H֒rrM_ӯue|xgW\0BIpŉz1pWxnP@@\0?#~ڷW[mgۛ$)P͔@yLa \n$ا\"~<JmëXu@\Zm1b#g?f^.Ū*.Sr*7VJ<҄c̒kXq9~ueF旳BHTVp5i;{7v\0\nČm~q{KUP衛h*1q2	2;7B?1AUA9\0$s]De\0H \'B)@\0R\nW9|\0kxMڜ~(ݹJ-UZ牘a<gNsMknG	\'h_IZJ_QhGs#=΃2yS>Z.Dc]`ێ9a-ڽ̷7.W|^%9\\`Qy`FH1\Z=Ad y3N3,8Nwc kkF Aqs75V#Ɩ\r4@iDqXXJ0X(T})F++jWSPg.es<{ZqLL)ʓRUN.%x6%r(` h㷾$2GlhH,\'²7(ۿ,7(#l3#AX(A\'p%kK[HvCbFcuAű-=;xn|Dnl&lK5S.Z7қlkxKiY[2N\r\nSIŪP~TiU):|QM/r6YdqbϿ G\\	R	8r*mڌ\0Uԕy,[\n8\'ԭceG4D`$hѣ(`Id\0Vʇoʵ_;T<pMˎU Za	E44yܮJjQVɩ;m}^U¬4d.k56|U%ھVw;FXA))˓\\pԵ@|w,N?.`pw+1CEb!\\gv3QNIPmNT\nb\00ێCmV\\n-.<^\n1r3_\'oFR]Y7{*2MKV$lU``1x+	\'/ <Ԥ\06!v00P.PT21_l&MB9:@kI\nO7)i:6dv9\'pqCO+nH=y_\r=myݚmtڹń*E=UzQmﵿ=u9d-dt$%W~I\rW-w29#\0l>bzB\0LG@O;pqZvQN#-cXm (A?zM]{ײ5JOwӺ4Bwvi@!~R@ĮQJIm+ *TN]G8 \\y1,6\nr6.Tf-E\ZmN\06ą8X%).Y˕I]5+wMY%k>>Tڋj۫+\ZZSA.W!NJm@V*F#\0,<U{VUa~R93TzD2my;r.6X;Q66\njD.T-\Z]b Op|CKIZ{kv۳M4㶷x˛I;kx?M;XK}ҁ}0d aB\n`#])vq`(YUBnf\\X*EY7|`*rX]2H7 }AP^2lH	r$*[+>1J1pI6꛺՗*J׻E˒NOY)$j6}w9{>B\n\0Km,_rF~`T\'/)6\0A`Jϴ]\\v0(8+8 Rr\0%U_JBy\n1*7N22S<8\\[IY;9ZɫݣiB3kZW%Q*w!TCm2ነC3d\\b(I\\/?.ݻYĊI#j6c{PQ@%Ad20sfKȋ傐Bn%J#?t0abOFv4^KJϙSM8v?	:jܽtvۺ`F\0`clqGBN3E;k	x1|SEi_?yy~/\07yL#+P|ReU#SA2a\\ctCcp\\C Z8!+vew 9]dìI0Bv+FTኊ.>ܔݹ.msj,GgNIvwef}?2;a/RdmnĮ={lv;gݸV9\Z,Qc\nDwcs\\|$1rJ9 j!fK+hۓ8bp$$)0a(Fsqkj?vWI4n\0^yJ[Y1lՔQ;&n| CsI\"xva\Z3\0p[j	as;5=cI=`qm(DieXȼoawgV9d9<m8G9dBpb	#.ODw\0e$&G	Kc#m\"XRYK&><QO\rZqn)p=ER85yN/h.N3.ɳ\Z*c0Кԩ!,:(U*msrT|rB\\KMH׺MM8U;nfQ$0,;	J/ڜ0Ms,Ҽ[̅%GDPV;{\\u<ryW34L2Yک&wnz#go1n,~vuQ9,BW @t?UgN&ZK֕!V$jjJy\\E)IFI\0?bQ\'bpR|U*auR}TS\'%NUk){LVpP!q\Zy\',mv6ByYY:lBݻ GI-HƔHp\rP!PJ++-̤p0l<0\n	8AFR\\ׂvIkh}35W:n7dwJ2JNI/zQJy !r3(iNW!r13x-v\05%ĳix+YESηB$\ZR$1HL)/\'\"I\'.$aqn8$j?!<*oh&h6*O<9*]O$`մ,t[]EݣCM[[MI,xapoI_ST)ε8%O꤯7Qy)	7;|\'\04f=]jTU\n3S#J\ZrU1zt\\sHӇ^ޓ$\0\0|II\'m#,I-2H]w88;\0g!@ 93w)E9\0np2 8Ca0[jՊ*\nqL:nP0w\\9/enVwmϕ()^z{v苫-,3<\n7(+HpI0 \n?ڎq{[\rcgqi01\\t+P-\0_K尓qvRT:<9)፤@%/bWȒew6*¼|_\r_6B3S]4կ5xEQRR8jbfTgN\"kNJ8J*ATϡ>&h\Z~bϤIp6B4\rxIbo68lq1󮗥jvjpk-I2Y.봱E]\Zէ>\rۺOj 1!ٔm$rI#>^%x~N,% \r4ۙ|]<Ҹ@1.kh*%*\nxLR6VnRRWkrnK,(ƼC\Za8,Cn*\ZuFpx{[xRŞյE\n<1l֫\rܤXY,bW\"KY`\Z\'Õlmx\\R)g\ro<qzpG|naXKbƅeR<<iӂ$*&j?E|g5 Z$1h(#]&E*p0iϫ\"#*\ZqUmF57g(Μy\"(.~kBM_L/eT9QXhN^\\&S~ʝ9.tU$S]>ed`,f|WlJ-m#+ʧ?uI݂.ec9EާݑA-$~\\nVi-ou#ڸPO\ZnnK#1)x@PDza_M>\"0E:RVeR\nIZ*KG18z]\nuδ\"VZUZT*i+s5$e2Gnr9Yk7C2rx7\0Ey%8KdHrC)rISrNKȮu+©\\`%aYG1f׺\\o/z7iUeXIIs7)veu>.#, %X\revPF89;R\\<ErDZHCm,0O\\3x<7[)s)%[s:c\Zu\'\0nuV\\vmNI{m5[[uD&HvUjie#$2+8Qw3 _5[\n#fSCw\\:b B2Ӓë\"GCAͼ	X\\oavw[Ӯ&vrI+%%vܣ\'&ik:\r{]=vޗ[t̲UQHqs/~xm\0`eȧr4v.7#\'^]w*:,V^BH0#0%W.LĩVrUX\0gk*Ha]x5ֱ\'+]75\'*ѹ4gkZ?.	{7Z+߭SvU] U@A`6f;Hx2!C1#%f,2]B	;\\uw)_@BBCQXjąL\0%ceQ7i^Mdd¹muby#yOWKVj5ff@f\n|̠ $*Us9n6$>\n|1\09evpKmܻ˙<*+|[/<T\0\rܝ1;Jٙmcz|]MEi(ﳋi˭\ZnVVI&,}ZI_T_eݨ(TU\\8P	 n fKF|iIc|J>I8%I16#\0?YVʜ./2 \06vK\nsDqmWҺ5+|#\n`\'\'Փ\0cQ==EJd]1$O ;:3u%Oף7I\0\0ogw\0n#z@!sVnāc*Crsg!s_\"o]NTyLp\\_6٭dM8G+\"d[ZAh42JJ@Fp8S+`jԚ5*KٸNRSZdM+Q37Juc(=XMPp	ũm$o%M`t`Pr`px*ԇs7ڊXUwPve7rEYn7316钘<{lsIs_i;kuvݞ}	ݻͤ9->.wSxw\'F;;vg<*$߂	DϹKU8٩i({e p%lM$#݀Ts\0S2Î\0\nT`CUܣZ*T[rI-䚓gUJӝ	|ЄKYy\'̤Ӆ̾a|-ѯx	^OafdC;(-ԡ-ʁ3,~eCq\",Be0C82x0uj\\ڥr[ʎL|L!*YX+kn\Z\\!*a,tEen`]eUh?x+;x\\N#0R_]կg(:nRTj^Rqsn(8O36bUgFg:\0XF\ZBua	ʪR+TVSVsQA%qp2WvrO;kAs(E\0\'yB0þBtC;۴8\"w\0]\n[h/88#IW+[~6d@NNpB`*W\ZضTy\\ϚM\'wku\rsmUtg(ϒ<aV2IJ5u>[V(R:y_\\ZsH&eXjvi:ݍwGvhGj;l2#H}-3Pf/-Zvp[,E5hϘ#9+av\Z-/fX&><õW`B+q#qbyIKNUqjJp92ORQiIrdW*pBSztfmJkB475SRP:i?KuK%kkѦ6JXKE,{ˑ\\rwH,J3aj-MFj:\\]\\ޛxZ/Xnfͣ4|E隿ƵewOg<ZH:Ǧr\\I=\"V8(/cX̵Iԕ\Z!+ƭ	ܭ\Z)>u$*5K݃a0JrѫNlL(ԤOg.U$.Ov0m5x:Yaf6ȧ$;dB\Zmbx(?GRaNH!\n>&s>%Zf5=z==thiwrmܵ%ʳ+5&=mU1k[\\如]CI[K\rRŢLa5(<.K:g+f׍,SZ(Ӎ9NRU*b%%N2pOS\0yʜc$(ȣfL.m*JY%\\/A$Aѩ(PJøIڄUyܢ`CϹAnrV5,1!X b_t\0\0GTFbqkm\r,p2B;}IcH.OKdQOJ4fI)-oaԾIwYq؊ܖ$x7 +:,-<-ho5+*tg(<ngWb14ZQr\'Fp*N2atvn)ebTeY\nʕLP^j13Ӕ[<]i*tdRQW!Qs~_#ƞm6vʱFM$p,A\ZƏN\'ÿҟxgzVi*e\\ʩY_iV:YڴbV-E]\0#x|c%PM\ZLx\\\r\n6_Zhw-H@s\\kW&zt\rsQ]L[ZZgs\\lT36|4N_ՅL<h0xwrN.3IRIrqS3<G\nucRc#EpqʋV8TJ{9kcZ=iS\ZOOHuJ{!ԊֳGG\\hKE:S\0hbY;bVI.$$jhX6Zf$inKI\Zgye6j7d2D3s2\\ԭ-$[IYE%-1$Pq$eQdϘeXU`~k,2Xc(FJf\"	JVNIYy5O%qy\':qW(эEMQu)JQU):*¬\\#JJj<XT9bK2\"2$0ybhY_n;P!/,Ob[%&e\0y.m5Ԗ?iu6F5濳kQs\ZG<c4hiQ%!/tF|J{kK*y	ʾBKo4N $ў~oYpZۤ?*oRrR9嫳QOEx|gaU\Zs$JXGUZʣRRS}R$dSw0*KanAI~RЂJw`[E%|2e׃Ǿ\"RxXR5\\AHe@%o.QW\rp3Y-[X:y]+rȱɞw( Rk3TU/~e9QR&}dm)]/ʱ\ZujP(Fe\'org{6hҒds\"\r*\n~ul!P5Le+.pTacPH`[hrVPP云QQnw$q:4: `*AUH\03b8:QohJi%-\ZҕݯmzvK\'-5VmkݾњCd,C)!*m 2F(>n 6W6k`,\" 8,3T>J~C\n_\n*T\0IgBd{h+jz` P7	vF9\nPr4x;U\n1߳wFMEE\'YŴkWҽkY5vZ;6JNb06\00Bdb˫8vuʹW3ﰳOU܇\0nsw2\0Bs*`F\n!-Fy1S$#$-w5nJ*޾_ʷek+okjYL	1.\'K.H!31SH|n|դ/\n73(JCUc:`3\0P$0p&Xuace!f,|2aʸpy9L(RM\'zI}O\'.xݧhnIM%;u\rBB+,)\'\rI>f[Ui\'{\r+pvbg}q\"1V@J-		F㌑{lʂܒpH\r<)8rvk)i)7e+^O.5c-Mz>o}b\0`8g<O1G\\\0=y;oy[yԕ_<-~FXGk5\0a4H!#I7]QHh {\0$D˨T ٟ\0F\ns5bYG\n\0̄+`0Ě؃_&W_X/88r39ҍJ.ERG6S=%nɽuv뙾W+(RܣNpe%6QTd,Lh9\nl 20;I!2zY\0$\0\nK1A>?PwބrE V%\n#SRዖ\rԒNFlr˻h`as;F&t\\4NMk]|n#.ay׳i7msx@ǌqdUI^rI$qP`9w1JRGLl-[wJ\n19`)occ8qiZ!g\0n,JA\0V@I9cֽY\\抌k7]ۛDSV<R\'$⚋Wf|_x^Y=a؂*{HpJ*m<>B~%usGJSmtnӚCiih9!D_4<3_R|o)@pkGbb)&\n`ܴr)bB\n3;itX|.}_\\*FnNZRSZMx^_:!KJ\nSZyҝNW	)њ䲜\\3Jo-KN0Ik$w2+,G\"\\%;oqXFl1FPQfs *\\|dx?MQ[ho13dKc!ico*2D2\"ݭo e5b(JoV\\?peI	aiގaB*6k*U~%}a$ݶ_#.s*+,u*J1U\\^\ZT\'xڝzpuiZ.׼\ZM4kH.d/K̐J#\'ͽcr#f(n}UED,9UK}gh/.Jɀw`^;Ы欛n(T2g*C UJ\0\0	2Bcc}\0$Vgq-\\-lEL+:xfI*tBU=XDySZy_PSaKңpJ&t0[#N+J:Iۢ\"Xfw&U*J+A\01Wq`}~4smaj]vsqN@$id6K;7&a۶sURrIS$2RH}ŝ\'c\0lɂS#,F\\NqԒR|N6\0eҴG	NV#EEEɷO2NjƳXZjV-FLk~]DYc\'s)1ckWӥ?v055IT{%m \\\"?`DHUi]aޗqun,2H%mA$eq揘eoMW>\0S^Iȭ-o6E>5}/Ӊ!s-Q\0D_=2t!<M$5ɬ*RRT9^.K-_؊MPU*XΚtqj\\sqntkRթ8(V3=?4	ov<`΢Nu:9#=c(Dv.f]om_k>!7u)oƛEjE1#BgT$3o/V4	+}qq+5Y6:v>jQQEuyAypD	FC\Z0P2JX\\v#1U\\\Zs(FaRjo)*q)k3)cx\\\ZF51\\6^Zu:J0RJJ3T(;an.^(gpS,By2LB760G=>/ILT<\\:|\07f,q@^XVȊ\r~$}\rzuiw\\]鑵 6dfT%g\"s㯈|\rgh^;Bc,u4aye4X[Khby%f!*y13#ٸ`VQf4T(AUUiII3q1|9fzU|d<K\rQ<VΕZuc,=	{:ӏ_/!{GI.5K7wY\'LdM2yֲKBѪlexObi0ܡ	}dۓ3>{\rj[Nռ\0v25r(2Eݧkpy/$д{O\Z$\"3ow}-F$O,K|cCw=ک$u೚8:8.3Zk8z5}FjaJq8CK~i?r]7(e*xlSb(TBrJ\ZdO6\'M\\fsG}HJ1<*a\"I)$]5\0𯁢</<u4F}6,RlT9|1!9YQ{{ozyf.Eq=q!x^F)<fG]<qLhxgm&GӼbcmêj)4S\\G}jicJRI\0<)iS硁3̱x;u`ܩRR9*B4>ER4Sy._ɸk3TЧ<)nS\Z\"41YT*ia(SƽYKRs_\r<mt4LwW)<JBCwD!wr _.6煾[7Jc-<o\r㾡\ZT-.	-G 1_ZZ[yZo*<q؉&jJ<n	؅#揩s\Z^X_rGˠLw_63w/\\$Gd U`xJs:>U)եUVtiƕgORQ;1XLJ<Ƣjc㆗+KV%9RNa\Z\\!7IV׾4<e5Ʃa6f\r)k$Ҭ@Ҳ4rAl=5c6o=?jh\'kg7TǙaT~lzk,L&1#D7yI~rdbC\0I\'giZjr\Zx͎\r#2\"ƶô5#h9_pVEjt]FqhBS~,\'m(qU<2ʰ=9Z\ZO0S~7\Z*	0<v}p[a .@XrY$d>y%d\"ŝAھ`!$up0^V]RQDKrnNFd6hؑkoRÕ6ܨw	f\\M718O06R	|q4hSMAFW*Ů}b(*NU%gtӿ-mcB]E$ |b\nmR˹hGj%xWTpZU6*\\;1bc(C``T\"m]dhcʨVicO(tUB%$._IVGدIME(_JzR5UJ[Jͧg{ʶ\Z#.xMdFH)\nw%	4>lH6+ppvc6]\'EB[*CHARJ^\r)ѡfpQѢCAc\\<RRnn~nԕVDm+Uizq7V:w-#;ʫ\0|-*-5aX*>e,2Yo01bDam|)ޠvlc;UP ;g\"\"Gp0YH	FaElu\"SoXIﭬIwiRnHRI)5tM-m]vبReGcsEb$nO\0NQLz}ywϸ\0y}hfp`*õFX4~\\3_=-t\rb\0PP+Πd6(*@~%i*nȼ+־ vc-CR)cRY \nK:ەYKH\n&!FPrJ-=YS\'u*[WW*ڌq\\Eͦݢڊ{1ѷ}cvwf#e;\0\n퓟\0iզd\"1.*GŗB=r!mKie7hNm/`}@j W\r[uokKth$0$JMK]OqIN2B!\\:hP9Pxw\\^)I)9/r<Ҋ_2bzS\'k	F.M=yh6U 		<k+1n·#<1x1W\n_W,Yg޻b\r&9f5lw˔#0Tu1bES\rTC030\r+ư,ǥʱ401T3%\'KѩYEZT]ے^M6|N7QEFTSDhme8.f۱Ẽ8Vl\0AX;Io-;>	Rv\071±w\01-#īgMJ20˿\' 2;*/މ<YP@@-\nQ<ĭdi-mmz+JhJ2qթA=5kkvmCyy4b6G,ms$FWxp񻲉UIr9-wV\\~-#.4\r䷵ڀY&KŚ=4)!D(C/Բ36vYVPWVb8l6axrK䱹W\nZ5(2B]Ď%+\0b^\"iUVp(Ft7Z4jpR\'\'Q~*c2iQҒz`4J?Gx\\::P$7$^ѫnly`\"|.\0n16^ah	_a+fjڵž[6vD4i!iHŘbɋ7zk_˧Ik[u.mYB.7M)bcx*L27`jX9}^ԩ\Z\'m\Zm̏xip^µ`>j*iBi8OEʲ]Gv,s&!)T`bgѤ!S\"BFLkeXLpVCA.eW1<\0C 4 .%|0ӝ|@]W\06CxrW}፫-{[6tʭ+YtnVgr\'*i4diU>itZ3\"N$/͒w;T/ʌ~~7~붧A:iq|њ=e>U$AwEoηp3-]+*P0VbUI o;xQ~վ\Zi>_X5Ѵd-,j>T Zl!r+fPT.HUJ͸%RRsJE\'Z?Fk;pَcP(t+:T^S(\ZJ*5B:rm|g⟇^_|Gx%X)m.P%!hxVA^=|9O4u7M٬3=u:Ȳ[y+c\08_2s\Zχ4>q<35icZi\Z+^Z\\E\rW:{[2M*	%<Xu?υ<sV\ZM{m},JemZ$ڙJ5ܲ豤F-$K9bqN8h׍c)Ν*RjME~˚qm/xf7 ɸw	KN{<Nʲ֭z,5\n#,f*7J4!*V*>9\0wiǉ.t\'tki\"UO+Qg4|&1cxtY~DYmRZR4ۛHMss$6f\0Xg@#sڴf7w7$t4Vנ\r\'u&Fy#CD}7xY׼/>[_4iͶZǡ[\r/RGũ,3i_\\~,^aqNajф?tUsRyZs:3N-f:T3\\qZfc[e:jA\'j1uh*r_Ÿ>MWT2[f\\G>5^9\"HfdUXYCZwqoۋkSmjwvz^K:Vn|(In$mm&o:i_\Znadmal,G,bI.@aJN٦6rll.#RN.aqe\rI!#br@-e\\Apѧ<E6\"RW#YTnݫϖRrpAObV\r^||V*ua+NTj}aqĺ5w\"d_uB\'x=O5Ɵmdyc	Dt~T-?0k\\BuI|fdy.|h%2ck#\Z3O9..a>=r$m\'0,\",ffYRC8h.,QH<\"[V9_g\\7VYa18#T[JU(JnIPB\nRWfjp1XT1Xrtptja,%\Zm+R$sU%\'ŨDv2O*4S22BBEpFKFѓo>M4oVӾ.[\\GK@Dm/{ hEW1M/Ǿ~VZS+kKIi3,0j~d\\,v!!wؐE\'~\'k/uDڍmƥ4a%ˉ-Q\"XmH]G2|ʋtheVbyrJ_\ZF6Uσα<9:8F,¶cF#߻\Z0gNbҧVJ4^%ne!zRkSKoכna$K}B&f]岋/\ZmZ-ͲYGJyn\Zsof\0Lm#[I3l<@WKTH	2ôLRFö5\roQ\'ԯ6(;B}Q#<,|ŜOU,W+.RRU*-yyT\Zj4%\\=/`pT*\\-q\nҧ\nT)_c(ϖX^5ׅDxK+A\Z2F\\/c\\h6IGi䬑Q\Z&PbU;9uU8@71/;dcM\npTnRpO (rpI9[A-|FmMgψwRqNN5ww++٦G>((R5\nocB13o*ݒMcLOY6w\"R9w\nF|F$8`KmI%96Օ~HHb)YCp	ԁY\"m3 rrl ?0mp|di_K;ܵ{,VVVtcr{\n@.\r܎F$c$eV܁컫ȶ2yܥkO\0rwpc[QՔm8g,Đ38U]>Ra.뜾#;>첖M0;dL\0w*||J<Q敟,MٵIF;kgͫ^)zw{m_\"h<̯*A	 `\rJY0e<ީbQ\0{Nd B\\\nƼգX܉v>ӵGvKXq$mW@9aY\'\n0\0՘W2WId}j4㪺nq/uzߕ_ҽ+\0yw=p(22; PB(,$v9Շexke[/$߹=g/\0_s$m꩝u@0>a0IAZate  T1^\'v\Z020+FV9C22dct*X#,J\0cvnRMyY_i_Gotn\0[\'}_Ue嬋f2یlN0đ^C`n`%h\rcvBzYBl#9l`>o$ a`kU.ՈU\rT\'%lxSKK)Ym{Ii0\\e	f[mI%iYVF\nr6cgc݌@R	U~^U=dr6$5\nUnA\0mނ*%H$	KeWh7JnZ;J-Z&U[QJd-kǡŨ0\n2~tU9mxs\0er.zd\Z9\0@ =$q^{VaWa0!rYWTU!I? Is҂0GN_Q%g̴wnZmC̩҂sIʯkֲ[mHPYݸ 2HPprp݉Qr!FEV._IRYXn8 \n䆩\0 mr89dJUq#`%e(	\nGX**I57ԛ溓V(mSd_EmjI$kݧ]⏃Լ!5x\rΏ%Ƨi=HɆky.pK;\nFn%ygw̅/a_\nFT.0BKnHMT@(\0a1_|Iv\0RԶiw$i$gd0Cv\0m~`27渺8hVj?U~NtJ<cRN)žkNYW6G9VZRPZ4:u77R\Z8՚MJdfC,rX?0qt\ZLNbF7 ݖ-Cmc.14U,F+ `]MHK(W_.,KF;sW8ZI9I$)Գ|ruYS].opm<.&|F+MÖRU1t.$ҚSrVZ5V;Q3\n!3HȄ*2*.	*_=cO_smݞQqm<.fR$P%VҬW	ln	v|$d\ZheXϕpj#5F\nD[\"މ1/I7gYlK$VwK	D@\r!H\0|@Yg)[R|VJpI(SiNեvaF_~/1e\\=eC*hSR7)rHjH\r\r7|Gƭ;]\"&iZBl8uf$ʡ%HdF+z??io>E?\riRMu[8^:^ot5ի)@{yPAksiG>\"i7RNasuU-_Gz]in8$og\'OI{O)7%5;O:ݥizex8SʊA.#ҫS5a3V:P<E)\\j\'xyG%:v叴kJ\\UgV\ZF]<oӪr+)Q[R9fnV\nx[-SPZ@Þ(ȳ.MT.1d[CSD&/Ȟ~\"|WC滢jއs\\xV[xgLK\"Yc:Y3&O<}j~<6,5\0x@_tSVWbK5T\ZMiiW{>8h$ӯu;4-?O$ip$Em,-8On[PQUOxN3_J\nU#NfN8Ɣ\nҦ,pE<g8\Zy>9\0W`xO+ǺQJrPf0Ϗ]\Z^mѭdoKq-p`I[y.^^W#XJ\'ž	g%]7Qum:	MFKXγOidZF[dZZ\Zg5-2M\0uMdἽHtemf3f{a4\0Cƞm-A\r>[Gڪ%QƮ`VHwVGTQìV\Z:xj^mN5U3\nG*MI=?,81(ӥV39瘙b*ѫJJ\"\"-xԫ^uJ<.UiVsIVU{6\0B7Mji!dKTȇxWeono\'ddYgϘy!]ﰝpʼ<Rx3H1H\r.?2K]>!vZ<P3	G(Ŏd-OfV9/;	/\"VًB;g/mOZ\0V&jZEFj*)$5t|F|\rNKҔ:uUTNjpaVU%:U96|g7U.>&MOha$2&Qq%w.7}WYadvFG;71VlWo~/LyTUqsIcnJĺ(l[oh4Il!H].gk<[簔)ˍUb,j7J2\ZupySu&cJ*Mz6ݜ٧pShTTypن*cMPu:Te\nSN4iGp߅>,Oc6IsbK˨@Ya[:KˬQȎYF^{K.	7,UlZ-ᛠ%\ZѠдm[]5)1l?lt#Hf\n0p>U|O#yW\'X&Ă/゠<ܒ3j%FO\n*rGNG(T4%rJ7b/۸grhe[ԩozSNQ(ECcoQ`ޡ_\0RK7% @$Kbxg\rлdBK\rLycF\nlYqrk$PKuw|+jsy!b#$%@fbĞxaXk+%$I7ZRꮬU\Z**[E։]+O]=Y5>7* elYDѫ\029\'\04Ye$b+\"(\0eC2@Ux*<K6*ce\\m!.K/,6NȟWء70\\8 .@\0\'rTc&ֶVi/ۯS\\ԛ|&}]ݴ=[,w2(Cn9}\Z<Dv;+X\"\nVUb\"eur)AkebPe$\r#) wepcexxݍv(fT!9%f\0\n `gu&VwiiugپJTUk(vKJ]\\ Vݟ ɍm/fea\"eP7	\"7HANGrk>݁Hfp2Ig@vǙ޹w_P\'\\*QR\0/r>K5Ir{җ۵yA:ݦgd㾶M_o\'`8ycy;yz+[_Y$)  g\'rOJ\0/[\'\0$^_]?=~ųB@p-ؤtfNس&O_aPd\n~\0$ɑr	#]i~P73!6$b/X6JL1w\02f\0nb37dvjWѵ~WNg	zQom\ZR~%}5m6}͂8`Ap+bk(?4K*;(\ndojēoCFSx*wdc!\0l\rn`]A;\\]ђ䪻`7\\di9{PNiԒVwMJuu~[4;nDŮ+;g;vT͉Isu+_\\fP\n8$6G)yB.X8o#(@f,pXɭ|E$P!@}e\\\0XY\0F\"]R)%5evI륕vrzjX4֩li{;i^gū)@y߹%\r.v6\rYd?{B,JI?wp\'\0P۸\rx \nq~NW,N\Zҋ\\%\0y0 w>u\\h^|KᵹJ-ngk<UQj<6wV][[?6rNGv0.I#88TG+\\`,ާ8ׁc8\0tXT\n9\0r7t@JjPyq4Mi-cy$ߺڲl{apgC7pTPron1 9Ol\0A ?\ZO <=$K9㴒6w1r0X,wgqp\\\0k{kf<K{{ҍo~f\ZsnT;sd1[2i#lVERB\'f2HV?wcԋ8\0rpį\\\0x=_ +J܆Q@n2F[A1I?uF3i-c(nQ|J&VYR1[vVOm5igYjDe>p0X#+pGX݁ Fuc!ǣx[ăH] \'\"CY`QT7HWB\'83@98\0H(Pd[/#>3E$\r,PiH(8ݍW+NJy5\njҫE:rK^iN0J6iF1MIK{_\0^&MB}B%D:ri3C6YOcIek\n_*y>1-4w6Tvv<v6W2X@5M0M(z#k%ԊTmVR:$ ]\0rrǑ]ZD@L۹C\rހUF \01$$Ÿn[knD(3|c<NMN.EJupt*\nIΜ	7x8Eŧ9A_ͩjz\\O]`+bEfu`͚dq7y}\rtæ\\t÷ڽ+@ne(8.\')kn-G1UڈуVdr ᘩV`\0H5\ZNrnpWC\02~3zSR<UI]ם\n)#q=*;?y#xg-J\n0S/><<nRq\Z9Ba(aӌ\ZޤT/:Fi,lsn\"3&e1G\Z\\4Eg¬jrXFjYZY%` g_$\"͐#D~WSj2ۖErT;0C#@}(k!Rȯt<Kf<ZS4s?{,3c.Xez\\-L:0BJO	խVSTV\"MpkJWեKGʆ`TOjիI.u+]F\\vq-C$5۝SJm:}c*\"\'v2ǿǘ8qJ[$FDu	DJ[.\ZuT,$Env.v\rs\rm`F@TR4R[* 1%c@/CK̍{wcJywYeVV~FE`2B+􌗊qW,¶MgFNX<&8RNʒq:t߷mӨo#ٯS̛l\Zf+UKRS64\'\Zw8QN[^ᶕV\'[k0Z4l@@\nwgrOy\0_Z7}4fB<68vyZMlgExCƤIq\Z<r}`&PDRn\'k]H*	cQ|\'#s%d{0-8YPMoIN\\qX<~-bUⰓX\"35EZ9R<7,(*G0Q1y.?ONGL*j|+SД5*ry\\i#ռ1ev&q-MH\ZЬ35&I1/)rݞʕU`w+DS3I1TeF#2!6>PA׵AQjaSʄ#32 V \0G-Z.BlI[k]nDV*r/_c9!0Z\\g-GEJϙRIFѴeggEJ&=KP׼/hԪI6m7s(T7Hi\n\0b\'1 ;zc&\n<BpҴjBTg毚<E$?nW\\FAAQKvK`7M4f2Z-˘6ήa$[p|%Th*&y%>WVK%H<$V0n1Qo|mK])Y-ߊ,&r\\e.8Q!8\0r\'{@p\0}TeJ2+;.#9#%r4k\"{˄fB\01߀\06Fo>k2\0H]F.<{8n&ZکtI7]h??<VjXQ0q^j~\'8%gwdW{tWl288ˀ,XdnuMb2ˀ`2_-bx\07!@%a\0?:eI̘H$aFG\n׷%M)J\rY=-x;YY\'{wv^fJ.Y[ *Ųrē7xIrN5Ʀ\\T2\0̻kicB\0H)<n	=\0eͬŋHʒy9\n12sjY;+\'/u\\gV6S	iRv7i7J+]7xK$+^yÆa\\u==ʯ>nߧݾTT*XnV\\Y+9&\'*FrZ2@d (RM~bx/7a_[yi\rrZj()v\\{%e%TrW^«czߦk2avC=V܊ks^\rr)O\nX5:qn;Y^P匝??(CI84\'SxVa\ZMT569Bvbf*M\\d60G\'f?895g hí0	c#),1M~Zme%$C*,!df:GVݜlu\Z)SAoMqHc<E_|{. U%QNny[MRi?9߮QC/ԣp8y(`c_Bc	ʞ5&.Y&]IDG<ɂɴ; A,1sƄ~\";\nI^dI mWŨ\rX!B:|ό9f`~ln:h_3j x`n$\"E4t֖Qhڲ7[I.ivZ$w]~+o1BbK|we`+nWٴf *#*W{6@#\nϫ8,͹QR$\0@9V:ٵ,XJ9mcqb8/rmJW+i{;e̓)>#%}OTfZjS|PĀI*qv<B2 \"smUPAn* fq_9k0NNp\'nu-]|s/\\qy\nP\\rqkھh>sN)Mֻצ菡mGn3F@$	FXr7U|6୼c\'c\'Tx^vȃyP2\'#b\n6lY|db[<b0Å\nRPn`>F$vaJ<ӲR$߹wK1y%-]5ohmU~?dqMQꥎ@\r\\qKz8||NOiM@(՘y]-\\LiHi\0Vcwx&X_Ǎ|Q4ާ9o2=1!a|$`\n>_\0Sx5rOeOeSP:tgҵ?-o)j񧈼X>-rl\\ͬ6?C4hZnag 6sܞO~@M\'sO#i9 +l?|\'d2JxOQ<9d-X띥n)\02om[*C<5efcZ6wA?4,T/qMI(Ҥ\\jtIEJq?/ojO̔0[*M+FVz=v-0F匒1V^\'n9,|u>rU%V\'nveS)\nĜOK\'G_ԵP!wtDev;4R	^BCQ.\0?\r~ѴaOVldw,ͼ6(G]_wU0|%g|EHjC	bbҍZT|v#O<0x(̣\ZNt0jJ\Z\'5W\r)IK{K\ZN>\0xCObȹF1cWs o٥!Ps\0Pgl9wI\0|BfT#G;ULV7w̓o9̞Z \r\0|t %mj)imxM6vV\0RzaekbKٖ!\'Mϸ3R]|^KgtbjU#i:-%g$>%<V*`\Z*x|<+Sp9grXsJ(MUӅ*uj+\rgđah$T,Gb\nMy⍆Vvʸ\0`7mbK<)ȏWKgfe]>HYt.\Zc\"; [KvѼpj^Ib*r$h]S\Z4h\"R7}_`p=)ӫJqTXҧ(I>YjKTI_0RN*pqPTg5(9dHӳ:;\"4hf3y8#l%CXQg;PY,yBUI\05{ABVVI\'}I畂mA\Z#[4kkknRUd~Xu`UG\\6ŋ|xs,N(rXJ3U!5KٷzpRG#$TYSpJ#(BWrVi\'G^s\n0\\ylwXV\n\0$;\0A:\0`fKϊ&eSiJE2TʮIP#oeI$Ws0@JI=+\rh8A#oF8\' uZwG,%*:p	4_KYɫj?\"9jUTEsGŤTtI9-\'vP3m«ݎ@%6rr|\\ySڹ9G,8z&d,AT\rP<9d<О.0$=A&N0!nE_\rڻq;Xd8:η̗,-QvikᶽS]Eƴ3`982s	Rd˼y8`6FA݌q\\HfPpJggc$ԖC,#vnª:ᯣUE-f4?s31WWӖI5+]yvz[Umy5RC۱t`@$D$A@;dA0y}0`x9\rO\'a\0UCp\0$:(Fkх5nXҒսݵ0\\juӫI˙]\Zm];mؾ\'ʠ0 )vs!;.PSe%\"amP~p1<3Es&G;nsӌסK$\r\rAGJф4WNݢշOK9qyR#[Wٺ~q9ԜydIn[\0v|O*Cnp2H>\n%YxI w\0Anyev*@rr*I9yQ#$\n4IՒJM++6DdےiKi4-zc{\0OsEs?npU88SEi#\0z_I)WR\0~=js:\'\'R@<cR?^ny߿wƣVWi?r\r{UVK=SP\0坭!~\"rI\'ssyn,l9$``dRI\\[sr^ۧMhQWOujJ9y\\irǛ.nU{~%(~ -I/귰Е%cΡ\\3!H\0YL~2&ءv}0x-wqy\r O҃篁,L5}\Z~ޅ*NV猴O;~#\rMKxߋ)\'cqȭ2|7N%Hfo>|8ǟmÆ{p\0U9l\0k~K4Rjv\"Fxf~b2\0\\g#83ּ1VyN]}jg\0.4?ZʾH~/#*qo7rR߶,ysoL!bHRHJ\0c$ۋӕįNm.\nxEsC|z~{+rPjUי.zO-ZlV1(dlEWrV?h7Ҟi> M7#)T\\6͒[֭D<<3)y̲_iJӀ$*Bbo~D>IV;AylnoLⴶѺby<1S}\0?/?g z$J\r	a1,j۔*u1tcwqZ2i%)AiS\0ғJ?3`q<]N2q0V\'<&kF3ڭ<&7\rJjBp|-n}KV/u-BFQyY$wv8[TY~m@3޳RR͆fR}!\nq)0Ra$IY$I%I%?8^\"+b5N\"&JըVZRYu*JS%ROg<zVwFIq$02:Ҫ_\\qrūVik̹wdwUQ&8?9cޓ#փO=i~}ۂ~9})<Xsoªg9d	5ni/\0>o_c#xkS/}̪4ţoo<c%:#;:F=K}j)iV֒l$^ӥҠ+YJ%2@eUE_˞xÞ3қ>a ?Ͻ|/8Kc8k$cAӫ*VnI?uRJ*|<9p\"pCbW,.):1TgC)9ukO\r:UzW2/mN f}*K\"7&j4Q@f*w\0\\\0lkky27\07Hc$.x\'q\089$9㝼~Du9)F.x5Pۿntoji+g9C	a3n2	T8&\n1JxeHJkMJ*Tğ_:xGRcI`b P>Th]-$JGJvL7PRKd2BMx%Ű\'tl!\06s[Pkʠ$<@A8/ia)эXҲsBY\'9\'$Ir$Ge/X\'2n)Ɲ ,+a`j\nNu*νJUU98*|RJ[wdcsr\",6($D8޺=7ұ-fő]`P^L2\'p8!ǃ0upFA#؞a\' `$S_jTUm6k痀ĬjU2N:/\rTmF	g$ڕzUb$v6os]C6ڲUr(w!<c),# Hn*`g$	#g\011oojexHRZ[Y%\0mo|yҌ:Ys[Q^-{Y5oύPnXiIU`p3U|wFܨ2E\0!8\'$q^Ҹ\\}rS\'t):9>p8hK3xu՝\\\"nOꔚwIhkGdWhsg!I%8(p3ǯ қDsoE\n32Ny={+-`6B8qꘓiF~\0Tph^nwzٿT_Stc)ӻ$0u%vz(ex+Rg?nڂ>Ww\'6㞞$`Ԍy23^j5szǧ@@nF2rGrG{֊? Ӷռw[8\0>ڳiY+A$Kܲ-.J\0_h6r\0_t\0{\n_ȿ8\0|\0uuy~z³\0@=	>\'Izu#y\n	5I+<@.2dUIR\\\\kI?d*xY(˂\0c\nG9+0qˎ};<F)U󷽾>wĸiwƢi]}Z+\0?oO\0~a5fbU,Gؕ<Π+\"~\'/ߧ]9yU@qg6K),W\0e.=i%9vJ-/\0!RkQтIj7WvI3w7c\099ҿDwf\n*/`$/H%#So쪟ꅶXyaɀ(r*F9T /<NxުQIǫw%}ɖpI~*;\'d%}Wn?9I\'<d}hH`~ʆ&F@f9o9!@4e$\Z\0?$&6?bv9n\0\0+Kgw^zt^CRKM3Hc ޟn#9W~ɾ	M52B`6ѓ	-\rQk)lx<̷6*Hp͊d`FZ㜒VIcIn+KKvwl@ߤTpT\n»nO\Z8p9<ds~~zU,Nn,2\0Nl\n-lUwռA!,v~kUv+qO&Ѥ4/\Z^N5ke?JOSNT&i5%+_g~q9\'_mGmZ?(C-@$B<`V{G\n	l #i9u8$?%{VNk?ᾁ\0HlD\ZY7\rR|q>Zni9}^~Gtcۧ?ҿK?xKU5>!\"TyEb\0<Qr`1Ld\r{\0q}\n=YM+bŭ\\<S_\'x<qجƓܙmjhqmWj}(Xp*v_aJo-TRG#=G*@)}\0*Kφ%{f۸)Q6X`X{ր\0X|0 c=\' B$RqdgaǮzq!|]sW\\W+Iٹi?;f\0Im*o\0/`ֻ|h$slt3sH9$3uܫ%e<Q7 KÆLl00q??O0\'\n\0r0r3>~T^amSZ.h$+\0vkH~̿\rHS8*I|eK֢k_yyR\0@ϧ);>V91޿fu&kK_xʨ$C1b01\n@?6G5\Z[7 1uQ(*BnTcx;7\\<F>qj	Rvv۾mm,ReJ/	NRKEWɇvnME)6~Y	 sH\'=Ѽf0l\'*d\0؀ϛ6@䜧$)ۑ2QE\'$:۔\Zk0F$Ӂ nU <7d(K\Zwtm^Z6mSi]|iCWN\\IFI0- pN1c{緡#I9uwV%az%W;8كp{FK8P{b+#zQ|R^N&k_k_cjmOpck&ʲWwk-/~XǖA,ycA$r:OB\0<\Z7cW.<6Vx;8_fu-lf>p \nz+Ej%t`{iwz94\'%g\n1mQȒN<rKz|oվyCW)X7R6hN=<t_7.a~O|Iu^\'C_d +wh3͓0	$q\04yjo\ZqVHFi*s*Wk[eMl|ڥF~fS\0\'0#_Zw\0R93>ǌ_nY}Qv99g\0gP~ B;ȱ CQ5p,,J5nP7~{Y]=/ucS%yE\\|JI]7ٟ}>r\0\0(}?G%F`q`\ngo	/.u#ԜY8^_pX$%\\/3yhɶID>OZl&ݭUns%ޯEm6zoV6^N8ѩzP H2@\ZO^5F@7 qxgYl>	A G\0	\'.9%Q}S赲mtWV\'iP[*Z6\Z	z]\0\0_H\0.\0hԇT\0%^ן \06T\0}~guI`C!	ЬHުco\nz8.ݐcnliFe.6lʭ	\"Q&|ڀ_kaƊhB	6(>[hU%hҳaB8coz:hԔbz=ދe}/\\\Z[VT(JrT[nҜ`S%ʣSlg\n.g\0-#1U䜘nGDUaIۙ[HyxHiY6.ѳ?8v]+ft8syp06L#$t(52,+S/Eeu&b,%DFHRTuc\Z\"+gͅ~xo\Zw}b&i4d*Zh%yj⤩ʅWRҤ8sS.Is*9JT>x\ZFI2FK۩s\nK	Z&2hV=*W(]tf{PK*	)\"Ɵ()!\\1K$˔tF6-j,Q),+,IbRMSˊIJ[Y%U	Aq\ZmR˘lQS(RrPKݪyt^.kMq]	˓J~ɶ	/auk	SN5#=\\m6!f2#zƊO4(,mUX(B͑qDұ\"4sHd\"HG\nT2	C\"+kfh C`H{\"[qɌ@Xb1-sR^ܕ7(1389et1\"岆e,NM)s:[*p%{sJVFRjX<MR9VU\nj4\')$B>˚jVM^܆lWTb-bE2cyV381IH35%>\\p]qr2	Ղ2w00v\"u$7\nlAG`Q\rJYKn\Z^wh)ƢV\\[Y+%uӍܚVxFOku:XRR*zV(\\`#mM\\ma#%!`ai%0PUwSLy!dB~o\n\0H݂Aki1q,(FnSERg|lj3!lrw%RDt2I2,SK%P敪~qpMrgkޝ5AK\n|S:jQVQj|T\\?r.oTLUg7?#\0$Fr@P&;	c2DRFYv&j7#%c#Xgym4@XyK2r8U]kb{WI,Q~~Fspc:9jekrrlw\'DGxVEERP\Zէ(Eӛ%N-0J+rr>~s*Z(⁌2,Ⱦ\\i\0\\Td0*1O<=w>瘍$1paW玁\\Zi[,$xbAV\"VB۞/82/eV$VRam8s#\\[e7_(ıIn#u,7@դξ&jpcEԣ*Tq*Ne5*Zp4.P?;9N\n(b#:TT)B4{J2T\0*Kסf$]m80$A\nEƈĆv;؄Ke2J:9i<`]\\A${B#VCnҼ*HLr-)&xȷ6\\EMzXH%imk3Y®ʳ<\rtG5ıJq*n%iM{XFS=m>x9ѓeA^,KMKQn-J.2,dɫX]J<1@qe\n]Hl>7eV&i	W3ʰt$6C\0XP2NFH-M#xd~eV-r̖?hӮm_dk)[\'{im\ZKk8<~K]@$5W\'yE{::2`ܔͨTᨨNd%*tT \'^V>u	N2e#\"!c`7];\0pKZ5Ru9v9wh$NțW*ܿL[+׾#M3cŎ7d1v\\DAS`vWYbf\0YQ<W$n|p#[̳]Di!F8/(WZmHsqrHEsQnjv>D0zQ	ʮF3*xj%RJ%\'(l$f\ri,4he	)2*!|GSp[!v|8;C#;q]\\\rˉ]-\nZʖD7	YvĪ;W-\"HZ$pB`i䉈?Q*\ncN^SiNV|IZO|Jʱckta{qr7*P|ӍN]UғVVQ!d^P14rĹ@˻nD]K8-N0e8-ybگp65,\r\Zt.IU&*cjmR\0gn@BuN=ֶvIW6$Ua(N9*\nbW9N.mSiLsnߗ8UQdK$).6i\n\n0w1?#\"8uk$OiH/,1<lS,_pxWr2RLLŕemx[,#h6:ٶ},8B?g(iJa(dJRIm8*3 !e!+N6AM˺cI\\Q`X8e0)>\"Jd GQ6T`\\l6u֡$\n\"FHȁEU%e[\'z: 2jQwj$vOUjy+ыVXq䓩ܽe%hq8ߙolIfSfw 6}%Ն	\\3IPN\0v`\"PGQ6s(IΥr2VYu$~mqT\\s\'vչ]wm<G#ۧFRtj\'˛A&{3ng*zGu\\1ߘm9 94$vԆ+~Wcg۟_ŖًG\"$nZJIyYdWVvbiw+$fr@EL:\0C6TneW	\0vXJi97ftm6WQr{3pUJRԌyn֥ίRR|Pz=9%Y݌LnHY<%+#%T[q\\aA\0Oʐط\'n3irnfݡaN_,\"n9UdU15#j-=omZI+w]t5(ƜԤtQ絧~dn(JIẟƊ\Z\0#8\0eՔ㌫3*F	\0QSZR\0Z4kմkyWG;530e\0sm=>vbn0[lב\\j+A4/V\"ond)?*d(e.vVv)k5	&Iv]Cj;VwPs,ӬᕼEFa%\n~=.j1QxxZR\'^qj1bRJ)Ͱ(ҭAЄc!Kѥ^.ar=ib[J2NjnJ2_Ѥo	-[vweePEy\"2Fs\'i&5S,[O6,+1esyвD,l9n֖c{-h.չ,Ȼ+!&[]I漿<[TM6֖F1 tܼj;0 7>CUOZu%zq<Bj7Pu,9C;SPW3MXjE֥VFB*NU%k}q7eJXɑxm92ot.Dď8\\V! Po\\Jk4n	>ƍ	fpy;ku-Oi$qYxtUfcl$&W}R1[=VkYePKR[h>\Z\'Fr)`ȍ,ܥcܩ*3qPjkYA{_l.2n8Ź\rR:%?hUU5nxJ5NѣI:3WybVRc17*.7ɄHAȈyya)gʾ[!{-\rfGl71_Q\"[	$֗Vw-\0	?`LiT+f#h&\r:)FuF{O24Yetn7$2$%5	[҆\"	VT%9r9^1VwNI%Aʝ8?my\"XZzHUʤ̪xq1cRSǚXbK	D<阛|Lpx1*@!ZD-Hc[rV\"L{d>[G\n\0\'[[-\rRʱ$>Vr\0A=ͻ1څ+[#F@P1%v9R\\\ZUC(TqqT=`_UBun,ҶUU`2χRy|<1u&FXFfUcBUc9s4H.1	+Dj)t KMq!:ضxmĬzrLU+o	%}Vx+\n2ηJNbɻhH 2CoE,l52h\'E&7$Y	p\\ReT;k[ҲM}#	Z2U*ST2))Ź֭MtE\Zp8SJtlld\r72K*o2dE:Hemj蠚YGH\0vK\'	`N+Wiceb(eĐ9r\n\0gtDmnKedK\"Q4ldH\"hF*+#JSspb$ӊ|\\9,jBX,=XҩԪ\Zr9Kbq5ʊxN?Tќ>h.$/<r	d.`^,DHNx!R&װ&\rMY#yVv\nxF򴩂)xz\ZxQ~.70_Ik<AD$H\Z\"Ac!\nSRQM4Ii@IpWrIf4QE4٪FFYwfVTk59S*sNZQtMyeGUe9fK*d\'_\ZRUIf9WS\nV9WjPѭK/x\Z{xvK.{_v!I#YHHW͎XٚX%gGZ|u+.m.9&NNn<Gm0rV\0	U4t:h/ǕiY.`F5Лo6ȝ6][	d㾹{[+KhRFb\"aۖh5<[BGoV`Ƶl7nRV⽄V\"5yU00-KJl*/Z(aC	9R*WΔq.,$،N%*тK\0i6vKpZ]詡j6+{=Ep̂oı.)[߆9tFt;(im$H|o%vq$,v//AR(l,SJ[MFIRY\0hK(=8IqmO$ɴbXyfXC<JL!\"0@clk\Z[K䞦M*ٖ\']J(ĺԦC%59ST:J0T2C,N\'Fz4ʜV&U(ĹRJ2N%^*\\mUkwg6ֺevs}5.KMs .vX\0\\6iR7wӝ\\gyD,4ʉS7UQiZhMݮm?]Hq\"KDwm9JYRfwEhn<sDc,spĪf)fY?y$Q§׭ZXZjtk/k\Z**Q5V$\' V2*ReK=UG\ZΔկL\Z+_Js:3lZ8ڝ\r\n%ʪ\0K[8eY\ZO2uR!@r^quƲIXj$Df6*UCS&@cmnV\"Wy>\"IZ=|}79WP4_0kyg;8hJUPFK,hNҩ#@_Nmoo(IEpޓSjrJ$|#1ӥδ\nO*P*Ng]`px~aTZN_z\'7-ْk`R+M.6<FHMĩeT0mw\Z0iLu[ٶ]Saqr[n⏑(]\n\\2ۦl\'Hdv*JVw.]س:\"IIuʗY\"|*x*сpN[SSozGqqZɵ+g3]xbaJ4ƛT㈝4\'R8U7YQpp\ZMq<)e33uD(8>u& C$#$v;rQ@d[\\|\ZF]G(|c?+]ĝi7\n]yGC\Z#YJ~e\\G܌sۏ\\&h(+Yͥ4ovv|3:3NZޅ8F,BU*T\'(SwyF}\"+A]V6/[ĥ ,C\08tU%gFRbHɒBU|LSʧ-0r]#\'\Zl!#?2Y\\1?\\I,\"\rׇ)EvD;%p0_rhcku\"ױy-H6\0~˭Og,g*Xs*U9\\p\'=Ԛ~*I+9fhk+-w&́Hd,,Yig`E61#JnždS\"p̅!`ٚeO67	G2Q#pɽ[۵VuS[Ia	/$.U8+9۳i:I$ڷ4oe.8Bxm\Z8z%%h<D0zQ?vTaNNmqnZBmw[&q1@}JnF5.R.	vJF%gOiюBW{PM6i[[	.A\"Id,;vYLхa*ܥTUbie-@#0p䃷r\0N7TrISMJn-EWy4쮝EUW)f$t+N^59:u+PSԣ,,iC8*SǖGٮDwfd6Yfݴ24R2c{<4@BO\'qzyA\"#(E3@˷s[a pRA3t ЈZ%Ȏ- %hL왕[i\nH5(hiZ-\'wʔJ\0}o1OJOR(1tc7Ku\'7̧ΥZ]@\0n._V\nY3m,I\\t$btk%ݺ%OPK08nVN5G89%\'tVMTo/sc}B,qvj~EBB2^	PV\'RYړ,-M;[[pygʄO-$%!a2\"Pn/bB$ązx!ԊuZP&S$_l8RĹFulW+ʾƝHRi7GIJJ\Z7i}4gUpEZ)ю89N4WEc1tΓRxƥ5_Qj6?oY}S0fW;1Ĭ0(\nh隦wqOgx#6\nH\r\n3ެf9Y*+<RQGtuiW`~HR=1&fwPm,X]Ch]x,Zl0[7:4O]<>*I1T9PtyHrʝH(VN{#fO,V>\nRX=:9G4+cn!SׄʢV1jI>\n(san\\X:ŒmŨ8_,\"P!C5JTK!T%\"eXѓ^GFi#M\nƐ!D*JZ2\"n%Zy#׺YlhV5)[kDPl\nI!ZW00N\\ѩ^\rI_qmIz+؎-dSRx\\(㰒8RHrJ7\Z$\'Q:MN\\N9CyH2ΞEPH͹E]z\\r`dIR9pH1Skey.಺rȅZV+xXpѼܽ>EŽn\0A1\ZGAW4cSns^{rӴ|&/^b\nntaFFR4c- N24iCeW)e<ƵZRc\nZPY*^ΤZJ\\ZzUOO:$0HC#6W\0Ҩ̺pŧP:yQb@B8|F.)uyɖ[I-IXHdp]YR%%v-t^8D6Ȟ\\o+SO3<ẏC*FR88ҧ[	jrc>jR.XK}hym{\\U\nuGV/2USzj8h½Zҭ|FV(EVjՓQyw槒d-mSUA)fl	8[z7xYFәMngY^#sFiB4u|?vonM㽒v+E!g0F7~ E7\rpΦ(?ޫ2$d3d:R@B<7)RMT\\|IjRJwy2VK,cbYG,%V>wNtgRsZQQU12irE\Zs8%no c\"\Z3<[\0$v\0mKke5&_iїuo&k`EEE$vcG9\'Kh[o-\"Gw*,^7q!q6 jݶ	oCKsm\nDyб<)Wן/cYʝm%8eܧV\\-Y)In_Y\nWO-Qs\\T1FNі]U\ZrQSzşKh&Ek;_8v{)%;#ނ<9BxG>˻/5nuO>$\'#]>X)ȰYR4sG MiʹsHOmK=LQ,7Q0Q@Rѭmco_%0u~iZ(\ZՕ_cڐ$S0B_ 8:_[x:p\'\nNRnx2*qjXScRNalxuVʿBt]*|s<6JxeSj(S,L>ԕt{h~\Zj.SÓF2Ēcw-D\n*Q\0w0xÒ\0ix|-5|Cqf=:w^}ȷ)N.h]?ɴ\Z< 5i`CVZE8dYS\0^		/odc<VmhGn^-Bm7QӡҢ}ZK4\0gNr3\\bf5pЎ#zy22秋F|	\n|})/iVs)Y<=QF+cXLM8ө\Zʥ>a9W\"KUzQS-ԼUy%FިK%縱xL$	nV\0\"E=\05_MsVfqw`g\r%][r%6EE+$	Z+c5ލo\'Ea>.\\oh.ҢmDXx-[C]=|G.a;{w38T]jI$P[tC(WO5\Z=auc2f&\n3%<pezu!%9,NNm{Qe<&8s\'uR9<HKNgRs񏴔9=jZuqk~Ca$qڤ͌OF$,ē!\'EC=plocmpyѬ1X5Hdg*(v{6o\Z{A;Mma5zi}BYbo(	FhW:b-Nk}#=Ы=ŭ<^##nDe+ʅj8foEQ5S.SIJ)^2n\\UͿ\051ve!X5F\"~Q./6;%8rԛ.N4ŧ]E{9[MXG\'{d\r)vi9fMTn@}i-3C5値.攪jɠ$ZZڮuGH%w=ΤhÑԤHV{DX<=}M\"۴16aѲKN2u1rFkRN.(r;;O\0sIdC5\n^֝ls<2sӶ*5VBtkTXqӋ,C|Nԍ\rM&f|ai<д&)q0\'hC%L%A#!;,6	!R0LK7\\/K}D1\\ mk,Ra&pTImmYk7i#n\"`N#ye8ɰ]Ҫg%JS\"n4ڴ N\rju(FeFw*Pp^ۚtSC(b(CNg:*/d.hh$vf6Xn!ۇ\njr%<-S #wVA(͒j4{\'F,%g9T0$(HFx\"g7B5B99]Q掩[gWȻ]q*QVU*O\rT\ZԔux1eIҾo2\\YO捬l8#sՔ3$I]}aZMl3cg+ٜ+3!e0:IL$c<2.ۃUHmH2o(8#8U\'gC#@LZ5I9;]N;JIy$JJ*Q\\Ò~jEPʵN2J*)МdVXHc5=Ny$dDl,MEԛ\06gHi7r\\_0\"4u\\VLcZI.-a@HX6I+)\0A5ż˕Yui\0\0.	\'##Q\\;i_U)Y_IwYQy:ܰ3~&&1QU1)Vp*Z2k$kq\0ԑj&XIcg\"V ̪YdW5ج<cۑ`B3U,0j$!Df[kVC)|XHF*s}FfŹbFUy\n9ٖaNZ*2|ӏ+bTN>jjM-=$yYlʊ.6x7[0T*\'N*nIF|N2#X6AeaWr}CoۙFZ|DYki^5#!du*]EneRYJM.ZmAѶ^-Eb_*]\0\'wH\\`n:-:ɒ>#Fr\0S$	@\n9 A]Xe%/bFQTwwOcM|x\\*xqFtI)B*9$J2i[\0Ut1ncܚ*&G,Ĵ#oQ\n)	\0>=?}g\nR_;[^c;J/nNwhx<~YiRBc%~~a\r@K\ZE(/lfYpBrHFyWu샹kVݤܭ;r#aʬ0\Z_^ic;۴7JkFbw)I:11c9ՔhS{ZM\\9f[cREC7,Ej،myթ\Zp]x.ldpӡF98)(6wWΚmjewDlŅ.B*0gjhGv%>l7K+y*7R6$Gi{Q]\"~R>1ヸ:WO`i1gE*B+ą yﭓׄkV9A(U\'YTVjRjvj\\x{19^coխV-r~G%ΜS\\sY/m%󫤛MGx%bkSoE1]FAy-+0o2i%1c\ry|A&xVk8$`|DB&0QʭFU&.$`&*\nM<dsO	Z^Ecjr8x*X~I44TiqFmŘJ9d\'F*C0҃,&273;R\'GG+:qnob=8Lf;%v)d&Y8\")<f2θ1\\ټAQ]Gt\\\\/lKq4o3.Md.рEI0]SV\'99Xma/S21Hbwgz=*3W^,_dʡfzqJI?~Ҵg0x2\\U৘0jOO)cqTӔ+JG^qM:QeBC22ht<Omy+L0clbVMtK<onGR7;}(vȍc1%~u~fQPCF&<F0vT`c$\Z:KWo$K\n	VGF受UqޞVznчpSjF\\j\\ڣq4Nv_es	Ԝ0SVAb\ns\nJU(7WZzK,[&Uӭg=	rmf؄[2腘Z|1U4鄐;o.\\1dm\\M;Mm4bYV\"À	~|\rEȪUB\rYInkԝW*0snr2Ee>V+{Yex+XT)Q,&jW^ҽ9bVTyk<L34U[đ<)yI%4*	GRINti!,`Ws-ͦ,ϵiN:+#.1جEhYݏ87l8Q\\7\\`q\ZNJuc>zTtܝhÑs줓y	9N<{^ĿQ2pPXX)ap}|Tj5RT_Jj4UBoW\ZYOSCwoH`΢>{Gn-29 Ư%}&\"cM lαA4i<ֳY[$mE|%<n͎j5a!3\0G&ɮ]um.>x-ExֱAJPpcLL<d\"u<efiq0\"yеeR)FJu\ZMIJ47V?~?y_Բo\'	M*x\\%WZFGO*n37*^Ư׶ZIKjo--d{2q%PJ~,{_m3]_mH̢+[0IWLѳ倵D@VQ]m~ዙo/5kKXnB\"EAc#ɯuۻ-*]27\'O\\+欑2&-IY@T.2ڵJQy=\'J5cMWNx,3R6,{<˲lǋ\n8pk+Nyfi_N9)SL\rFp¹	^qo]4\ZQl8dˆm6iW\rMAs׸ҼM>nt?P;BC\\*!&Ԉ8f\'9i?MV^Z.<=E9TycD\\ʫ\0^N6؝HH+].il\'io	Gh\nxʾO\nxjU}z5a9ia2hƍ5VIa0(ӝ*q.~4?\\[5&csY~Zh;O/IWc1^54å\Zxj5S<gXjm{=HT(o%bckו\'YITVA&Avh*Xu<uDiLGPʠ^}C5lEHng!me@\08\0@}E8bat	V3B-JBu)JJ\n3+NUe)5|@d&;S`;\n}Ub04qybqSTMՃ\n좰HollrO--&H(Ϡ\\RGiEx8+%H\\4LHSxH\\ˮƓ\\D!0ngHC*),~Up1gYApGi$|`xHܱ$< Wh*s\')/cF8$RI]4n߸ukeC/\nXZd*b3|1leJn)^gx8ʄ*(\\\r\04Xf2oĖh#_#Iڢ-MjIC<JbH cdVsY~=O)L9# $rNs1mmnŵ\\5fXቶG2(\0$\0,INN~8VkGiyǕE%N?(kC;Υŵ:_Y(r煊7TjOP.xYΤ%PCeL4+!HJ@\Zgݩ,`ti-3$X/\"BB^ NCuU$Bn=JOs\\jW\\Z$ *IplإbihM<ǒJKVJ߈0]-gOXZ2)JcNpa%ӛTUhYmuPL+:(?t;R;EmIuYK)`H#..&[;)pZP&`\nǃI$`V,pUNs+,E9R\\W9vK[9l]c짜aT14qu\"TKUR4Nh]..qjMEƼ0۫Qت[8Td/I34Q`ڬ%qTYe@@9RI,\0M;VO,`1($.\'g\' ?s,\0mHuXb\rf2\'h\'tٸ=V(rskN1wH]_]Z9ֆUBP*SFq,V-ʔeJ.TykN2PAJIU;KcƂ=prC:KP8u5UdnNi`ÙggpNBU\0EbҾ7n#dDD։QeHGLs7:u,Fnna\n3lE2[ԃ\0)ғnr39ch6puKkݟ+Ϩ43J9],ETj{7[SZ\r(xxQIZSxʮqۑ_jM[{h$Am>#1\0~U<|7.a(ENcBB2vSkrSRb8UOm]F|;@~XV2H~!yTAN^SSNu=KAMݳ9{Z.*iTheS:	֎aA\\f)b{L/n1Hlr1\'>V7IEv}W\0?\r~_ʾ)Siږ*MlOEݟ',0,0,0,'','CAJA',0,1),(29,'','555469','','mejorando el registros',0.000,0.000,0.000,0,1,0,'Producto Terminado',1,NULL,NULL,NULL,NULL,'','CAJA',0,1),(30,'','2224445555','','codigo test',758.000,0.000,900.000,0,1,0,'Producto Terminado',1,NULL,0,0,0,'','CAJA',0,1),(31,'6325411','58479658','5548968','codigo test',100.000,110.000,115.000,10,1,0,'Producto Terminado',1,'\0JFIF\0\0\0\0\0\0\0C\0		\n\r\Z\Z $.\' \",#(7),01444\'9=82<.342\0C			\r\r2!!22222222222222222222222222222222222222222222222222\0+\"\"\0\0\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0}\0!1AQa\"q2#BR$3br	\n\Z%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0\0\0\0\0\0	\n\0\0\0w\0!1AQaq\"2B	#3Rbr\n$4%\Z&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0?\0;b7QqXf(?3b1N3b1N3\\CqI~)1N7bQq+\\C1I~)1N31Iw(<LS3⍴!\"B(&*LRbGLT\"n*B)1Nj)bsLRb1E7b1En)1NqbQpLT;f)1OqbQpLT#E,EcB\n\\H2\0\\qzSp4\rVybGF֭5ȧH<\n:~;#\\u<\r\nNZ_ԩ`Ư\Zb(<aH>rq]Q	G.kQ<hQݍA!i\n̇_|7OW/\rG슧a#dFFN\0$BGZD&@ס^?Jgs<T0*fUh^w+w믑X7	[s#d#!ꤊn+c%$gϴӳ#\"!Iq&);a␊wQNccWјQ.qI~(;Q~)1Ef(?1O&)VLqN0:<Nr@Oy>8,;_}Yӄ<EU}\nmq<EU\\|o1E\05h\"rt?\\W*9kʹ:NyT{GeY\nqjKϐع+ Gׁ\\V}c{sq+󓜞Uj/䳬ap}\Zů) B	\\(qٌw0qB=YOᕖ-J$>g\0fk\\[\'1)9tx&R03?*ܿ:]ш#=p+^zIV>2r[^ߡgEEPy1?F\r=GeۂFq;M,%1ˏLqYޟ-޻)QESk{|&4.7>RE\'+zjޙsp&\nTc1Lb̊GJoin[jussz叻bA[mTq+&3\0	9Q[\nrqYEٜSZ3\\^VZ25)AGزLl1x(Jg~L<~Tk5.F3␊q\")1NE&(4H폻57]L#X\'+ʖy#~_ceR:oIHR4lSz\\6)\ZGTQb\0HUq咳,ǣ_K\ZȐX=ۯc@J߉ꬶ631O&+ڹ7b1En)1Op1O&(\\VMj@9Z	*EnCm88(E/upr^1o6vJc\'dM!ĳsZzC VyE~z.k,F\0>㳺)BQ릪G4og_znQ\\ivRT26&;u98cW0tWV\0?s\0.vurąNkD\0L1\0\Z|juM6&ǰ n)W}uX>\Zvd#\rE\n\n<=3*9\rp6୪D#4KV8W;\rjDB߼CV7eEKz\Z|vP~Y\0\Z宥QεU+8;dA(2M6\0ReQ%\0f9t-#l̈G`D@\\\r(6wjFFS-Dg-tV7)XNG+؟jh\'c8ڝxH#\"]iss75ʆj7pe=\0U~k+\n d+`vNMYPDWK8[sqW˺HWnˑTWGUJ.Z3$8\" P@\'hCr\0;WkPymC	^JVz-rNjKwIV^\n~Mg)9$+ɻw9Wm\r%\nʹt6v]2qqL6HX_Gg)Q%>\0yb\'+sEW\'j\0#5^f~(?bSV1O&(Xn(;QqXn)1N\\,7Dcq#\\6m\'\0\0\' }qSqU]@iA+QjWqzzcz\'UtQ\0ƹs3#\'RiO\'?9u\"|5G)ijϩchCAs\Z)\\jA\ZF\0_jMY:yR2A;2x=\05NSGу=roiώrg5)rexEz10k:Mb\'i8X215GWs\nݷsZJWsfsך^o.gSk8W<Tm@&?sQ\\cWrX<l/y*n	Ĺi<{\Zi<casu*N`\n\0\\?X[[W7@T\\⡸l\\Di6ѩNvkl~*o_Kw5jdӦV?0Lk-C̸$qWO5 ,cU%,MYK\"4P!$	K1lA\0¢1Iay7JpGUWwrc\\bWrm7KTGXZVi3 °l$mJv-tS\n?\nT9I]*R~.k6m6۹8ʲuFٴ4\\LW,K6seuI}}?&uICsEeFbSIp))أ\0Rb1Ef(;be@PriS6\\_ƦK_ٟԥ_Rj;a:|շe[	# }\0={$G|kIC&GU^3=b5-{aiQ7)R*m85>h˚7=DJSURRh\0,:x5_TM.=UYJߺz2?\Z2@gG6k?4\0ta	u<݇\"RUp4 ~gɺxI7s9;]Пԡ9Iү)$$+Bky\0*BI=j{r91捎F3tʻT1T\'W^|﹍84!lf#eA;dvF!rIH/TO-\\3VpS>r{סE&\0\"y=caZY*c_i|M_Ira:5g2JsqZ]?S(%&`]3ܵƗg ZRB/\0ci嵩e21L*,\0\Z׊OPqLzy2+o/\0)7;t24vp|\Z<@R1WRwEXx=hY\0M|QuqF)b\r/Y(iqY76.}8ּ1x\ZJQ4كbm7d4#ka&vߧ+7ziƝhmm>S5RbK\00{Wf|A^.ױ2p6u\\\'t@nEqQӰDBmھQɭFmQ[corihQB=uFG5;]\0ƹYc1_C^:天)?tƸN!:|ڻ(g\'MwW2AUmX\rJһ\Z-\Z:[!>}\\oaă5IpO];\":0a>_ݩ\Zvw!$h09\r\0`<g\0|J5xuh9J&;>\rjAIa4ш͜E^dj-$c-ukr64mZ5%V8_=?ZΔ`S3dSTІGb*<9p:+t[7ui=6sea[ۑ	C\0XS\rZ&Z3+@yW\'g;f$Ծ%|{19]Td<f3:Wε5Za]TexeY#r ]ej:|s3)F%h![sYmnNAMS/LvdautC0֊ԓqE;bPh;bV$ѝ;S_nⰼJ]د iߩeBG9hlf< f5d<(\'pKqek׌RO5(_ԓoٟSWix<{uO̪n[:>ʹF\'Knųc[vs@\rs%c=9y$۷\"L-R*jv;ZZ+}6ayT.6$J]G{;u<2g=c5PFbW*CtNH&]^\rui(hńPk;)?4y_è\0>Ն*Ah0Il.}z⹌DZ\0Dw^=ƙtBp`枦֗ڵ;h@i~Uq=ި\n9ĺl@>?:߿k2͊n2O:Ky-V9v3đ<}*l|uUsBՕɳY3]B\0<zæӟV-FV-k dEe۵FF\Z֒XDmr\0֭}_HvZ\0D_Q]yf&2P1s~k7ٯc8+RƑqF\rnry+ z寢1Q\"_ ֺMi|9$ߡe5XWzhor2vȨԱEu[KkHq##=>u[RvCEcEC\nAxI?\"q7QGEj>SIv(~sl7brGN솢۲V,ӛ%d؃Z3}8!9 zV~ʪ1G8_fVTi{/F	NK+jqoҦ˚d\0qg9G^*dh&(2W]8G[x5^Q+\nv<{tf44?w utc\"Ԓk7J=?iG Qf\nTM/hU1 ܑBwݨ]kl	̒yy~M`̩ũ]u`d sǿZ.0Lѷ#ߴ|ǏZZ$\ZށpL)z8t׽2|>Y|dxo-ppV\Zaf?\Z?zЦcPzIVƉxlyg#=MrZYެMG(1^Il\"47WncN^n={F0*N;}}jXԢh%;|L>y_h$6\';]\n,y`:`kHghחv.Y8;ָ[\0(Gz0(SKVZO*@jZ*q1\\\nx_&)t!\\rG\\S^iON6sʺ#l3d)\r+/e+ѱPimfq_ēOsVk2ppk=\\v2X9Ohīj\0]P{k[O=ⓇS޽6z2k\rPgh+31I_\0貊xuwKC˕Qۯ6Vї4nI]XJ(Е6ClWl|T\rt\'UOcp<ZHMJY^_U-u<ڤ6;c?ֹXwS+mm\"Oo\n}|Uq	Gw1bF3!0h`(]]})w_y4Pwl*Jڽ)՚=k_f6@o?ξ4ㅇ,\03IVw{q\\Wڿ*cZos^0޾	өQ{QѧP/#gQl֌HDc9U+9XnƎ`s6<z)\r|zV\ZU>涡Ԣhŭa܇ZhPQ[M#Vb{5G̜Ef<Kds27Rբҩ)sA\nRH%5ZsKE<Wy4<`aF\\4%db<,Kjem?0֙pؿ>sqJg ֕iieBӼV׹bk=#T>շ	H=R@qj\nj\Z\\[d,sEZ]RyJ90kJXzhʢZpmٽ-V+U-2Pۜ0*;m]5\\|{	fkk;0UMmSު7!\0d?oܦlˀoO5kԬ%Q1F׭a$ov{r?Qƽ?X	S{\03X>=$_s2{%Jwֹ?#t{(:՞V)kKJk!<?\\τR9dD}nPq֮,ǽexb])F3^)F|p76<Ub~#P)cߣV؞a@O\0KIu[?ܞ6\0ֹφ-o}*l|̍\0~˛(3W{2HHSoƟhf=r8IKJOLp++[YAQ0ؘN3SV^ntvwdÚk\0~]NFR}3w9~Qb:ЧR-]h*s\Zh-c1SY;ݍ]6mi>SּzQWֶ3\'bBwz׈/\\7\0jMMŰ+BQȤɦ]ݘR3#F0\\g\0vS9>e\Z1wv6>{>ߕG5&9tdQAu.I/-)	޲ltoOOybF:^sѓo:A{>Zvߊ+j_u6ԟzB9~̅#Oz-Ʈ\n`2\0E\"@f!v2WO+RGR[8(>`@泒@YޯqZbwQ>.rv.q}\ZeQcUሮoDkHKm2	<SkQYq?J.|\r;\\A&ɥR?y+Q}g-18`lt#r\0N&tTEƏ+Ѱ4̊\0՝iڞ䴴?\ZX\\[ysK+l.!)%Qufo5\\k}r.G\"\rf.&J,m$cПk.lo\".`0:Xʖħc3%8A\'%h,\0j\\;7/\Zm9>Һ\'on2^z\ZkH\r4kcZ:5Aw=4K&wV;B\n\Z//a{9~;le{J?b\rht?޺K@ԓ񟨮b}Pd2,fhӫ<{eʥv{t_}%y{3t> L\\^H\\ߎSvg?Z->fxsQjzF}՝W>VL\rxT}Xk1AfQG\\b&V}ћO&몐Lz*=FR>κT? nGo]}zNaM\'`?Z-ƛm	dă#\"9{Y~S$OOb\\Ʈ7\0õI$\0̌WԖ鞭})-Iƪe\r̆=SqpU2b֑Myy.tm\r}KTy,Т\\yqtMk1-cʑЊdpvXϥV^AC=]JqǞjGwPQ>FI+i`iT8ҽ}Z)c$ƿ>8<WGL7Lw/\"}FG5qXҝ\0#=$%5\0hvOk	O˟^\\s5\0{u#zfo\0[`N&;	.UVC9bI5QOZMsIw\"R{8;ޢT2:O4EOcW4rRw)X	+Y|l=\nuYO)Q\\SR.y?ĄVn.	珑kK˽ggY\\ygJk\n\'8u_]\nܭ\ZEQ<\075;=,c<,wr#L.v\n$=KiL4r>^s֦{˖f*\\rm\"Srt<ƖcG>BF\r]&Φ2~k&<z<<\r]b5<\noNK]ݪ1早Yx~[(@(5\Z^(߻b?/+׭ztNr^/.Dȿֵ֕J[+\nit4߾s\Z[j/dsYz&j	wef@DA8횱i̗SS$0۝ݻszW=\\3մlW)b\rEPԝ_wj}.PH77k\Z9Hk8ӕH{n),R\0\n)I?A\rP4i_y:ס鶭c f*ft>נDrf3ӡ;Rg<8wFW;}^ayl\'a1)ʺZH.{Ra}+ܐpzxab\0EFdF\n3UK׌4e3##Ұ2Oolt}[e8Pq+qs8<*iѦ*vFw^S.kĞ\nB\\i6\0RD*V/hvc+]^xSBZHeݒsHK	߲ʨ2a][u\'+\0]/c_asnܟ	؀GXW^Q*4t׎KH6A>WmScOop797~c<H9rZK,Ԯ[2yTjcH)cdt5v\'7B-NUWyY:?\nƴz4D}4pO鬿7n:c\nQ\\vN[?j?hFygA}+u^F0Y{[B_1KXSJR}O`5c(7QPn8sC\0BdT8$swkxniWZeԗDov-\Z쯞	kΒqzSO\\szVsudc?u9xBt&5Aoe翵oeV*p֦[\Zy#I|>RWnpqJx\nZR:^[KXi)C崨fU$SР1ֱ/aN.ㇼjVpUH(&3hSi^SN߭`\\J;xSSޣl#`w!*A7k!#]Y{e$¾IS)okexN0\0׭\nj8gu4sWz\ZIK\Z238ti\"XР]6I۽wYH1Zw:U1\r-!ñ=Ma\n\'T\\ӒW8wx^JU S	\\ohX\\)%Fq5[?#RԬL<d!\0WscXa_QPWu[\r*ktWibǮGJTnQ]5eL`n~gMpz;J\'X(NQo[7S<T_Oqc,\'r֦K2I_J`mBquֽS(̛HjqwĮw\n\\?K!?P:`w	/w~ԼDͬҡp5<ΟNkͅqu]\\EucYO+V_cp||Q\\uxf.>b	%la]Th{:Gc*؅4u+XmrO/S:ΙXXA?wqZ:ƁcQOZuiB>ޞ\"1iIu\riy1U\0W_{p9$`\n\ZwRGp:ˑKb?xב+F̓:pJkhf}Nrֆ\06z.:VǇc3kV?*mIjv.xHhe$\n9ygD!\Z}C٬(X\0O¼+NZ@I3Z`O9\'V4W7aeWE9WF Ƴ|A;[y,{URzCu`]$\nR%Y_~Y&bOc$	Jp6+Ӌ,MLr gX;VjT]lַmBAmm{)_\\5BZKct7Z*I:oN5Z?o&\0á?w&4F԰nj-\"&/d8ӧO۷!ԖVZyCY$=eLѮ-e1Ru.fcO=̗H#9|0*R~c,`SR)dPEnY\\L[8wv \'珑]=@1T9d⤎xբe\\(Zqw4fs3sF%,cZ/*^U+꺗>k,u0E![uj\0ZXOZ\ncd$͐|zz>(]O	?kyR9Ǒ\0|\0/֨sзO5ʪkX&dAOpFШ)lM\"r C܎G隳ǥbO=]0fK(Ak,3bxJ]|ιIWTƫhp&NP\\-eK+2\Zp5ԍRّ֣\r\0=\"S\"_\rd\0\Z[J]*\nN,SG]h|> \0Jue1	se}|+^_9\'F#mGǀxñhB6.df!n;u\"^;ҙ;2X.V\0zW%EYWoNz\Z0NRKSmWNԄq1Pk*.O ]tƿ:<bH1ܢdшYkSy؈rcfͦ|Y,H#\"F^X9Io?WgW A\0E$|ڱU*iѿ:XE$ΖpBkP܌ƃͣFlt}53cλϛ*U?Aƾ	Ϲر1^uYu\rvk-BG5gM*8Ҵ%F9`]SQK9I5&=dPcS:k2+@9V5u\"~*I\0r*jIw_\n-\'b#iiUQB/^)m%r23Z.~fm\n4[jfm\\6sueeK)L6@qYWj%_uv5:77\0^.As$;\Z)GSҧ\'cԮ.r΍b;iSL	s\\ֽ%jN\nW>T܂cm؞kUWwoȚyrdyq0ۓIVզ˹$g\ZM\Z<W=}u>5(܄9c)禽nI(i&+	rQ$!O|v?drz ꟒xOmSRhQ}\Z9VJM~[R\ZRp}\0Nz\\#\\&}IYIb7)>5Z\\*\r[\\`28\r\ry<<1_8͜	#&]+sn\n8?m\ZěI0\0\Z+qdF!LŘ=>*d)\Z##Xȵ\02ֺ[6qJ+dU!#[ZҶ\\\Z޽;Ќ\0ʜ{(#v[ojp>w`GR?z͝ե|baTV\'*.OJ\Zf=s2{RE#\0WO\'//c[wiN	*7&\0>HXJf8|t8k&5hrAOeWi}֏,ؤS2DhkV3-R}\0+;x˛Ga3pk?\rhH}%զηQJ*Фu5EZ}OC)z2^\0a@خ>\"ws],\ntN9q-xky]GKk}BGܸAYEI@-<6/i1H\Z&=@H(Xd16ܖg?*rW9P@ILԷ\0k`LٛrZ&/voǃZ6؅G\Zcm&Y.PU}joTs4X\0K^T/4`Hʹzf_䕬cx~&tAnr2YqׁYj0^ICpkWӰĥrIc.d5y纙,8k\Z7`Y`\Z֜Rfm\0fՠ1 >潃EӼU+sr\rxei\0֯ͮoso+	wf_Y\'n_ׇ*{~ 6\"4yM5ԑ>vog/#.I5eaAV\rj~F\"δ%t_$XG&{zt6ιX?\n&IfH\nԭ8\0\nqV35QI\\ԭ.;{xD3M^wFt^\\^/L*}&si?8$Q\\/K;3-S-v8h_z{g7:UGps\0J4g( f/Nү׏Jxw\0zXh\'l=jHc2ɎN&,g ?P0kcGgwq&>HQwW8Yĉ,Dfiz٬Y	EGl\Zs-6ю\0J\'EgJ\nq3眧 tnyQ]ψ]r@==`Uv𵬊P\0w,}{.3MM4˧YF5eզYq:֯crϸ,1{qW̾8=8I&KyU?\0sJO٭.$.5hV#7ݡڹOoM9,:\nȾn=	G6?j0qp~G&)\'MsGN9W.<?dj-7 VZ~,v ~M¥\0R5:6Eg4Aʯ7;\\֟7l)8i.lsQ]_ԛM\"\0WDhNL05mr*xsTPTZ(|̟.~rdGvHȤ3hۇލ<L\"#T曧0]GV(0ُ=zTZeMF0z9<Oocݚ΁qVx27fzM:B/cV=II:ІWmxB~6ezr*ֽ7ҽfnNǚ;C^;j`(b3EODr\"F$ZHO<v@i\"h+1[.QMַ$!/5n[QbqU*O:iEm^LJ%K[дK+F@Ўj8=\'lW%UVCߜVL/xkX+#@R1ۊ.`Ez$~.*R;3pLjs\0*h-\0^\\{u c˓my>wTxR^:}\n{	O>M\'DqIm3*샟C^uۛ{ya!ّ#ָadߴ>N`-eonW=Ѽ9\0`5,wfI0+Fǩaݳ\r\'bYYRY]+J܁@3	hu11ԝED5.03CQvhgWwvpc!s\0UM,hEf]+	ʵ\'hɔ.\0~7OeN;*UuZZ1lb^	\'N*Z\\r2HPBe}((H5+K|qRzj8&?KmonERanߑ+\0/b{yʙ\"e%B~T##AEmr\\гznӣ\0U~\0 ۓ\0UIeİk8nQrq$gUwmzsWܒ/CfZOº黫t3\0g~!+2ILZ^bί^+Y?wV\"WưdMJI! @i>W~(UM\r;؅?Z*L7\Z*D=̣DUr߽IۺYzUr߼ut6q\nA5+{\ns&ПV]Eh\'?vWJ/_/hř7H)+%Et=u}IIu޽Et(E%lHTԱM51oO?TI&>ܾ2X~9Vs2>\"_8O!n\r;OFMZ\0?*or=ֳ-96hd\0%??Umj6YTi[d\\\ZqWA3޺\r\\-ޒmـdԡ<Ϗʴ,C\nW%q\0\r<z㚒\rApa\'\'5+Jtu^SKEvlZ6s\n,[\0-J\nve\nqekAXG@^-LkE&y|@̊]~uUn\n=ִy&i!L㹋;=zXYBeQ&٥d嘟bGw+<G0X[rيFU?y\0\\SPO.uu݌SBĢN1OX\ZSN畋VȵMHJKU<,1uk7O$Xg\"b8{ÈdTl$)Z[[kYfήC#6QvЧo! ?Jk\rdcq[#\\ŏ폨Juܑٚ5ür#Jι%/vd5Ruؠu_b6f9yhL|YWSg\\*5[Df42u\nZA4i2<\nI.G\'p+RSC[kh!B1Tb4]}9I RʛQW)@xf1Gj+ܛ.UZnB8?jY\'55Vm5[o+P}r޹TQ\"~Ui\0#T\0|BO_![,r6f,]PiQZR9vmԔՄW}<U\ZRfHi>7s&Ƒkqch1?[MޝoȤb/VO1XTׁ2(d`\rsYyʶ62EstOh?ҳhv9(n~R\raqJI9;)&g끃.!Y9VJӬ?7\0ڴ<?4myz5\"49xj2uײ@x&rH	\\15ӫ#׌;ky%3ҹF?T]:O\0K{5<2u|@tQ*-8or%8?N6w\'?ccZ>!6\Z{@~Y\nz{Uqi$,Y9\'=V3589\0ҟOT;d&χ\0}UToOcӿc6e1\0f5vX\'\\`oi\01Nq\0,:NĲ]6ۓ0a4#/;6I;j?X\06\0rNt2]޵6vO1ZOuoI$kV$~+o6m\Z\0=!7쵍`uy?\r\\k%e1ѓܚab2gw$m+BGH.62V$[@,A8 f\0tEWIY\'iHυKhEN|uOWi[nY9дf=|=9_Qw(hY4WO',NULL,NULL,4,'','CAJA',0,1);

/*Table structure for table `gv_proveedor` */

DROP TABLE IF EXISTS `gv_proveedor`;

CREATE TABLE `gv_proveedor` (
  `idproveedor` int(11) NOT NULL AUTO_INCREMENT,
  `ruc` varchar(50) NOT NULL,
  `razon_social` varchar(150) NOT NULL,
  `direccion` varchar(200) NOT NULL,
  `ciudad` varchar(150) DEFAULT NULL,
  `telefono` varchar(15) DEFAULT NULL,
  `nextel` varchar(15) DEFAULT NULL,
  `movil` varchar(15) DEFAULT NULL,
  `fax` varchar(15) DEFAULT NULL,
  `cta_bancaria` varchar(30) DEFAULT NULL,
  `nom_contacto` varchar(125) DEFAULT NULL,
  `email` varchar(125) DEFAULT NULL,
  `rubro` varchar(125) DEFAULT NULL,
  `productos` text,
  `activo` int(1) DEFAULT '1',
  PRIMARY KEY (`idproveedor`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

/*Data for the table `gv_proveedor` */

insert  into `gv_proveedor`(`idproveedor`,`ruc`,`razon_social`,`direccion`,`ciudad`,`telefono`,`nextel`,`movil`,`fax`,`cta_bancaria`,`nom_contacto`,`email`,`rubro`,`productos`,`activo`) values (1,'4687224','desconodic','otraa direccccionnn desconocidaaa','una ciudad','125-3654','25*165*3695','321654','321654','123-65549876','Contacto descocnocid','elasad@hotmail.com','hoasjdhkdfas','pc,accesorio,etc',1),(2,'555555','nuevoo razon solcial','asinando una direccion nueva','una ciudad','125-3654','25*165*3695','321654','321654','123-65549876','Contacto descocnocid','elasad@hotmail.com','hoasjdhkdfas','pc,accesorio,etc',1),(3,'4687224','desconodic','direccion nueva','una ciudad','125-3654','25*165*3695','321654','321654','123-65549876','Contacto descocnocid','elasad@hotmail.com','hoasjdhkdfas','pc,accesorio,etc',1),(4,'4687224','nuevooo','otra dirreccion mas','una ciudad','125-3654','25*165*3695','321654','321654','123-65549876','Contacto descocnocid','elasad@hotmail.com','hoasjdhkdfas','pc,accesorio,etc',0),(5,'555555','nuevoo razon solcial','Jr. jose galves','una ciudad','125-3654','25*165*3695','321654','321654','123-65549876','Contacto descocnocid','elasad@hotmail.com','hoasjdhkdfas','pc,accesorio,etc',1),(6,'12345658','sfas dffasfsff fasdf','sasfasdfasf','desconocid','3654','6542','2548','2548','214654987','unknow','tesdad@dajsdka.com','sdfasdfasdfsdf','producto1,producto2,producto3',0),(7,'78888899655','proveeedor15','Av. Maritegui 152','sdfasdfa','8897974','79978979','5446464','1655646','98766488979464654','sadfasdf','text@hotmail.com','dasjfhadf','gadgasdf',1),(8,'88888888','James Brown etc','UU.EE. virginia','virginia','548799','564664','8978998','8978998','652896532','deconocido','james@yahoo.es','sin rubro','musica,letras,etc',0),(9,'123456879','Pavaroti','italia','desconocida','326444','265634','4859658','4859658','12345648','james brown','opera@hotmail.com','musica clasica','musica,canto,etc',0);

/*Table structure for table `gv_seriesproducto` */

DROP TABLE IF EXISTS `gv_seriesproducto`;

CREATE TABLE `gv_seriesproducto` (
  `idsp` bigint(20) NOT NULL AUTO_INCREMENT,
  `idproducto` bigint(20) NOT NULL,
  `idcliente` bigint(20) DEFAULT NULL,
  `idproveedor` int(11) DEFAULT NULL,
  `num_serie` varchar(50) DEFAULT NULL,
  `vendido` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`idsp`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `gv_seriesproducto` */

/*Table structure for table `gv_usuario` */

DROP TABLE IF EXISTS `gv_usuario`;

CREATE TABLE `gv_usuario` (
  `idu` int(11) NOT NULL AUTO_INCREMENT,
  `dni` varchar(30) NOT NULL,
  `codigo` varchar(30) NOT NULL,
  `login` varchar(125) NOT NULL,
  `nombre` varchar(185) NOT NULL,
  `apellidos` varchar(185) NOT NULL,
  `foto` longblob,
  `clave` varchar(125) NOT NULL,
  `salt` varchar(125) NOT NULL,
  `fec_nac` bigint(20) DEFAULT NULL,
  `fono` varchar(15) NOT NULL,
  `fono2` varchar(15) DEFAULT NULL,
  `celular` varchar(15) DEFAULT NULL,
  `nextel` varbinary(15) DEFAULT NULL,
  `email` varchar(125) DEFAULT NULL,
  `sexo` enum('H','M') NOT NULL,
  `tipo_cargo` enum('CAJA','COMPRAS','VENTAS','SERVICIO TECNICO','ALMACEN','MULTIPLE') NOT NULL,
  `descripcion` text,
  `activo` tinyint(1) DEFAULT '1',
  `fec_registro` bigint(20) NOT NULL,
  `fec_baja` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`idu`,`dni`,`codigo`,`login`)
) ENGINE=InnoDB AUTO_INCREMENT=36 DEFAULT CHARSET=utf8;

/*Data for the table `gv_usuario` */

insert  into `gv_usuario`(`idu`,`dni`,`codigo`,`login`,`nombre`,`apellidos`,`foto`,`clave`,`salt`,`fec_nac`,`fono`,`fono2`,`celular`,`nextel`,`email`,`sexo`,`tipo_cargo`,`descripcion`,`activo`,`fec_registro`,`fec_baja`) values (24,'9876542','U00000003','tbane','nstas','tesnas',NULL,'2nCMFqT0CWw=','4659852524567892589564',0,'321654','','','','','H','VENTAS','',0,1359655989421,0),(25,'12345687','U00000004','gases','usuario desc','dfasdf','\0JFIF\0\0\0\0\0\0\0C\0		\n\r\Z\Z $.\' \",#(7),01444\'9=82<.342\0C			\r\r2!!22222222222222222222222222222222222222222222222222\0\0,\"\0\0\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0}\0!1AQa\"q2#BR$3br	\n\Z%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0\0\0\0\0\0	\n\0\0\0w\0!1AQaq\"2B	#3Rbr\n$4%\Z&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0?\0O_Z`xdP(QR*:Q@QR\0M\0?4P\0Pc4boQIf)MJ@bRTxb(RKBhTdSP sNS@H6SRor!!9J1Mf 4!0ԛ	1v4j`)Qut0T&y~\\\\ʵ JxP*M9Ԁ\nv()pANHZQMI<P+\nM!5N8c|\nJ<6c<y~:^&nQsn\\w^FQ%oSs	ŚLvÍrsѷ\'ѵб\0X֯\\c)ݳ8!\\3:0\"M˲_7[VKvYt\rm/+}rJⲤmvU,?ىC7qPh68Ԑ|ْeo9c\r&LBV[2\0cMuSZ\\N]-ͅ\\\'܊Rjɧj	GHd~𭞈\"5Qg>p(q^A >鬵\rJ5{+.Gʔd(1`Rz9\\!Ux<]3\0sL$]@?3~C&*\0\Zqeir\'U0.<r7O2)k>ĺEo^*+ZY%a<cQFʏʹw,ay\n̘=OG=OVӖN=O(&Vqi}>X\0~\ZeΟAr89kt/$ayfnmi5GDnv}^^?p/[릟{\0;p|5-:_%xU3!`(_xZ{`$I_Nxff	);zWM{ksuǙV4wݴEM]v+L\"ϥ7ʢV#nڶ\"JTI]0!@CR,d\\E8R,MR\'ҋ⛰R48\r#f^\Zpm=c[8ӎ\0ʗʏ3\\]]v:0UM&]oĳK;ZB<6`^{sٜ\\E}{&\0]\ZGF_?[K,\ZnIY$wgFZwl~f,~HS\r<|/\'/im,+rV?ӥG\"I嶴9x?@8lWF#}ҫJ5sFq.(jriB3NS4h\n]۽1\n5oyG.&6hn\rHzUi̺m;sZ͟X#92qYxn]<n\"DbWqz:ǇLѯ0e׹<m˞kMFч6	|Zk&!~Gb?ߵ{Cuoż,2tt9z]iWϦLRByCzsUO5$Cr=˦ߔh1W1A\r H\'MqDcC0Akm0||ڝ5|<N*΄W__=<aMIjqz?Yޟ7-\\eG\'ay]1ҹZs!mc`x]W\\դ]WМ׳NT ˈ6]^e\'\ZZ\\\'++X8_A/\0Y4*E-}9ӲHTԛ\rE4Hc-@\r \'lTDQ31|&keVY(Y3YX<aJ2jT=+N{UH;WRqT-5{5ʥmVW\\]G\r֭պ2FKӁXV\ZSVv=FIV*uTۢkMq`L9$b2:sЍgMY2tT|C81\\4`O\rM[n\\TݍlW){<)cKcZ\nF(}Xa AExǍiR\\`ّ-Hȅ2\0׎ڮ.#FoXm؈ \"O׿=+iKmEKsS3pAq\nOñ{u\ZC8\0׬{PrhIS3UԻzT:dT+~+udOSҸ/+o\0\0J]9w\\=j߳$\\G#+њɾ(yu/u%}\0?Z[iZs޽12x0Ggּ{Kuq][n9Je^T:M,&1_԰++2\nOס5mcOc̰$?F9*=ɧ(P9XЊsZ2Ug	)C9jPi\\?g\\tfȦRǭ8IJl1OPY\ZGcP)qѓG(\\%EH*O\r.EOpTwA[/xxF\"#w@s(Z>̧DVgB:?<d_v.:G[$dLUxI\n2T&ҟPoZ~<#?{Մ]˹YH zlEZg!͕3$pw_.\\io,b7v+@0#]\0豨-[?_뚵R=Lc\\^uTҮamtہ)d\'3]_ZN*Zzᙩ\\ep5k~<Ӵۑq1鎂tG7:\nKM\nSe\rkX6[AI&;=v\0Ƽ!LK&Iyΰ\'\ZBS-axk$Ds+1wcIKn|kq)\\Vm	F\\լ\ZW6zmn?,Wz{677#WVY/5m@vBKp\0o\ZU)tdiR:Ұ,*UM6Y^-.l(OkQga^5g!KPH\"Ķ~U8|0HKض\Z~of%Hm)]?Enp\"KsW\0tBM3Zԣ{ye+ӷ4?&}#|X4k$mdfa)\\Pێ*Q#@kf jHvvV\'BuPyRz4\Z=U\rZDP:Sw\'Ҭơ~yqذO&3P\r+źx{ī}L?@i7d<7\'YDɂ_TQI9e\\с+\\#K3( `k髧x|\\8}d/afܮPh5j\0Ӄޘ$`I浊).5o÷|=V/t\ni{.$ȷSH}}e7[]ˮKPH!ll~.<]iѐkUW?S!^s}[ˡ|zMd_Ff\ngI^UCĥh)95h$3v*~weVd=MRdngbRrՏP\ZZc?zԺ_4-\rh~u\Z£4g\"E=F*泪,~r@3->DP/>mA\'5Ml15=v\n	$9\0eVE9p+_Ks>8 ֥ ^>ߘH[xmR/>/zUf(M_?;}\"N;F蚤\Zs\"lZB5r&\0~mʸֽ~/Co*F^<Gg}B^\'+0iZjvcxGdr=^^InuƟnA#\0|iM+\\gnz\\1,NN3C\\׻6u[	\Z߯;>\Zݫ>\r{RX6U!\0?{0=oM$IjWm.aDOj֧1G\r:9-hƙg)v2.Q޷5#0+?l>S2=5jd}Mj\"R\"QtA&@IVasdOyI:fNLc+L@\rx6s#VQq}XDY_\r\0Ww\0	0}\n?J]\ZZCj&A	#Iasڔ<cSʟF2\\M@cuea֪?tnֺzr+i2Om8Zm[Y	/f/,dWE7U]NdG7ZqwM,DK\\L\"fg\'\0IK=SY;md8>V14~<WiW.5ic+}M{¾w&)|J6L@[5ZhE:ivV\"E=5{DJǍ|N4Kƙcі»Cx;Ҽ~y<u#ɛ(H\Zh?kʧ8ks[DrYe${5M5bc`yjRfCOջvJܱGx8|C,Gk-ĉdRs]ǃtoXs<S^3\Z@g5+X]G\"N\Z5o\'|6	hrW-odT9\Z9QWVS+JÒ\rkOc5Yc\" >v, \n3)Fj\'uUAA(ǯ~%]D%YW\',;$w+Ԛ.|gaS[Lۗ7ʇ\0?;>haGְhKiY%3¾\\}~7hY#ba؊g:~&𖙬&3s\02?h]tq@{V-@撪؜lg<a:R#zճmJv9յ&bKIڤH\0D\"rEY)H9ڏ61\\OȪ%IVn%)j7Ie]]@H\"yX(\'W	2N$1V@|<I<knY/&x2t	91	>*lKiȯs˘ޒXyNb&c\0	\\ʮC6v:pMq6*a<^WS+(8UIsM&\rلd)ǡ\\\0\Zmx,{u sHͫ3<u]b]Y<΋R>R9һ>O/B {S]:jDDc8,̾U!{#Vnq.,2+#(pizKHRՇs2y-bndCB5Z:<r\\U˶@3E;w=*\"GZ:bO֮Y@\rz`e+=,Kx{f\"=O@P˦OϋdpMcE(mA;gW<\rbgԚx\0x^k:ЪK>x🅼Exb=kL#Hq>az|\\w$dDywGoO5!{D-rqx뱊c=]7/\\i ~eU\Zv\'ڶRM)CMnjKWaȈgmph:#̳	0@s\0zyx{rNۛRX~TZ}74NRX\Z\r)I@\n42MN¹A\"\'XX*5$zSlkgrM;N&c~\'OhYQSpA\nQB@#p5+(0[\\+]p\rm?V/f kJG\'K1\'\05{K\r+F	&}4Ow8ڒa2;o\"5fguI28^nֶpy؁X<ʧ3ƪ[YHr?:v7.u\Z3J+KOlkD&yva{zXCGx.\Z{\"{ʺTV[EojGMGSi+}BS*z_PY3ܩ4ޯwO\'@d\'Gs\\8+r\rtOU\'HtHLiiֲu-#FϰAyo?Pv8pqEz a͜ IX>ӆX~o7?nW w\':V7f{i5yNw=?.G^u,Q7\'Ih($\"0T0-і\0W%ŝ:F*Ñqm궏etNA=Uk[_c$9.@yI@gڲ-$qX~x\Zp3\rxut~%qt9OJO$fڲr?R+GF4\n矖ttRmYP\0U\"Ԭ	\'riCU\r7SV-uGK,g،ugq{\Z\\ij4`AM&qcц?L0oW:\nxaҎfk\0	uu@\\ \rWrcE:;vkoDNg\'	PREFQ#b s9Xб{CTVeV6z>瞔+[;	}@ygRrcWD4j1. ³\ZgUw1f9BKj١h<*~nI<%i#z\ntȚG	5XXע\n+#zJU/73D^%C\\j`s3k#Ĩ~5`\\w.$y\\Im«+s&2~l\0Ji2VW<uL$aI\'\0qY*I㷽tMgvaF\0\\g d6XKRA4<J⚼]\rMX sTu\'\r%b*|o/oҼR;ƹ&\rqȯXsO\'W;GWg7-&TQ#o3\0$^%E_5̴RofvXd\n?:<S\0_ٮGu44.\r;Q6`J{7y{L2IWq96{u\Z1ޟ4ٜ)#e윀77q}{f|3eyk\"$rO\0Wh\ZW/#\0ϧY7m>d1@9kzvL9(ONX\0	^MrV4r&Ϻm#Ek]\Zп<Zϰ\\9&vD6~6q\'?Jmڣjv	\"P2Mc\';Jmqu8ris\0U~8\\<\n9=Xюj`RsD)\n]}{P29<7W?gRpSTn6a\r@?\0c]=7cqƹ]GWMұ\r!lfItxGFrIӷ!=7PyTO\rtJ1G3oG{q&\"+N݃xnVkc[GbOyb`CtztuzV\ngaksw<H#U(ǽ.eٕ_j&Έ+\"= \'5J+[:jQ:2cu#.@|КF8=+ہ$R#kj|DY&F»3{/:8I<	Wwɧ%@dr;L/.NNOA{ҍ5$Oni`wWlt{QKXECGLg4A,R3DH0GֲI9\\Rlo.7ԞO\0xgGo}@?^<O7}v?SWGpvVRZ6.uR_G\n1\0ԃaֹor\rYI]hКf)ه*ݔQ]M8\njXyEu8`A59asڹ&	׵e/,%LnY.(> \'_\'\"ĚE;#{gbT+\05R\rS!Cw!\\HMY&	!ͤYvi=Exީk7B΍Ɠ7 (8#QHԱ=p\0˹IΨ4unxnms{7yBg[MTM/Rn\'=w(<ӟ½s+ŭo5Z=嫡epOG\\WGV3A\"0r:556m܁ڢqz͓Y]9qՌqm$:EKSXx78Lƪ/&QyjH.du\0<>jIL9RqނJ<c2T!#P2@AlSfOo4%#!.W\0$z2XQp<WwR-2iB9<8~?t\0:ΡmyP$H9#4j~{n$*By\\=kFp.۸#|nBFLׅ实xǔ8۟J&֦T7^rFlǂ:=jo Y|ɏSAu\ZZ-AI!C8ִ^;uJOO\'G>*ߌ&`Mԋ>VO:GOU5m:>yB]W gs\\Eu7OE~5Ω-\0W\'irJyk;C:\'iʟ韥s/\r\"p%jF8P\"CIn3W7cbEI	l9tZwQ5a5|7iROov@lmMqMiKlo\'a_N\\,j`^\0CO\" m,I?VA$~Zt\"/>~UGr\0u%hF~?\n\'2$z3GuLN\ryE9rp2sBs.Y\0LN,~bv_gkeÓCx΋^ZEi6\"DʲºdVh95eGJ%y;EYtÛ^?dMI\"YO\",%ʖ\'+o2kf\0i=jk~[Fg*T18sדB.:G7ppSQ-@32o}8Btc\'/.~Dy&cyn{G\0Wff\0cr{?Elaן^c.a O+\n2|0\\nsڇ^FarIrHDzjMrqoaxഖ2/גmcQ[+k[>%ô)NIǿ8BGE?eǘĂ:j=ğ7BWvn?\Z9XՕu۫\\!E(\0+5C֖V#H?6rH<޸t9G:ĳv`7+ FɕEk#QDݟ,z[FgR\0>&QVc:DTbmvf~Fy;Kd,\nϨT^k;k0\nᴒ@z2^#\\ ~`O98={O#X7K6N@8۞f7fYP!橪$|u+m?0kڇu\Zdu@ C\r$99tQX,X)@\0\r)Ew19 @*@\0u\0cC@+9?/VE!U@_Q\0M(q\0Frs8{Sn*9/=;Z( #B`\rÌPtrb<4\0OE]\"mJv=}JN@B3QClvBGgkѭc>QsI3:g\n}y\0\n(wp \r\'{o4}l_i^a#Mof?^\0(JVNK\0C2OiWF%@%p>֊(Rc],c];2-y6,Qق\0Nu_̢3**YE-9>RZpla\n#(<};QE.f; GБ7^GP)G{KvU^x#Ҋ(85Br0NzbHO*@O^xh$G)\'|G˜~}LQ<q֊)<Ssq4ԅd;\ns+?J(\rh̨\\|p\0RQ)-ď,H⦅c*KBNqQ@\\','+ugykyVGj8AB8Ro3ZCQBtw==','40000000U2178654321U00000004',0,'789654','','','','','M','COMPRAS','',1,1359663589203,0),(27,'95135789','U00000006','genius','gener','unknow','\0JFIF\0\0\0\0\0\0\0C\0\0C\0\0,\"\0\0\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0}\0!1AQa\"q2#BR$3br	\n\Z%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0\0\0\0\0\0	\n\0\0\0w\0!1AQaq\"2B	#3Rbr\n$4%\Z&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0?\0UȝpJxBx\'`n ݂Ѳ||0$6y,.whjjR*&W-0pY\\o( @\01\0+ܪ~T*ďjui]I$;hM4t\0I)e7M֖m.zV!~@oԩ\\nS!0*틷ht6\0Fi|2	6Y1\036Y@`FKkEC\\2A\rWÞа7qc U1[]^Wk.\Zh쮚}.FwdVnŝ60%O<ldO2פ0x	\rv@p\0`@TNa܅r\\\"recTd܆̋k!HVP$`76݄y#+vgSQbwzzZNI\'4>\'JTu\0ģ}-Oh.*@\n$\0 QBSHL(,>2wG#H,IY.u\nBGz5n!v\r˝XpۙX6\nof٫4S[vU~Qk+7e޿ѻ-ʐ\naY<}ܑAaU,db(@n*-JV\0U~S266C!I\rB;Q\\p&@&ḅ,\0\0Ğ5KXIFaxSn*ZٻO}RZ4ڽ]h99#BJ\nwCɐ63J(,-AV eCb}Ys,֛QD$pp7|2Z},\0mUeE<(LV6&Օ՗7.vImdO\r*-YIwW}J<qL$3\r0\\YgڱD[aZY3)ʐ,ځ=[\n0܏,OhÓ9Y!\r2NvZ2%Q]9P\'#$?\07B01Gvӽqm٦wd֍=|]mu岶[7~I`Aܽw`*# bpxps6AsWRX6T*Bi\r;lnL\0@YOZVMbR$કe\0e< VuDzx^7IH-6֞l	w~]mdvjOFvM`tHBT3!`Ymd*|Iʶ6`1 `P~WH-Ig\0\nT69BPFńc \na(GBHZ5\'$~[ݓNisYD\0~.7}JDm\"Հ wƥ3/*`0Hes4[i	T%\\.>$L烈4l,>V#&ݻA200;w-ϲ!v8,RpBFyrHfדi{]Ri;ߕ]izl$#m^+kݻg]X|1\nKa ieCQI#lNqyJWb S\r`*\\\0ǥMaʡU%xOxW.lU7\'%9ʤ(U,QV++A+֔V%+E飳勗5K.8iͧ{4z{QZ7u-=w0xL,rN6d8\nr\nU%ʐ0ԕyP&/*دM0`rn ` P<\0T0*4vq*\0wBBbcN]c.K]m굳jTNvvv-.g}vG\r8;T#`!G[x`ܤj%Op4ٗRNpBۊk\0Fr@ܙ8A\"S$(\"(E m\\#Qgr1uBFђĂPNaM^N]^j	7+5I$φ^)Y$[\\7]vLwK2/Ⱦ_ -	Vbj)jg1!Vʠ2FIC%6عVb1%vlA%H\n!B>nGf;ʓ#%n$/sy]rK-9EGךVz(K-P弭Vi&ZO{M]<R&}\'ifbI<=尔HpNSțXT9oHsc.1	^AbI#+\\Hv nP7)q*n*RP2\'Eԣtw}m-M-cfއcjyl՚Mo(=}O4`\nT&J_H9bA,Q\Z$x|˓\0(Ò]`[JoB,4axՀA,6+?aR7`)`\rXpi~rMz)5tqKj]w,4iӚqm^Mݴj\0=nݛ嚄7\0A,@I,w\r@,q,BY\00*H>}\Z\nr@!O?1䁟w98C\\,[8PĲ,Yp9SZr(VM;\\Vkwl9˗rM.U3I],Փm{kdRvm<$JuX¹8w%UW\0:%rW?*K\nB\n$e#,+UA#r)<8vEnPHR0v>T(#C\nsVVZ)}t3ݖ.AIwfMZ7{KSswn0 0aR0#snŸ@\0\r z=ɮwerw1K!b:sB#w8̬BQE B T`Fjj6$z_Gd=ϗ/44J-;y#!v.A\\w)	0l18RXyNP\0\0qv^Okq2M*nEVT`QnFp	&|efC$31%qBߝw%&12j|b4ZNPg3ZYe:%hJ]ATo.Vۗ}Tul-ٲpH%@0`a]TOyU#+:d` \0߷~жEd(X2`$Ua!bF[*0<n#%pT#\n;vFz*IYY&&ڲ/ZTt]%km4~Nֶ,59P6GQ\r0ɒǘRX18v[oWJ\0±c@,8|Ĩ,\n\Z-meu#IV=#lF$6UW>Z1\nx%mIVVi&wV5׽\ZIF2ѭvz$K},u\Z2ȋyXK\rMn(TD۝+|32[>`|\n7\06!veb|NoHmbWs8Q#T0fZ 3#TЄ82ߎcs\nny-i՝n7qwi煩wQiM3i-[j)\"ʨn2͵s`b2o=%D{(UB/N]~2R(\0K\\9ێvlvFN>V#!vEPFXv_RQӓ%g~fm\'ys(c8BV2[];9qi۹9\\aNIlmB*6*UW4d|ICSYSIA#2S`P1rXٲ70biHRC\0j*)~Tի(E-5륿\rh[E\0`]@;RT)2En~Ōx\nOB&T6ܲ$tȉ\"C0(VeCm.ߺ	{FHgr	ٝ@ۜ\nvS\\[NᕹyVZIZI5טUj]譪wMKcnC)T܂A\n@HQ,סîF*J*>Aۇ(.zi`K0 G8F#yq	 g8l.Fӟyې\0Rv`sV.[r˕]]|.%hWN;ګ]I$V|)HݒXl\0/ Y `.	i)w,6ϸ|:fn2	P̭n<`!A)*Ym=f- UƵ{FI]6vve&ڳX[fZzn l!E\"L\r;B	]ۂp[f,2;DdO(o5#rUC\nઍvwS_PT@rA 15MDi]\'Qs(Dkrl\0 n%*AS0U9Tl~F܀Bs!u\n˸.Ne,;VfPkt\'pwj*	Q@al81gG!%O*|\n#*(`8!eC#vu\ZRK[u48٥cW2aH(BXd%HR.CEݛʪnJ|u ށ\n#kV\n[{DxV`>`/Y4y[$:3\0W%FvكuC0ո+5i5cgd⫗S%N;+-uk>>-46ǂc= pJi\0\\	/$m\";XdaqqFpG*9.T0$!c#`\n\r`((X|Aj0lRT⩎6n2MFRjkVމk&԰4{k++--k-X1~j|+̤3N<i5XػJT7;C\nwzF@H\r\r9r)^cjlW\'|~~g8\\&\"rQ~ӓW慛GcT)dI)-\Zn{jVW$I@rw?2IXW]eT@mVa\'EQ\0G\0c.Qv-s@@	P:\\u!䃵P&1fM+\',Nr<BmYRKM㰜KZ4kmtjѭ<PVJBDC;Uʛm.h}$C.mz3)9_Lԡ@X og-H	Wff(+6rw\\\0ە~bQ6n%$杣ܩ$Ӿ;|eW3j*Z_]mV1n$+`*_BF͌``=I._p*0YEŗRK3)8ʑn%Ai*\0rlnb HIIك2s̬Z/\\OX+*PMSJN_i]魯kmf]ݲ\"0^W~w*1SjG|NBL+ARC1|bqݍ6}\"A@\\@bwRːȮa\\4{#.O$\rc!T@.SIA+Dqˬ\05V\\>m(zZM;i%{cujRFŰX0anʱ݀\0bT8秳m#ubN\r@9@|t8(	b9-.	^\\\0aYa$m@<PN0[sq}e$I+ok+\'EeZAo̟#{[knuHsG/75,ڗ٣.̗zT%%[98y;\0t\0F\0GGykbKUQ\0QC8%.B?Ԣ|@ڥZͧZ=ݥɶ!<\r\r7v!<<*;W,e,nUL=6c25,]xbk59Oȡ\Zu%8	:vOJ1VwsĹ-FkPjaAEЫF8TɶNu.[ N8\'j\0A\0]ŋfvmq\'$b38܍vY@	r\0b\\%\02w(#b1Eqʔڌۂ@!~USV\'``rQlԴv\\Fގ=mf_9O)jw[=o޶WPTmb8;q	݆Q/ޟ	]x|->V8G4<Guq,PN0&Ht5	I⹼NH$heHF]$6.pR1*dqL~|#)?P<WMlFaH\0hgOe޴a8pj^IS\n#:ԜiJm9d%bZ-f5*tJOM<F%SBFUYJZ*Qj^]}kZ_ic\r&[^^ŧYxbk3n֫CawEk\r-}gd9ed\n質ȪV@+(H?O9|\0QW[CZv=fѵӮkwNk֍$Q#w?߄ Mj׶:l&crA-P[<1{sq<8Rb\\L+aq(\r\Z1#Mqڞuy_B0BJ^\nsJ)N3&UoF\Zj}DD!v$FQ񸐤a*kV$܌7{\nU,\0JI;PUI\rD`6N	]J8eRW$ W|/ymdcHYIb[hŷUbiFqզ|2qItWqK,V7iÚwoU]TVwB\'NH*~\\9Q0%qmʰbI\\WwV`X+%6֕99]g	\\ߜddtQw`\"rUQKjzĆ=ANn+ɧxͧvںj8利M&M4k~-Min)7\\]ë)Rvnm<#~[O!0Lą.\0e my\\>PO Ż?w)`9\0:e5(˖I=vV~#Nhc,E\0mm쵳9h-8KFFᓵH@G/`X{Bq~+\0w|r2GsdLd Sw pCgykaNOoJI-ye7{Y{4{6eS[hS$\0\n/\0\rımH3`Od2dF\nĀ3WNKQ\0P9ݓ*\0D|@cp\'\rhc]?1mEK^v+[I[gwOFꥋqwvK+mf@6I\\d)ARHN\0~U]89@~.c9A\r0-q\0?7e%<d@P\nH=n_ 3w$*V(8F3OQ~W+fA8ui׭Ib8UXN weXVEJhR\"\0Qi9`JCn\'abU`\nT8bW+\n2ERqdPҰX6 )(!rW\'k[efo&GFGQJdvwk=u1Zpv\n*Ba\0l,y4{I\n\0\\UJ\nfa0u.CV\rT>fIϗ ($jj`*.R96;#qW.Ei+ٵlW_)s+R*#M[oӯg{oO@A uO>1\nNIlqO.E$TnR \0݂y ЈЩPIy\0HPp2Oʄ1\\J$RJ˚ͤޒm-tqMn=gVVv[}m4{Vo⠲`{~\\<2l*_r\r>PGv|8˔B	17	d,K2\07QOQ<`Gl\0\'ve*<M;%(S:QS\\	oGmw]W/!p`\nJ*>x\0Yv*JC\\\'nq\nKe	\\z葉;7Vm&Sb\"E*Hb],Ubn #qR!X0qĥexNqrNҽ+rjt{#י1Z]mgt:\'lĠb6wPrX`Py8*ClÍFmڪH[u\nI W,ȫ9\\,i7*J:pT!`p\n0Q$<1_pan|^IYs>i+ܓն\\N_료RK=[n)vĨ?(!~PC}%w~$s8YR&I^\r6m\0LU`y+&8%Ax\0R,JW&n%$޶[>fSnKi1&9(E)9Y5m޶Zmm8E}َ8 O	\0n,\')+6qǌi\0\0;Yv=\nh$`ɴ=v>Nr8B@o-BX*6x!`>TÐA0wm׹+\'vN<9_[9ʜn6KQmtR߿Xƙ~,r݂pX}[$x$$O, \0$;IA\'+;*w54J$}ʡ,fL9fUl\0a0Ĥݷr[E_is[]7ʡJ0vy^I-?H<q:MToe%i#ɟ}	H8m))Ow|<$/lt$yp`%>g1fFRTJkf~\0[{}%D;mEa269r	fK+	(Yg/QC9C\nduJRgTs^¦ҧƌj*oyvs&3\ZjlƋ5ʍ\\:5V]\n8(Hr}]W[wY-EA{\nwZRr>VEHbڔC3%pyd;L`o$>ɴ%eJ\0>>{em;I	\"Bs\n%X*׋\0%A*]A\")!>^\\_dycIF6[m&W~^gYmޫs<abcU5}i9Y朮rmK.coe[\"f)%!iZ3Y]&K2d˯P?<i!&->_Io`>J`.ug-݋K;c$Ӯ[JlԦ{-V]^$dXf*)a!UH(TW5\rnxKyqr5.d^C$<G1Xk0ե#,DiХNM[iR(*4QiJc,cK\rY1Shau(J\Z**\'JT^98Ηy$!#.bp7]$}w2kI*{˨1C_oxIKVmm}2XG/sm4K1Y\"{ylG\r^\Z>\\	cv.4bU\\|ɻ;ɻrʍęWWݸb0\'\rQBGJN)ƫR~=\';\\缏+8\'r%О!JqM8FItM(TՌe:nn\rђែџE}gD:Xv8Fo\\YI\r*14r3/KŚ>k~Ԣ4/u;g]i΍p!\ZcMk4sGm+5+i&ꅉ7I3+%/$pv9k$evV{oW^DQdPLVD$2Yxa)`Py\\Uz\'_N>&)FU\\>XQjqruZlƇ\0rlJ*tףRPn%n咩\'ʥ)\0MX\nȜp0\0lnlo 0İ-lb]1SUap\\_\n?mܦG4}GO}fa4Y|lQQ]VgðvvÏfZE4>D%S\"M[IeS7$-𹷷˫a*QsqSjrRJPQWrťth7+\n+3T1tO\ZwJ6忶Wyy&8[=JHݎ<:vvv9#;:$@ 6w]`Z%m NB\\u9_$rC6+pCpr!8\n7%g%\'*OE-י]>:ԧ(+w^{$WwWJ.Ԫ4\nam\0*cv@ޱaO<,ƿ[wH\ZnRVΐGk;BN%ps\Z |0>W.ah^(ڝՌYt	癌g*@rѶ\"S\'eyqXu,6\'V(B5e*pvT[2WR4)r_gzҞ<Xe%*P9҄NP\n$F=\".|G=ͽֳ&@IA(du+< )^v\r22pBtWJ8\nXO/p+lwZ[&YlYʙSE&W#h_仂̎W5纮3I}r)ew 4\r89#\"<ES(w*ij6\\Y{Y6iLa9fl]\n\ZUaMћ*SS|뗕F=\\rc*\nP\0ʀ`;#vUTIyvcp.`Ć%FY#W#]-Ėw\"\0i9.cEhw^X?+QUqXnݕ=Wc8#\'\nz1ϱK8\ZVQSnm4vImtOrHך3\\$u5t|\0e\'foGI\'үe\">A*瀥EaG|	$#**Al1H\0FUv2\n\0FK0nP,͹HC7fBidӳJpO߽di4fatT}-tӶK=ݺĀsbA!dn%,lrCl,$巜`ecF\09cCh#\'f\rTc(ep5ZC\rR1F!\nX`QwqRW\']ٷ}_e^Iɤ$$ov]FM1Lg\01| W]H r)E̛98`\0/\"\\Ilt:ʱ+;9PQWca;YI ^\Z}#\'r֔qzZOIV}UrsqKk;]Ⱥbd2[ʜlW,8g`)+1%`cqSŔ8K]@̌ʹ\r%[;Pwn*I`kK;dbF$|&J(,۰bh݃Ge<b;kZݩ%oy4ݮvS?Eo[]YfKoR1/f8P2m?1*wl4\Zs ${UVڌ4pTʞHBQ6|m\'s#c?7J)-_dnfr/#JҔey76y7⭗FyQxY:[cԢ¹φʅ$b8 CdyiXfw8q$:ْ\nz{[#*a!9$9B~pvX#j0E``2ce-+(f|\0\0z9F|CX-t.E|3,Ud쯳mez;RvSrϝ4TP,G+\Z+8&M$`o,U\\~pT2e)/3]bwnf*sA*m_j]D\naw1;J^4,TY3I9Msrzlb2{I䕺YdO]p|ೕ=S\0Wݓx7X\0aՊ+[p]Ԏch!X[$0WՉ\ro4nЬ;*p^.δSI6լ+96i˥fY\ZJϖot=__4jl.\0%T`e,6s\0# NHzw^Q0aU\\6Ge1(%jxՁ\',	)T2OLq2I;4䥣i{uuv|//gFIue{^;JesY6?1A#pC\r.1\Z.ϹAfʌˀ3`:ÃRI4	2IbHXU5b3cF6!e\0I	T(\0(@G0-*ŧyI1䋷5^BZ)pmڒ{k~X\'},5ń7xt	\0$ ~R)R.LO6t \nJ[v	IB@p#$|ώ7w΀WqP7x\"1\nTPIo-A/tR\rI+`cR\n-ٻ;6N:]i*U#\'VZ\\ti;]5};>#Uv~I;D>p*}\0>SԿgk#}\ZE֥/m)d#o.Tq\'cQLffܻ@v$Rpm/YuwsK2²hH#Ȫ%+h̨\0aC1PR7iG²UF7tܥehyFrrJcTP\"樹5gg)GI\'ԭZ{&iN#QFb[q&|PX5l<6Z{LcW¶4śt%s(zd.caK-RO^|J6\0vrXLI/zȈYdDnj	GpKǐoU]_S<ct֭(aqԫP55uRxyF97N]J\\hPĬ2q9l04Jq=*ޝ\ZkN:uõJ(Wϖe$6<ܰn7ʽNHb@YP0I <\0r[eX\rM9O,*IauW%wcafbA#j$Hѣ\ni,>\rbp$WǨZKMe$⬣vg{ms8R)1yZj.Nꥢ{ja6#rgđX۞4CAkq:vOk2]:uigkwwa4dS/*ۿPH\0eT48SoFEڄ\rᮛj\Z\n[&Km$$R&_ۼBAĜoR\ZX~z΃ZM86Ҭ*sFw	Dv\\~_(e}\rZ2R<5%N$ܨNg(^j$Jdn⵿fMlaeo<Q]2)H̡jv*erN|I%;F)|Sڻڍ3DӭK$kXL4FWcqnPNTۂq `@nWcKx*(HRQMB7}gTm+5lK\rF\"c(ʶԔRh=7Q\\+]_>M:v`H-ʡ e\\p8=J333egUm,-:$\0\rRKYG,>IBW8`#$i#G#.@ݸ\0I\'egƨ^IKH:J&ںz_䳞LMXOBq<Z{\Zj&[O\0VH.!.3g]FYlK;ۺLL #յK-0SG^\\^,Eu\"A0zψecX0YxlfF+互km[k~#O,oo֧iZ[3n3=*&1m}!Tj\'JpR+UtsB7JN??>A^`_UU^c:0xJ*؈%^Q5M$=NҴo\"@qi\ZDU7^i	Jyvq1^I^+4x-=9tºvn\ros%ݵKr,Etmr\0\'լ0Vv6\"ZhPZX<ܙAw!\\s\n=Ov}v{6JQ\rd˼u6	.-$H74jxobfJR*tjG*I>I{.6P^pPs:©MQuC	Jq%\ZN%<M(QV4U%8ߞ,r4:	VDPg+1o6r@YX<nO\nr^pά[F~̚Ԗ6x\'Ԕ=o$%Ց^D<S >?x_:$SoKav42\ZVI^<2c\nug(Δg8:ѩ\'e.~7եbp6/gq|\Z4dKs9#Nj\\)9R\\\"p<Ve$6\n,H# \'zc?PX*xܐ0rI I`Wk#Z8&\0P,-E䥦S)Bay¼U{$GH2:E.|(q]5$)TʪCYQtzjZ^_XqnK8BJ*\Zwmy-l:Bec`H\0>gp%J<e\Zd.0	fT6d\\RKYUd6[m_9\n>ԉeDhdoccnB㕯{	s(ԔнI^Q+^Qi;8n{4KNᙀ\n_rr\06B5A\ZPQm,wP%)%N%]Ձ]EYU3JAVr\ne&y卪0ySUP2B;Wrr\\CtdSkFݚ曓_W~O^X\rӋjZ-ujֽWҹ$%\\)\\͸a\0A)pݰkdl+CIU۞CdpfY\'bv!W%iQ<(˸ɍ2[yCUW9#iė;nm>JV}ji{~~eyb+	WR!\0!,~\\ Xcr\n$v(EƁx a|N ,<{J(NCF$# /kpFPy\\\rySf`\0K5Fg̯NVͦ&i?y_3W;og\'m-uǖBey\0reE*Brw3m$MszP1H2L\n	1}9prF ʩ\0y\0B++|ۊ¹(C.N9a7yx)c[e)^+ifKU}>{r4ܕkX\'wjvur7rCp\rh**ø\\\0yqPwj(.9ܬ\0ԻfA gmcB30.8v8ʪ	gs#H\0(Fˊ#۞*RnKd|Zh澽򸬷-ҡ)OvRֺʹ4#\0dY,A$ʻ۪pd+H s\01,tei!ذ8f$mLmʰb/uBA,A9,wgs1l\rH<ז+Sݬ+;t+^Wzw\\vwiޭ\'?C|VԚP:sm/lmeG- Xm	!3<ln#dFohKKD^W*Pv#1\07nyic\0Iġrv$OK}]mFĢcp8E0!G8_Nu*Tի	n4\0w8cmgVQSZ._eBo̔㇧iGNNSTc)8?f+ܦ4W+I0Nf<o9\nP@|?0p2܅gٱw*&ܶT/T2`啎3B`lA#\06݆H)p~rK:(,H8QmPI$ےnߺ媌}֟K+RS.YYT\\V1dǅ$OW@g]Akt9R>lU*J1wwd`	O_pmp1=~S<l\\S\0嶪9Ќf#@n}9SO;MI+ENMJ<j5nR3I+i+7%g\0K	[yR#ƌȅJl0o%70a_ᅽ՞m[xV[QKlf,^\'p#~[Ij~`foAdݕTVmSEL4a\"Ax$YǛK/L\'BI,fJq/\r˱EJliNQ:hNf89rt5F	F5QRX,eغuBJ3Ԥ9PrҭR*^5HF/ɼI\"I (bnWx$\r#e9ʩ%HnC4\"\r	d29NŒ^&mCn|-5A*3C,ܒ+XVXX~tw>/i?uh%e -6Y\0 2.:ʳNa̧eyZi)\Zb!s+jIlRxܷ	/iiI֥N2\'^2:$ݥIɥ\ni~\\BX,	},Ȭ(`̨o,R9\'oj_YȂ#E&٣/,dXVWhpk Thd+,FI\nP9x5צR,K[QƋhJʃ/!FeWr]/Vbu.Ne*&\ZTT\ZMe}%,>O`9dQNOMbqJwJ54gë<oy!o{, .H8õ@+$ˑ7][쏅\0-IukCCNBG_Sή^GR~{j#i!0Y-*\r\"#K1UTkhŽM*L+*ܹS!<<f	B9P̧%x:U)ITjnvJ\\&?	F|VhTx+KF<aJVZ\0V~m.m:Ƶe7ע8QCi*ﴄ$kgXh\Zh\0~#cmN[o[]ILݪ-/\ZfU{ie0Ynq۶%\">_0,e+	We_CZd#kʂ홒IV7\"@-qGh%8F\ZUS1VEU禥)N)Ӕ!$xSOEҌcoub85ాu3\nuptqRXDa*Ѝ<=ZMӦ4_Wx<=cO4rZYM(&-΁Z/:$v]N\0\rxNSO{-]|ZIX۱7^\\oDݬDL|APxZGY\0MB=Reϵ	Kw0<Sk#!c	-?o{ch!:m$uIsu-H&bl8FUNq:u`*]8NNZ哲捝6%g<c~l>)[W:F|7#(O:5aWl$c[S>o9i6GB;׺Eƣw%դ\\i>[_[o+.QԾ4x4փKxYΎ=;@$(=\"xj{ [XR8TTѯ;4V0I|O`B#(PO}bx~Ud0_2sD%fyI,r?(ч!M`90%UP(^r\\\\=rk>_.Wo[N2E^0Y}}bt0]\'Frꓫ(,$\'*2t\ZNIթ#S<E+Oj]j\ZjZ߆iLu9EմmJ\0i$h#057\r/j_0jRH[L8s%dE^y$2n<UCI1)nl.$Wk6̍?K\rFY\n{oVe6i,ROT\ZmJGf\\=;{y\\E\'f-ʥtsQUF4U:jէJXJwR*9gOPcZy`9\n41LV\n8lM,u\\=`#kSFs<$qUTVƥy8{5xf/fu;2[Q+p4\r幏QbB?j?Lt]sU [[mPYMjeyİnD-m1tXo_Y3}\ZX\0[mwtI5\\G.mǽ጗Y\"/Z\0+j\n-;H.c裸F,F9vjB\nȰ>S`1Jձ:8Wp*x(5\Zs$*Tf9I{ї*#f,9uV&)aҫM<#O3pU\n\\EZ4zU^Os;UYg\\6\Z_ll]M4M\\G4~rH7yWq[_54j>qqN`A4,{<_eE*>D/~V]?t+	#k==3[Gt֒l|bvZQ t\"CYZI;A=\Zb<ѭ	gbۧ~㌖Rsψ%./0PWJկB\"8wN^\'SGƮʖMQju\'(֭I8uiVגyǙwM\Z^XCQ\'hD7)\"De%Ygyg&\0!ARe_YUG}	,/1٥-eGIV\"[ĞuA+>,cԵ}1mfxA76:Qyh.%ȎtyI$%\0,n&teѥ:XNP8U璌ʒgIV*JNPV\\u^*8=L/2\Z,)(˞S	St\Zӗ,	z~\0qm(d$!.0a/O\nZz23o_` WbTJ\0G¿\\<@|9s,GF핣OuzlNxmNq,^J!B ^(e6ު]J.YUxYI	Rw\r7VDicjZ\\u3v唧47&\\5y<Ua/	]JʕMVN!${/C^.*NmX\rRO|1S9g\0#gbC4%\0dp߲DK7ϙH(@P.B\0mU/FgrC\0\Z>a:S:a)Uqn[7Qr\\WE,0ӟ3sM_N-uM+_s6L~.Ȍ˒L8VV+RCxC9\0Fã\"A1qֻ5ß6H+ةi8Uc\060bW\nL\r#pIڋm[&ߕKmRZ+EJ)4[m$z\n8~QaŦ@0_v%UqguI,l~]<,d\0>OCT¤=4r\"V@JP`6>rY[9`	ŖsB,	)uL\"*S\\Gy*rm>ۢI\'\"\Z*M+{嶝,4 pT*!h+U(AcnXKŉU0I;d\'w؂2z2z#7%KBXK\03l1q\' \'5F%O7)4՟4\n쾱/nbTtwukR@+/!Lz[T[F0d!UYǃ*Pv@bpXn	!7?V&M^Pk~G_,rq; ,\0`(\03,N\ZsuB<ROir]JwOF̵thBONM\'\'ŮX-UWdmYڽ׽֡,\nw7pª\rp;yc@Zŕ0DN$QORʭl[/o͹ʤWsr!8H亶6ybT:M_	k\r\Zjp$i61|ŊC){xrQʭn\\ե(ƥwd2]Ԝ?w5mex5$#R6[R=_xu@ŝ54x^3\ṇFѾ\"h\Zq6zm Iq̽C+V|1\0>݄Y<=+ [mCQP]mb7T>:\rWO2Zj\nce9A!ޤR\0wmdӗҭi(®	,?<]4ݣ%YJ+N%zjʢNu6Ɵ$ծUwd]Z-TȨ2@$|\0gh\n\0lڊGLNUHd2׉iO?\0u;\n\\\0.f@|c\02I	$8 \0$by9R,jͪ}Ns6ڲNVW<:4V~Zi]Z(}i6)+C\n~<ßP\\,jY\\3\0QDiDwkKn/\'ŬDZ-dY6KzX+9Pv,p2c5K*vXR\0$O0m}<g#\np&\",]ƴ\'\n*22iJ-\\3YلUa>zUiSOJ^rO[̓M;xǅu:OVwDys#@E*BFD2K(/|O:ޕAN-㷗tVھlk*o׾hzκ5חP0ZyvH\n\\»cɇ\n\0>c4[ߌ6hV;[S۹	jeJ9̗2mR\0\0%W%BQrsiμ7Q+ӌ^3<1ɋ{RZX*P\ZX{)NTu)F8Ö^S`|Uga^`Xñֶ]6qv.Y*݊b*.d*Jġ9б a@;OSyOKd2 ~[1kdZ٫l>SΝjo8I}ԕޗistI\\זl,̭$T:ᷨMKWGm;{5픖LC xbYDT7n(Wei#YBg?x0RNpv9a2ś:\\1ophc4\r3eA\nC%QQ祇Z4ԓ7$*rj~*r^\0ϱ\"첬UZtRU*hT\Z7(k֭?Uƾ/MQm|7j\'@Owiem*Yi7-+er7w9aǇx:멋h%/Y$Oa$le2]:WY\"~%熵h^\rg ֣Ҭ2[}Zgj	7CvIdSqYO+y|7*ִGWֻyyAsڪ{oEp\"LQ&i\"0T=9{ld\n404cGBKTM*r\"R\\?!jS\rΪFFKy\\˰S.qR׆C8(N*Ӌx^Otho6-BY4;3$9RRC,b:ƚ%!eٻA%,w\Z|u}c=lé(k]j<\ru}yi\rd[He%724ER[H$@>j;<oaf׼9h:6]j+rc/ۘRY;4	/!ƎeeIὖcҴ-	ԍUS8Ɯ_\\L&7IV8\"Q_6n50qG<ҕ\\9fTMZUk,>\Zִ BE?\"s0KZҴ{{AkIbMV-H#+3hkxx}~>ΏxwK=KHՙm5mJ?Ž3gssw6K;Pm-G\'/Yj?ͫxrMZI5XIkAc|43Lw9f٤\Zhƫz^l٤edIBb#TE;US5\0%Z,!B^hF:U$zq~Tg|53.5q?\'rXzXըՖ_bqT%,#Q*:Nq~n<=Ѯ&#_Ԭ-͝oq,izcD7~oǈ<+\']wz괓^ڌ\nsxHT0m.Oq-ݴ]դrMHE#JWEئ@B2E/xIoW[[}=|6%yy	nRe.ZFq3Ʊ$1ice(L.U3B2J0`)cg[R(<f*8W՛QƅYыP9_ܶom*Xb%\"j1֋xmj\Z,jթBe)πk\rM[bYMFY\0Ƒ.Pb.-fG>o\\ZOi]m.6q=6.KZvnq4C~ExֺFv-K9V8ebJ#Fb|H\\?a.N<ͥXחi\"<RhnWnЬm<k3;8+̳LAUQU櫅F.!]g:ƌKp\\ߑV帜g.*_l-,4 ZN9ʄNo\re΃\nSGǏ?EWGѭ<C\0bID;ah%ݴb$YCΡccKqq^?\ZY#,d*B<i!S-ocV9pv)\'\0gw,<ik7Zu6akM\0fkDڑW`ifX}*+3`{J[Kj?ZTEUhr\'*TM99rM088#Pkl>*NqXjQNƔ#AңE4:|2ZW7J!ӣ<ƁZI.L\0}k)XU#2K)k	~<#zNҬ-bH|2ecnBx%F]iڳ\";ɞY\0I1Q2]0env^\\p#m`̍81[8,wWهyE<^=N1!sB1~ɸʳQIΦ#S|%ECÔ\'*u%|Ez:ؙ{YքTPoiPKo1UMUI1b_@AaPW+PG\0+\0KNNsp +2Qm̂BH@\nvہÒy4c# řrh;FJw	uχZ\'SP\\]Ҝo+;K&gGF#Q%VI$M.۩& 2͖(NCc!?p\02:qC`nF@S\nTɺPۈ;rXS@̥)$ɐ|2<H l$o`RH,U#n©\0R2ךN2鬹eZ+=\ZIPVZE.[m-}sԦ֠A$Cp!e6H&7	\01ϮC$NઓDIvk!ّ@`0\n)uPa+Km(V(I봜RmrI]Iٻc*R978}E]{\\l\0x @PrFɖn5$1N\0^Uy>fÆ`Pv+g]yK# 0A,rUF L&Խ夝mu>?0ǨVRvyl]7e_//vp8?#˙/9\0y1ho$\0d,?`,Bm\\a;Bʗ>I ^7=]AC]ە-I.U6ynmIەkoqX<J\\-=m5{^[S̪ͷl|ńv\rh[YI8Soʌ~Q~P\"0ڇnT(ن	ooim<qa63sBA\nT2ÄF|*6\"2|ݯ+\'tu%QIߥ*ֺn5W}ϦNr`\0 77`y;*Zz\'go	06ΐUZ|pTkpyqZxyH=`2X\' G`k,|y5;JNWtquI-lOK|CN{\'M4_-ϠW\0`[*\r60ۜ9!z}uJ-?+iV\0uV	ڡ+q!Eha#0ٻ;9<HPڠlC8gI$Z;_vIRW~\'.ͣgQD[*rX7 \n$A$ᜨkSHJ8bP$:Xqu51yH_pT0H\\8%N:\"Ԓyoi$SZ.rOdQ)GM7mitq{uGA@	ʾ7\nO8,n\0\0o߉?tb[u8_1$b|b&1;42>yT]~7r0G]p\0%p(\n0?0r\0͂&%r0vF<lv?-fS.xՂ|Ӌ\'\'	q?R=Ҕyg	%(;^2fGQ˫?=`ؖGe̱$9/ٛETWOBiPr}[kc!\0bk\nW9$6W?(\'\09Cg\'k|\0 C^Q__(:EE5(qWm\\E.T,𱏲aJm%uaQuy[m>oΖ6,1R@Y[v~9Q3ʌznվְ44EBoyx*ŻK<Jm50v`+	`C8p1u6]91%	b	~	b.+~!\\8tox`:1JTq\"vrqJVgqf(e[FJC\rNNQ^:Rw\ZJRyec\rO;/9do&̑%9NeHAK>$W,Mj?躌#Oj<5Xe!X-ظFs$>8NpASp9Pm,HF3%COpIH#.V3\r\'9SNJQHiZ$s;AOFܭ\0:g\Zd\rԜrb4aU*|Sa6&tҋQt)/oj4;G~$\r߈4Ԉ\ZZFxX2mk5rlMVG9Bԥ=;k[滹mgg,v]7Tĩڲ]_e=Jk[IhZ1tLw`\0\0`x\Zc,!UPgm)QʥU@rV֥U}J5(ԩ^tҧ9UeYM(ETȚ\\yd+*0I]K:cbqx0bqXJъS4:VFkbޏz]RwÒ5]&Hԙaciv֓۫/,\'|wux^v+_=|1޽G[^ɨHͽ@\n<jAihd,>)Vl:rۉŤ]^XMōAypC6<d# 5x^9fU..\'>5ī-/W\0oFQGB6\"8xxBZ*E(UuN+FSO\r)˒Pa(\rX,]U\nPnYQN+%t:8}^N4gMS8ué\ZՕjZV$AkwEź-7X&I#wA$\\Ok/u	Ja$,#%K5O(9Gv&XwM>YYE3+$38pX9H4Eo\raW6m3}pʐ­Vp\r9f\Z:,+TB*,6\Z*QʊʭIT\rRu8ԄޮRJt*pT7F\\zuc\Z1I^e3Js^dx[r%[bmI&ݭc~1<Kr,bH<s=¡O<HG awD`m<|:[f^RPZP㍤5W.ox)aagp3\Z7,i/Ce_(Z)8WTMGysJ\\^5!TҒe%yyFeԯnZW$J28A|9Ë|#MK[߰٢:yO3G[yvrL\06dQ6\0I7kk-̎H<ogX㹺Rw1G8M\'V5(8꒬5/!KF7?ң9n=<k/Ɗ#6$򍘸*ݽrF0Y~b%\ZZuakUJPxxөV\n\nNr9Wb\Z1n?c\Z*5,pMisy^2A49zj ZAH7191.5RUUCmellP-sA*|^G,$GRg[#n F\0/+JTT-.۷*ݹ{A>\r#0WM)KEnI^%&M\'2PN%Fey^:Iw~Ts\',~B%;ۊ瑵.p2q0@C%0Lp;Z2%/*b\r\Ze1.~\"[Jp/`(Qw֧٥OҪG3m%xM{8>|%4M[jWFpޜ9]WI;\'>Tq+?p<񏘝yXޫʊ<a# `\0@;P(Up=㈟%\'IB82B0nh%6$$7̤\r;;Mzn\Zm7ufE;$!SMqMIU;k+\'.Z+]wv7q;1V\\U:*73wmA9grr׈xAIB`ɞU I|N?6]GK]dRH*pJ)FT&{;%{[f-2̩8e={miuW*rt@\\HT\0\0;`7N%lI,w<la|A&8*T.NB\n6dsx#8/,pG1qׯ&-.k]k}lvK~u-{zQKM=s@񾕯YChzf`R|e.;,1 tx_ߐ8>Rv8QWsi0kyC\07FOpr3^|z\"]|I>?Ha>Κ(8 W>;yjXU\"q*2QU(oewNmsY^׀iGZ8|7dս88c0x*֕+ff*`x҆;7\'zČH\nT`@8\0*@S7[rVv\rbX(2A>bŁsgiVxC.zxQ!>\\= n>RKc;ASߵ7Qw,Zu-g5g5de<)]*ٵVaW+V1%{i\0F-u\00#f*zJn{ln*\r*MZت7r>/v\0\"6Wkm;IbW\'h۰\Zbk0PM2@eR3Leӆ)\0Q~*c>e,uUd+ (0\0U+08L*%рQ\n]\Z0W#h\058*V18TSfqodL}Cxܭ\'lÄ$c))Fu9%(-xm.QIVbݪHڃ6l\n9ğG_HI,\n6e[p>ՠx^\\Ƅv_ù+{i6/6c\"n&.x$q+TJmp2/\nO_rUcø?^ѻOƒ)#bn9xQ\rn|SoQov\0` mf\'*\\,%IxiIsfv{Y/;eeq	Q0,b1?¨h|`$mҵU\'*2ʬJ\'Ì(之I]`\r^:>YB\r4o.IeK&:¿gQSi(KYNl5)\'jJ\'ݷ+[iRI \'`±\rk⧓b6ݷ|*rY~՟	>63>*;Yo*w?R~hҽ΃)gi:@FBK}2əNW-tk/3ψOs9vQKZ	sZ7IB*I*-;55soC\rJu.;|U_v<4,Ҷ.^ThѣRJM#xy[nߑFAo!F~`8\01aW\0RE/;~t{-JTy#\0˧io)@/Yʒm\'Sch7=_P+÷ !k*`7OR<*V0\')kw/SvZd{=.5DUem)WK5%\n[iJ0vR*S5[HZv\rrsFYIS@Z4KPNO%xPN	]RyrX\0h`|X4m\"HXE@$rfSo)>10:o <F+כ&/Xq\'Ro\rM5Ej=O1\0+S7(%$%&f>((~MId]4\"0A%Bu`Y8`\0}? [[UGdpN;@b!?ڛW˺d~>(R(ci+084/:_xs.16jZ~Pax\00a@ |#(yov,2ѽdhW	琫#JWjy7-{KѶ~џ/xRH<e˰LfȔFg݆BT|Zu\r+.WQƒR[\r5̪\0.ȡX Jᕐ ## g]Ǉ0R-\'ǞfYźoV{k-܆l5/uJŌ>aYJ0+jGVӗɻ.iϒ௧$Gs,Mu*LEYGiB\\_լb\0^\'g,!i\r\\)VBJ_00?*F˴$ *nSEa=So^c5HؒF,n\"H_L?QjI/\0KDh3j6^ b35	|?5XWȼܲM#y{e\0n+˸xcJ>ԝU\ZGM}?~UPY\\Q.rsLy)}o0֪T0s#5xkrۃ#C*W$r$aF!*xG+%2.!.`ΛC\r`1_&>ߺ\rK~&Dzymj8`w{$7vt>cw^dԯ4g`\nz,>5U;KsV\r¤3YglƟ->jΝ<dUMW+o(rW.ÿmVQBoO\'*2bR҅8Uڌ\'uI\"ﵳ<5I9SeΛp!~ӸoRwTU\\bo\02i\'n	/fs܈dfې&\0<.\Z鬴#eG-4,vqTX\'O?P,XO&Q{8PNxfws(s^VM_\0;\\/%aCpu\'(4Zu>QpGƛGDFI08RXG	|N.MIe`6r2ɟ0e&WU *^¡xV<k?-XP2$$d|S*\"F)`\\);\'Frm+7}.x,MN<O.\0g8栣lN\nkj|^-.<]u.w\\6ӐF@\'8\nŃ\rb97.˰\0Č\r2f\\\05_\n\r~le?%=܁᭾r%+.qϗ>\Z,u4! +\0O?&O!~U\nZ,%[;w魟~AxG9<e=ᦥYӋѸԶ!:s\'(+Sf$KCρ!܃zrV;8XAd`pw3䌪7UT<deN	=j66NEd1;peN\ngӟ0z2K-o}ꭻČ.!MGrG6TM[iۦS+ <8\0@\0zdJ-	 6Le/e B2G!`\0ِsN7\"F$w7+IzN*Rɾ[+n+if{o/u\\(f7\'HxefӖZOc[[B:\0NK(QʟvA,Iiɪ]f/8e!,0a{/t\r;O\ZJG`.I12l=v$w|8\'$si/TZZ]|QJ%$qmW(]]%j\rA9\'񍤐=l7$\\v#p6Glu$d㓜;{ξmÁ9=OBN*zYtWӥ۵յGD.jY$|##8$}(1U[M,3&y\'v\02,|Vb? Ԧ\0=Gۗjۑyor=G/Ւ?\n8ݮ#kAh|E} d\0\0n0 t\09San䌵e-N}[oQWvO\0@q?6;&/$&Wt_!?^\0Ț˖T_hMWpA՜rUO88v?\'NA!I$I<lTկ]o\\>\0H\np]QY^-/d@Q}1yOhˀG\' l=I#\0f	?e4dTk0nqyО]fFտwFw7\0cAE]GqU4ZIuL0\'57\'\'\"?\0?År#,F9O-Q</TҘpNq4.&]^k&ێ--,?9?	Ykg֢Ҿ]_| 9h?fǁucdR6`\r+\0$@ +?>]H8ZA,xy&A>ƢN{[hC6\0t)khߪ<ΓgjA1{znwg~GHR@SdG@Nsl4|Ms(t6f\0nӐ͘S8*ZXe}079ZqW׏2N;;;;xOݎ>y# c{Ҿ>-]m&Omy\'g^F;k`;\nN3?L\'o\nkq	S/>˨B/YU7Wq_ǽ\'$\"rp=SvKMujl|tet<z,|z߮J?\0k.F2)[hR˧`@|*MFCdI?98<\Z~+xq>3\"k<u;M-TzwSm_KmU.ߏ1`iwqH2?k\0k~d0\0DcNszҗ	HD0%&	\0S?yw\r4o҂_|2=_g=N3tk\0qh7?!\0Vr1\r@眻=i?	dߺ׮\\\\tP	9?&z(Ӯ裿e\nG9\"\'edҩuѴ|cA$qڣO5UeXÃa %PlIm.UU~\0 ReMSdm;Xp\0 $fqGIl#\\z+ɦޮ5O.5#dڳzׯ|\ndG8\0~9?;jP UmI\0pxu!^\'20KI܃T\0$\0ǂ##LĆ\0|<wnoˑ:p*\0\0.s].eޫWwP_><o\0MӜlkJVSԀ$㝄{\r9T篧?\Z,	%Ƨsp\'n\01wqrxy\034#;\"Twfw{[pp)oia	toM3sуӟǟ@;!`=HӚgm ڍb1uӹ+18 Np< \0\n	#RAc؝cqH:ҵZz糶k;wz?\nV7g{6Rv_M?-outyB8P{c1^g)k	UA:tҘ~`N)BP,	B9}\")O&v]9[JI=ZZZ뵷yh=\0,RI{`0cB9qCϧ_#QCç&\Z\0N	#9OlB/oK\rߓt\'wO75xV^Y/K^zh៉_Ggi۪ףo]^g66Fܑ9\'=jmrI?>\'\"\rE]q2Kp\\1ԕwގUѿTxi8׋ћOU鳷f柇#R~*Tcek$̕/fE-H$:\0Z89^5?/4U9گBrNI\0N8|\ZNuyYH8$:}{jrOiSmO];;z۳c0^sf$9Aۻ8;ܒL%Reܬfuڮ\nφV	\'e5?iBęchѦ79f2Lv|:ޡ$ZM\\G-R8>~,6\'6!?zx[;tmX+[t*rvI7wkj\0ެ7dy}\ZT_X9{UQRIVR	NZNӝ7(Qtz:uD~ē*l^0ۃѪ20JYs<qG\\UBz&1法7x-$ 7ds\Z^D}W\\o>j,@O8n,wD8+ş634l\"Yn4)d>y\0Feb%\'u%ouj+\Z-)&2uU&F	RYQHΝhMһqSsR+;4,0ʼܤR2lxC$,1\"0ĩdqN%VDTBQB@mqtRiQa7\nFs*G!I%i_UR.AstЙY,-7G*#\rŴӂO5fp%4[!pcRmɨ2sn1j|5˼PbNa^gTiAb=8ѣ[ɑFR|)		gi 0@6~TWzux`2<+l$2$*ŞIZhqE p6Ȁo%KȔY,@s3.dlѥҳʳ>u,	*m\nzd2#apJQK JKNRKH)5M]?ӑUʚ:^*c(Ra+:pN2QAadW*uN)TS\'J׭	tV3mFcRg6Ͼ1Qqu1H-\\.8v*^2HgvpwĲ3:F؁	+C6$+$qLF|>\\#6F}6q:nUO\'`Tm:K:~dH07Ki9n֓Jɴ5y$RZ|#,E:uh	\n2ONN<SNJwJҌ5Sbĭ-+)*)WW`c) 1bB4Y	R_@Nv6)^lyZ	Y71_$>@OvݬѶ	44!*J5.~gEg@˰S9KMF2UFG}4+Tm;Sc05*WRBgT\'+PLęi*UB$# +pMKf\rP\n\0]ɹ v+yTTKW(KȁX)ݴ`\09вrdYb\"PRJ=[1vKfdb51,咵ʥ7vZ抚GK[Gd2\Z5iֽZY˛{қ9BQMA4\\oɾDUج,!vUX,H;;!GeDI$diê\r3uT6|/cFWw$4XE;K2++r)%>Ru<pi鐴7UI#2ԣaSo(̐$˸0:Uc&JJISeQޜSMIDZaN%JTkFԫR\n	Ɣ)G3A?}$AP ev2U89-gEUÈXyq\'aCrp[MǋV-İ\\^W6\0i-\'\nGS6sg2Hc6DSgb}-vl|Cww~+4fԬWpoUoü-<=)b*0	BjU:x^2Px&ԧNye2qJ:Mօ8T9(FUFkt8AұڴqFGc]P`A~]Ǖ5%G@ː#,`޿*8?z=%Ė-}kxNi^MFIa-م|0-U1MRQq]й[]/TUSk)PKQ<\"ixGN8d(jrajҧM7\n:K\nO{7S\ZXQ-N\\EBRԏ+ڌ4R>s}4Hѻ	;N7GG7ޠnە+0byn㽴<&Xyc0X]  VJ{_V\\4ۭm4_:U3(y6\\Γ]#Y5MgQF}<P]iVF,O;Hs)gɝC~^aU*iO\rcmi\Zx5>vENMy\nW8e\nxC3xrMxhN+8NG(wd2X26\n!Fܸ\'i\"|K`6JPn/#\ZDX+Q	gi.$\0ѧ\'^7h[p#w	:yr?9\\شadUT[[ToީibGeu\r䰗SJ=WhVIRihJ6~/<[&\n5<\\jf/Si*\'V4Q7*&N8hԄɝYGesbN`\nyp1;U[hcE#@s %H$v}J٤2F+@$y%Y7`~,`*~Jl,\0$K/v(بkn1\"һvܣyr当[Om5V\'Īb_(ocGsr:%>GbՄ*Fsi.F	gbU\"+pG1bU-5`ĶpZhܠw+p*_<D\n\\\'\\)UJo-ءi2d{ɥbHѠfS¿.>rn1!F4✛4od얉Yjܞ_M_9VbJxzot/{ݻZK58uq1(df (CP+	K[pAN3,F	s\0Ub|ǋB<(|3Rl>a!ëdy\"mna\n;~ɐn D?֌JmĚFQ}[M\Z﫶|+F?Pһi*B,Z>!*R+Q٨^nWaK6(7iCmkbH51fhن]\\J1RJ\02\\c_u\ZH\rE6<U;U.-\rM\r9nC6wt`)_1r6މ)5^)]m4O֕8ཝ:	ҟ┦(G*rPvw)JIOkrۆ7,;I\08#iU9V\\e)b2mnd$\rȶyS7CE(\nF<Rp@CT`U+7\0dX7.eW@JblnZʹ/k;h/v\'g\'Ǒ,<4}`b(E!Y9FNR1-Ku2SN*\r~\\7;NrHIbE,!Dl぀۔u}6!`n˫٣t,VSŸU	E3uyrQ&KeP&3q)m|{HhPc\0mO朧ll3mJWOmZg2&\Zt)vMN\"e\r(ХIrSj;Kw$큒\0V3%<7fpq\0w|\\IiF&R!vE̒>fQ lڃFRT0߅1<şS<\0HPǥaPZ.Uk}zhϔrXTT57$(ÓTܒR/\"]I-G\nۍa&fFE(25BYmi5\'[F]fCdf]J(n[/v/m$(?\"+vcV7KW#L	ѩ,7&I!ͳL,%݌[1\n$h!,jm]]Ij{P4H4ԗ*In[czxzsVT%\Ztc5^Y.7aI$_I/ExquCb̑4䬷޵֎Bt0F3B0@gK}$jmAs@,Rtpe]̲E(Z^kP_y0I,m$0X\\[C4mwYULdfPR)ӗ-|-iƜqNдGʜn8KNQ<VoG̓;8rѩ#g/h僎}UNtbpέ;]\\W7%\0,36m4Y#,\refz+@0[{řd;$p\\mY\"hK\"Ar%wiWrV[\n7lb8閚貖!m6D|\\;Rfv]  ML5jM8Jha:ھY{5e)#ԏ-e\n*\naU7~^!х)08៵rJqRIbj}V=epOy-[qr\0r6ܥ U%OswsWl^[O_04X \0y2$\ZT\'Q\"y֬,WtVdSlV@fRY*^c7RMlyvvI	OTm6ͥF4(j~.>n1P*ik$J.<쯝3,Ə\0*࣍PSU	LkK*0՝W{GRZIrMnm3 #y;Fnz=U.ѵkT#QuIPXH |e٧dqRb.\"8l-Fʪ-ze\0j6,ine?HpҠƂO92\0^5%Bsc\"\\t9V\\iCܗ%/>i(i2x`k:aJR3ZT!B2RNVX\n\"jcz\r&(\\bI\"y1L4A]Wn}f+RE!K)Y^4(cHР\'ܑ.#;@lZFIf`Y\Ze9cVu\\eV%FƑHNƝg\"^FRH:VXU(݅^ѳI*Qo\\*jvN\n1wQnvM.e{FE|6T5Iӡ\ZtRkR<c\'H:x|%9WbNg@m\'|Җ\\1\r$\ra_dӎ\\F\"aa4$Q]dgU<2+-sr\n<[H~FTLbA3+X,LY%yo1\rݜ+F{B TS.Fu9\'	4Ҵi9IvV1xJ\nL\\Sl$=N3\r%7R\rӧ8F#;gl=GgI`bEF7$o8,4IZɠ[;Udd#Vv3O$Lցdh<ED|,\0G$ؔKEl]q>͟)m?Q	8VHKCJӯoA!3Jx;hOSVVMFU*SsG5Z?qLupe%\0fTAԎju:Rt\':yX֝:]BS\0e~|:=/i>m%n4yn%ǙzqL`xUivh-ua%,_j:$&aū[,\\bSoje&iv<:=Jo83\\ԤhcnDz\"8%H0_\"xK|=QeY5N̨ʅmRƲI0i\"(α5SNA¬$baMRXxa}s1_ԕ7*rl/FS1V̨*qup1*֣(P<V/ӣcBj\Z~ѭy5\n\\D/5\rL$bcici줃Y Yeu5a\\<}\Zjbº>³YtH\"&-PH\"-¢$u2[0쭑M,Y Sl$Qml&ddbǌtn}Li#mx3#[]nX9rO$Y(I,l>o.B<i}\\$],ZRERV]Xk\Z*rJ5!4cV*\ra!<ew#*W8US&*jriZ.xͨ2p-*+s֍-eUWϒ(nmL2k򘥻E3\rAbLbTX ]v+`Q>(Ե7#WGl5Vqp<qj86f,EC扼PQGL O\'\rM\Z&PY2\nb3n|^>4u>LPN2pn>N**Ea&\nxNZ|%>!7NT،*\nR^qW%:MJ2Ͽ8A=1ĻkKYgF4W\\^aQ<:4ku\n [lFyX!5m`7@RQSQ3#Eewnh;:-ҵqfv@7ysy9]V[ysCg5+eLN\"ef;.UeIΧ7RqU]u8j|q<?6cpXl`XѩO\"xDOcS\rOx)b(\ZV*[q*9g.[xO4vp4󎞷URkHd2q-<`ОU)B^kPGrKkIˋt($\"@v2[K)1eC4\ry>!K-	+(ཀྵi#%~wo17Ĥ!7Ni<ݔ%$7~ȴnZy*<18v>zbGF8FyckbwkԖ+I\n-1Gcj^)Ƀh<HUVi%@ ,-Ich*6OY	UȉqE@ŉ$VΝ`k5saPBpV<[r$h6TJg`0FА18Wލ	4ښQѥ٫fI)$>5¥X.OkN7:~hJISsi>zϕ.GFS8s\Zb-aAEM\nj)TWTTk5Y\Z5bܨgd\00ƨ\\]J?w2djă ?m\'#n9cqt̄H2WZ\"&Obڏ.1ާBiB)(Ӛyfq*(+ڧ?o%\')WJ%\0`nWWAxRHbH۶]mwb\nR]i!<SdRv-QYT amIⲕᰕX2>R03{waC.\0ĄE`#܂K;yn-P6t,q_ib;\rR2犂QNPODyQnt};Sy|KԆ\Z*9$)Q_nsS.&@m4JWB\nwhQޜq\Z;kr#[E9*LW\Zs\\g<]$TrJEsnrc	t[\nar$7Z셲tFDS3Ux$V?^lNHpr匴V6%&-դVNɳk\n01(C**UqqNgJVq4\Z&Gj]m;Il<Une\",JL+	0[|,nddl1sw\\2f\nZՔ;cO \'hF\0̡#v,Ȭ;	Fm|Ia4WpTq0ӕXs+ݸ7-ݭvѦ+糅*¥nxԦ9ET4%(&s\"ٳJG\npF`J# :+8C--PQ\0ae?1XctV RWf.w,r]Dۏᷧ9Og\Z˝23\\H#0n}+ڽ8OK\n%ڗmK-s:ӳY=jTy՜-R/N\\~e{\rB{`RdhM$2ee>VX`|	%mU^v^pI|ZY\\jwI\\&&u2ɪXY՝{RuN87*ӕ.dƝqM{ge.`o-\'C#͇b)Vs\r\\MZS1K<r]c|7b\n!HfJ+ЧV9|J1n*vp|Ͷrշva}%VX1X<$\'FUJ=TfƜy{Ifkm>.g}O*nwIo83+mt ?l?DrL%;6%*$(!\nV+,L<j6S.pvr]6(Iim&wos\\F9O\r,,26!aP	FEZISvy[(aFI,PIW322,3a-;t\r6<*mxԍ%IE<5[ԩUTY-6Z~w7mK9%dt18L&5XxJJXbSPҌ`bJ*Q\"m88$fUnObv#$X`ϙs\r@\0fG1,da1UX]H.%I]!q`łEDU!Zxt({hÚiʥWVOLLnOPGa\ZTC-JUUgZP*өQCΜ⦨O[b1C{Y!dlm	5%Dl,V`F˄,pE%G)إFȥgRtU\nq\Zpƣ̢cn->dֵ\nTtkSJxzjnxhm*3:ITJX8ҌԒfV2YMDL2uSq<l䐷٬gKW$,Y,ࢻtQ{rIhyo}Twgg51\0F#ףeR2֕yVG-8~J)s86^Y0as\0u-9`ц1|E`!e+).Y}><&h. i1j/v76t0^&(IWE{^*:SU˖O^4*Wi5+f^;&qcpu}URtMG0Nx%6.hڵz;6tv?t|OE[3Im2Gm# rЮ?3l\ruVxVNgzo*E]5̶ߺI(,Ml8\nէ:L趩rVRַqq12\ZJvI˩`sCiB6V\"*x^)S	Rs5)ҥ\ZgJ.nO֡݌%Y4|C{@&LdڽmuKSP-𦢓ۃ\"97pZE|mgG$WX7ĪR(ϙB\"a)F628Sڌ+f|	ⱱk9no9)УW51،v1GWrJj\n$\Zڵ[WFY>\nAi5\ruc\Z.$Eד]_5cĲUsE%mk_(EZ?n\"\"50ҧR|%9ӧ)уƤ0NЫRmF]Gq.$ӯ/	W3jWaXif?Uj]e*r|u{)UK(vC:ȬZ&C<P\nv\\.3R-l՝YdThY@TĔQ%$OMARwVwx4ԯzIYk+q^kTα{,NF<F>q=ay\Zܚu 6ܔiPHdgeFd0,b@|G\0O\"}.	)\\d2Ynv3Q_OFptcMrn򚴹eҵ֗-m᎞hԦaU(TӤք$c+Vi*i({og$2P\Z[rFcɋ11aʁmdu[­;3\"qH gUg\'-*F.Ko=}NLd{%8NU)QJ2f)1<bJ]1cd`Y՜dX Ϙ@}e{E:ܲiC|dP~Z(%ʓJ^N׻Z߻򷟇ͱ8RnG(&p:\ry.Y+P$/5PCb,A\08m=ڝP FV8QI{@bEaF(s>^k[KhFדse1O\rB4+))Fr%MnWm3?/2)Kp̖ȄdL1sUfE\nV9ki\r+$R>AmpWRMJnEk$ߪgGZ\n%~*87VqN%VJRQn..Ro.M\rh5BP%mAe*Hr;&)#$D̑b	\0Ev-R}/]X\0ļ	ҩC\r\nczm,sPRT^=)}FuF 0\'+9Q#;N:m\0X3ْ3~i9<O `(	6KJ^_،Bp+r)UCFJiҦ.XE7YF','NH9Wt4nre4M=','60000000U598753159U00000006',0,'985632','','','','','H','COMPRAS','',1,1359757762703,0),(28,'888859656','U00000007','jfers','numgrod','hejis',NULL,'KKeN0jZfAQw=','70000000U7656958888U00000007',0,'888958754','','','','','H','MULTIPLE','',1,1364792400000,0),(29,'225566987','U00000008','eminem','eminem','unknow',NULL,'RPYYvxmMvwA=','80000000U6789665522U00000008',0,'55874458','','','','','H','COMPRAS','',1,1364914499062,0),(30,'5521654','U00000009','erno','ricardo','savaleta',NULL,'VzjRR15GOlY=','90000000U74561255U00000009',0,'3659874','','','','','H','COMPRAS','',1,1364914731859,0),(31,'5527946','U00000010','calle13','sinnombre','calle','\0JFIF\0\0\0\0\0\0\0C\0		\n\r\Z\Z $.\' \",#(7),01444\'9=82<.342\0C			\r\r2!!22222222222222222222222222222222222222222222222222\0\0,\"\0\0\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0}\0!1AQa\"q2#BR$3br	\n\Z%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0\0\0\0\0\0	\n\0\0\0w\0!1AQaq\"2B	#3Rbr\n$4%\Z&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0?\0bqOp8yTGOա8EKv*x`U8EKv+&@G #\"+ݕgg(ڕbCOSt]v)];˥t\"?53idGGE6yTyTsPGW<<|bI+ڐG0J:O.W>arLtl>{\'EQ\'_G,v9JBQyCñWe/d\"\Z(Q01Q1ִJSLyL9Lt݆~=W0R1Za`Fa9e<GV\\ty^Շ1v*_ZSTbNU;ˣ9YTGNՑ8GK|_*GV_*0r|_*^yTs\"חKO.˫~_/.`)tyUs9J~__]<j9ÔU/G8rG*ߗIQm*חHc*:Re*yt4\\t^]/i)G捄(`*lZMVYE1\rDc)HsMǵ12X1iOzwHEKև=)|j;1)K9J\"/jwWcQJ9Ô\"ߕKQQ(ڭ|\\UDuk˥)W˥ϖ=)v\n9]*ϗGK,VFʵzQڎ`We&ʵˣV+חGO,UחI*ڭ6G0X`#4Z*i6J|b)6V{R4sIL1Rm.Ra3a)O1bSڣ(3Ү/ڟ0MԻJ#q\Z܄({T:pJ9;A괢5SRBKzT)v<j<mV/}*Z]խԻ=GVj6{Q_..y~y~Թ_.˫~_ҳ\rVLuKx\\LFy슅9M*ˣʬ\0I@&HE\0\ZO\\sЅutm*\0_*X=;XYx\0ft&d!x,FN(Ysb)cl5-R&&U8ldcRWL\\])<Lu\\OˤB,S)L)V0\ZaJi\\u%E4R=&>`JՃiUsd-8-8\\<͉R\\Z9ٰ()dQ̀QKQUQ7\"]g$n$:TbKR>plnK\"pl6]¢ݧ$K:ՍRm\"]mc\0|7TxJ3=R?f4FYhsQx	$XMq\r- r<T]\'5,oi1U0Ȯ\\S.oV\Z˷`g$r3Q\0PARuh@2mz.x5jYl}&-AGq1\"ya?VHBM_-)>cV5$\"6k(S\0?T,̢ܵFc!y̾cBū{e]ۉ#=kb)JL0;o1m2/G8\'{Boj%&-w^tT9G\\rZ\r>OQ\ZjA#aQ\ZLw\'5ԡ<\02,be|2zXsl$\\UHz:0j1^Gs`EHӠ\0IeTM].̐H-_\0Fu7ۭ`ڮ%+M)YxJ7}wEGZ=5cXMOhѡfA\0	.=|\0\n=?K7t҂\ZiP,W++cҫ!GVF1G^gnk9UڞʷtMEÒFx´m;.ӦAd\rn/[Օ=DrdxqxgVau(W/ sOSMzk;zĞ(tܲ?5 %\05ͨ^.vH\'j	G+IKЃɎC(SrيT#\\5h]\nqRCf?ׄ3j`fiсF~ⳏRc\0\"ކSTӴu=V]M\rcId5PIoY^F4W8=8J~4/9\r ,qOj)-EG¼fz\0i-j?4[^JoxF$#54#vI,ʷzP}t^lQ*nH,+S]呡BJ|LOFp>5.[CNy=2_ihވ+֮oaHg$s}!&W9<\\EJ0i-B\'#zc`ST71\npW=eI<*ɩn\rq)t\'X~ Ƒlow$.{Z4j\Z,+H@:#	b)¢}YtN\0\0v\0~U\"oaɐ*ԑZ4k(B83ҝ55!TFNO^lùMVCXAWbiāq8 <~#WcETe]qiqUTIY	yQЅaa4c$t2A\r>He+2Z]Y,2{G kYcKPWpcnU\0g;\\wfȺkDNBpzV]S\0s\0JǏ#,#*77#֝2)Kb dJSٽRU+EM2`gsY$:Oem&rs3u,FFXO?ª2CQ\0\ZhbF>H+`߶UTߥLnNs\Z͓)?j.3O櫚,yvEúwȦ-d5BtH$d\ZɚT\0t77D`·,cr]s{4߶sq\\ډ Mw*)V \0O?DcқﶷEk`?0^h,epA~e<m&X@O\nNqU2/b2C̣G3\0<m `98XPmYv+JӯүYGo,{9?J\\5RȞVկ;y>Զ7Ȫ1\0IcǗ\r1VmQS_e*bchң\'yɲŞgîbR!q\\f彅	8\rNH>aƹjF&wQBuղ>iaÓ\\gYbmzgIu<c VɣeI%r*$L%	cFLsZs]+{:Wn.|d=5f/HcAV\'U.i<V2>٧xu\'@zr\'E{GcR?Z2y<W>jwDh2a靣T\\ݢT(Fбy`S\"H1\\\0ΪgK\0hN$bB~=u6֖qFt^kZRGWԌ>j=NK\0iT79$qj$Io|)y[͑:o$YCT7`꧃u$\03Zs#%ҳF1(T&)SL$Kys.۸wa;5]!\'}{Vrwq2ЮTRr 2\\TWիTU Od{^90}*\0P1[2܃w@A Veōn!Pʊ0=^\ZQ{N\'>w5+[v:jvsJz7\n?r<j@?O:GF.>Qۖϸ5e\\g?悊vЪKk\r3$N8M \\8TIA$^Ӻ]\rISsӨX\nO;z\0)ܖd2(U a\0xa|1}*}еJ1Z# qpsM6qXSZ-76Έ4<\0昹iِۊԬs\0CI]1\06F^Hb.\0}T$\0}\ZK0{ِJ]	|1\'n\Z{Db5Sd7)	\0aI$XːN;hF}8Oɗ$v c`G&/f1éԞX +iw\"!PAAZ`DL|su45_,9QfS\0*`b}\"\r!Qv\057TVu{u˒WnR3j)5bq/Mp3\ZIԝp[FV23)\0l~4J8[\Zj_s.u]fVH7}\"sZb\rv|*,}kf+hU;zeU>à[Jؓ\'\n櫍\\t2TKml#D]*@=8Vp\0;:zUa*xLpzW[ u9=ݻ+,ۘ*OUP=zв~w= s)g+*ʱ<zФ\\`6I0pF1QTQ\"À8]qa{ҖsWv\'@F\0#~NW`gI+\rȹy4!9}<sWf\nqZXs2`|1?7YrϱNG<VWPz57T|#\nW8c\'tsM{0NO\0߼SQkb	P\rp?*͚%:.2\nkc-<=Ha$x/	(?+nWyr&f?zt)e%\nݔHNk[ufoݍ̀ۈ6qI-%=Ϊϐ{Q{55-x1.;0w&O\n뵂iD21#~_d/2}xFUл O,AMܕbep@L\01T?SIpǿ\0cv3QRh)i 坲;?5C͏|R^=ԏqEhW }O?P`ǟi\ZpXuqS_ݚ\rx\ZG$ߏ)R[\npŷ/#fVۦF\rY_܂֔k)=dYKPI`X`mLdSX$\0ĀZI,/$q\n}5hr3,ȹqS2HpG~]FMrf9\0\nsފx\Z]ߩm<${pұ>R\',_q i6\0ϵf.BFU=\0pN3UnT(W>q.@很qv՗$	l2{P[c+]FyIe0+I<l<G$Vi#P|rH\"*BN{ک<PnmOZ0㎴[jIh>l x4!1q5q\'}IiҖ6bC1*KT..󓊉bP=OҩLH8\\zE;MA%pr|4#\'\'\0ŴzYbRAxzb95\\zuY;|h@Ot2n@@#֨NdA^W1.i$U܄1:Dg?PßZUWAdN	\'S&#wVdf(@U	nVgpXaXg.-XZ_ @?,MVBcǨ?[K]Ef#?>ĸPr]YKgo΁,q0ҭKrgGqdQDy`5U]Tfэ1Y]{\'4M\Z5@ά^Ԓj2:_(5f43b\'sL.[l|\05\0\nXyDl˥\'MRLU=Ȥ\0\Z13f|`Ќlj抬:4ކFd\n;EFH8!@oY	tN\nnG}H2ʇEM\'M\ZodOhcoDTR__HpB}cCf2~]\r>Z#g#\n+5sZ$Ws|\Zъ=|\nmw|ըǒ{r)&*\r-W8s \0y:\0?<#hDNOƙ欬s#HǴ`*9[-Hp(b~= ZS4ꨁqT]1GQ:AGcp@v9U\\U:l#Q.#\nP,,B|rI5\Zħ8-&pianO6mc>Vj1(Ԗk\ZP>r;z[|Ɏick:Gf[\nnlԔX┞<7~ct*)\0Q<LY|\0U\\403Px\\]]3Hr?䴊ͼŚ[?+`	|O^o&էsje[{.I<zt*?7OҳPEtB:\0:vd(P`{~rK\ZPoI\ZzI]pܱ@u@3UaCmI`䚡w11R<Nj).:kWzK\"94\n$\"0>S1[ZLesڣ\Ze6xzu~.>H˴U0n~cֱ&Ur9ԷV|M<S!p5qJOS9Z:q!*\0\\z)5)!Oq\ZDN@\n\0\"8};ֱfj\Z)Q++m<rj	Zg2&p\rYfGa$x!?)WWuF>SADvcUY΀U;t+B+;1R7%I5+&nیc8HۖD@y5hZYzp{Wm .cQhTZ;0yq}ݡHap\ZD;9cOy# qC.jZfQj(	#nqJZK\n2?ɪfVOKV۟CJ.,?RG\"VW/NX\'2\0eyBi ~y$ݛ~1KZ[\"Wah#RFȘxN\Z9p:4G԰Mr?%Tp{*/ȱ\r,\0&U -aw69-Gm\n!e}N+aTk)(@\'? #}Jh6Տo.5Bۡ\'?5JpfnE/Ђ;K 7C.}<U(d؅P4;4o/5jZxxq$x(cW*]V7	dm!¨SMXypTsH0}(.rITjY~}ߝ 8|ALp\0;`ݐ*LLZHʳ|PMgfڠG+\"ec@D\0JVj8;_3V]^yIFB\0OaMQFF}=*ZLa@8	kEbsKz\0	P*4j|V$Pߐ1#8Ҡ2+\0\"B\05/%8;UD3\nM\\)2Z;ݗh%f㷵mMȕc}8BLc*ze˸G=?JK\Z#r{{(H\">9;U\r;$<U]I3W}qWج\'o.X5.b`Tho#[xbFi#bK7Bu@E`]^Oy3$a3ƣ~ƣUS:!W6byĒ9z~\\,(]Om->_~GiH[GQJZz2?8:lB8=&B<RKQǧҪ\\L\n7sg.ZI\'b9b/nϒi?rɁN?QeaH1zyz[&K,\nk]:1ױ٥Y&%6dU(s)Tj\"(\'QZiܓOH̎\0E&cD\0?q3\'RSF=%l6j[[dq\0Ie2{̲ur|.3NJEܟ^:^)?>j4#\'ʪyHOj6fy?!B+\"Գđmߙ?*}V洭g[h ;{R-%+ )rTZ2TK6}9i\"y8V,$-\r3SFH#ӥ\'9B\Zp#?eӯ-z	jI>yh~fPe?I5X\">.-JN2oqԂޖw\0!pqѱޤg0WɦHI(\"l\"0?Zv^v86C\0gN6a;3E/l~\0|:|T]\nuʏ7\"Of	?r\n#MY3T3F=#oӚNskJẀ@0\0*[h2<ļDov=	&^|%\0;qm[cĜp9^i }}_+-@ij2̻JpOj)AQO4%MĸVlYU=݄!Fˣ>)cɀz?I_c\')ICr+m^^*Xi|;$4h0XU澞V\'i\0=+7j?`U6,p>|c5{h\'9$z&\"G1`yCa\r0$Ϟb`:tѓz7x\'-N1LaoH0Wt\rj.v=OJ	i p)\\T\nԚ8 ai\rA\nbؚ`mQS&w=NY@vD9ׁ{L)9_Tmc7qgޤ3}EZhK-1U,c(w$QYɻ.Њq[o\'?)S8a[p0Fh{Iu!t8@G!G5l.4QUʈcb\"<M^d|(qdAzg\"vc֊*cDKCTXo\0*!aLO\0^)l0TdD=\n(\'4̗ʧ|f.8	H9$n\0QE\n)ln[*f(\\q3?\\nI>[A1G-#noZ$I4QZ-e4q)!x^rxo;h%8[wU,c*Pcڊ*Z-J/4P\09vL\\[3','fO3+Empdk+Q=','01000000U96497255U00000010',0,'5599864','','','','','H','CAJA','',1,1364915241140,0),(32,'221648735','U00000011','patanco','cordel','cruds',NULL,'HBrJWa0ZeU4=','11000000U6537846122U00000011',0,'5522698','','','','','H','CAJA','',1,1364915615109,0),(33,'2456987','U00000012','tody','losr','daslo',NULL,'n0tiDCT7IgE=','21000000U47896542U00000012',0,'22554879','','','','','H','COMPRAS','',1,1364915907187,0),(34,'22166889','U00000013','kodis','loker','pesu',NULL,'JJEdGsD51i8=','31000000U598866122U00000013',0,'25469855','','','','','H','ALMACEN','',1,1364916058890,0),(35,'11246359','U00000014','little','kosmn','losdp',NULL,'qy4HWmzBK98=','41000000U595364211U00000014',0,'224685987','','','','','H','CAJA','',1,1364916289265,0);

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
